<?php
	//Variables de conexión
	require 'global.php';
	
	// Las acciones posibles son:
	//		usu 		-> devuelve los datos de usuario (codigo, clave y tipo)
	//		getpwd		-> devuelve la clave de un usuario.
	//		chgpwd		-> cambia la clave de un usuario.
	//		opc			-> devuelve las opciones de la aplicacion a las que tiene acceso
	//					el usuario dependiendo del tipo al que pertenezca.
	//		provi		-> devuelve todas las provincias donde hay cuadro médico.
	//		pobla		-> devuelve todas las poblaciones en las que hay cuadro médico 
	//					de una provincia dada.
	//		espec		-> devuelve las especialidades del cuadro médico de una población.
	//		asegurados	-> busca el asegurado en función de los parámetros facilitados.
	//		medicos		-> devuelve los prestadores y puntos de asistencia de una
	//					provincia-población-especialidad dada.
	//

	$conex = mysqli_connect($server, $user, $pwd, $db) or 
		die("No se puede conectar al servidor MySQL");
	
	/* cambiar el conjunto de caracteres a utf8 */
	if (!mysqli_set_charset($conex, "utf8")) {
    	printf("Error cargando el conjunto de caracteres utf8: %s\n", mysqli_error($conex));
	}
	
	$result = array();

	$accion = safe($conex, $_GET['accion']);
	
	switch ($accion) {
		case "usu":
			$usuario = safe($conex, $_GET['usuario']);
			$sql = "CALL sp_iCMED (20, '".$usuario."', '', '', '', '')";
			break;
		case "getpwd":
			$cod_usuario = safe($conex, $_GET['usuario']);
			$sql = "CALL sp_iCMED (22, ".$cod_usuario.", '', '', '', '')";
			break;
		case "chgpwd":
			$cod_usuario = safe($conex, $_GET['usuario']);
			$clave = safe($conex, $_GET['clave']);
			$sql = "CALL sp_iCMED (23, ".$cod_usuario.", '".$clave."', '', '', '')";
			break;
		case "opc":
			$tipo_usuario = safe($conex, $_GET['tipo_usuario']);
			$sql = "CALL sp_iCMED (30, ".$tipo_usuario.", '', '', '', '')";
			break;
		case "provi":
			$sql = "CALL sp_iCMED (1, '', '', '', '', '')";
			break;
		case "pobla":
			$provincia = safe($conex, $_GET['provincia']);
			$sql = "CALL sp_iCMED (2, ".$provincia.", '', '', '', '')";
			break;
		case "espec":
			$provincia = safe($conex, $_GET['provincia']);
			$poblacion = safe($conex, $_GET['poblacion']);
			$sql = "CALL sp_iCMED (3, ".$provincia.", ".$poblacion.", '', '', '')";
			break;
		case "asegurados":
			$nombre = safe($conex, $_GET['nombre']);
			$apellido1 = safe($conex, $_GET['apellido1']);
			$apellido2 = safe($conex, $_GET['apellido2']);
			$NIF = safe($conex, $_GET['NIF']);
			$tarjeta = safe($conex, $_GET['tarjeta']);
			$sql = "CALL sp_iCMED (10, '".$nombre."', '".$apellido1."', '".$apellido2.
				"', '".$NIF."', '".$tarjeta."')";
			break;
		case "medicos":
			$provincia = safe($conex, $_GET['provincia']);
			$poblacion = safe($conex, $_GET['poblacion']);
			$especialidad = safe($conex, $_GET['especialidad']);
			$sql = "CALL sp_iCMED (40, ".$provincia.", ".$poblacion.", ".$especialidad.
				", '', '')";
			break;
	}
	
	//Consulta a base de datos
	$rs = mysqli_query($conex, $sql);
	
	//
	while($row = mysqli_fetch_assoc($rs)) {
		$result[] = $row;
	}
	
	// Devuelve los resultados codificados con JSON
	echo '{"datos":'.json_encode($result).'}';
	
	/* cerrar la conexión */
    mysqli_close($conex);
?>