//
//  BuscarAseguradoController.m
//  iCMED
//
//  Created by Jose Mariano Garcia Luengo on 01/03/13.
//  Copyright (c) 2013 Jose Mariano Garcia Luengo. All rights reserved.
//
#import "BuscarAseguradoController.h"
#import "OpcionesController.h"
#import "Comun.h"

@interface BuscarAseguradoController ()

@end

@implementation BuscarAseguradoController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }
    return self;
}

- (void)viewDidLoad
{
    @try {
        [super viewDidLoad];
        
        [[self nameText] setText:@""];
        [[self last1Text] setText:@""];
        [[self last2Text] setText:@""];
        [[self cardText] setText:@""];
        [[self nifText] setText:@""];
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarAseguradoController.viewDidLoad: %@", e);
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

- (void)alertView:(UIAlertView *)alerta clickedButtonAtIndex:(NSInteger)buttonIndex
{
    @try {
        NSString *title = [alerta buttonTitleAtIndex:buttonIndex];
        
        if([title isEqualToString:@"SI"]) {
            [self performSegueWithIdentifier:[NSString stringWithFormat:@"%s", "CerrarSesion"] sender:self];
        } else if([title isEqualToString:@"VOLVER"]) {
            [self performSegueWithIdentifier:[NSString stringWithFormat:@"%s", "VolverDesdeAsegurado"] sender:self];
        }
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarAseguradoController.alertView.clickedButtonAtIndex: %@", e);
    }
}

- (void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender{
    @try {
        if ([[segue identifier] isEqualToString:@"BackSearchAseg"]) {
            OpcionesController *nextView = [segue destinationViewController];
            [nextView setUserCode:[self userCode]];
            [nextView setUserType:[self userType ]];
        }
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarAseguradoController.prepareForSegue: %@", e);
    }
}

- (IBAction)exitClick:(id)sender {
    @try {
        UIAlertView *alert = [[UIAlertView alloc]
                              initWithTitle:[NSString stringWithFormat:@"Atención:"]
                              message:[NSString stringWithFormat:@"¿Seguro que quiere abandonar la sesión?."]
                              delegate:self
                              cancelButtonTitle:@"SI"
                              otherButtonTitles:@"NO", nil];
        [alert show];
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarAseguradoController.exitClick: %@", e);
    }
}

- (IBAction)nameEditEnd:(id)sender {
    [[self nameText] resignFirstResponder];
}

- (IBAction)last1EditEnd:(id)sender {
    [[self last1Text] resignFirstResponder];
}

- (IBAction)last2EditEnd:(id)sender {
    [[self last2Text] resignFirstResponder];
}

- (IBAction)cardEditEnd:(id)sender {
    [[self cardText] resignFirstResponder];
}

- (IBAction)nifEditEnd:(id)sender {
    [[self nifText] resignFirstResponder];
}

- (IBAction)searchClick:(id)sender {
    @try {
        NSArray*            asegArray;
        NSURL*              url;
        NSData*             urlData;
        NSDictionary*       dict;
        NSString*           web;
        
        NSMutableString*    name;
        NSMutableString*    last1;
        NSMutableString*    last2;
        NSString*           nif         = @"";
        NSString*           card        = @"";
        NSString*           address     = @"";
        NSString*           cp          = @"";
        NSString*           city        = @"";
        NSString*           state       = @"";
        
        [self hideKeyboard];
        
        if ([[self nameText].text isEqualToString:@""] && [[self last1Text].text isEqualToString:@""] && [[self last2Text].text isEqualToString:@""] && [[self nifText].text isEqualToString:@""] && [[self cardText].text isEqualToString:@""] ) {
            
            [Comun showAlert:@"Por favor, introduzca al menos un dato y realice de nuevo la consulta."];
        } else {
            web = [NSString stringWithFormat:@"%@%s%@%s%@%s%@%s%@%s%@",WEB_TFC, "asegurados&nombre=", [self nameText].text, "&apellido1=", [self last1Text].text, "&apellido2=", [self last2Text].text, "&NIF=", [self nifText].text, "&tarjeta=", [self cardText].text];
            
            web = [web stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
            
            url = [NSURL URLWithString:web];
            
            urlData = [NSData dataWithContentsOfURL:url];
            
            if (urlData.length > 0) {
                
                NSError * err_json = nil;
                
                dict = [NSJSONSerialization JSONObjectWithData:urlData options:kNilOptions error:&err_json];
                
                asegArray = [dict objectForKey:@"datos"];
                
                if(asegArray.count == 1){
                    name = [NSString stringWithFormat:@"%@",[[asegArray objectAtIndex:0] objectForKey:@"nombre"]];
                    last1 = [NSString stringWithFormat:@"%@",[[asegArray objectAtIndex:0] objectForKey:@"apellido1"]];
                    last2 = [NSString stringWithFormat:@"%@",[[asegArray objectAtIndex:0] objectForKey:@"apellido2"]];
                    nif = [NSString stringWithFormat:@"%@",[[asegArray objectAtIndex:0] objectForKey:@"nif"]];
                    card = [NSString stringWithFormat:@"%@",[[asegArray objectAtIndex:0] objectForKey:@"tarjeta"]];
                    address = [NSString stringWithFormat:@"%@",[[asegArray objectAtIndex:0] objectForKey:@"domicilio"]];
                    cp = [NSString stringWithFormat:@"%@",[[asegArray objectAtIndex:0] objectForKey:@"cod_postal"]];
                    city = [NSString stringWithFormat:@"%@",[[asegArray objectAtIndex:0] objectForKey:@"poblacion"]];
                    state = [NSString stringWithFormat:@"%@",[[asegArray objectAtIndex:0] objectForKey:@"provincia"]];
                    
                    [Comun showAlert:[NSString stringWithFormat:@"%@ %@ %@\n%@\n%@ %@\n%@", name, last1, last2, address, cp, city, state] withTitle:@"Asegurado encontrado:" andButton:@"VOLVER"];
                } else if (asegArray.count > 1) {
                    [Comun showAlert:@"Por favor, revise los datos y realice de nuevo la consulta." withTitle:@"Hay más de un asegurado con los criterios utilizados:" andButton:@"ACEPTAR"];
                } else if (asegArray.count == 0) {
                    [Comun showAlert:@"Por favor, revise los datos y realice de nuevo la consulta." withTitle:@"Asegurado NO encontrado:" andButton:@"ACEPTAR"];
                }
            }
        }
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarAseguradoController.searchClick: %@", e);
    }    
}

-(IBAction) hideKeyboard {
    
}

@end
