
//
//  BuscarMedicoController.m
//  iCMED
//
//  Created by Jose on 01/03/13.
//  Copyright (c) 2013 Jose Mariano Garcia Luengo. All rights reserved.
//
#import "BuscarMedicoController.h"
#import "MedicosController.h"
#import "OpcionesController.h"
#import "Comun.h"

@interface BuscarMedicoController ()

@end

@implementation BuscarMedicoController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }
    
    return self;
}

- (void)viewDidLoad
{
    @try {
        [super viewDidLoad];
        
        [self stateText].enabled = true;
        [self cityText].enabled = false;
        [self especText].enabled = false;
        
        [self searchButton].enabled = false;
        
        [self setStateArray:[[NSArray alloc] init]];
        [self setCityArray:[[NSArray alloc] init]];
        
        [self setWeb:[NSString stringWithFormat:@"%@%s",WEB_TFC, "provi"]];
        [self setUrl:[NSURL URLWithString:[self web]]];
        
        [self setUrlData:[NSData dataWithContentsOfURL:[self url]]];
        
        [self setError:nil];
        
        [self setDict:[NSJSONSerialization JSONObjectWithData:[self urlData] options:kNilOptions error:[self error]]];
        
        [self setStateArray:[[self dict] objectForKey:@"datos"]];
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarMedicosController.viewDidLoad: %@", e);
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)proviPicker;
{
    return 1;
}

- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component
{
    @try {
        if([pickerView isEqual:statePicker]) {
            [self stateText].text = [[[self stateArray] objectAtIndex:row] objectForKey:@"provincia"];
            [self setState:[[[[self stateArray] objectAtIndex:row] objectForKey:@"cod_provincia"] intValue]];
            
            statePicker.hidden = true;
            
            [self cityText].enabled = true;
            [self especText ].enabled = false;
            
            [self cityText].text = @"Elige ahora una población...";
            
            [self setCityArray:[[NSArray alloc] init]];
            
            [self setWeb:[NSString stringWithFormat:@"%@%s%d",WEB_TFC, "pobla&provincia=", [self state]]];
            
            [self setUrl:[NSURL URLWithString:[self web]]];
            
            [self setUrlData:[NSData dataWithContentsOfURL:[self url]]];
            
            [self setError:nil];
            
            [self setDict:[NSJSONSerialization JSONObjectWithData:[self urlData] options:kNilOptions error:[self error]]];
            
            [self setCityArray:[[self dict] objectForKey:@"datos"]];
            
            (void)cityPicker.reloadAllComponents;
            
        } else if ([pickerView isEqual:cityPicker]) {
            [[self cityText] setText:[[[self cityArray] objectAtIndex:row] objectForKey:@"poblacion"]];
            [self setCity:[[[[self cityArray] objectAtIndex:row] objectForKey:@"cod_poblacion"] intValue]];
            
            cityPicker.hidden = true;
            [self especText].enabled = true;
            
            [self setEspecArray:[[NSArray alloc] init]];
            
            [self setWeb:[NSString stringWithFormat:@"%@%s%d%s%d", WEB_TFC, "espec&provincia=",  [self state], "&poblacion=", [self city]]];
            
            [self setUrl:[NSURL URLWithString:[self web]]];
            
            [self setUrlData:[NSData dataWithContentsOfURL:[self url]]];
            
            [self setError:nil];
            
            [self setDict:[NSJSONSerialization JSONObjectWithData:[self urlData] options:kNilOptions error:[self error]]];
            
            [self setEspecArray:[[self dict] objectForKey:@"datos"]];
            
            (void)especPicker.reloadAllComponents;
            
            [[self especText] setText:@"Elige ahora una especialidad..."];
        } else if ([pickerView isEqual:especPicker]) {
            [[self especText] setText:[[[self especArray] objectAtIndex:row] objectForKey:@"especialidad"]];
            [self setEspec:[[[[self especArray] objectAtIndex:row] objectForKey:@"cod_especialidad"] intValue]];
            
            especPicker.hidden = true;
            [self searchButton].enabled = true;
        }
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarMedicosController.pickerView.didSelectRow: %@", e);
    }
}


- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component;
{
    @try {
        NSInteger filas = 0;
        
        if ([pickerView isEqual:statePicker]) {
            filas = [[self stateArray] count];
        } else if ([pickerView isEqual:cityPicker]) {
            filas = [[self cityArray] count];
        } else if ([pickerView isEqual:especPicker]) {
            filas = [[self especArray] count];
        }
        
        return filas;
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarMedicosController.pickerView.numberOfRowsInComponent: %@", e);
    }
}

- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component;
{
    @try {
        NSString *seleccion = @"";
        
        if([pickerView isEqual:statePicker]) {
            seleccion = [NSString stringWithFormat:@"%@",[[[self stateArray] objectAtIndex:row] objectForKey:@"provincia"]];
        } else if([pickerView isEqual:cityPicker]) {
            seleccion = [NSString stringWithFormat:@"%@",[[[self cityArray] objectAtIndex:row] objectForKey:@"poblacion"]];
        } else if([pickerView isEqual:especPicker]) {
            seleccion = [NSString stringWithFormat:@"%@",[[[self especArray] objectAtIndex:row] objectForKey:@"especialidad"]];
        }
        
        return seleccion;
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarMedicosController.pickerView.titleForRow: %@", e);
    }
}

- (IBAction)stateTextClick:(id)sender {
    @try {
        [[self stateText] resignFirstResponder];
        statePicker.hidden = false;
        cityPicker.hidden = true;
        especPicker.hidden = true;
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarMedicosController.stateTextClick: %@", e);
    }
}

- (IBAction)stateTextEditBegin:(id)sender {
    [[self stateText] resignFirstResponder];
}


- (IBAction)cityTextClick:(id)sender {
    @try {
        [[self cityText] resignFirstResponder];
        cityPicker.hidden = false;
        statePicker.hidden = true;
        especPicker.hidden = true;
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarMedicosController.cityTextClick: %@", e);
    }
}

- (IBAction)cityTextEditBegin:(id)sender {
    [[self cityText] resignFirstResponder];
}

- (IBAction)especTextClick:(id)sender {
    @try {
        [[self especText] resignFirstResponder];
        especPicker.hidden = false;
        statePicker.hidden = true;
        cityPicker.hidden = true;
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarMedicosController.especTextClick: %@", e);
    }
}

- (IBAction)especTextEditBegin:(id)sender {
    [[self especText] resignFirstResponder];
}

- (void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender{
    @try {
        if ([[segue identifier] isEqualToString:@"PasarDatos"]) {
            MedicosController *nextView = [segue destinationViewController];
            [nextView setState:[self state]];
            [nextView setCity:[self city]];
            [nextView setEspec:[self espec]];
            [nextView setUserType:[self userType]];
            [nextView setUserCode:[self userCode]];
        } else if ([[segue identifier] isEqualToString:@"BackSearchMed"]) {
            OpcionesController *nextView = [segue destinationViewController];
            [nextView setUserCode:[self userCode]];
            [nextView setUserType:[self userType]];            
        }
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarMedicosController.prepareForSegue: %@", e);
    }
}

- (void)alertView:(UIAlertView *)alerta clickedButtonAtIndex:(NSInteger)buttonIndex
{
    @try {
        NSString *title = [alerta buttonTitleAtIndex:buttonIndex];
        
        if([title isEqualToString:@"SI"])
        {
            [self performSegueWithIdentifier:[NSString stringWithFormat:@"%s", "CerrarSesion"] sender:self];
        }
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarMedicosController.alertView.clickedButtonAtIndex: %@", e);
    }
}

- (IBAction)exitButtonClick:(id)sender {
    @try {
        UIAlertView *alert = [[UIAlertView alloc]
                              initWithTitle:[NSString stringWithFormat:@"Atención:"]
                              message:[NSString stringWithFormat:@"¿Seguro que quiere abandonar la sesión?."]
                              delegate:self
                              cancelButtonTitle:@"SI"
                              otherButtonTitles:@"NO", nil];
        [alert show];
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en BuscarMedicosController.exitButtonClick: %@", e);
    }
}

@end
