//
//  CambiarClaveController.m
//  iCMED
//
//  Created by Jose Mariano Garcia Luengo on 01/03/13.
//  Copyright (c) 2013 Jose Mariano Garcia Luengo. All rights reserved.
//
#import "CambiarClaveController.h"
#import "OpcionesController.h"
#import "Comun.h"

@interface CambiarClaveController ()

@end

@implementation CambiarClaveController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

- (IBAction)okButtonClick:(id)sender {
    @try {
        NSURL*              url;
        NSString*           web;
        NSData*             urlData;
        NSString*           e;
        
        e = [self changeUserPwd:[self userCode] pwd:[self pwdText].text newPwd:[self theNewPwdText].text newPwdRep:[self theNewPwdRepText].text];
        
        if(![e isEqualToString:@""]) {
            [Comun showAlert:e];
        }
        else {
            web = [NSString stringWithFormat:@"%@%s%d%s%@",WEB_TFC, "chgpwd&usuario=", [self userCode],"&clave=", [Comun md5:[NSString stringWithFormat:@"%@", [self theNewPwdText].text]]];
            url = [NSURL URLWithString:web];
            urlData = [NSData dataWithContentsOfURL:url];
            
            [Comun showAlert:@"Clave cambiada correctamente." withTitle:@"INFORMACIÓN" andButton:@"Aceptar"];
            
            [self performSegueWithIdentifier:[NSString stringWithFormat:@"%s", "BackChangePwd"] sender:self];
        }
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en CambiarClaveController.okButtonClick: %@", e);
    }
}

-(NSString *) changeUserPwd:(NSInteger) userCode pwd:(NSString *)thePwd newPwd:(NSString *)theNewPwd newPwdRep:(NSString *)theNewPwdRep {
    @try {
        NSString*           error   = @"";
        NSArray*            userArray;
        NSURL*              url;
        NSData*             urlData;
        NSDictionary*       dict;
        NSString*           web;
        
        if ([thePwd isEqual: @""]) {
            error = @"Falta la clave actual.";
        }
        else if ([theNewPwd isEqual: @""]) {
            error = @"Falta la clave nueva.";
        }
        else if ([theNewPwdRep isEqual: @""]) {
            error = @"Falta repetir la clave nueva.";
        }
        else if (![theNewPwd isEqual: theNewPwdRep]) {
            error = @"Las claves nuevas no coinciden.";
        }
        else {
            web = [NSString stringWithFormat:@"%@%s%d",WEB_TFC, "getpwd&usuario=", userCode];
            url = [NSURL URLWithString:web];
            
            urlData = [NSData dataWithContentsOfURL:url];
            
            [self setError:nil];
            
            dict = [NSJSONSerialization JSONObjectWithData:urlData options:kNilOptions error:[self error]];
            
            userArray = [dict objectForKey:@"datos"];
            
            if (userArray.count !=0) {
                if (![[Comun md5:[NSString stringWithFormat:@"%@", thePwd]] isEqual:[NSString stringWithFormat:@"%@",[[userArray objectAtIndex:0] objectForKey:@"clave"]]])
                    error = @"La clave actual tecleada es incorrecta.";
            }
            else
                error = @"No existe ningun registro con los datos introducidos.";
        }
        
        return error;
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en CambiarClaveController.changeUserPwd: %@", e);
    }
}

-(void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender{
    @try {
        if ([[segue identifier] isEqualToString:@"BackChangePwd"]) {
            OpcionesController *nextView = [segue destinationViewController];
            [nextView setUserCode:[self userCode]];
            [nextView setUserType:[self userType]];
        }
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en CambiarClaveController.prepareForSegue: %@", e);
    }
}

- (IBAction)hideKeyboard:(id)sender {
    
}

- (IBAction)hideKeyboardPwdRep:(id)sender {
    [self okButtonClick:self];
}

- (void)alertView:(UIAlertView *)alerta clickedButtonAtIndex:(NSInteger)buttonIndex
{
    @try {
        NSString *title = [alerta buttonTitleAtIndex:buttonIndex];
        
        if([title isEqualToString:@"SI"])
        {
            [self performSegueWithIdentifier:[NSString stringWithFormat:@"%s", "CerrarSesion"] sender:self];
        }
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en CambiarClaveController.alertView.clickedButtonAtIndex: %@", e);
    }
}

- (IBAction)exitClick:(id)sender {
    @try {
        UIAlertView *alert = [[UIAlertView alloc]
                              initWithTitle:[NSString stringWithFormat:@"Atención:"]
                              message:[NSString stringWithFormat:@"¿Seguro que quiere abandonar la sesión?."]
                              delegate:self
                              cancelButtonTitle:@"SI"
                              otherButtonTitles:@"NO", nil];
        [alert show];
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en CambiarClaveController.exitClicke: %@", e);
    }
}

@end
