//
//  GPSController.h
//  iCMED
//
//  Created by Jose Mariano Garcia Luengo on 01/03/13.
//  Copyright (c) 2013 Jose Mariano Garcia Luengo. All rights reserved.
//
#import <UIKit/UIKit.h>
#import <MapKit/MapKit.h>

@interface GPSController : UIViewController <MKMapViewDelegate,CLLocationManagerDelegate> 

@property (nonatomic,strong)    CLGeocoder*         geocoder;
@property (nonatomic,strong)    CLLocationManager*  locationManager;


@property (nonatomic,strong)    NSString*           name;
@property (nonatomic,strong)    NSString*           coordinates;


@property (nonatomic)           NSInteger           userCode;
@property (nonatomic)           NSInteger           userType;

@property (nonatomic,strong)    NSString*           url;
@property (nonatomic,strong)    NSData*             urlData;

@property (nonatomic, strong)   MKPolyline*         routeLine;
@property (nonatomic, strong)   MKPolylineView*     routeLineView;
@property (nonatomic)           MKMapRect           routeRect;

@property (nonatomic, strong)   MKPolyline*         walkingRouteLine;
@property (nonatomic, strong)   MKPolyline*         drivingRouteLine;

@property (nonatomic)           MKMapRect           walkingRouteRect;
@property (nonatomic)           MKMapRect           drivingRouteRect;

@property (nonatomic, strong)   NSString*           fullName;
@property (nonatomic, strong)   NSString*           destination;
@property (nonatomic, strong)   NSString*           address;
@property (nonatomic, strong)   NSString*           phone;
@property (nonatomic, strong)   NSString*           especDescription;

@property (nonatomic)           NSInteger           state;
@property (nonatomic)           NSInteger           city;
@property (nonatomic)           NSInteger           espec;

@property (nonatomic, strong)   NSString*           position;

@property (nonatomic)           float               lat;
@property (nonatomic)           float               lon;

@property (strong, nonatomic)   IBOutlet MKMapView* map;

@property (strong, nonatomic)   IBOutlet UIButton*  walkingButton;
@property (strong, nonatomic)   IBOutlet UIButton*  drivingButton;

@end
