//
//  InicioController.m
//  iCMED
//
//  Created by Jose Mariano Garcia Luengo on 01/03/13.
//  Copyright (c) 2013 Jose Mariano Garcia Luengo. All rights reserved.
//
#import "InicioController.h"
#import "OpcionesController.h"
#import "Comun.h"

@interface InicioController ()

@end

@implementation InicioController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];

    @try {
        [[self userText] setText:@""];
        [[self pwdText] setText:@""];
        
        [self setUser:@""];
        [self setPwd:@""];
        
        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
        [defaults registerDefaults:[NSDictionary dictionaryWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"UserDefault" ofType:@"plist"]]];
        [[self userText] setText:[defaults objectForKey:@"USUARIO"]];
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en InicioController.viewDidLoad: %@", e);
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

- (IBAction)userTextClick:(id)sender {
    
}

- (IBAction)userTextEditEnd:(id)sender {
    [[self userText] resignFirstResponder];
    
    [[self pwdText] setText:@""];
}

- (IBAction)pwdTextClick:(id)sender {
    
}

- (IBAction) pwdTextEditEnd:(id)sender {
    [[self pwdText] resignFirstResponder];
}

- (IBAction) initSessionButtonClick:(id)sender {
    @try {
        [self setUserDefError:@""];
        
        [self setUser:[self userText].text];
        [self setPwd:[self pwdText].text];
        
        if ([[self user] isEqualToString:@""] || [self user] == nil) {
            [self setUserDefError:@"Falta el nombre de usuario."];
            [Comun showAlert:[self userDefError] withTitle:@"ERROR" andButton:@"Aceptar"];
        }
        else if ([[self pwd] isEqualToString:@""] || [self pwd] == nil) {
            [self setUserDefError:@"Falta la clave."];
            [Comun showAlert:[self userDefError] withTitle:@"ERROR" andButton:@"Aceptar"];
        }
        else {
            [self setWeb:[NSString stringWithFormat:@"%@%s%@",WEB_TFC, "usu&usuario=", [self user]]];
            [self setWeb:[[self web] stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]];
            
            [self setUrl:[NSURL URLWithString:[self web]]];
            
            [self setUrlData:[NSData dataWithContentsOfURL:[self url]]];
            
            if ([self urlData].length == 0) {
                [self setUserDefError:@"No se han recibido datos."];
                [Comun showAlert:[self userDefError] withTitle:@"ERROR" andButton:@"Aceptar"];
            } else {
                [self setError:nil];
                
                [self setDict:[NSJSONSerialization JSONObjectWithData:[self urlData] options:kNilOptions error:[self error]]];
                
                [self setUserArray:[[self dict] objectForKey:@"datos"]];
                
                if([self userArray].count != 0){
                    if (![[Comun md5:[NSString stringWithFormat:@"%@", [self pwd]]] isEqual:[NSString stringWithFormat:@"%@",[[[self userArray] objectAtIndex:0] objectForKey:@"clave"]]]) {
                        [self setUserDefError:@"Usuario y/o clave incorrectos."];
                        [Comun showAlert:[self userDefError] withTitle:@"ERROR" andButton:@"Aceptar"];
                    } else {
                        [self setUserType:[[[[self userArray] objectAtIndex:0] objectForKey:@"tipo_usuario"] intValue]];
                        [self setUserCode:[[[[self userArray] objectAtIndex:0] objectForKey:@"cod_usuario"] intValue]];
                        
                        // Escribimos el nombre de usuario en archivo plist para que aparezca por defecto
                        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
                        [defaults registerDefaults:[NSDictionary dictionaryWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"UserDefault" ofType:@"plist"]]];
                        
                        [defaults setObject:[self user] forKey:@"USUARIO"];
                        [defaults synchronize];
                        
                        [self performSegueWithIdentifier:@"Entrar" sender:self];
                    }
                } else {
                    [self setUserDefError:@"No existe el usuario tecleado."];
                    [Comun showAlert:[self userDefError] withTitle:@"ERROR" andButton:@"Aceptar"];
                }
            }
        }        
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en InicioController.initSessionButtonClick: %@", e);
    }
}

-(void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender{
    @try {
        OpcionesController *nextView = [segue destinationViewController];
        [nextView setUserType:[self userType]];
        [nextView setUserCode:[self userCode]];        
    }
    @catch (NSException *e) {
        NSLog(@"Excepción en InicioController.prepareForSegue: %@", e);
    }
}


- (IBAction)hideKeybPwd:(id)sender {
    [self initSessionButtonClick:self];
}

- (IBAction)hideKeybUser:(id)sender {
}

@end
