//
//  OpcionesController.m
//  iCMED
//
//  Created by Jose Mariano Garcia Luengo on 01/03/13.
//  Copyright (c) 2013 Jose Mariano Garcia Luengo. All rights reserved.
//
#import "OptionsController.h"
#import "CambiarClaveController.h"
#import "BuscarMedicoController.h"
#import "BuscarAseguradoController.h"
#import "Comun.h"

@interface OptionsController ()

@end


@implementation OptionsController

- (id) initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }
    return self;
}

- (void) viewDidLoad
{
    [super viewDidLoad];
    
    [self setWeb:[NSString stringWithFormat:@"%@%s%d",WEB_TFC, "opc&tipo_usuario=", [self userType]]];
    [self setWeb:[[self web] stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]];
    
    [self setUrl:[NSURL URLWithString:[self web]]];
    
    [self setUrlData:[NSData dataWithContentsOfURL:[self url]]];

    if ([self urlData].length == 0) {
        [Comun showAlert:@"No se han recibido datos."];
    } else {
        _arrayOptions = [[NSArray alloc] init];
        
        NSError * err_json = nil;
    
        [self setDict:[NSJSONSerialization JSONObjectWithData:[self urlData] options:kNilOptions error:&err_json]];
    
        [self setArrayOptions:[[self dict] objectForKey:@"datos"]];
    
        if([self arrayOptions].count == 0)
            [Comun showAlert:[NSString stringWithFormat:@"%s", "No hay opciones definidas para el usuario."]];
    }
}

- (void) didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

#pragma mark - Table view data source

- (NSInteger) numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return [[self arrayOptions] count];
}

- (UITableViewCell *) tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Celda";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    // Configure the cell...
    NSDictionary *dic = [[self arrayOptions] objectAtIndex:indexPath.row];
	
	cell.textLabel.text = [NSString stringWithFormat:@"%@",[dic objectForKey:@"opcion"]] ;
	cell.detailTextLabel.text = [NSString stringWithFormat:@"%@", [dic objectForKey:@"segue"]];
    
    return cell;
}

#pragma mark - Table view delegate

- (void) tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSDictionary *dic = [[self arrayOptions] objectAtIndex:indexPath.row];
    [self performSegueWithIdentifier:[NSString stringWithFormat:@"%@", [dic objectForKey:@"segue"]] sender:self];
}

- (void) alertView:(UIAlertView *)alerta clickedButtonAtIndex:(NSInteger)buttonIndex
{
    NSString *title = [alerta buttonTitleAtIndex:buttonIndex];
    
    if([title isEqualToString:@"SI"])
    {
        [self performSegueWithIdentifier:[NSString stringWithFormat:@"%s", "CerrarSesion"] sender:self];
    }
}

- (void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender{
    if ([[segue identifier] isEqualToString:@"CambiarClave"]) {
        CambiarClaveController *nextView = [segue destinationViewController];
        [nextView setUserCode:[self userCode]];
        [nextView setUserType:[self userType]];
    } else if ([[segue identifier] isEqualToString:@"BuscarMedico"]) {
        BuscarMedicoController *nextView = [segue destinationViewController];
        [nextView setUserCode:[self userCode]];
        [nextView setUserType:[self userType]];
    } else if ([[segue identifier] isEqualToString:@"BuscarAsegurado"]) {
        BuscarAseguradoController *nextView = [segue destinationViewController];
        [nextView setUserCode:[self userCode]];
        [nextView setUserType:[self userType]];
    }
}

- (IBAction) exitClick:(id)sender {
    UIAlertView *alert = [[UIAlertView alloc]
                          initWithTitle:[NSString stringWithFormat:@"Atención:"]
                          message:[NSString stringWithFormat:@"¿Seguro que quiere abandonar la sesión?"]
                          delegate:self
                          cancelButtonTitle:@"SI"
                          otherButtonTitles:@"NO", nil];
    [alert show];
}

@end
