//
//  StartupController.m
//  iCMED
//
//  Created by Jose Mariano Garcia Luengo on 01/03/13.
//  Copyright (c) 2013 Jose Mariano Garcia Luengo. All rights reserved.
//
#import "StartupController.h"
#import "OptionsController.h"
#import "Comun.h"

@interface StartupController ()

@end

@implementation StartupController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];

    [[self userText] setText:@""];
    [[self pwdText] setText:@""];
    
    [self setUser:@""];
    [self setPwd:@""];
    
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    [defaults registerDefaults:[NSDictionary dictionaryWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"UserDefault" ofType:@"plist"]]];
    [[self userText] setText:[defaults objectForKey:@"USUARIO"]];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

- (IBAction)userTextClick:(id)sender {
    
}

- (IBAction)userTextEditEnd:(id)sender {
    [[self userText] resignFirstResponder];
    
    [[self pwdText] setText:@""];
}

- (IBAction)pwdTextClick:(id)sender {
    
}

- (IBAction)pwdTextEditEnd:(id)sender {
    [[self pwdText] resignFirstResponder];
}

- (IBAction)initSessionButtonClick:(id)sender {
    [self setUser:[self userText].text];
    [self setPwd:[self pwdText].text];
    
    if ([[self user] isEqual: @""]) {
        [Comun showAlert:@"Falta el nombre de usuario." withTitle:@"ERROR" andButton:@"Aceptar"];
    }
    else if ([[self pwd] isEqual: @""]) {
        [Comun showAlert:@"Falta la clave." withTitle:@"ERROR" andButton:@"Aceptar"];
    }
    else {
        w = [NSString stringWithFormat:@"%@%s%@",WEB_TFC, "usu&usuario=", [self user]];
        w = [w stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];

        url = [NSURL URLWithString:w];
        
        urlData = [NSData dataWithContentsOfURL:url];
        
        if (urlData.length == 0) {
            [Comun showAlert:@"No se han recibido datos." withTitle:@"ERROR" andButton:@"Aceptar"];
        } else {
            NSError * err_json = nil;
            
            dict = [NSJSONSerialization JSONObjectWithData:urlData options:kNilOptions error:&err_json];
            
            arrayUsu = [dict objectForKey:@"datos"];
            
            if(arrayUsu.count != 0){
                if (![[Comun md5:[NSString stringWithFormat:@"%@", [self pwd]]] isEqual:[NSString stringWithFormat:@"%@",[[arrayUsu objectAtIndex:0] objectForKey:@"clave"]]]) {
                    [Comun showAlert:@"Usuario y/o clave incorrectos." withTitle:@"ERROR" andButton:@"Aceptar"];
                } else {
                    [self setUserType:[[[arrayUsu objectAtIndex:0] objectForKey:@"tipo_usuario"] intValue]];
                    [self setUserCode:[[[arrayUsu objectAtIndex:0] objectForKey:@"cod_usuario"] intValue]];
                    
                    // Escribimos el nombre de usuario en archivo plist para que aparezca por defecto
                    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
                    [defaults registerDefaults:[NSDictionary dictionaryWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"UserDefault" ofType:@"plist"]]];
                    
                    [defaults setObject:[self user] forKey:@"USUARIO"];
                    [defaults synchronize];
                    
                    [self performSegueWithIdentifier:@"Entrar" sender:self];
                }
            } else
                [Comun showAlert:@"No existe el usuario tecleado." withTitle:@"ERROR" andButton:@"Aceptar"];
        } 
    }
}

-(void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender{
    OptionsController *nextView = [segue destinationViewController];
    [nextView setUserType:[self userType]];
    [nextView setUserCode:[self userCode]];
}


- (IBAction)hideKeybPwd:(id)sender {
    [self initSessionButtonClick:self];
}

- (IBAction)hideKeybUser:(id)sender {

}

@end
