//
//  iCMEDApplicationTests.m
//  iCMEDApplicationTests
//
//  Created by Jose Mariano Garcia Luengo on 07/06/13.
//  Copyright (c) 2013 Jose Mariano Garcia Luengo. All rights reserved.
//

#import "iCMEDApplicationTests.h"

@implementation iCMEDApplicationTests

- (void)setUp
{
    [super setUp];
    
    appDelegate = [[UIApplication sharedApplication] delegate];
    inicioController = (InicioController*) appDelegate.window.rootViewController;
    view = inicioController.view;
}

- (void)tearDown
{
    [super tearDown];
}

- (void)testApplicationDelegate {
    
    STAssertTrue([appDelegate isMemberOfClass:[AppDelegate class]], @"bad UIApplication delegate");
    
    STAssertTrue([inicioController isMemberOfClass:[InicioController class]], @"bad inicioController");
}

- (void) testLogin {
    NSLog(@"%@ start", self.name);
    
    // Test 1: Usuario y clave vacios.
    [[inicioController userText] setText:@""];
    [[inicioController pwdText] setText:@""];
    
    [inicioController initSessionButtonClick:self];
    
    STAssertTrue([[inicioController userDefError] isEqualToString:@"Falta el nombre de usuario."], @"Test 1: Fallo con usuario y clave vacios.");
    
    // Test 2: Usuario introducido y clave vacia.
    [[inicioController userText] setText:@"usuario"];
    [[inicioController pwdText] setText:@""];
    
    [inicioController initSessionButtonClick:self];
    
    STAssertTrue([[inicioController userDefError] isEqualToString:@"Falta la clave."], @"Test 2: Fallo con usuario introducido y clave vacia.");
    
    // Test 3: Usuario vacio y clave introducida.
    [[inicioController userText] setText:@""];
    [[inicioController pwdText] setText:@"clave"];
    
    [inicioController initSessionButtonClick:self];
    
    STAssertTrue([[inicioController userDefError] isEqualToString:@"Falta el nombre de usuario."], @"Test 3: Fallo con usuario vacio y clave introducida.");
    
    // Test 4: Usuario y clave introducidos pero no correctos.
    [[inicioController userText] setText:@"usuario"];
    [[inicioController pwdText] setText:@"clave"];
    
    [inicioController initSessionButtonClick:self];
    
    STAssertTrue([[inicioController userDefError] isEqualToString:@"No existe el usuario tecleado."], @"Test 4: Fallo con usuario y clave introducidos pero no correctos.");
    
    // Test 5: Usuario introducido y existente pero clave introducida pero no correcta.
    [[inicioController userText] setText:@"jgarcialue"];
    [[inicioController pwdText] setText:@"clave"];
    
    [inicioController initSessionButtonClick:self];
    
    STAssertTrue([[inicioController userDefError] isEqualToString:@"Usuario y/o clave incorrectos."], @"Test 5: Fallo con usuario y clave introducidos pero clave no correcta.");
    
    // Test 6: Usuario y clave introducidos y correctos.
    [[inicioController userText] setText:@"jgarcialue"];
    [[inicioController pwdText] setText:@"1234"];
    
    [inicioController initSessionButtonClick:self];
    
    STAssertTrue([inicioController userCode] == 1, @"Test 6: Fallo validacion usuario (codigo devuelto incorrecto).");
    
    NSLog(@"%@ end", self.name);
}

@end
