CREATE DATABASE  IF NOT EXISTS `icmed_db` /*!40100 DEFAULT CHARACTER SET utf8 */;
USE `iCMED_db`;
-- MySQL dump 10.13  Distrib 5.5.24, for osx10.5 (i386)
--
-- Host: localhost    Database: iCMED_db
-- ------------------------------------------------------
-- Server version	5.5.30

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `domicilios`
--

DROP TABLE IF EXISTS `domicilios`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `domicilios` (
  `cod_domicilio` int(11) NOT NULL,
  `tipo_via` tinyint(4) NOT NULL,
  `via` varchar(50) NOT NULL,
  `num_via` varchar(10) NOT NULL,
  `piso` varchar(5) DEFAULT NULL,
  `escalera` varchar(5) DEFAULT NULL,
  `puerta` varchar(5) DEFAULT NULL,
  `cod_postal` int(11) NOT NULL,
  `cod_provincia` int(11) NOT NULL,
  `cod_poblacion` int(11) NOT NULL,
  PRIMARY KEY (`cod_domicilio`),
  KEY `poblaciones_cod_poblacion_fk` (`cod_provincia`,`cod_poblacion`),
  KEY `tipos_vias_cod_tipo_fk` (`tipo_via`),
  CONSTRAINT `poblaciones_cod_poblacion_fk` FOREIGN KEY (`cod_provincia`, `cod_poblacion`) REFERENCES `poblaciones` (`cod_provincia`, `cod_poblacion`),
  CONSTRAINT `tipos_vias_cod_tipo_fk` FOREIGN KEY (`tipo_via`) REFERENCES `tipos_vias` (`cod_tipo`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `domicilios`
--

LOCK TABLES `domicilios` WRITE;
/*!40000 ALTER TABLE `domicilios` DISABLE KEYS */;
INSERT INTO `domicilios` VALUES (1,1,'DEL PRADO','26','2','INT','IZD',28014,650,62172),(2,2,'SANGENJO','17','1',NULL,'D',28034,650,62172),(3,1,'DE LA CASTELLANA','81','8',NULL,'A',28023,650,62172),(4,2,'SAN AGUSTIN','3','2','EXT','IZQ',28014,650,62172),(5,2,'GRAN VÍA','10','BAJO','','',28220,650,62173),(6,2,'VALLE DE IZALCO','30','CASA',NULL,NULL,28669,650,62098),(7,1,'DE GRACIA','53','1',NULL,'D',8080,648,61405);
/*!40000 ALTER TABLE `domicilios` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `especialidades`
--

DROP TABLE IF EXISTS `especialidades`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `especialidades` (
  `cod_especialidad` int(11) NOT NULL AUTO_INCREMENT,
  `especialidad` varchar(40) NOT NULL,
  PRIMARY KEY (`cod_especialidad`)
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `especialidades`
--

LOCK TABLES `especialidades` WRITE;
/*!40000 ALTER TABLE `especialidades` DISABLE KEYS */;
INSERT INTO `especialidades` VALUES (1,'ALERGOLOGIA'),(2,'AMBULANCIAS'),(3,'ANALISIS CLINICOS'),(4,'ANATOMIA PATOLOGICA'),(5,'ANGIOLOGIA Y CIRUGIA VASCULAR'),(6,'APARATO DIGESTIVO'),(7,'CIRUGIA CARDIOVASCULAR'),(8,'CIRUGIA GENERAL Y DEL APARATO DIGESTIVO'),(9,'CIRUGIA MAXILOFACIAL'),(10,'CIRUGIA PEDIATRICA'),(11,'CIRUGIA PLASTICA Y REPARADORA'),(12,'CIRUGIA TORACICA'),(13,'HOSPITALIZACION'),(14,'DERMATOLOGIA'),(15,'DIAGNOSTICO POR IMAGEN');
/*!40000 ALTER TABLE `especialidades` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `opciones_menu`
--

DROP TABLE IF EXISTS `opciones_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `opciones_menu` (
  `cod_opcion` int(11) NOT NULL,
  `opcion` varchar(45) NOT NULL,
  `segue` varchar(45) NOT NULL,
  PRIMARY KEY (`cod_opcion`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `opciones_menu`
--

LOCK TABLES `opciones_menu` WRITE;
/*!40000 ALTER TABLE `opciones_menu` DISABLE KEYS */;
INSERT INTO `opciones_menu` VALUES (1,'Buscar Servicio Médico','BuscarMedico'),(2,'Cambiar Clave','CambiarClave'),(3,'Buscar Asegurado','BuscarAsegurado');
/*!40000 ALTER TABLE `opciones_menu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `opciones_usuario`
--

DROP TABLE IF EXISTS `opciones_usuario`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `opciones_usuario` (
  `cod_tipo_usuario` tinyint(4) NOT NULL,
  `cod_opcion` int(11) NOT NULL,
  PRIMARY KEY (`cod_tipo_usuario`,`cod_opcion`),
  KEY `opciones_menu_cod_opcion_fk` (`cod_opcion`),
  CONSTRAINT `opciones_menu_cod_opcion_fk` FOREIGN KEY (`cod_opcion`) REFERENCES `opciones_menu` (`cod_opcion`),
  CONSTRAINT `tipos_usuario_cod_tipo_fk` FOREIGN KEY (`cod_tipo_usuario`) REFERENCES `tipos_usuario` (`cod_tipo`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `opciones_usuario`
--

LOCK TABLES `opciones_usuario` WRITE;
/*!40000 ALTER TABLE `opciones_usuario` DISABLE KEYS */;
INSERT INTO `opciones_usuario` VALUES (1,1),(2,1),(1,2),(2,2),(1,3);
/*!40000 ALTER TABLE `opciones_usuario` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `personas`
--

DROP TABLE IF EXISTS `personas`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `personas` (
  `cod_persona` int(11) NOT NULL,
  `cod_domicilio` int(11) NOT NULL,
  `nombre` varchar(25) NOT NULL,
  `apellido1` varchar(60) NOT NULL,
  `apellido2` varchar(25) DEFAULT NULL,
  `NIF` varchar(9) NOT NULL,
  `sexo` varchar(1) NOT NULL,
  `tratamiento` varchar(4) NOT NULL,
  `telefono` varchar(12) DEFAULT NULL,
  `email` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`cod_persona`,`cod_domicilio`),
  KEY `cod_domicilio_fk` (`cod_domicilio`),
  CONSTRAINT `cod_domicilio_fk` FOREIGN KEY (`cod_domicilio`) REFERENCES `domicilios` (`cod_domicilio`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `personas`
--

LOCK TABLES `personas` WRITE;
/*!40000 ALTER TABLE `personas` DISABLE KEYS */;
INSERT INTO `personas` VALUES (1,1,'JOSE MANUEL','GARCIA','RUIZ','1R','H','Dr.','915555000','jgarcia@correo.es'),(2,2,'DOLORES','GIL','RUIZ','2R','M','Dra.','915555100','dgil@correo.es'),(3,3,'MONICA','GARCIA','ARIAS','3R','M','Dra.','915555200','mgarcia@correo.es'),(4,4,'RAQUEL','RODRIGUEZ','MORA','4R','M','Dra.','915555300','rrodriguez@correo.es');
/*!40000 ALTER TABLE `personas` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `poblaciones`
--

DROP TABLE IF EXISTS `poblaciones`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `poblaciones` (
  `cod_provincia` int(11) NOT NULL,
  `cod_poblacion` int(11) NOT NULL,
  `poblacion` varchar(60) NOT NULL,
  PRIMARY KEY (`cod_provincia`,`cod_poblacion`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `poblaciones`
--

LOCK TABLES `poblaciones` WRITE;
/*!40000 ALTER TABLE `poblaciones` DISABLE KEYS */;
INSERT INTO `poblaciones` VALUES (609,48498,'Agaete'),(609,48499,'Agüimes'),(609,48500,'Ajuy'),(609,48501,'Aldea blanca'),(609,48502,'Ampuyenta la'),(609,48503,'Antigua'),(609,48504,'Arguineguin'),(609,48505,'Arinaga'),(609,48506,'Arrecife'),(609,48507,'Arrieta'),(609,48508,'Artenara'),(609,48509,'Arucas'),(609,48510,'Asomada la'),(609,48511,'Atalaya la'),(609,48512,'Ayacata'),(609,48513,'Bañaderos'),(609,48514,'Berrazales los'),(609,48515,'Berrugo'),(609,48516,'Betancuria'),(609,48517,'Breñas las'),(609,48518,'Caldereta'),(609,48519,'Caleta de famara'),(609,48520,'Caleta del sebo'),(609,48521,'Cardón'),(609,48522,'Cardones'),(609,48523,'Carrizal'),(609,48524,'Casas del islote'),(609,48525,'Casillas de morales'),(609,48526,'Casillas del angel'),(609,48527,'Casitas las'),(609,48528,'Castillo del romeral'),(609,48529,'Cofete'),(609,48530,'Colonia garcia escamez'),(609,48531,'Conil'),(609,48532,'Corralejo'),(609,48533,'Cotillo'),(609,48534,'Cruce de arinaga'),(609,48535,'Cruce de sardina'),(609,48536,'Cuchillo el'),(609,48537,'Charco el'),(609,48538,'Doctoral el'),(609,48539,'El oasis'),(609,48540,'Fataga'),(609,48541,'Femes'),(609,48542,'Firgas'),(609,48543,'Fontanales'),(609,48544,'Gáldar'),(609,48545,'Gando'),(609,48546,'Giniginamar'),(609,48547,'Golfo el'),(609,48548,'Gran tarajal'),(609,48549,'Guatiza'),(609,48550,'Guía'),(609,48551,'Guime'),(609,48552,'Guisguey'),(609,48553,'Haría'),(609,48554,'Ingenio'),(609,48555,'Jinamar'),(609,48556,'Juan grande'),(609,48557,'Juncal el'),(609,48558,'Juncalillo'),(609,48559,'Lajares'),(609,48560,'Lajita la'),(609,48561,'Llanos de la concepcion'),(609,48562,'Maguez'),(609,48563,'Malpaso'),(609,48564,'Marzagan'),(609,48565,'Masdache'),(609,48566,'Maspalomas'),(609,48567,'Matas Blancas'),(609,48568,'Matilla la'),(609,48569,'Matorral el'),(609,48570,'Melenara'),(609,48571,'Meson el'),(609,48572,'Mogán'),(609,48573,'Mojon el'),(609,48574,'Montaña blanca'),(609,48575,'Montaña hendida'),(609,48576,'Monte coello'),(609,48577,'Morro del jable'),(609,48578,'Mozaga'),(609,48579,'Muñique'),(609,48580,'Nazaret'),(609,48581,'La Oliva'),(609,48582,'Orzola'),(609,48583,'Pájara'),(609,48584,'Las Palmas'),(609,48585,'Pasadilla'),(609,48587,'Pino santo'),(609,48588,'Playa blanca'),(609,48589,'Playa de mogan la'),(609,48590,'Playas las'),(609,48591,'Pozo negro'),(609,48592,'Puertito el'),(609,48593,'Puerto de la peña'),(609,48594,'Puerto de lajas'),(609,48595,'Puerto de las nieves'),(609,48596,'Puerto de los molinos'),(609,48597,'Puerto del Carmen'),(609,48598,'Puerto del Rosario'),(609,48599,'Punta de mujeres'),(609,48600,'Risco el'),(609,48601,'Roque'),(609,48602,'Salinas las'),(609,48603,'San agustin'),(609,48604,'San Bartolomé'),(609,48605,'San Bartolomé de Tirajana'),(609,48606,'San lorenzo'),(609,48607,'San Nicolás de Tolentino'),(609,48608,'San roque'),(609,48609,'Santa Brígida'),(609,48610,'Santa la'),(609,48611,'Santa Lucía'),(609,48612,'Sardina'),(609,48613,'Soo'),(609,48614,'Tabayesco'),(609,48615,'Tablero el'),(609,48616,'Tafira alta'),(609,48617,'Tahiche'),(609,48618,'Tamaraceite'),(609,48619,'Tao'),(609,48620,'Tarajalejo'),(609,48621,'Tasarte'),(609,48622,'Tefia'),(609,48623,'Teguise'),(609,48624,'Teguital'),(609,48625,'Tejeda'),(609,48626,'Telde'),(609,48627,'Temisas'),(609,48628,'Tenoya'),(609,48629,'Tenteniguada'),(609,48630,'Teror'),(609,48631,'Teseguite'),(609,48632,'Tesejerague'),(609,48633,'Tesjuates'),(609,48634,'Tetir'),(609,48635,'Tiagua'),(609,48636,'Tias'),(609,48637,'Time el'),(609,48638,'Tinajo'),(609,48639,'Tindaya'),(609,48640,'Tinguaton'),(609,48641,'Tiscamanita'),(609,48642,'Tocodoman'),(609,48643,'Toto'),(609,48644,'Trasmontaña'),(609,48645,'Triquivijate'),(609,48646,'Tuineje'),(609,48647,'Uga'),(609,48648,'Valsequillo de Gran Canaria'),(609,48649,'Valle de los nueve el'),(609,48650,'Valle de santa ines'),(609,48651,'Valles de ortega'),(609,48652,'Valles los'),(609,48653,'Valleseco'),(609,48654,'Vega de San Mateo'),(609,48655,'Vega del rio palmas'),(609,48656,'Vegas de tegoyo'),(609,48657,'Vegueta la'),(609,48658,'Villaverde'),(609,48659,'Yaiza'),(609,48660,'Ye'),(610,48661,'Abanco'),(610,48662,'Abejar'),(610,48664,'Abioncillo de catalañazor'),(610,48665,'Adradas'),(610,48666,'Ágreda'),(610,48667,'Aguaviva de la vega'),(610,48671,'Alcoba de la torre'),(610,48675,'Alcubilla de las peñas'),(610,48678,'Aldealices'),(610,48679,'Aldealpozo'),(610,48688,'Almajano'),(610,48691,'Almarza'),(610,48692,'Almazán'),(610,48694,'Almenar de soria'),(610,48698,'Andaluz'),(610,48699,'Añavieja'),(610,48700,'Arancon'),(610,48702,'Arcos del jalon'),(610,48703,'Arenillas'),(610,48704,'Arevalo de la sierra'),(610,48707,'Atauta'),(610,48710,'Aylagas'),(610,48714,'Barahona'),(610,48720,'Bayubas de abajo'),(610,48725,'Berlanga de duero'),(610,48728,'Bliecos'),(610,48729,'Blocona'),(610,48735,'Bordecorex'),(610,48736,'Bordeje'),(610,48738,'Borobia'),(610,48743,'Buitrago'),(610,48744,'Burgo de Osma'),(610,48747,'Cabrejas del pinar'),(610,48762,'Casarejos'),(610,48766,'Castil de tierra'),(610,48768,'Castilruiz'),(610,48769,'Castillejo de robledo'),(610,48775,'Cidones'),(610,48782,'Collado el'),(610,48783,'Concepcion la'),(610,48785,'Cortos'),(610,48787,'Covaleda'),(610,48788,'Covarrubias'),(610,48792,'Cubo de la sierra'),(610,48794,'Cuellar de la sierra'),(610,48795,'Cuenca la'),(610,48804,'Deza'),(610,48807,'Duañez'),(610,48808,'Duruelo de la sierra'),(610,48816,'Estepa de san juan'),(610,48818,'Esteras de medinaceli'),(610,48819,'Fraguas las'),(610,48826,'Fuenteboba'),(610,48832,'Fuentelcarro'),(610,48833,'Fuentelfresno'),(610,48839,'Fuentestrun'),(610,48844,'Garray'),(610,48845,'Golmayo'),(610,48846,'Gomara'),(610,48848,'Herrera de soria'),(610,48849,'Herreros'),(610,48850,'Hinojosa de la sierra'),(610,48857,'Ines'),(610,48861,'Jaray'),(610,48864,'Judes'),(610,48866,'Langa de duero'),(610,48874,'Losana'),(610,48876,'Lubia'),(610,48879,'Madruedano'),(610,48880,'Magaña'),(610,48884,'Martialay'),(610,48885,'Matalebreras'),(610,48886,'Matamala de almazan'),(610,48888,'Matasejun'),(610,48893,'Medinaceli'),(610,48894,'Mezquetillas'),(610,48896,'Miñana'),(610,48897,'Miño de medinaceli'),(610,48900,'Molinos de duero'),(610,48909,'Montuenga de soria'),(610,48914,'Muela la'),(610,48920,'Nafria la llana'),(610,48921,'Narros'),(610,48924,'Navaleno'),(610,48934,'Noviergas'),(610,48935,'Ocenilla'),(610,48936,'Ojuel'),(610,48938,'Ólvega'),(610,48943,'Osma'),(610,48944,'Osona'),(610,48949,'Paredesroyas'),(610,48963,'Poveda de soria la'),(610,48964,'Pozalmuro'),(610,48967,'Quintana redonda'),(610,48969,'Quintanas de gormaz'),(610,48976,'Rabanos los'),(610,48979,'Rebollo de duero'),(610,48982,'Rejas de san esteban'),(610,48985,'Renieblas'),(610,48986,'Retortillo de soria'),(610,48991,'Rioseco de soria'),(610,48995,'Royo el'),(610,48997,'Sagides'),(610,48998,'Salduero'),(610,48999,'Salinas de medinaceli'),(610,49002,'San Esteban de Gormaz'),(610,49003,'San Leonardo de Yagüe'),(610,49004,'San pedro manrique'),(610,49008,'Santa maria de huerta'),(610,49009,'Santa maria de las hoyas'),(610,49012,'Santervas del burgo'),(610,49016,'Sauquillo de boñices'),(610,49017,'Sauquillo de paredes'),(610,49019,'Seca la'),(610,49021,'Señuela'),(610,49022,'Seron de najima'),(610,49024,'Somaen'),(610,49025,'Soria'),(610,49032,'Tajueco'),(610,49033,'Talveila'),(610,49038,'Tardelcuende'),(610,49039,'Tardesillas'),(610,49040,'Taroda'),(610,49043,'Tera'),(610,49045,'Torlengua'),(610,49049,'Torraño'),(610,49051,'Torrearevalo'),(610,49059,'Torrubia de soria'),(610,49065,'Vadillo'),(610,49067,'Valdealbin'),(610,49069,'Valdeavellano de tera'),(610,49079,'Valderrodilla'),(610,49081,'Valderrueda'),(610,49083,'Valtajeros'),(610,49084,'Valtueña'),(610,49091,'Velasco'),(610,49093,'Velilla de los ajos'),(610,49103,'Viana de duero'),(610,49105,'Vilviestre de los nabos'),(610,49106,'Villabuena'),(610,49107,'Villaciervitos'),(610,49110,'Villalvaro'),(610,49111,'Villanueva de gormaz'),(610,49116,'Villar del rio'),(610,49123,'Vinuesa'),(610,49125,'Vozmediano'),(610,49126,'Yanguas'),(610,49131,'Zayas de torres'),(610,49132,'Zayuelas'),(611,49133,'Abarca'),(611,49134,'Abastas'),(611,49135,'Abastillas'),(611,49136,'Abia de las torres'),(611,49137,'Acera de la vega'),(611,49138,'Aguilar de Campoo'),(611,49139,'Alar del rey'),(611,49140,'Alba de cerrato'),(611,49144,'Ampudia'),(611,49145,'Amusco'),(611,49146,'Antigsedad'),(611,49147,'Añoza'),(611,49148,'Arbejal'),(611,49149,'Arconada'),(611,49150,'Arenillas de san pelayo'),(611,49152,'Astudillo'),(611,49153,'Autilla del pino'),(611,49154,'Autillo de campos'),(611,49155,'Aviñante de la peña'),(611,49157,'Bahillo'),(611,49158,'Baltanas'),(611,49160,'Baquerin de campos'),(611,49164,'Barriosuso'),(611,49165,'Barruelo de santullan'),(611,49168,'Becerril de campos'),(611,49169,'Belmonte de campos'),(611,49173,'Boadilla de rioseco'),(611,49174,'Boadilla del camino'),(611,49177,'Buenavista de valdavia'),(611,49179,'Bustillo de la vega'),(611,49182,'Calabazanos'),(611,49184,'Calzada de los molinos'),(611,49185,'Calzadilla de la cueza'),(611,49187,'Campo el'),(611,49188,'Camporredondo del alba'),(611,49196,'Carrión de los Condes'),(611,49198,'Cascon de la nava'),(611,49200,'Castrejon de la peña'),(611,49202,'Castrillo de don juan'),(611,49203,'Castrillo de onielo'),(611,49204,'Castrillo de villavega'),(611,49205,'Castromocho'),(611,49210,'Cervera de Pisuerga'),(611,49211,'Cevico de la torre'),(611,49212,'Cevico navero'),(611,49215,'Cisneros'),(611,49218,'Collazos de boedo'),(611,49219,'Congosto de valdavia'),(611,49221,'Cornon de la peña'),(611,49223,'Cozuelos de ojeda'),(611,49224,'Cubillas de cerrato'),(611,49230,'Dueñas'),(611,49231,'Espinosa de cerrato'),(611,49236,'Frechilla'),(611,49237,'Fresno del rio'),(611,49238,'Fromista'),(611,49239,'Fuentes de nava'),(611,49240,'Fuentes de valdepero'),(611,49244,'Grijera'),(611,49245,'Grijota'),(611,49246,'Guardo'),(611,49250,'Herrera de Pisuerga'),(611,49251,'Herrera de valdecañas'),(611,49252,'Herreruela de castilleria'),(611,49254,'Hontoria de cerrato'),(611,49256,'Husillos'),(611,49260,'Lagartos'),(611,49261,'Lagunilla de la vega'),(611,49262,'Lantadilla'),(611,49266,'Lavid de ojeda'),(611,49268,'Ledigos'),(611,49275,'Magaz'),(611,49277,'Mantinos'),(611,49281,'Mave'),(611,49282,'Mazariegos'),(611,49283,'Mazuecos de valdeginate'),(611,49284,'Melgar de yuso'),(611,49287,'Meneses de campos'),(611,49289,'Miñanes'),(611,49294,'Monzon de campos'),(611,49297,'Muda'),(611,49298,'Muñeca'),(611,49304,'Olmos de pisuerga'),(611,49308,'Osorno'),(611,49309,'Palacios de alcor'),(611,49310,'Palencia'),(611,49311,'Palenzuela'),(611,49314,'Parapertu'),(611,49315,'Paredes de Nava'),(611,49320,'Perales'),(611,49321,'Perazancas'),(611,49324,'Pino del rio'),(611,49326,'Pison'),(611,49328,'Poblacion de campos'),(611,49330,'Poblacion de soto'),(611,49331,'Polentinos'),(611,49334,'Portillejo'),(611,49338,'Pozuelos del rey'),(611,49341,'Quintana del puente'),(611,49346,'Quintanilla de onsoña'),(611,49356,'Renedo de valdavia'),(611,49358,'Requena de campos'),(611,49361,'Respenda de la peña'),(611,49362,'Revenga de campos'),(611,49365,'Revilla de collazos'),(611,49366,'Revilla de pomar'),(611,49367,'Ribas de campos'),(611,49368,'Riberos de la cueza'),(611,49369,'Riosmenudos de la peña'),(611,49371,'Roscales de la peña'),(611,49372,'Rueda'),(611,49375,'Saldaña'),(611,49376,'Salinas de pisuerga'),(611,49379,'San cebrian de campos'),(611,49384,'San llorente del paramo'),(611,49391,'San martin del valle'),(611,49392,'San nicolas del real camino'),(611,49396,'San roman de la cuba'),(611,49397,'San salvador de cantamuda'),(611,49399,'Santa cecilia del alcor'),(611,49406,'Santervas de la vega'),(611,49408,'Santibañez'),(611,49410,'Santibañez de resoba'),(611,49411,'Santillan de la vega'),(611,49416,'Soto de cerrato'),(611,49422,'Tariego de cerrato'),(611,49424,'Terradillos de los templarios'),(611,49425,'Torquemada'),(611,49427,'Torremormojon'),(611,49431,'Valbuena de pisuerga'),(611,49433,'Valdebustos'),(611,49437,'Valdespina'),(611,49443,'Valle de cerrato'),(611,49451,'Velila del rio carrion'),(611,49454,'Venta de Baños'),(611,49464,'Villabermudo'),(611,49468,'Villacuende'),(611,49469,'Villada'),(611,49473,'Villaescusa de ecla'),(611,49474,'Villafria de la peña'),(611,49478,'Villaherreros'),(611,49479,'Villajimena'),(611,49484,'Villalcazar de sirga'),(611,49486,'Villalobon'),(611,49489,'Villallano'),(611,49490,'Villamartin de campos'),(611,49493,'Villamediana'),(611,49495,'Villameriel'),(611,49499,'Villamuriel de Cerrato'),(611,49502,'Villanueva de abajo'),(611,49503,'Villanueva de arriba'),(611,49507,'Villanueva del monte'),(611,49509,'Villanueva del rio'),(611,49513,'Villaproviano'),(611,49518,'Villarramiel'),(611,49520,'Villarrodrigo de la vega'),(611,49521,'Villasabariego'),(611,49522,'Villasarracino'),(611,49524,'Villasur'),(611,49525,'Villatoquite'),(611,49526,'Villaturde'),(611,49527,'Villaumbrales'),(611,49531,'Villaviudas'),(611,49534,'Villerias'),(611,49536,'Villodrigo'),(611,49537,'Villoldo'),(611,49542,'Villotilla'),(611,49543,'Villovieco'),(612,49544,'Abejera'),(612,49545,'Abelon'),(612,49546,'Abezames'),(612,49547,'Aciberos'),(612,49548,'Aguilar de tera'),(612,49549,'Alcañices'),(612,49550,'Alcorcillo'),(612,49551,'Alcubilla de nogales'),(612,49552,'Alfaraz'),(612,49553,'Algodre'),(612,49554,'Almaraz del duero'),(612,49555,'Almeida'),(612,49556,'Almendra'),(612,49557,'Andavias'),(612,49558,'Anta'),(612,49559,'Arcenillas'),(612,49561,'Arcillo'),(612,49562,'Arcos de la polvorosa'),(612,49563,'Argañin'),(612,49564,'Argujillo'),(612,49566,'Arrabalde'),(612,49568,'Asturianos'),(612,49569,'Avedillo de sanabria'),(612,49570,'Ayoo de vidriales'),(612,49571,'Badilla'),(612,49573,'Barcial del barco'),(612,49575,'Barrio de rabano'),(612,49576,'Belver de los montes'),(612,49577,'Benavente'),(612,49578,'Benegiles'),(612,49579,'Bercianos'),(612,49581,'Bercianos de valverde'),(612,49582,'Bermillo de Sayago'),(612,49583,'Bernillo de alba'),(612,49584,'Boveda de toro la'),(612,49587,'Bretocino'),(612,49589,'Brime de urz'),(612,49590,'Burganes de valverde'),(612,49591,'Bustillo del oro'),(612,49592,'Cabañas'),(612,49597,'Calzadilla de tera'),(612,49598,'Camarzana de tera'),(612,49599,'Campillo'),(612,49601,'Cañizal'),(612,49603,'Carbajales de alba'),(612,49605,'Carbajalinos'),(612,49607,'Carbellino'),(612,49609,'Carrascal'),(612,49611,'Casaseca de las chanas'),(612,49614,'Castro de alcañices'),(612,49615,'Castrogonzalo'),(612,49616,'Castronuevo'),(612,49617,'Castropepe'),(612,49618,'Castroverde de campos'),(612,49619,'Cazurra'),(612,49622,'Cerecinos de campos'),(612,49623,'Cerecinos del carrizal'),(612,49624,'Cerezal de aliste'),(612,49628,'Cional'),(612,49629,'Cobreros'),(612,49630,'Codesal'),(612,49631,'Colinas de trasmonte'),(612,49632,'Congosta'),(612,49633,'Coomonte'),(612,49634,'Coreses'),(612,49635,'Corrales'),(612,49638,'Cubillos'),(612,49640,'Cubo de la tierra del vino el'),(612,49641,'Cuelgamures'),(612,49643,'Chanos'),(612,49644,'Domez'),(612,49645,'Donadillo'),(612,49650,'Entrala'),(612,49657,'Faramontanos de tabara'),(612,49659,'Fermoselle'),(612,49660,'Ferreras de abajo'),(612,49663,'Ferreruela de tabara'),(612,49664,'Figueruela de abajo'),(612,49666,'Figueruela de sayago'),(612,49668,'Fonfría'),(612,49669,'Fontanillas de castro'),(612,49670,'Formariz'),(612,49674,'Fresnadillo'),(612,49678,'Fresno de sayago'),(612,49679,'Friera de valverde'),(612,49681,'Fuentelapeña'),(612,49682,'Fuentelcarnero'),(612,49683,'Fuentes de ropel'),(612,49684,'Fuentesaúco'),(612,49686,'Fuentespreadas'),(612,49687,'Galende'),(612,49689,'Gallegos del pan'),(612,49692,'Ganame'),(612,49693,'Gema'),(612,49695,'Granja de moreruela'),(612,49696,'Granucillo'),(612,49701,'Hiniesta la'),(612,49702,'Jambrina'),(612,49716,'Lubian'),(612,49719,'Madridanos'),(612,49723,'Malva'),(612,49725,'Manganeses de la lampreana'),(612,49726,'Manganeses de la polvorosa'),(612,49729,'Manzanal del barco'),(612,49731,'Matellanes'),(612,49734,'Mayalde'),(612,49735,'Melgar de tera'),(612,49737,'Micereces de tera'),(612,49738,'Milles de la polvorosa'),(612,49743,'Mombuey'),(612,49745,'Monfarracinos'),(612,49749,'Moral de sayago'),(612,49750,'Moraleja de sayago'),(612,49751,'Morales de Toro'),(612,49752,'Morales de valverde'),(612,49753,'Morales del rey'),(612,49754,'Morales del Vino'),(612,49757,'Moreleja del Vino'),(612,49758,'Moreruela de los infanzones'),(612,49759,'Moreruela de tabara'),(612,49762,'Muelas de los caballeros'),(612,49763,'Muelas del pan'),(612,49764,'Muga'),(612,49765,'Muga de sayago'),(612,49766,'Murias'),(612,49768,'Navianos de valverde'),(612,49769,'Nuez'),(612,49771,'Olmillos de valverde'),(612,49773,'Olleros de tera'),(612,49774,'Otero'),(612,49778,'Padornelo'),(612,49779,'Pajares de la lampreana'),(612,49780,'Palacios de sanabria'),(612,49781,'Palacios del pan'),(612,49787,'Pego el'),(612,49789,'Peleas de abajo'),(612,49791,'Peñausende'),(612,49793,'Perdigon el'),(612,49794,'Pereruela'),(612,49795,'Perilla de castro'),(612,49796,'Pias'),(612,49797,'Piedrahita de castro'),(612,49801,'Piñero el'),(612,49804,'Pobladura de valderaduey'),(612,49805,'Pobladura del valle'),(612,49806,'Pontejos'),(612,49813,'Prado'),(612,49814,'Puebla de Sanabria'),(612,49816,'Pueblica de valverde'),(612,49818,'Puercas'),(612,49821,'Quintanilla de urz'),(612,49822,'Quintanilla del monte'),(612,49824,'Quiruelas de vidriales'),(612,49826,'Rabano de aliste'),(612,49830,'Revellinos'),(612,49834,'Riego del camino'),(612,49835,'Rihonor de castilla'),(612,49837,'Riofrío de Aliste'),(612,49839,'Rionegro del puente'),(612,49840,'Roales'),(612,49841,'Robleda'),(612,49843,'Roelos'),(612,49844,'Rosinos'),(612,49845,'Rosinos de la requejada'),(612,49847,'Sagallos'),(612,49854,'San cebrian de castro'),(612,49858,'San Cristóbal de Entreviñas'),(612,49860,'San juan de la cuesta'),(612,49861,'San juan de rebollar'),(612,49865,'San marcial'),(612,49871,'San miguel de la ribera'),(612,49876,'San pedro de la viña'),(612,49877,'San pedro de las cuevas'),(612,49882,'San vicente de la cabeza'),(612,49883,'San vitero'),(612,49886,'Santa clara de avedillo'),(612,49887,'Santa colomba de las carabias'),(612,49890,'Santa Cristina de la Polvorosa'),(612,49891,'Santa croya de tera'),(612,49897,'Santa maria de la vega'),(612,49899,'Santa marta'),(612,49900,'Santibañez de tera'),(612,49901,'Santibáñez de Vidriales'),(612,49903,'Sanzoles'),(612,49904,'Sarracin de aliste'),(612,49905,'Sejas de aliste'),(612,49909,'Sobradillo de palomares'),(612,49910,'Sogo'),(612,49913,'Tabara'),(612,49917,'Tapioles'),(612,49918,'Tardemezar'),(612,49924,'Toro'),(612,49925,'Torre del valle la'),(612,49927,'Torrefrades'),(612,49928,'Torregamones'),(612,49930,'Torres del carrizal'),(612,49936,'Uña de quintana'),(612,49938,'Vadillo de la guareña'),(612,49940,'Valcabado'),(612,49941,'Valdefinjas'),(612,49942,'Valdemerilla'),(612,49943,'Valdeperdices'),(612,49944,'Valdescorriel'),(612,49946,'Valparaiso'),(612,49948,'Vallesa de la guareña'),(612,49952,'Vega de villalobos'),(612,49955,'Venialbo'),(612,49956,'Vezdemarban'),(612,49960,'Vigo'),(612,49961,'Villabrazaro'),(612,49962,'Villabuena del puente'),(612,49964,'Villaescusa'),(612,49965,'Villafafila'),(612,49967,'Villageriz'),(612,49968,'Villalazan'),(612,49969,'Villalba de la lampreana'),(612,49970,'Villalcampo'),(612,49971,'Villalobos'),(612,49973,'Villalpando'),(612,49974,'Villalube'),(612,49975,'Villamayor de campos'),(612,49978,'Villamor de los escuderos'),(612,49980,'Villanueva de azoague'),(612,49981,'Villanueva de campean'),(612,49985,'Villanueva de valrojo'),(612,49986,'Villanueva del Campo'),(612,49990,'Villaralbo'),(612,49991,'Villardeciervos'),(612,49994,'Villardiga'),(612,49996,'Villarejo de la sierra'),(612,49997,'Villarin de campos'),(612,50001,'Villaseco'),(612,50004,'Villaveza de valverde'),(612,50005,'Villaveza del agua'),(612,50006,'Viñas'),(612,50008,'Vivinera'),(612,50009,'Zafara'),(612,50010,'Zamora'),(613,50011,'Acicar'),(613,50012,'Alcalá de los Gazules'),(613,50013,'Alcalá del Valle'),(613,50014,'Alcaria la'),(613,50015,'Alcornocalejo'),(613,50016,'Algaida la'),(613,50017,'Algar'),(613,50018,'Algeciras'),(613,50019,'Algodonales'),(613,50020,'Almarchal el'),(613,50021,'Almoraima la'),(613,50022,'Angeles los'),(613,50023,'Arcos de la Frontera'),(613,50024,'Atunara la'),(613,50025,'Baños de gigonza'),(613,50026,'Barbate'),(613,50027,'Barca de la florida la'),(613,50028,'Barrio nuevo'),(613,50029,'Los Barrios'),(613,50030,'Barrosa la'),(613,50031,'Benalup-Casas Viejas'),(613,50032,'Benamahoma'),(613,50033,'Benaocaz'),(613,50034,'Berrueco el'),(613,50035,'Bonanza'),(613,50036,'Bornos'),(613,50037,'Bosque el'),(613,50038,'Cabatillas las'),(613,50039,'Cádiz'),(613,50040,'Campano'),(613,50041,'Caños de meca los'),(613,50042,'Caserio de san bernardino'),(613,50043,'Castellar'),(613,50044,'Castellar de la Frontera'),(613,50045,'Colorado el'),(613,50046,'Conil de la Frontera'),(613,50047,'Cortijo capita'),(613,50049,'Cortijo del romero'),(613,50050,'Cuartillo'),(613,50051,'Chiclana de la Frontera'),(613,50052,'Chipiona'),(613,50053,'Espera'),(613,50054,'Estacion la'),(613,50055,'Estella del marques'),(613,50056,'Facinas'),(613,50057,'Fuentebravia'),(613,50058,'Gastor el'),(613,50059,'Gibalbin'),(613,50060,'Grazalema'),(613,50061,'Guadalcacin'),(613,50062,'Guadarranque'),(613,50063,'Guadiaro'),(613,50065,'Jarana'),(613,50067,'Jarda la'),(613,50069,'Jedula'),(613,50070,'Jerez de la Frontera'),(613,50071,'Jimena de la Frontera'),(613,50072,'Jose antonio'),(613,50074,'Junta de los rios'),(613,50075,'Lentiscal el'),(613,50076,'Libreros'),(613,50077,'La Línea de la Concepción'),(613,50078,'Marchenilla'),(613,50079,'Mata la'),(613,50080,'Matagorda'),(613,50081,'Medina-Sidonia'),(613,50082,'Mesas de asta'),(613,50084,'Molino castro'),(613,50086,'Muela la'),(613,50088,'Naveros los'),(613,50089,'Nueva jarilla'),(613,50090,'Olvera'),(613,50091,'Palmar el'),(613,50092,'Palmones'),(613,50093,'Parra la'),(613,50094,'Parralejo'),(613,50095,'Paterna de Rivera'),(613,50096,'Patrite'),(613,50098,'Porquerizas'),(613,50099,'Portal el'),(613,50100,'Pozo amargo'),(613,50101,'Prado del Rey'),(613,50102,'Puente mayorga'),(613,50103,'El Puerto de Santa María'),(613,50104,'Puerto Real'),(613,50105,'Puerto Serrano'),(613,50106,'Rinconcillo el'),(613,50107,'Rota'),(613,50108,'San enrique de guadiaro'),(613,50109,'San Fernando'),(613,50110,'San isidro'),(613,50111,'San jose de malcocinado'),(613,50113,'San José del Valle'),(613,50114,'San martin del tesorillo'),(613,50115,'San pablo de buceite'),(613,50116,'San Roque'),(613,50117,'Sancti petri'),(613,50118,'Sanlúcar de Barrameda'),(613,50119,'Setenil'),(613,50120,'Sotogrande'),(613,50121,'Tahivilla'),(613,50122,'Taraguilla'),(613,50123,'Tarifa'),(613,50124,'Tempul'),(613,50125,'Torno el'),(613,50126,'Torre alhaquime'),(613,50128,'Torre nueva'),(613,50129,'Torrecera'),(613,50130,'Trebujena'),(613,50131,'Ubrique'),(613,50132,'Urbanizacion roche'),(613,50133,'Valdelagrana'),(613,50134,'Vejer de la Frontera'),(613,50136,'Villaluenga del rosario'),(613,50137,'Villamartín'),(613,50138,'Vistahermosa'),(613,50139,'Zahara'),(613,50140,'Zahara de los atunes'),(614,50141,'Abaigar'),(614,50142,'Abarzuza'),(614,50143,'Abaurregaina'),(614,50144,'Abaurrepea'),(614,50145,'Aberin'),(614,50146,'Abinzano'),(614,50147,'Ablitas'),(614,50148,'Acedo'),(614,50149,'Adanza'),(614,50151,'Adios'),(614,50152,'Adoain'),(614,50153,'Aguilar de codes'),(614,50154,'Aibar'),(614,50155,'Aintzialde'),(614,50156,'Aintzioa'),(614,50158,'Aizkorbe'),(614,50160,'Albiasu'),(614,50162,'Aldaz'),(614,50164,'Alkaiaga'),(614,50166,'Almandoz'),(614,50167,'Altsasu/Alsasua'),(614,50168,'Alzorriz'),(614,50169,'Allo'),(614,50170,'Alloz'),(614,50171,'Amaiur maia'),(614,50178,'Andosilla'),(614,50179,'Aniz'),(614,50181,'Ansoáin'),(614,50182,'Antxoriz'),(614,50183,'Añezca'),(614,50184,'Añorbe'),(614,50185,'Aoiz/Agoitz'),(614,50187,'Apaioa'),(614,50190,'Arandigoyen'),(614,50191,'Aranguren'),(614,50193,'Arantza'),(614,50194,'Aras'),(614,50195,'Arazuri'),(614,50197,'Arbizu'),(614,50199,'Arcos los'),(614,50202,'Areso'),(614,50203,'Arguedas'),(614,50204,'Arguiñano'),(614,50206,'Aria'),(614,50207,'Aribe'),(614,50208,'Arielz'),(614,50210,'Aristu'),(614,50213,'Arizala'),(614,50215,'Arizkun'),(614,50223,'Arraiza'),(614,50225,'Arribe atallu'),(614,50226,'Arrieta'),(614,50227,'Arroniz'),(614,50228,'Arruazu'),(614,50229,'Arruitz'),(614,50231,'Artaiz'),(614,50233,'Artajona'),(614,50235,'Artavia'),(614,50236,'Artaza'),(614,50237,'Artazu'),(614,50238,'Arteaga'),(614,50240,'Artica'),(614,50244,'Artze'),(614,50247,'Asiain'),(614,50251,'Astrain'),(614,50253,'Auritz burguete'),(614,50258,'Ayechu'),(614,50259,'Ayegui'),(614,50261,'Azagra'),(614,50262,'Azanza'),(614,50268,'Azpilkueta'),(614,50269,'Azpirotz'),(614,50272,'Ballariain'),(614,50275,'Barañain'),(614,50276,'Barasoain'),(614,50277,'Barbarin'),(614,50278,'Bargota'),(614,50279,'Bariain'),(614,50280,'Barillas'),(614,50282,'Basongaiz'),(614,50283,'Beriáin'),(614,50284,'Beartzun'),(614,50285,'Beasoain'),(614,50286,'Beintza labaien'),(614,50287,'Beire'),(614,50288,'Belascoain'),(614,50289,'Belzunce'),(614,50293,'Bera/Vera de Bidasoa'),(614,50296,'Berasain'),(614,50297,'Berbinzana'),(614,50298,'Beriain'),(614,50300,'Berriozar'),(614,50301,'Berrizaun'),(614,50304,'Beruete'),(614,50305,'Betelu'),(614,50306,'Beunza'),(614,50307,'Bezquiz'),(614,50309,'Biskarreta gerendiain'),(614,50310,'Biurrun'),(614,50313,'Buñuel'),(614,50314,'Burgui'),(614,50315,'Burlada/Burlata'),(614,50316,'Burutain'),(614,50318,'Cabanillas'),(614,50319,'Cabredo'),(614,50321,'Cadreita'),(614,50323,'Caparroso'),(614,50324,'Carcar'),(614,50325,'Carcastillo'),(614,50326,'Cascante'),(614,50327,'Caseda'),(614,50328,'Castillo nuevo'),(614,50331,'Cia'),(614,50333,'Cintruénigo'),(614,50334,'Cirauqui'),(614,50335,'Ciriza'),(614,50336,'Cizur mayor'),(614,50337,'Cizur menor'),(614,50338,'Corella'),(614,50339,'Cortes'),(614,50340,'Dehesa de san juan'),(614,50345,'Doneztebe santesteban'),(614,50347,'Ecala'),(614,50351,'Echarren de guirguillano'),(614,50352,'Etxarri-Aranatz'),(614,50353,'Echauri'),(614,50355,'Egozkue'),(614,50357,'Egüés'),(614,50360,'Elbete'),(614,50361,'Elcano'),(614,50362,'Elgorriaga'),(614,50364,'Elizondo'),(614,50365,'Elorz'),(614,50366,'Eltzaburu'),(614,50368,'Eneriz'),(614,50371,'Eransus'),(614,50372,'Eraso'),(614,50376,'Erdozain'),(614,50381,'Erratzu'),(614,50382,'Errazkin'),(614,50385,'Errotz'),(614,50387,'Esnotz'),(614,50388,'Esparza'),(614,50391,'Espronceda'),(614,50393,'Estella/Lizarra'),(614,50399,'Etxalar'),(614,50400,'Etxaleku'),(614,50401,'Etxarri'),(614,50402,'Etxarri aranatz'),(614,50403,'Etxberri'),(614,50405,'Eulate'),(614,50406,'Eulz'),(614,50408,'Ezcaroz'),(614,50411,'Ezkurra'),(614,50413,'Falces'),(614,50416,'Figarol'),(614,50417,'Fitero'),(614,50418,'Fontellas'),(614,50419,'Funes'),(614,50420,'Fustiñana'),(614,50421,'Gabarderal'),(614,50424,'Galar'),(614,50429,'Ganuza'),(614,50433,'Garinoain'),(614,50435,'Garralda'),(614,50436,'Gartzain'),(614,50443,'Goizueta'),(614,50449,'Gorraiz'),(614,50455,'Grocin'),(614,50458,'Guerendiain'),(614,50462,'Guirguillano'),(614,50465,'Hiriberri villanueva de aezkoa'),(614,50466,'Huarte/Uharte'),(614,50467,'Ibero'),(614,50474,'Igantzi'),(614,50477,'Iguzquiza'),(614,50478,'Ihaben'),(614,50481,'Ilurdotz'),(614,50485,'Inbuluzketa'),(614,50487,'Intza'),(614,50488,'Iñarbil'),(614,50491,'Iraitzoz'),(614,50492,'Irañeta'),(614,50500,'Irurita'),(614,50502,'Irurre'),(614,50503,'Irurtzun'),(614,50504,'Isaba'),(614,50505,'Iso'),(614,50511,'Iza'),(614,50514,'Izco'),(614,50515,'Izcue'),(614,50520,'Javerri'),(614,50522,'Kaule'),(614,50524,'Labeaga'),(614,50525,'Labiano'),(614,50529,'Lakuntza'),(614,50532,'Lapoblacion'),(614,50535,'Larraga'),(614,50537,'Larraintzar'),(614,50541,'Larrion'),(614,50543,'Latasa'),(614,50546,'Lazagurria'),(614,50547,'Leache'),(614,50555,'Leitza'),(614,50556,'Lekaroz'),(614,50557,'Lekunberri'),(614,50562,'Lerin'),(614,50564,'Lesaka'),(614,50567,'Lezaun'),(614,50569,'Liedena'),(614,50573,'Lizarragabengoa'),(614,50574,'Lizaso'),(614,50577,'Lodosa'),(614,50578,'Lorca'),(614,50580,'Lumbier'),(614,50581,'Luquin'),(614,50585,'Mañeru'),(614,50586,'Maquirriain'),(614,50589,'Marcilla'),(614,50591,'Melida'),(614,50592,'Mendavia'),(614,50594,'Mendigorria'),(614,50595,'Mendilibarri'),(614,50597,'Mendivil'),(614,50598,'Meoz'),(614,50600,'Mezkitz'),(614,50601,'Milagro'),(614,50603,'Miranda de arga'),(614,50604,'Monreal'),(614,50605,'Monteagudo'),(614,50606,'Morentin'),(614,50608,'Mues'),(614,50609,'Muez'),(614,50615,'Muneta'),(614,50617,'Muniain'),(614,50619,'Murchante'),(614,50621,'Murieta'),(614,50622,'Murillo'),(614,50626,'Murillo el fruto'),(614,50627,'Murugarren'),(614,50628,'Muruzabal'),(614,50630,'Muskitz'),(614,50632,'Nabaz'),(614,50636,'Napal'),(614,50640,'Nardues andurra'),(614,50641,'Navascues'),(614,50643,'Noáin/Noain'),(614,50644,'Nuin'),(614,50645,'Obanos'),(614,50646,'Oco'),(614,50647,'Ochagavia'),(614,50650,'Oharriz'),(614,50653,'Olaiz'),(614,50655,'Olave'),(614,50656,'Olaverri'),(614,50657,'Olaz'),(614,50659,'Olazagutia olazti'),(614,50660,'Olcoz'),(614,50661,'Olejua'),(614,50662,'Olite'),(614,50671,'Orbaitzeta'),(614,50673,'Orbaiz'),(614,50675,'Oricain'),(614,50676,'Oricin'),(614,50677,'Orisoain'),(614,50681,'Oronoz'),(614,50683,'Ororbia'),(614,50688,'Osacain'),(614,50689,'Osacar'),(614,50697,'Oteiza'),(614,50698,'Otiñano'),(614,50700,'Ozondritz'),(614,50701,'Pamplona/Iruña'),(614,50702,'Paternain'),(614,50704,'Peralta'),(614,50707,'Pitillas'),(614,50708,'Potasas'),(614,50709,'Puente la Reina/Gares'),(614,50710,'Pueyo'),(614,50712,'Rada'),(614,50714,'Reta'),(614,50715,'Ribaforada'),(614,50717,'Ripa'),(614,50720,'Roncal'),(614,50721,'Sada'),(614,50722,'Sagaseta'),(614,50726,'Salinas'),(614,50728,'Salinas de oro'),(614,50729,'San Adrián'),(614,50731,'San martin'),(614,50732,'San martin de unx'),(614,50734,'Sangüesa/Zangoza'),(614,50736,'Sansol'),(614,50738,'Santacara'),(614,50740,'Sarasa'),(614,50745,'Sarriguren'),(614,50746,'Sartaguda'),(614,50750,'Sesma'),(614,50751,'Solchaga'),(614,50755,'Suarbe'),(614,50756,'Sunbilla'),(614,50757,'Tabar'),(614,50758,'Tafalla'),(614,50761,'Tiebas'),(614,50762,'Tirapu'),(614,50763,'Torralba del rio'),(614,50766,'Torres del rio'),(614,50768,'Tudela'),(614,50769,'Tulebras'),(614,50776,'Uharte arakil'),(614,50781,'Ulzurrun'),(614,50784,'Unciti'),(614,50785,'Undiano'),(614,50786,'Unzu'),(614,50790,'Urdazubi urdax'),(614,50791,'Urdiain'),(614,50793,'Ureta'),(614,50795,'Urra'),(614,50801,'Urroz'),(614,50804,'Urzainqui'),(614,50806,'Usetxi'),(614,50811,'Uterga'),(614,50814,'Valcarlos'),(614,50815,'Valtierra'),(614,50817,'Viana'),(614,50818,'Vidangoz'),(614,50820,'Vidaurreta'),(614,50822,'Viloria'),(614,50823,'Villafranca'),(614,50824,'Villamayor de monjardin'),(614,50827,'Villatuerta'),(614,50828,'Villava/Atarrabia'),(614,50830,'Yelz'),(614,50831,'Yesa'),(614,50833,'Zabalceta'),(614,50836,'Zabalza'),(614,50852,'Zilbeti'),(614,50854,'Zolina'),(614,50856,'Zuasti'),(614,50857,'Zuaztoi'),(614,50858,'Zuazu'),(614,50862,'Zubiri'),(614,50864,'Zufia'),(614,50865,'Zugarramurdi'),(614,50866,'Zulueta'),(614,50870,'Zurucuain'),(614,50871,'Zuza'),(615,50872,'A piuca'),(615,50873,'Abavides san martin'),(615,50874,'Acebedo do rio'),(615,50875,'Aceredo'),(615,50876,'Alban'),(615,50877,'Albarellos'),(615,50879,'Albergueria'),(615,50880,'Allariz'),(615,50882,'Amoeiro'),(615,50883,'Anllo'),(615,50885,'Arcos'),(615,50886,'Arcucelos'),(615,50887,'Armada a'),(615,50889,'Arnoia'),(615,50890,'Arzadigos'),(615,50893,'Avión'),(615,50894,'Balde'),(615,50896,'Baldriz'),(615,50897,'Baltar'),(615,50898,'Bande'),(615,50900,'Baños'),(615,50901,'Baños de Molgas'),(615,50902,'Barbadás'),(615,50904,'Barco o san amaro'),(615,50905,'Barracel'),(615,50906,'Barrio'),(615,50908,'Beade'),(615,50909,'Beariz'),(615,50910,'Beiro'),(615,50913,'Bentraces'),(615,50916,'Blancos os'),(615,50918,'Boborás'),(615,50919,'Bola a'),(615,50920,'Bolo o'),(615,50922,'Bouza a'),(615,50923,'Bouza'),(615,50925,'Bouzas'),(615,50926,'Brues'),(615,50928,'Bustelo'),(615,50929,'Cabanelas'),(615,50930,'Cabreiroa'),(615,50931,'Cadavos'),(615,50932,'Caldeliñas'),(615,50933,'Calvos de randin'),(615,50936,'Cambeo santo estevo'),(615,50937,'Campobecerros santiago'),(615,50941,'Carballal'),(615,50942,'Carballeda'),(615,50943,'Carballeda de avia'),(615,50944,'O Carballiño'),(615,50945,'Cartelle'),(615,50946,'Casaio santa mar_a'),(615,50950,'Casas dos montes'),(615,50951,'Casasoa'),(615,50954,'Castrelo de Miño'),(615,50955,'Castrelo do val'),(615,50956,'Castro caldelas'),(615,50961,'Celanova'),(615,50962,'Cenlle'),(615,50966,'Cerdeira'),(615,50971,'Confurco'),(615,50974,'Cortegada'),(615,50977,'Cotelas'),(615,50980,'Covas'),(615,50981,'Covelo'),(615,50982,'Crespos'),(615,50983,'Cristimil'),(615,50984,'Cualedro'),(615,50985,'Cubilledo'),(615,50986,'Cudeiro san pedro'),(615,50987,'Cumial o'),(615,50988,'Cusanca'),(615,50989,'Chaguazoso'),(615,50993,'Dacon'),(615,50994,'Dadin'),(615,50995,'Desteriz'),(615,50996,'Devesa'),(615,51001,'Eirasvedras'),(615,51002,'Entoma san xoan'),(615,51003,'Entrambosrios'),(615,51004,'Entrimo'),(615,51010,'Esgos'),(615,51013,'Facos'),(615,51014,'Faramantaos'),(615,51015,'Faramontaos'),(615,51017,'Feas'),(615,51021,'Fitoiro san paio'),(615,51022,'Flariz san pedro'),(615,51024,'Fontefria'),(615,51028,'Francelos'),(615,51029,'Freas'),(615,51032,'Froufe'),(615,51037,'Gomariz'),(615,51038,'Gomesende'),(615,51042,'Gudiña a'),(615,51044,'Gustei santiago'),(615,51045,'Guxinde'),(615,51047,'O Irixo'),(615,51049,'Lama'),(615,51050,'Lamalonga santa mar_a'),(615,51051,'Lamas as santa mar_a'),(615,51055,'Lapela'),(615,51057,'Larouco'),(615,51059,'Laza'),(615,51063,'Leiro'),(615,51067,'Lobeira'),(615,51068,'Lobios'),(615,51069,'Loiro'),(615,51073,'Luintra santa eulalia'),(615,51074,'Maceda'),(615,51076,'Magros'),(615,51077,'Manchica a nosa sra. de lourde'),(615,51078,'Mandin santa mar_a'),(615,51081,'Manzaneda'),(615,51083,'Maside santo tomé'),(615,51085,'Medeiros santa maria'),(615,51087,'Melias san miguel'),(615,51088,'Melon'),(615,51089,'A Merca'),(615,51092,'Meson de calvos o santa mar_a'),(615,51094,'Mezquita a'),(615,51098,'Montederramo'),(615,51099,'Monterrei'),(615,51101,'Moreiras'),(615,51103,'Mosexos'),(615,51108,'Mugueimes'),(615,51109,'Muiños'),(615,51112,'Nieva'),(615,51113,'Niñodaguia'),(615,51114,'Nocedo do val san salvador'),(615,51115,'Nogueira'),(615,51116,'Oimbra'),(615,51117,'Olelas'),(615,51118,'Orense'),(615,51123,'Outomuro'),(615,51124,'Paderne de allariz'),(615,51125,'Padrenda'),(615,51126,'Palmes san mamed'),(615,51128,'Parada da serra'),(615,51130,'Parada do sil'),(615,51133,'Paradellas'),(615,51134,'Paraisas'),(615,51135,'Paraño o'),(615,51138,'Pazos'),(615,51141,'Pedrosa'),(615,51148,'Pentes san mamade'),(615,51150,'Pereira'),(615,51151,'O Pereiro de Aguiar'),(615,51152,'Pereiro o san pedro'),(615,51153,'Peroxa A San Eusebio'),(615,51154,'Petin'),(615,51157,'Piñeira'),(615,51158,'Piñor'),(615,51159,'Piton'),(615,51163,'Pobra de trives'),(615,51165,'Ponte a'),(615,51166,'Ponte barxas'),(615,51168,'Pontedeva'),(615,51169,'Porqueira'),(615,51172,'Porto de eguas'),(615,51176,'Prada san andres'),(615,51179,'Pradocabalos'),(615,51181,'Prexigueiro'),(615,51183,'Progo san miguel'),(615,51184,'Punxin'),(615,51186,'Queirogas san breixo'),(615,51189,'Quins'),(615,51190,'Quintela de leirado'),(615,51191,'Quintela'),(615,51193,'Rabal santa maria'),(615,51195,'Rairiz de veiga'),(615,51196,'Rairo'),(615,51197,'Ramilo san pedro'),(615,51198,'Ramirás'),(615,51200,'Razamonde'),(615,51207,'Reza'),(615,51208,'Ribadavia'),(615,51211,'Rio'),(615,51212,'Riós'),(615,51213,'Rioseco'),(615,51215,'Rodeiro'),(615,51216,'A Rúa'),(615,51217,'Rubia'),(615,51222,'Sainza'),(615,51224,'San amaro'),(615,51225,'San Cibrao das Viñas'),(615,51227,'San Cristovo de Cea'),(615,51228,'San cristovo san cristovo'),(615,51233,'Sande'),(615,51234,'Sandias'),(615,51237,'Santa baia'),(615,51240,'Santa mariña de augasantas'),(615,51241,'Santiago'),(615,51242,'Santigoso'),(615,51244,'Sarreaus'),(615,51247,'Seara a'),(615,51249,'Serantes'),(615,51255,'Soutelo verde'),(615,51257,'Soutochao santa maria'),(615,51258,'Soutopenedo san miguel'),(615,51260,'Taboadela'),(615,51261,'Tamaguelos'),(615,51262,'Tamallancos santa maria'),(615,51263,'Tameiron'),(615,51264,'Teixeira a'),(615,51266,'Toén'),(615,51272,'Trasmiras'),(615,51273,'Trelle'),(615,51276,'Untes san esteban'),(615,51277,'Urros san mamede'),(615,51282,'Valongo'),(615,51283,'Veiga'),(615,51284,'Veiga a'),(615,51287,'Velle'),(615,51289,'Vences'),(615,51291,'Verea'),(615,51292,'Verín'),(615,51293,'Viana do Bolo'),(615,51297,'Viladerrei'),(615,51298,'Vilamarín'),(615,51299,'Vilamartín de Valdeorras'),(615,51300,'Vilamea'),(615,51302,'Vilar'),(615,51303,'Vilar de barrio'),(615,51304,'Vilar de cervos'),(615,51306,'Vilar de santos'),(615,51307,'Vilardevós'),(615,51309,'Vilariño de conso'),(615,51310,'Vilariño frio'),(615,51313,'Vilavella'),(615,51314,'Vilaza san salvador'),(615,51318,'Xinzo de Limia Santa Marian'),(615,51319,'Xirei'),(615,51320,'Xironda a san salvador'),(615,51321,'Xubin'),(615,51322,'Xunqueira de ambia'),(615,51323,'Xunqueira de espadanedo'),(615,51324,'Xurenzas'),(615,51325,'Zorelle santiago'),(616,51326,'Abades'),(616,51327,'Adrada de piron'),(616,51329,'Aguilafuente'),(616,51330,'Alameda'),(616,51331,'Alconada de maderuelo'),(616,51332,'Alconadilla'),(616,51333,'Aldea-real'),(616,51334,'Aldealazaro'),(616,51335,'Aldealcorvo'),(616,51336,'Aldealengua de pedraza'),(616,51337,'Aldealengua de santa maria'),(616,51339,'Aldeanueva del codonal'),(616,51347,'Alquite'),(616,51348,'Anaya'),(616,51349,'Angeles de san rafael los'),(616,51350,'Añe'),(616,51353,'Arcones'),(616,51354,'Arevalillo de cega'),(616,51355,'Armuña'),(616,51358,'Ayllon'),(616,51361,'Barbolla'),(616,51362,'Barsardilla'),(616,51363,'Bercial'),(616,51364,'Bercimuel'),(616,51365,'Bernardos'),(616,51366,'Bernuey de porreros'),(616,51369,'Boceguillas'),(616,51370,'Brieva'),(616,51371,'Burgomillodo'),(616,51372,'Caballar'),(616,51373,'Cabanillas del monte'),(616,51374,'Cabañas de polendos'),(616,51375,'Cabezuela'),(616,51377,'Campo de cuellar'),(616,51378,'Campo de san pedro'),(616,51379,'Cantalejo'),(616,51380,'Cantimpalos'),(616,51383,'Carbonero de ahusin'),(616,51384,'Carbonero el Mayor'),(616,51388,'Casla'),(616,51390,'Castillejo de mesleon'),(616,51393,'Castrojimeno'),(616,51394,'Castroserna de abajo'),(616,51396,'Castroserracin'),(616,51397,'Cedillo de la torre'),(616,51398,'Cerezo de abajo'),(616,51399,'Cerezo de arriba'),(616,51401,'Ciruelos'),(616,51403,'Cobos de fuentidueña'),(616,51405,'Coca'),(616,51406,'Codorniz'),(616,51407,'Collado hermoso'),(616,51409,'Corral de ayllon'),(616,51413,'Cuéllar'),(616,51418,'Dehesa'),(616,51420,'Domingo garcia'),(616,51422,'Duraton'),(616,51424,'Encinas'),(616,51426,'Escalona del prado'),(616,51428,'Escarabajosa de cuellar'),(616,51430,'El Espinar'),(616,51431,'Espirdo'),(616,51432,'Estacion de el espinar'),(616,51433,'Estebanvela'),(616,51437,'Fresneda de sepulveda'),(616,51440,'Fuente de santa cruz'),(616,51441,'Fuente el olmo de fuentidueña'),(616,51443,'Fuentemilanos'),(616,51445,'Fuentepelayo'),(616,51446,'Fuentepiñel'),(616,51447,'Fuenterrebollo'),(616,51449,'Fuentesauco de fuentidueña'),(616,51451,'Fuentidueña'),(616,51453,'Gallegos'),(616,51454,'Garcillan'),(616,51455,'Gomeznarro'),(616,51456,'Gomezserracin'),(616,51458,'Grajera'),(616,51462,'Honrubia de la cuesta'),(616,51463,'Hontalbilla'),(616,51464,'Hontanares de eresma'),(616,51465,'Hontoria'),(616,51467,'Huerta'),(616,51468,'Huertos los'),(616,51471,'Juarros de riomoros'),(616,51472,'Juarros de voltoya'),(616,51473,'Labajos'),(616,51474,'Laguna de contreras'),(616,51475,'Laguna-rodrigo'),(616,51477,'Lastras de cuellar'),(616,51478,'Lastras del pozo'),(616,51479,'La Lastrilla'),(616,51480,'Losa la'),(616,51482,'Lovingos'),(616,51485,'Madrona'),(616,51488,'Marazoleja'),(616,51490,'Martin miguel'),(616,51493,'Martin muñoz de las posadas'),(616,51494,'Marugan'),(616,51495,'Mata de cuellar'),(616,51497,'Mata la'),(616,51499,'Matabuena'),(616,51504,'Miguel ibañez'),(616,51506,'Montejo de arevalo'),(616,51511,'Moraleja de coca'),(616,51513,'Mozoncillo'),(616,51514,'Mudrian'),(616,51515,'Muñopedro'),(616,51519,'Nava de la Asunción'),(616,51521,'Navafria'),(616,51523,'Navalmanzanedo'),(616,51527,'Navas de oro'),(616,51528,'Navas de riofrio'),(616,51529,'Navas de san antonio'),(616,51530,'Negredo el'),(616,51531,'Nieva'),(616,51534,'Olmo el'),(616,51535,'Olombrada'),(616,51539,'Ortigosa del monte'),(616,51540,'Otero de los herreros'),(616,51541,'Pajareros'),(616,51544,'Palazuelos de Eresma'),(616,51545,'Paradinas'),(616,51547,'Pascuales'),(616,51549,'Pedraza'),(616,51554,'Perorrubio'),(616,51559,'Pinillos de polendos'),(616,51561,'Pradena'),(616,51567,'Remondo'),(616,51568,'Requijada'),(616,51569,'Revenga'),(616,51570,'Revilla'),(616,51573,'Riaza'),(616,51574,'Ribota'),(616,51578,'Roda de eresma'),(616,51579,'Sacramenia'),(616,51581,'Saldaña de ayllon'),(616,51582,'Samboal'),(616,51583,'San Cristóbal de Cuéllar'),(616,51584,'San Cristóbal de la Vega'),(616,51585,'San Ildefonso o La Granja'),(616,51587,'San miguel de bernuy'),(616,51588,'San pedro'),(616,51589,'San pedro de gaillos'),(616,51591,'San rafael'),(616,51592,'Sanchonuño'),(616,51593,'Sanchopedro'),(616,51594,'Sangarcia'),(616,51595,'Santa cruz'),(616,51599,'Santiuste de san juan bautista'),(616,51600,'Santo domingo de piron'),(616,51601,'Santo tome del puerto'),(616,51602,'Santovenia'),(616,51604,'Sebulcor'),(616,51605,'Segovia'),(616,51606,'Sepulveda'),(616,51607,'Sequera del fresno'),(616,51610,'Sigueruelo'),(616,51611,'Sotillo'),(616,51612,'Sotos de sepulveda'),(616,51613,'Sotosalbos'),(616,51614,'Sta. maria de la real de nieva'),(616,51615,'Tabanera del monte'),(616,51621,'Tejares'),(616,51624,'Torre la'),(616,51626,'Torreadrada'),(616,51627,'Torrecaballeros'),(616,51628,'Torrecilla del pinar'),(616,51630,'Torregutierrez'),(616,51631,'Torreiglesias'),(616,51632,'Trescasas'),(616,51633,'Turegano'),(616,51639,'Valdevacas de montejo'),(616,51641,'Valsain'),(616,51642,'Valseca'),(616,51644,'Valverde del majano'),(616,51647,'Valle de tabladillo'),(616,51648,'Vallelado'),(616,51649,'Valleruela de pedraza'),(616,51653,'Veganzones'),(616,51654,'Vegas de matute'),(616,51659,'Villacastin'),(616,51660,'Villacorta'),(616,51668,'Villaverde de iscar'),(616,51670,'Villeguillo'),(616,51671,'Villoslada'),(616,51672,'Villovela del piron'),(616,51674,'Yanguas de eresma'),(616,51675,'Zamarramala'),(616,51676,'Zarauela del monte'),(616,51677,'Zarzuela del pinar'),(617,51678,'Abaltzisketa'),(617,51679,'Aduna'),(617,51680,'Aguinaga'),(617,51681,'Aia'),(617,51682,'Aitze'),(617,51683,'Aizarna'),(617,51684,'Aizarnazabal'),(617,51685,'Aizpea'),(617,51686,'Albiztur'),(617,51688,'Alegia'),(617,51690,'Alkiza'),(617,51691,'Altzaga'),(617,51693,'Altzo'),(617,51694,'Alzola'),(617,51695,'Amasa'),(617,51696,'Amezketa'),(617,51697,'Andatza'),(617,51698,'Andoain'),(617,51699,'Anguiozar'),(617,51700,'Anoeta'),(617,51701,'Antzuola'),(617,51704,'Arama'),(617,51705,'Arantzazu'),(617,51706,'Araoz'),(617,51707,'Aratz matximenta'),(617,51708,'Aratzerreka'),(617,51709,'Arditurri'),(617,51710,'Arrasate/Mondragón'),(617,51711,'Arrate'),(617,51713,'Arrietamendi'),(617,51714,'Arroa bekoa'),(617,51715,'Arrona'),(617,51716,'Artadi'),(617,51718,'Asteasu'),(617,51719,'Astigarraga'),(617,51721,'Astigarribia'),(617,51722,'Ataun'),(617,51723,'Aya'),(617,51725,'Azkoitia'),(617,51726,'Azpeitia'),(617,51727,'Azpilgoeta'),(617,51728,'Baliarrain'),(617,51730,'Barrenaldea'),(617,51731,'Beasain'),(617,51732,'Bedayo'),(617,51733,'Behobia'),(617,51734,'Beizama'),(617,51735,'Belauntza'),(617,51736,'Berastegi'),(617,51737,'Bergara'),(617,51738,'Berrobi'),(617,51740,'Bolivar'),(617,51741,'Brinkola'),(617,51742,'Deba'),(617,51743,'Eibar'),(617,51744,'Elduain'),(617,51745,'Elgeta'),(617,51746,'Elgoibar'),(617,51748,'Elosua'),(617,51749,'Endoia'),(617,51750,'Erdoizta'),(617,51751,'Ergobia'),(617,51752,'Ergoien'),(617,51753,'Eskoriatza'),(617,51755,'Ezkio'),(617,51756,'Gabiria'),(617,51757,'Gainza'),(617,51758,'Galartza'),(617,51760,'Garagarza'),(617,51761,'Garibay'),(617,51763,'Getaria'),(617,51768,'Hernani'),(617,51769,'Hernialde'),(617,51770,'Hondarribia'),(617,51771,'Iciar'),(617,51772,'Idiazabal'),(617,51773,'Igueldo'),(617,51774,'Ikaztegieta'),(617,51775,'Iraeta'),(617,51776,'Irun'),(617,51777,'Irura'),(617,51779,'Irusta'),(617,51780,'Itsaso'),(617,51781,'Itsasondo'),(617,51783,'Jauregui'),(617,51786,'Lasarte'),(617,51787,'Lastur'),(617,51790,'Lauztierreka'),(617,51791,'Lazkao'),(617,51792,'Lazkaomendi'),(617,51794,'Legazpia'),(617,51795,'Legorreta'),(617,51796,'Leintz gatzaga'),(617,51797,'Lezo'),(617,51798,'Lizartza'),(617,51799,'Loiola'),(617,51801,'Madariaga'),(617,51805,'Mendaro'),(617,51807,'Mutiloa'),(617,51808,'Mutriku'),(617,51809,'Nuarbe'),(617,51810,'Oiartzun'),(617,51812,'Olabarrieta'),(617,51813,'Olaberria'),(617,51814,'Olaskoegia'),(617,51815,'Olaso'),(617,51817,'Oñati'),(617,51818,'Oñatz'),(617,51819,'Ordizia'),(617,51821,'Orexa'),(617,51823,'Orio'),(617,51824,'Ormaiztegi'),(617,51828,'Otzaurte'),(617,51829,'Pagoaga'),(617,51830,'Pasai'),(617,51831,'Pasai antxo'),(617,51832,'Pasai san juan'),(617,51833,'Pasai san pedro'),(617,51834,'Pikoketa'),(617,51835,'Placencia'),(617,51837,'Renteria'),(617,51838,'San gregorio'),(617,51839,'San lorenzo'),(617,51840,'San prudentzio'),(617,51841,'San Sebastián'),(617,51842,'Santa agueda'),(617,51843,'Santa lutzi anduaga'),(617,51844,'Santa marina'),(617,51846,'Saturraran'),(617,51848,'Segura'),(617,51850,'Soravilla'),(617,51852,'Tolosa'),(617,51854,'Txikierdi'),(617,51856,'Udala'),(617,51857,'Ugaldetxo'),(617,51859,'Ugarte barri'),(617,51863,'Urnieta'),(617,51864,'Urrestilla'),(617,51865,'Urretxu'),(617,51866,'Ursuaran'),(617,51868,'Usurbil'),(617,51870,'Veneras'),(617,51871,'Ventas'),(617,51872,'Villabona'),(617,51873,'Zaldibia'),(617,51874,'Zarautz'),(617,51875,'Zegama'),(617,51876,'Zerain'),(617,51877,'Zestoa'),(617,51878,'Zizurkil'),(617,51879,'Zubieta'),(617,51881,'Zumaia'),(617,51882,'Zumarraga'),(618,51883,'Abenojar'),(618,51884,'Agudo'),(618,51885,'Alameda de cervera'),(618,51886,'Alameda la'),(618,51887,'Alamillo'),(618,51888,'Albaladejo'),(618,51889,'Alcázar de San Juan'),(618,51890,'Alcoba'),(618,51891,'Alcolea de calatrava'),(618,51893,'Alcubillas'),(618,51894,'Aldea del rey'),(618,51895,'Alhambra'),(618,51896,'Almadén'),(618,51897,'Almadenejos'),(618,51898,'Almagro'),(618,51899,'Almedina'),(618,51900,'Almodóvar del Campo'),(618,51901,'Almuradiel'),(618,51902,'Anchuras'),(618,51903,'Arenales de san gregorio'),(618,51904,'Arenas de san juan'),(618,51905,'Argamasilla de Alba'),(618,51906,'Argamasilla de Calatrava'),(618,51907,'Arroba de los montes'),(618,51910,'Bazan'),(618,51911,'Belvis'),(618,51913,'Bolaños de Calatrava'),(618,51914,'Brazatortas'),(618,51915,'Bullaque el'),(618,51916,'Cabezarados'),(618,51917,'Cabezarrubias del puerto'),(618,51919,'Calzada de Calatrava'),(618,51920,'Campo de Criptana'),(618,51921,'Cañada de calatrava'),(618,51922,'Cañamares'),(618,51923,'Caracuel'),(618,51924,'Carrión de Calatrava'),(618,51925,'Carrizosa'),(618,51926,'Casa de la puente'),(618,51927,'Casas blancas'),(618,51929,'Castellar de Santiago'),(618,51931,'Cinco casas'),(618,51932,'Ciudad Real'),(618,51933,'Corral de calatrava'),(618,51934,'Cortijo de abajo'),(618,51935,'Cortijo de arriba'),(618,51936,'Cozar'),(618,51937,'Cristo espiritu santo'),(618,51938,'Daimiel'),(618,51940,'Fernancaballero'),(618,51942,'Fontanosas'),(618,51943,'Fuencaliente'),(618,51946,'Fuente el Fresno'),(618,51948,'Garganta la'),(618,51950,'Granatula de calatrava'),(618,51951,'Guadalmez'),(618,51952,'Herencia'),(618,51953,'Herrera de la mancha'),(618,51954,'Hinojosas de calatrava'),(618,51955,'Horcajo de los montes'),(618,51956,'Hoyo el'),(618,51958,'Huertezuelas'),(618,51959,'Labores las'),(618,51961,'Luciana'),(618,51962,'Llanos del caudillo'),(618,51963,'Malagón'),(618,51964,'Manzanares'),(618,51965,'Membrilla'),(618,51966,'Mestanza'),(618,51967,'Miguelturra'),(618,51968,'Minas de horcajo'),(618,51972,'Montiel'),(618,51973,'Moral de Calatrava'),(618,51978,'Pedralosas las'),(618,51979,'Pedro Muñoz'),(618,51980,'Peralvillo'),(618,51981,'Picon'),(618,51982,'Piedrabuena'),(618,51984,'Poblachuela la'),(618,51985,'Poblado calvo sotelo'),(618,51986,'Poblete'),(618,51987,'Porzuna'),(618,51989,'Pozo de la serna'),(618,51990,'Pozuelo de Calatrava'),(618,51992,'Puebla de don rodrigo'),(618,51993,'Puebla del principe'),(618,51995,'Puerto lapice'),(618,51996,'Puertollano'),(618,51997,'Quiles los'),(618,51999,'Retuerta del bullaque'),(618,52001,'Ruidera'),(618,52002,'Saceruela'),(618,52003,'San benito'),(618,52004,'San carlos del valle'),(618,52007,'Santa Cruz de Mudela'),(618,52009,'Socuéllamos'),(618,52010,'Solana del pino'),(618,52011,'La Solana'),(618,52013,'Sotillo el'),(618,52014,'Terrinches'),(618,52017,'Tomelloso'),(618,52018,'Torno el'),(618,52019,'Torralba de Calatrava'),(618,52020,'Torre de juan abad'),(618,52021,'Torrecilla'),(618,52022,'Torrenueva'),(618,52027,'Valdemanco de esteras'),(618,52028,'Valdepeñas'),(618,52030,'Valverde'),(618,52034,'Villahermosa'),(618,52036,'Villamanrique'),(618,52037,'Villamayor de calatrava'),(618,52038,'Villanueva de franco'),(618,52039,'Villanueva de la Fuente'),(618,52040,'Villanueva de los Infantes'),(618,52041,'Villanueva de san carlos'),(618,52044,'Villarrubia de los Ojos'),(618,52045,'Villarta de San Juan'),(618,52046,'Viñuela'),(618,52047,'Virtudes'),(618,52048,'Viso del Marqués'),(619,52049,'Abadiño'),(619,52050,'Aceña la'),(619,52051,'Ajangiz'),(619,52052,'Ajuria'),(619,52053,'Akorda'),(619,52054,'Albiz'),(619,52055,'Aldacueva'),(619,52056,'Aldana'),(619,52057,'Aldape'),(619,52058,'Alday'),(619,52059,'Alen'),(619,52060,'Alonsotegi'),(619,52061,'Alzusta'),(619,52063,'Ambasaguas'),(619,52064,'Amezola'),(619,52065,'Amorebieta-Etxano'),(619,52066,'Amoroto'),(619,52067,'Andra mari de meñaka'),(619,52068,'Andraka'),(619,52070,'Apatamonasterio'),(619,52071,'Aracaldo'),(619,52072,'Arana'),(619,52074,'Aranguren'),(619,52075,'Arantzazu'),(619,52076,'Arbacegui monditivar'),(619,52078,'Arboleda la'),(619,52079,'Areatza'),(619,52080,'Arenao'),(619,52081,'Arenas las'),(619,52082,'Aresandiaga'),(619,52083,'Areta'),(619,52084,'Arguiñano'),(619,52085,'Arilza olazar'),(619,52086,'Arkotxa'),(619,52087,'Arminza'),(619,52088,'Arostegieta'),(619,52089,'Arraibi'),(619,52090,'Arrankudiaga'),(619,52091,'Arrazola'),(619,52092,'Arrieta libano'),(619,52093,'Arrigorriaga'),(619,52094,'Arronategui'),(619,52096,'Arzuaga'),(619,52100,'Asterrica'),(619,52101,'Atxuri'),(619,52102,'Aulesti'),(619,52103,'Autzagana'),(619,52104,'Avellaneda'),(619,52105,'Axpe'),(619,52107,'Azkarai'),(619,52108,'Bakio'),(619,52109,'Balmaseda'),(619,52110,'Barakaldo'),(619,52111,'Barinaga'),(619,52113,'Barrika'),(619,52114,'Basatxetas'),(619,52115,'Basauri'),(619,52116,'Basetxeta'),(619,52117,'Beci'),(619,52118,'Bedarona'),(619,52119,'Bedia'),(619,52120,'Belandia'),(619,52122,'Berango'),(619,52123,'Bermeo'),(619,52124,'Bernagoitia'),(619,52125,'Bernales'),(619,52127,'Berriatua'),(619,52128,'Berrio'),(619,52129,'Berriz ollacueta'),(619,52130,'Betako'),(619,52131,'Bilbao'),(619,52132,'Billela'),(619,52133,'Bolibar'),(619,52134,'Botiola'),(619,52135,'Busturia axpe'),(619,52136,'Butron'),(619,52137,'Callejo el'),(619,52139,'Castillo elejabeitia'),(619,52140,'Ceanuri'),(619,52142,'Ciervana'),(619,52143,'Concha'),(619,52146,'Derio'),(619,52147,'Durango'),(619,52148,'Ea'),(619,52149,'Elantxobe'),(619,52150,'Elorrio'),(619,52153,'Erandio'),(619,52156,'Ermua'),(619,52157,'Errigoiti'),(619,52158,'Etxebarri'),(619,52159,'Euba'),(619,52160,'Fika'),(619,52161,'Fruniz'),(619,52162,'Galdakao'),(619,52163,'Gallarta'),(619,52164,'Gallartu'),(619,52165,'Gamiz-Fika'),(619,52166,'Garay'),(619,52167,'Gatica'),(619,52169,'Gernika-Lumo'),(619,52170,'Gerrikaitz'),(619,52171,'Getxo'),(619,52175,'Goitioltza'),(619,52176,'Goiuria'),(619,52177,'Gorgolas'),(619,52178,'Gorliz'),(619,52179,'Goyerri'),(619,52180,'Güeñes'),(619,52181,'Guerana'),(619,52182,'Guizaburuaga'),(619,52185,'Ibarra'),(619,52186,'Ibarranguelua'),(619,52187,'Ibarrola'),(619,52188,'Ibarruri'),(619,52191,'Igorre'),(619,52194,'Ipiñaburu'),(619,52196,'Ispaster'),(619,52197,'Iturreta'),(619,52198,'Iurreta'),(619,52199,'Izurza'),(619,52200,'Jainko-oleaga'),(619,52201,'Kortezubi'),(619,52203,'Lanzas agudas'),(619,52204,'Larrabetzu'),(619,52205,'Larrauri'),(619,52207,'Laukiz'),(619,52208,'Lauro'),(619,52210,'Ledoño de arriba'),(619,52211,'Leioa'),(619,52213,'Lekeitio'),(619,52214,'Lemoa'),(619,52215,'Lezama'),(619,52216,'Libarona'),(619,52218,'Loiu'),(619,52223,'Mallabia'),(619,52224,'Mañaria'),(619,52225,'Markina-Xemein'),(619,52226,'Marmiz'),(619,52228,'Marueta'),(619,52229,'Matiena'),(619,52230,'Matienzo'),(619,52236,'Mendexa'),(619,52238,'Mercadillo'),(619,52241,'Mundaka'),(619,52242,'Mungia'),(619,52243,'Muñecas las'),(619,52244,'Murueta'),(619,52245,'Navarniz'),(619,52246,'Oba'),(619,52247,'Olabarri'),(619,52249,'Olabe'),(619,52252,'Ondarroa'),(619,52253,'Oñarte'),(619,52254,'Orduña'),(619,52255,'Orobios'),(619,52256,'Orozqueta'),(619,52257,'Ortuella'),(619,52259,'Otxandio'),(619,52260,'Otxarkoaga'),(619,52261,'Pando'),(619,52262,'Pando'),(619,52264,'Paules'),(619,52266,'Plentzia'),(619,52267,'Pobeña'),(619,52268,'Ponton el'),(619,52269,'Portugalete'),(619,52270,'Regato el'),(619,52271,'Renteria'),(619,52272,'Rigada la'),(619,52273,'Rioseco'),(619,52274,'San andres de etxebarria'),(619,52275,'San cristobal'),(619,52276,'San esteban'),(619,52277,'San lorenzo de maruri'),(619,52278,'San martin'),(619,52279,'San miguel'),(619,52280,'San pedro de galdames'),(619,52281,'San pelayo'),(619,52283,'Santa maria de getxo'),(619,52284,'Santecilla'),(619,52286,'Santurtzi'),(619,52287,'Sestao'),(619,52288,'Sodupe'),(619,52290,'Somorrostro'),(619,52291,'Sondika'),(619,52292,'Sopelana'),(619,52293,'Sukarrieta'),(619,52294,'Trapagaran'),(619,52295,'Traslaviña'),(619,52297,'Triano'),(619,52299,'Ubilla urberuaga'),(619,52300,'Ugao-Miraballes'),(619,52301,'Ugarana'),(619,52302,'Ugarte goikoa'),(619,52303,'Ugarte muxika'),(619,52304,'Umbe'),(619,52306,'Urduliz'),(619,52309,'Urkiola'),(619,52311,'Urrutia'),(619,52312,'Usansolo'),(619,52314,'Villanueva de la presa'),(619,52315,'Zabala'),(619,52316,'Zaldibar'),(619,52317,'Zaldu'),(619,52318,'Zalla'),(619,52319,'Zamudio'),(619,52321,'Zaratamo'),(619,52322,'Zeberio zubialde'),(619,52323,'Ziortza'),(619,52324,'Zollo'),(619,52326,'Zubiaur'),(619,52327,'Zubiaur orozko'),(619,52328,'Zubieta'),(619,52329,'Zugastieta'),(620,52330,'Abecia'),(620,52331,'Abechuco'),(620,52332,'Abornicano'),(620,52333,'Acilu'),(620,52334,'Acosta'),(620,52335,'Adana'),(620,52336,'Alaiza'),(620,52337,'Alangua'),(620,52338,'Albeniz'),(620,52339,'Alcedo'),(620,52340,'Alda'),(620,52341,'Alegría-Dulantzi'),(620,52342,'Altube'),(620,52344,'Amezaga'),(620,52345,'Amurrio'),(620,52346,'Anda'),(620,52347,'Andagoya'),(620,52349,'Andollu'),(620,52350,'Angostina'),(620,52352,'Antoñana'),(620,52354,'Añes'),(620,52355,'Añua'),(620,52356,'Apellaniz'),(620,52357,'Aperregui'),(620,52358,'Apodaca'),(620,52360,'Araca'),(620,52361,'Aranguiz'),(620,52362,'Araya'),(620,52364,'Arcaute'),(620,52366,'Aretxavaleta'),(620,52367,'Argomaniz'),(620,52369,'Armentia'),(620,52371,'Arraia Maeztu'),(620,52372,'Arreo'),(620,52374,'Arriola'),(620,52375,'Arrizala'),(620,52376,'Arroyabe'),(620,52380,'Artziniega'),(620,52381,'Ascarza'),(620,52382,'Aspuru'),(620,52383,'Assa'),(620,52385,'Atauri'),(620,52388,'Azaceta'),(620,52390,'Azua'),(620,52392,'Baños de Ebro'),(620,52393,'Barambio'),(620,52394,'Baroja'),(620,52395,'Barrio'),(620,52396,'Barriobusto'),(620,52397,'Barron'),(620,52402,'Berantevilla'),(620,52404,'Berganzo'),(620,52405,'Bergsenda'),(620,52406,'Bernedo'),(620,52407,'Berricano'),(620,52408,'Berrosteguieta'),(620,52409,'Betolaza'),(620,52413,'Buruaga'),(620,52417,'Carcamo'),(620,52418,'Castillo'),(620,52421,'Comunion'),(620,52423,'Corres'),(620,52425,'Cripan'),(620,52427,'Chichetru'),(620,52429,'Delica'),(620,52431,'Durana'),(620,52433,'Echeuarri'),(620,52434,'Echevarri-Urtupiña'),(620,52435,'Eguilaz'),(620,52440,'Elciego'),(620,52442,'Elosu'),(620,52443,'Elvillar'),(620,52447,'Espejo'),(620,52448,'Estarrona'),(620,52450,'Etura'),(620,52453,'Fontecha'),(620,52454,'Foronda'),(620,52455,'Fresneda'),(620,52458,'Gamiz'),(620,52460,'Gauna'),(620,52461,'Gobeo'),(620,52462,'Gomecha'),(620,52463,'Gopegui'),(620,52465,'Gordoa'),(620,52472,'Gurendes'),(620,52473,'Heredia'),(620,52475,'Hermua'),(620,52478,'Huerto Arriba'),(620,52479,'Ibarguren'),(620,52480,'Ibarra'),(620,52481,'Ibisate'),(620,52483,'Inoso'),(620,52485,'Izarra'),(620,52486,'Izarza'),(620,52490,'Labastida'),(620,52491,'Lacervilla'),(620,52492,'Lagrán'),(620,52493,'Laguardia'),(620,52496,'Lanciego'),(620,52498,'Lapuebla de Labarca'),(620,52500,'Larrimbe'),(620,52501,'Lasarte'),(620,52506,'Legarda'),(620,52510,'Leza'),(620,52511,'Lezama'),(620,52513,'Luco'),(620,52515,'Luquiano'),(620,52516,'Luyando'),(620,52517,'Luzuriaga'),(620,52518,'Llantano'),(620,52520,'Llodio'),(620,52524,'Manzanos'),(620,52526,'Marieta-Larrinzar'),(620,52528,'Maroño'),(620,52532,'Mendarozqueta'),(620,52533,'Mendieta'),(620,52535,'Mendiola'),(620,52537,'Mendoza'),(620,52541,'Miñano Mayor'),(620,52546,'Montorio'),(620,52547,'Moreda de Álava'),(620,52550,'Murguia'),(620,52553,'Nanclares de la Oca'),(620,52559,'Ocio'),(620,52560,'Oion'),(620,52562,'Olaeta'),(620,52566,'Ondategui'),(620,52569,'Opakua'),(620,52572,'Ordoñana'),(620,52573,'Oreitia'),(620,52576,'Otaza'),(620,52577,'Otazu'),(620,52578,'Oteo'),(620,52580,'Ozaeta'),(620,52581,'Paganos'),(620,52585,'Pipaon'),(620,52586,'Pobes'),(620,52587,'Portilla'),(620,52588,'Puentelarra'),(620,52593,'Respaldiza'),(620,52595,'Ribera'),(620,52596,'Rivavellosa'),(620,52598,'Sabando'),(620,52599,'Salcedo'),(620,52600,'Salinas de Añana'),(620,52601,'Salinillas de Buradon'),(620,52603,'Salvatierra'),(620,52604,'Samaniego'),(620,52609,'San Román'),(620,52610,'San Vicente de Arana'),(620,52611,'Santa Cruz de Campezo'),(620,52612,'Santa Cruz del Fierro'),(620,52613,'Santa Eulalia'),(620,52615,'Saracho'),(620,52616,'Sarria'),(620,52623,'Tobillas'),(620,52624,'Trespuentes'),(620,52626,'Tuesta'),(620,52628,'Tuyo'),(620,52629,'Ullibarri'),(620,52633,'Ullibarri Gamboa'),(620,52634,'Ullibarri Jauregui'),(620,52638,'Urbina'),(620,52641,'Urturi'),(620,52643,'Valluerca'),(620,52645,'Viloria'),(620,52647,'Villabuena de Álava'),(620,52648,'Villafria'),(620,52654,'Villanueva de Valdegovia'),(620,52655,'Villarreal de Álava'),(620,52657,'Villodas'),(620,52659,'Virgala Mayor'),(620,52660,'Virgala Menor'),(620,52661,'Vitoria'),(620,52662,'Vitoriano'),(620,52663,'Yécora'),(620,52664,'Yurre'),(620,52666,'Zaitegui'),(620,52667,'Zalduendo de Álava'),(620,52668,'Zambrana'),(620,52669,'Zarate'),(620,52671,'Zuazo'),(620,52673,'Zudiviarte'),(620,52674,'Zumelzu'),(621,52675,'Abad'),(621,52676,'Abanqueiro'),(621,52677,'Abegondo'),(621,52678,'Abella'),(621,52679,'Abelleira'),(621,52680,'Abuin'),(621,52681,'Agualada'),(621,52682,'Aguassantas'),(621,52683,'Aguiño'),(621,52684,'Albores'),(621,52685,'Aldariz'),(621,52686,'Aldeavella'),(621,52687,'Aldemunde'),(621,52688,'Allo'),(621,52689,'Ameixeenda'),(621,52690,'Ameixenda'),(621,52691,'Ames'),(621,52693,'Andeade'),(621,52694,'Andeiro'),(621,52695,'Angustia'),(621,52696,'Os Anxeles'),(621,52698,'Aña'),(621,52699,'Aranga'),(621,52701,'Ardaña'),(621,52702,'Ares'),(621,52703,'Argalo'),(621,52704,'Armeton'),(621,52705,'Arou'),(621,52706,'Arteixo'),(621,52707,'Artes'),(621,52708,'Arzon'),(621,52709,'Arzúa'),(621,52710,'As neves'),(621,52712,'Augapesada'),(621,52713,'Aviño'),(621,52714,'Babio'),(621,52715,'Baiñas'),(621,52716,'Baio'),(621,52717,'Balares'),(621,52718,'Baldaio'),(621,52719,'A Baña'),(621,52720,'Baos'),(621,52721,'Barbeira'),(621,52722,'Barcala (san xoan)'),(621,52723,'Bardaos'),(621,52726,'A Barqueira'),(621,52727,'Barrañan'),(621,52728,'Barro'),(621,52729,'Bastavales'),(621,52730,'Bazar'),(621,52732,'Beigondo'),(621,52734,'Berdeogas'),(621,52735,'Berdia'),(621,52736,'Berdillo'),(621,52737,'Berdoias'),(621,52738,'Bergondo'),(621,52739,'Bertoa'),(621,52740,'Betanzos'),(621,52741,'Biduido'),(621,52742,'Boaño'),(621,52743,'Boimorto'),(621,52744,'Boiro'),(621,52745,'Boqueixón'),(621,52746,'Borneiro'),(621,52748,'Brandeso'),(621,52750,'Brandoñas'),(621,52751,'Brantoas'),(621,52753,'A Brea'),(621,52755,'Brión'),(621,52758,'Bugallido'),(621,52759,'Buño'),(621,52760,'Burres'),(621,52762,'Buxantes'),(621,52763,'Caamaño'),(621,52764,'Cabana'),(621,52766,'Cabanas'),(621,52768,'Cacheiras'),(621,52769,'Caion'),(621,52771,'Calo'),(621,52774,'Camariñas'),(621,52776,'Cambre'),(621,52778,'Camces Grandes'),(621,52779,'Camelle'),(621,52782,'Cando'),(621,52783,'Candoas'),(621,52784,'Capela a'),(621,52786,'Carballo'),(621,52788,'Cariño'),(621,52789,'Carnes'),(621,52790,'Carnota'),(621,52792,'Carral'),(621,52793,'Carres'),(621,52794,'Casal de Arriba'),(621,52795,'Castañeda'),(621,52796,'Castelo'),(621,52797,'Castiñeira'),(621,52800,'Castriz'),(621,52801,'Castro'),(621,52805,'Cedeira'),(621,52806,'Cee'),(621,52808,'Cerceda'),(621,52809,'Cerdido'),(621,52810,'Cereo'),(621,52811,'Cerqueda'),(621,52812,'Cervas'),(621,52813,'Cervo'),(621,52814,'Cespon'),(621,52815,'Cesuras'),(621,52817,'Cobas'),(621,52819,'Coiro'),(621,52820,'Coirós'),(621,52822,'Conxo'),(621,52823,'Corbelle'),(621,52824,'Corcoesto'),(621,52825,'Corcubión'),(621,52826,'Coristanco'),(621,52827,'Corme'),(621,52828,'Corredoiras'),(621,52829,'Corrubedo'),(621,52830,'A Coruña'),(621,52831,'Cospindo'),(621,52832,'Costa'),(621,52834,'Coucieiro'),(621,52835,'Couzadoiro'),(621,52836,'Cruces'),(621,52837,'Cuiña'),(621,52838,'Culleredo'),(621,52839,'Cumbraos'),(621,52840,'Cuns'),(621,52841,'Cures'),(621,52842,'Curtis'),(621,52843,'Curtis San Vicente'),(621,52844,'Curtis Santa Eulalia'),(621,52846,'Chaian'),(621,52847,'Chimparra'),(621,52848,'Churrio'),(621,52849,'Daneiro'),(621,52851,'Dexo'),(621,52852,'Dodro'),(621,52853,'Dombate'),(621,52854,'Doniños'),(621,52856,'Dumbría'),(621,52857,'Enchousas'),(621,52858,'Enfesta'),(621,52860,'Entrecruces'),(621,52862,'As Escobras'),(621,52863,'A Escravitude'),(621,52864,'Esmelle'),(621,52866,'Espasante San Juan'),(621,52868,'Esteiro'),(621,52871,'Eume'),(621,52872,'Ezaro'),(621,52875,'Fene'),(621,52876,'Ferreira'),(621,52878,'Ferrol'),(621,52879,'Figueiras'),(621,52881,'Filgueira'),(621,52882,'Filgueira de Barranca'),(621,52883,'Filgueiras'),(621,52884,'Fisterra'),(621,52885,'Folgoso'),(621,52887,'Formelos'),(621,52888,'Frades'),(621,52889,'Freixeiro'),(621,52890,'Freixo'),(621,52894,'Gandara'),(621,52898,'Golmar'),(621,52901,'Graña'),(621,52902,'A Graña'),(621,52904,'A Grela'),(621,52906,'Grixoa'),(621,52908,'Herbes'),(621,52909,'Herbon'),(621,52912,'Lago'),(621,52913,'Laiño'),(621,52914,'Lamas'),(621,52916,'Lanza'),(621,52917,'Lañas'),(621,52918,'Laracha'),(621,52919,'Lariño'),(621,52920,'Lavacolla'),(621,52922,'Laxe'),(621,52923,'Leioio'),(621,52924,'Leira'),(621,52927,'Lemaio'),(621,52929,'Lens'),(621,52930,'Leroño'),(621,52931,'Lesende'),(621,52933,'Leston'),(621,52934,'Limodre'),(621,52936,'Lira'),(621,52940,'Loureda'),(621,52942,'Louro'),(621,52943,'Lousame'),(621,52946,'Luou'),(621,52948,'Macenda'),(621,52949,'Malpica de Bergantiños'),(621,52953,'Mañón'),(621,52954,'Mariños'),(621,52956,'As Maroñas'),(621,52960,'Mazaricos'),(621,52961,'Meana'),(621,52963,'Meirama'),(621,52964,'Meiras'),(621,52966,'Meire'),(621,52967,'Melide'),(621,52969,'Mera'),(621,52973,'Mesía'),(621,52974,'Meson do Vento'),(621,52975,'Miño'),(621,52976,'Miñortos'),(621,52977,'Mira'),(621,52978,'Miron'),(621,52979,'Moar'),(621,52980,'Moeche'),(621,52981,'Monfero'),(621,52982,'Monte'),(621,52984,'Montevixan'),(621,52985,'Montouto'),(621,52987,'Moraime'),(621,52988,'Moras'),(621,52992,'Mugardos'),(621,52994,'Muros'),(621,52995,'Muxía'),(621,52996,'Nanton'),(621,52997,'Narón'),(621,52998,'Nebra'),(621,52999,'Neda'),(621,53000,'Negreira'),(621,53001,'Nemeño'),(621,53003,'As Neves'),(621,53005,'Noia'),(621,53006,'Noicela'),(621,53009,'Ois'),(621,53010,'Olas'),(621,53011,'Oleiros'),(621,53012,'Oleiros'),(621,53014,'Olveira'),(621,53016,'Olveiroa'),(621,53017,'Ordes'),(621,53019,'Oroso'),(621,53021,'Ortigueira'),(621,53022,'Orto'),(621,53024,'Oural'),(621,53025,'Outes'),(621,53026,'Oza'),(621,53027,'Oza dos Ríos'),(621,53029,'Padreiro'),(621,53030,'Padrón'),(621,53031,'Paiosaco'),(621,53032,'Palmeira'),(621,53033,'Pantin'),(621,53034,'Pantiñobre'),(621,53040,'Paxareiras'),(621,53041,'Pazos'),(621,53043,'A Pedra'),(621,53044,'O Pedrouzo'),(621,53045,'A Pena'),(621,53046,'Pequian'),(621,53047,'Perbes'),(621,53048,'A Pereira'),(621,53049,'Pereira'),(621,53051,'Perillo'),(621,53052,'Pesqueira'),(621,53055,'Picaraña'),(621,53056,'O Pindo'),(621,53058,'O Pino'),(621,53060,'Piñeiro'),(621,53063,'Pobra do Caramiñal'),(621,53065,'Ponte Beluso'),(621,53067,'Ponte do Porto'),(621,53071,'Ponte Ulla'),(621,53073,'Pontecarreira'),(621,53074,'Ponteceso'),(621,53075,'Pontedeume'),(621,53076,'Pontepedra'),(621,53077,'As Pontes de García Rodríguez'),(621,53078,'Pontevea'),(621,53081,'Portomeiro'),(621,53082,'Portomouro'),(621,53083,'Portosin'),(621,53084,'Poulo'),(621,53085,'Pozomillos'),(621,53088,'A Queimada'),(621,53089,'Queiruga'),(621,53091,'Quembre'),(621,53092,'Quilmas'),(621,53093,'Quintans'),(621,53098,'Razo'),(621,53099,'Reborido'),(621,53100,'Regueira'),(621,53102,'Restande'),(621,53103,'Rial'),(621,53104,'Rianxiño'),(621,53105,'Rianxo'),(621,53107,'Ribeira'),(621,53108,'Ribeira (sant uxia)'),(621,53110,'Rilleira'),(621,53111,'Rodis'),(621,53112,'Rois'),(621,53118,'Sacro'),(621,53119,'Sada'),(621,53120,'Sales'),(621,53121,'As Salgueiras'),(621,53122,'Salto'),(621,53123,'San Andres de Teixido'),(621,53124,'San Mamede'),(621,53125,'San Marcos'),(621,53126,'San Mauro'),(621,53127,'San Pedro de Nos'),(621,53128,'San Ramón'),(621,53129,'San Sadurniño'),(621,53130,'Santa Catalina'),(621,53131,'Santa Comba'),(621,53132,'Santa Cruz'),(621,53133,'Santa María Peregrina'),(621,53134,'Santiago de Compostela'),(621,53135,'Santiso'),(621,53136,'Sarandones'),(621,53137,'Sardiñeiro de Abaixo'),(621,53140,'Seixo'),(621,53141,'Senande'),(621,53142,'Senra'),(621,53143,'Sequeiro'),(621,53145,'Serantes'),(621,53150,'Serra de Outes'),(621,53152,'Sigueiro'),(621,53153,'A Silva'),(621,53155,'Sisamo'),(621,53157,'Sobrado dos Monxes'),(621,53158,'Sofan'),(621,53160,'Souto'),(621,53164,'Suevos'),(621,53167,'Taboada'),(621,53172,'Tapia'),(621,53173,'Tarrio'),(621,53174,'Teixeiro'),(621,53175,'Teo (ramallosa)'),(621,53179,'Toras'),(621,53180,'Tordoia'),(621,53181,'Torres'),(621,53182,'Touro'),(621,53185,'As Travesas'),(621,53186,'Trazo'),(621,53190,'Urdilde'),(621,53191,'Uxes'),(621,53192,'A Vacariza'),(621,53194,'Val do Dubra Bembibre'),(621,53195,'Valdoviño'),(621,53198,'Vedra'),(621,53199,'Veiga'),(621,53200,'Veigue'),(621,53202,'Viceso'),(621,53203,'Vigo'),(621,53204,'Vilabade'),(621,53205,'Vilaboa'),(621,53207,'Vilacova'),(621,53208,'Vilachan'),(621,53211,'Vilanova'),(621,53213,'O Vilar'),(621,53215,'Vilariño'),(621,53216,'Vilarmaior'),(621,53217,'Vilarromariz'),(621,53218,'Vilarrube'),(621,53219,'Vilasantar'),(621,53220,'Vilasenin'),(621,53224,'Vimianzo'),(621,53225,'A Viña'),(621,53228,'Visantoña'),(621,53229,'Visma'),(621,53232,'Vivente'),(621,53234,'Xavestre'),(621,53235,'Xesteda'),(621,53236,'Xestoso'),(621,53238,'Xobre'),(621,53239,'Xomes'),(621,53240,'Xubia-Casadelos'),(621,53241,'Xuño'),(621,53242,'Zas'),(622,53243,'Abaño'),(622,53244,'Abiada'),(622,53245,'Abionzo'),(622,53246,'Acebosa la'),(622,53247,'Adal'),(622,53248,'Aes'),(622,53249,'Agsero'),(622,53250,'Aguilera la'),(622,53251,'Aja'),(622,53252,'Ajanedo'),(622,53253,'Ajo'),(622,53254,'Alceda'),(622,53255,'Alcomba'),(622,53256,'Aldea de ebro'),(622,53258,'Aloños'),(622,53259,'Ambrosero'),(622,53260,'Ampuero'),(622,53261,'Anero'),(622,53264,'Arantiones'),(622,53265,'Araos'),(622,53266,'Arce'),(622,53267,'Arcera'),(622,53268,'Arenal'),(622,53269,'Arenas de iguña'),(622,53271,'Argomilla'),(622,53272,'Argoños'),(622,53274,'Argueso'),(622,53275,'Arnuero'),(622,53276,'Arredondo'),(622,53278,'Arroyo'),(622,53279,'Ason'),(622,53280,'El Astillero'),(622,53281,'Astrana'),(622,53283,'Badames'),(622,53286,'Barcena de pie de concha'),(622,53287,'Barcena mayor'),(622,53288,'Bárcena'),(622,53290,'Barcenaciones'),(622,53291,'Barcenilla'),(622,53292,'Barcenillas'),(622,53295,'Barreda'),(622,53296,'Barrio'),(622,53299,'Bejes'),(622,53300,'Belmonte'),(622,53301,'Beranga'),(622,53302,'Bernales'),(622,53304,'Bielva'),(622,53305,'Bolmir'),(622,53307,'Boo'),(622,53310,'Bostronizo'),(622,53313,'Busta'),(622,53314,'Busta la'),(622,53317,'Bustasur malataja'),(622,53322,'Cabarceno'),(622,53323,'Cabezón de la Sal'),(622,53324,'Cabezon de liebana'),(622,53325,'Caldas de besaya las'),(622,53326,'Calga'),(622,53329,'Camargo'),(622,53331,'Campillo'),(622,53332,'Campo de ebro'),(622,53334,'Campuzano'),(622,53335,'Canales'),(622,53336,'Cañeda'),(622,53337,'Cañedo'),(622,53338,'Carandia'),(622,53339,'Carazon'),(622,53340,'Carcobas las'),(622,53341,'Carmona'),(622,53342,'Carrasa'),(622,53343,'Carriazo'),(622,53344,'Cartes'),(622,53345,'Casamaria'),(622,53346,'Casares y quevedo'),(622,53347,'Casasola'),(622,53348,'Castillo pedroso'),(622,53350,'Castrillo del haya'),(622,53351,'Castro Urdiales'),(622,53352,'Cavada la'),(622,53353,'Caviedes'),(622,53358,'Cerdigo'),(622,53360,'Cicera'),(622,53361,'Cicero'),(622,53364,'Cobreces'),(622,53367,'Colindres'),(622,53368,'Colio'),(622,53369,'Colsa'),(622,53370,'Collado'),(622,53371,'Comillas'),(622,53373,'Concha la'),(622,53376,'Coo'),(622,53377,'Corconte'),(622,53379,'Los Corrales de Buelna'),(622,53380,'Correpoco'),(622,53381,'Corvera'),(622,53382,'Cos'),(622,53383,'Cosgaya'),(622,53384,'Cosio'),(622,53388,'Cotillo'),(622,53391,'Cubillo de ebro'),(622,53393,'Cudon'),(622,53394,'Cueva'),(622,53397,'Dueso'),(622,53400,'Entrambasaguas'),(622,53401,'Entrambasmestas'),(622,53402,'Esanos'),(622,53403,'Escalante'),(622,53404,'Escobedo'),(622,53405,'Esles'),(622,53406,'Espinama'),(622,53412,'Fontibre'),(622,53413,'Fraguas las'),(622,53415,'Fresneda'),(622,53419,'Galizano'),(622,53420,'Gama'),(622,53422,'Ganzo'),(622,53423,'Gibaja'),(622,53427,'Hazas de cesto'),(622,53430,'Helguera'),(622,53431,'Helgueras'),(622,53432,'Herada'),(622,53433,'Heras'),(622,53434,'Hermida la'),(622,53435,'Hermosa'),(622,53437,'Hijas'),(622,53438,'Hornedo'),(622,53440,'Hoz de anero'),(622,53441,'Hoznayo'),(622,53443,'Ilces las'),(622,53444,'Isla'),(622,53445,'Islares'),(622,53447,'Labarce'),(622,53448,'Lamedo'),(622,53449,'Lamiña'),(622,53450,'Lanchares'),(622,53451,'Langre'),(622,53452,'Laredo'),(622,53453,'Lastra la'),(622,53455,'Lerones'),(622,53456,'Liandres'),(622,53457,'Liaño'),(622,53458,'Liérganes'),(622,53459,'Limpias'),(622,53460,'Linares'),(622,53461,'Linto'),(622,53462,'Loma somera'),(622,53463,'Lomba la'),(622,53466,'Luey'),(622,53467,'Luriezo'),(622,53468,'Luzmela'),(622,53471,'Llano'),(622,53473,'Llanos los'),(622,53476,'Llerana'),(622,53477,'Lloreda'),(622,53479,'Maliaño'),(622,53480,'Marron'),(622,53481,'Mata de hoz'),(622,53482,'Matamorosa'),(622,53483,'Mataporquera'),(622,53484,'Matarrepudio'),(622,53486,'Mazandrero'),(622,53488,'Mercadal'),(622,53489,'Merilla'),(622,53490,'Miengo'),(622,53491,'Mioño'),(622,53492,'Mirones'),(622,53493,'Mogro'),(622,53496,'Molledo'),(622,53497,'Moncalian'),(622,53499,'Montealegre'),(622,53502,'Movellan'),(622,53503,'Muñorrodero'),(622,53504,'Muriedas'),(622,53505,'Nates'),(622,53506,'Navajeda'),(622,53509,'Nestares'),(622,53510,'Nocina'),(622,53511,'Noja'),(622,53513,'Obregon'),(622,53514,'Ogarrio'),(622,53515,'Ojebar'),(622,53516,'Ojedo'),(622,53518,'Olea'),(622,53520,'Ontaneda'),(622,53521,'Onton'),(622,53522,'Ontoria'),(622,53523,'Orejo'),(622,53524,'Oreña'),(622,53525,'Oriñon'),(622,53526,'Ormas'),(622,53527,'Oruña'),(622,53528,'Orzales'),(622,53529,'Otañes'),(622,53531,'Pamanes'),(622,53535,'Parbayon'),(622,53536,'Pechon'),(622,53537,'Pedredo'),(622,53538,'Pembes'),(622,53539,'Penagos'),(622,53541,'Penilla la'),(622,53544,'Periedo'),(622,53547,'Pesaguero la parte'),(622,53548,'Pesues'),(622,53551,'Pido'),(622,53555,'Poblacion de abajo'),(622,53556,'Poblacion de arriba'),(622,53558,'Polanco'),(622,53559,'Polientes'),(622,53560,'Pomaluengo'),(622,53561,'Pomar'),(622,53564,'Potes'),(622,53567,'Presillas'),(622,53568,'Presillas las'),(622,53570,'Proaño'),(622,53573,'Puente el'),(622,53575,'Puente san miguel'),(622,53576,'Puente Viesgo'),(622,53577,'Puentenansa'),(622,53578,'Pujayo'),(622,53580,'Quejo'),(622,53581,'Quijano'),(622,53582,'Quintana'),(622,53584,'Quintana'),(622,53587,'Rabago'),(622,53588,'Rada'),(622,53589,'Ramales de la Victoria'),(622,53590,'Ranero'),(622,53593,'Rasines'),(622,53596,'Rehoyos'),(622,53597,'Reinosa'),(622,53598,'Reinosilla'),(622,53599,'Renedo'),(622,53601,'Reocín'),(622,53602,'Requejada'),(622,53603,'Requejo'),(622,53607,'Revilla'),(622,53609,'Riba'),(622,53612,'Riopanero'),(622,53613,'Riosapero'),(622,53616,'Riva la'),(622,53617,'Rivero'),(622,53618,'Rocamundo'),(622,53619,'Roiz'),(622,53625,'Rubayo'),(622,53626,'Rucandio'),(622,53628,'Ruente'),(622,53630,'Ruiloba'),(622,53631,'Ruiseñada'),(622,53632,'Saja'),(622,53634,'Salces'),(622,53635,'Samano'),(622,53636,'San andres'),(622,53638,'San bartolome de los montes'),(622,53639,'San bartolome de meruelo'),(622,53641,'San esteban'),(622,53642,'San mames de meruelo'),(622,53644,'San martin de hoyos'),(622,53645,'San mateo'),(622,53646,'San miguel'),(622,53649,'San miguel de luena'),(622,53650,'San miguel de meruelo'),(622,53651,'San pantaleon de aras'),(622,53652,'San pedro'),(622,53653,'San pedro del romeral'),(622,53655,'San roman'),(622,53656,'San roque de riomiera'),(622,53657,'San sebastian de garabandal'),(622,53658,'San Vicente de la Barquera'),(622,53660,'San vicente de toranzo'),(622,53661,'San vicente del monte'),(622,53663,'Santa Cruz de Bezana'),(622,53664,'Santa eulalia'),(622,53666,'Santa María de Cayón'),(622,53667,'Santa olalla'),(622,53668,'Santa olalla de aguayo'),(622,53669,'Santander'),(622,53670,'Santibañez'),(622,53671,'Santillan'),(622,53672,'Santillana del Mar'),(622,53673,'Santiurde de reinosa'),(622,53674,'Santiurde de toranzo'),(622,53675,'Santoña'),(622,53676,'Santotis'),(622,53677,'Santullan'),(622,53679,'Saro'),(622,53680,'Saron'),(622,53681,'Secadura'),(622,53682,'Sel de la carrera'),(622,53684,'Selaya'),(622,53686,'Selviejo'),(622,53687,'Seña'),(622,53689,'Serdio'),(622,53693,'Sierra'),(622,53695,'Silio'),(622,53697,'Sobarzo'),(622,53703,'Solares'),(622,53704,'Solorzano'),(622,53705,'Somahoz'),(622,53707,'Somo'),(622,53708,'Sonabia'),(622,53710,'Sopeña'),(622,53712,'Soto de la marina'),(622,53714,'Suances'),(622,53716,'Suesa'),(622,53717,'S. pedro'),(622,53719,'Tagle'),(622,53720,'Talledo'),(622,53722,'Tama'),(622,53724,'Tanos'),(622,53726,'Tezanos'),(622,53733,'Torrelavega'),(622,53735,'Trasierra'),(622,53736,'Trasvia'),(622,53737,'Treceño'),(622,53739,'Tresviso'),(622,53740,'Tudanca'),(622,53742,'Ubiarco'),(622,53743,'Ucieda de abajo'),(622,53744,'Ucieda de arriba'),(622,53745,'Udalla'),(622,53747,'Val de ason'),(622,53748,'Valcaba'),(622,53752,'Valle de cabuerniga'),(622,53753,'Valles'),(622,53754,'Vargas'),(622,53755,'Vega'),(622,53756,'Vega de pas'),(622,53759,'Veguilla'),(622,53761,'Vejoris'),(622,53766,'Viernoles'),(622,53767,'Villacarriedo'),(622,53768,'Villaescusa'),(622,53770,'Villafufre'),(622,53772,'Villanueva de la peña'),(622,53773,'Villanueva de nia'),(622,53776,'Villapaderne'),(622,53781,'Villaverde de pontones'),(622,53782,'Villaverde de trucios'),(622,53783,'Villayuso'),(622,53786,'Vioño'),(622,53787,'Virgen la'),(622,53788,'Viveda'),(622,53790,'Yera'),(622,53791,'Yermo'),(623,53792,'Abejuela'),(623,53793,'Abla'),(623,53794,'Abrucena'),(623,53795,'Adra'),(623,53796,'Agua Amarga'),(623,53797,'Agua del Medio'),(623,53798,'Aguadulce'),(623,53799,'Los Alamos'),(623,53800,'Albánchez'),(623,53801,'Los Albaricoques'),(623,53802,'Alboloduy'),(623,53803,'Albox'),(623,53804,'Alcaudique'),(623,53805,'La Alcazaba'),(623,53806,'Alcolea'),(623,53807,'Alcóntar'),(623,53809,'Alcudia de Monteagudo'),(623,53810,'Aldeire'),(623,53811,'La Alfahuara'),(623,53812,'Alfaix'),(623,53813,'La Alfoquia'),(623,53814,'Alhabia'),(623,53815,'Alhama de Almería'),(623,53816,'El Alhanchete'),(623,53817,'Alicún'),(623,53818,'Almadrava de Monterva'),(623,53819,'Almajalejo'),(623,53820,'Almanzora'),(623,53821,'El Almendral'),(623,53822,'Almería'),(623,53823,'Almerimar'),(623,53824,'Almócita'),(623,53825,'El Alquian'),(623,53826,'Alsodux'),(623,53828,'Antas'),(623,53829,'Arboleas'),(623,53831,'Armuña de Almanzora'),(623,53833,'El Arteal'),(623,53834,'Aspilla'),(623,53835,'Atochares'),(623,53837,'Bacares'),(623,53838,'Balanegra'),(623,53839,'Balerma'),(623,53840,'El Barranco de los Lobos'),(623,53841,'El Barranquete'),(623,53842,'La Barriada de Alcora'),(623,53843,'Bayárcal'),(623,53844,'Bayarque'),(623,53845,'Bédar'),(623,53846,'Beires'),(623,53848,'Benahadux'),(623,53849,'Benecid'),(623,53852,'Benizalón'),(623,53853,'Bentarique'),(623,53854,'Berja'),(623,53856,'Bujulu'),(623,53857,'El Cabo de Gata'),(623,53858,'Los Cabreras'),(623,53859,'Campico'),(623,53860,'Campohermoso'),(623,53861,'Canjáyar'),(623,53862,'El Cantal'),(623,53863,'Cantoria'),(623,53864,'La Cañada de Cañepla'),(623,53865,'La Cañada de San Urbano'),(623,53866,'Las Carboneras'),(623,53867,'La Carrasca'),(623,53868,'Casablanca'),(623,53869,'Castala'),(623,53871,'Castro de Filabres'),(623,53872,'Celin'),(623,53873,'El Cercado'),(623,53875,'El Cid'),(623,53876,'Cóbdar'),(623,53877,'El Contador'),(623,53878,'Cortijada de Marín'),(623,53879,'Cortijo del Callejón'),(623,53881,'El Cuche'),(623,53882,'Cuevas de Almanzora'),(623,53883,'Las Cuevas de los Medinas'),(623,53888,'El Chaparral Bajo'),(623,53891,'Chirivel'),(623,53892,'El Chive'),(623,53893,'Dalías'),(623,53894,'Darrical'),(623,53895,'Doña María Ocaña'),(623,53896,'El Ejido'),(623,53897,'Enix'),(623,53898,'Escullar'),(623,53899,'Los Escullos'),(623,53900,'La Estación'),(623,53901,'La Fabriquilla'),(623,53902,'Felix'),(623,53903,'Fernán Pérez'),(623,53904,'Fines'),(623,53905,'Fiñana'),(623,53906,'Fondón'),(623,53907,'La Fuensanta'),(623,53908,'La Fuente de la Higuera'),(623,53910,'La Fuente'),(623,53911,'Fuente Victoria'),(623,53912,'Gádor'),(623,53913,'Los Gallardos'),(623,53915,'La Garrofa'),(623,53916,'Garrucha'),(623,53919,'Gérgal'),(623,53920,'Los Giles'),(623,53921,'Goñar'),(623,53923,'Guardias Viejas'),(623,53924,'Guarros'),(623,53925,'Guazamara'),(623,53926,'La Herradura'),(623,53928,'Higueral'),(623,53929,'El Hijate'),(623,53930,'Hirmes'),(623,53931,'Hortichuelas'),(623,53933,'Huebro'),(623,53934,'Huécija'),(623,53935,'La Huelga'),(623,53936,'Huércal de Almería'),(623,53937,'Huércal-Overa'),(623,53939,'Illar'),(623,53940,'Instinción'),(623,53941,'La Islica'),(623,53947,'Laroya'),(623,53948,'Láujar de Andarax'),(623,53949,'Líjar'),(623,53950,'Los Lobos'),(623,53951,'Lubrín'),(623,53952,'Lucainena'),(623,53953,'Lucainena de las Torres'),(623,53954,'Lúcar'),(623,53955,'El Llano de Don Antonio'),(623,53956,'Llano del Espino'),(623,53958,'El Marchal de Antón López'),(623,53959,'El Marchal'),(623,53961,'María'),(623,53962,'Marraque'),(623,53963,'Los Martínez'),(623,53964,'Matagorda'),(623,53968,'Las Minas'),(623,53969,'Mojácar'),(623,53970,'La Mojonera'),(623,53971,'Los Molinas'),(623,53974,'Nacimiento'),(623,53975,'Las Negras'),(623,53976,'Níjar'),(623,53977,'Las Norias'),(623,53978,'Ocaña'),(623,53979,'Ohanes'),(623,53980,'Olula de Castro'),(623,53981,'Olula del Río'),(623,53982,'Oria'),(623,53983,'Padules'),(623,53984,'Palomares'),(623,53985,'Pampanico'),(623,53986,'El Parador'),(623,53989,'Partaloa'),(623,53990,'Paterna del Río'),(623,53992,'Pechina'),(623,53997,'Pilancon'),(623,53998,'Pilar de Jaravia'),(623,53999,'El Pilar'),(623,54000,'Las Pocicas'),(623,54004,'El Pozo de los Frailes'),(623,54005,'El Pozo del Esparto'),(623,54007,'El Puente del Río'),(623,54009,'El Puerto'),(623,54010,'Puerto Rey'),(623,54011,'Pulpí'),(623,54012,'El Puntal'),(623,54014,'Purchena'),(623,54015,'Rágol'),(623,54016,'La Rambla Aljibe'),(623,54017,'La Rambla Honda'),(623,54018,'El Real'),(623,54019,'El Retamar'),(623,54020,'La Ribera de la Algaida'),(623,54022,'El Río Grande'),(623,54023,'Rioja'),(623,54024,'Rodalquilar'),(623,54025,'Roquetas de Mar'),(623,54027,'El Saltador'),(623,54028,'San Agustín'),(623,54029,'San Francisco'),(623,54030,'San Isidro de Níjar'),(623,54031,'San Juan de Terreros'),(623,54033,'Santa Cruz'),(623,54034,'Santa Fe de Mondújar'),(623,54035,'Santa María de Nieva'),(623,54036,'Santa María del Águila'),(623,54038,'Santopetar'),(623,54040,'Senés'),(623,54041,'La Serena'),(623,54042,'Serón'),(623,54043,'Sierro'),(623,54044,'Somontín'),(623,54045,'Sorbas'),(623,54046,'Suflí'),(623,54047,'Tabernas'),(623,54048,'Taberno'),(623,54049,'Tahal'),(623,54051,'Terque'),(623,54052,'Tices'),(623,54053,'Tíjola'),(623,54054,'Las Tonosas'),(623,54055,'Topares'),(623,54056,'Turre'),(623,54057,'Uleila del Campo'),(623,54058,'Urbanización Roquetas de Mar'),(623,54059,'Urcal'),(623,54060,'Urrácal'),(623,54062,'Velefique'),(623,54063,'Vélez Blanco'),(623,54064,'Vélez Rubio'),(623,54066,'Venta del Viso'),(623,54067,'Vera'),(623,54068,'Viator'),(623,54069,'Vícar'),(623,54070,'Vilaricos'),(623,54071,'El Viso'),(623,54073,'Zurgena'),(624,54074,'Abanto'),(624,54075,'Acered'),(624,54076,'Agón'),(624,54077,'Agramonte'),(624,54078,'Aguarón'),(624,54079,'Aguilar de Ebro'),(624,54080,'Aguilón'),(624,54081,'Ainzón'),(624,54082,'Aladrén'),(624,54083,'Alagón'),(624,54084,'Alarba'),(624,54086,'Albeta'),(624,54087,'Alborge'),(624,54088,'Alcalá de Ebro'),(624,54089,'Alcalá de Moncayo'),(624,54090,'Alconchel de Ariza'),(624,54092,'Alera'),(624,54093,'Alfajarín'),(624,54094,'Alfamén'),(624,54095,'Alfocea'),(624,54097,'Alhama de Aragón'),(624,54099,'La Almolda'),(624,54100,'Almonacid de la Cuba'),(624,54101,'Almonacid de la Sierra'),(624,54102,'La Almunia de Doña Godina'),(624,54103,'Alpartir'),(624,54104,'Aluenda'),(624,54105,'Ambel'),(624,54106,'Anento'),(624,54107,'Aniñón'),(624,54108,'Añón de Moncayo'),(624,54109,'Aranda de Moncayo'),(624,54110,'Arándiga'),(624,54111,'Ardisa'),(624,54112,'Ariza'),(624,54116,'Atea'),(624,54117,'Ateca'),(624,54119,'Azuara'),(624,54120,'Badules'),(624,54121,'Bagses'),(624,54123,'Barboles'),(624,54124,'Bardallur'),(624,54125,'Bardena del Caudillo'),(624,54126,'Barrio de Claveria'),(624,54127,'Barrio de la Salitreria'),(624,54128,'Barues'),(624,54130,'Belchite'),(624,54131,'Belmonte de Calatayud'),(624,54132,'Berbedel'),(624,54133,'Berdejo'),(624,54134,'Berrueco'),(624,54136,'Bijuesca'),(624,54137,'Biota'),(624,54139,'Boquiñeni'),(624,54140,'Bordalba'),(624,54141,'Borja'),(624,54142,'Botorrita'),(624,54143,'Brea de Aragón'),(624,54145,'Bujaraloz'),(624,54146,'Bulbuente'),(624,54148,'El Burgo de Ebro'),(624,54149,'El Buste'),(624,54150,'Cabañas de Ebro'),(624,54152,'Cadrete'),(624,54153,'Calatayud'),(624,54154,'Calatorao'),(624,54155,'Calcena'),(624,54157,'Campillo de Aragón'),(624,54159,'Carenas'),(624,54160,'Cariñena'),(624,54161,'La Cartuja'),(624,54162,'Casas de Espes'),(624,54163,'Casetas'),(624,54164,'Caspe'),(624,54165,'Castejón de Alarba'),(624,54167,'Castejón de Valdejasa'),(624,54168,'Castiliscar'),(624,54170,'Cerueruela'),(624,54171,'Cervera de la Cañada'),(624,54172,'Cetina'),(624,54173,'Cimballa'),(624,54174,'Cinco Olivas'),(624,54175,'Clarés de Ribota'),(624,54176,'Codo'),(624,54177,'Codos'),(624,54180,'Cosuenda'),(624,54181,'Cuarte de Huerva'),(624,54182,'Cubel'),(624,54184,'Las Cuerlas'),(624,54188,'Daroca'),(624,54189,'Ejea de los Caballeros'),(624,54191,'Embid de la Ribera'),(624,54192,'Encinacorba'),(624,54193,'Épila'),(624,54194,'Erla'),(624,54195,'Escatrón'),(624,54196,'Esco'),(624,54198,'Fabara'),(624,54199,'Farasdues'),(624,54200,'Farlete'),(624,54201,'Fayón'),(624,54203,'Figueruelas'),(624,54205,'El Frago'),(624,54206,'El Frasno'),(624,54207,'Fréscano'),(624,54209,'Fuendejalón'),(624,54210,'Fuendetodos'),(624,54211,'Fuentes de Ebro'),(624,54212,'Fuentes de Jiloca'),(624,54214,'Gallocanta'),(624,54215,'Gallur'),(624,54216,'Garrapinillos'),(624,54217,'Gelsa'),(624,54218,'Godojos'),(624,54221,'Gotor'),(624,54223,'Grisén'),(624,54224,'Herrera de los Navarros'),(624,54225,'Ibdes'),(624,54226,'Illueca'),(624,54229,'Jaraba'),(624,54230,'Jarque'),(624,54231,'Jaulín'),(624,54232,'La Joyosa'),(624,54234,'Juslibol'),(624,54235,'Lacasta'),(624,54237,'Lagata'),(624,54238,'Langa del Castillo'),(624,54239,'Layana'),(624,54240,'Lécera'),(624,54241,'Leciñena'),(624,54244,'Litago'),(624,54246,'Lobera de Onsella'),(624,54247,'Longares'),(624,54248,'Longás'),(624,54249,'Lorbes'),(624,54250,'Lucena de Jalón'),(624,54251,'Luceni'),(624,54252,'Luesia'),(624,54254,'Lumpiaque'),(624,54255,'Luna'),(624,54256,'Llumes'),(624,54257,'Maella'),(624,54258,'Magallón'),(624,54259,'Mainar'),(624,54260,'Malanquilla'),(624,54262,'Malón'),(624,54263,'Malpica'),(624,54265,'Maluenda'),(624,54266,'Mallen'),(624,54269,'Mara'),(624,54270,'María de Huerva'),(624,54271,'Marlofa'),(624,54272,'Marracos'),(624,54273,'Mediana'),(624,54274,'Mequinenza'),(624,54276,'Mezalocha'),(624,54277,'Mianos'),(624,54278,'Miedes de Aragón'),(624,54279,'Miraflores'),(624,54281,'Monegrillo'),(624,54282,'Moneva'),(624,54283,'Monreal de Ariza'),(624,54284,'Montañana'),(624,54287,'Monzalbarba'),(624,54289,'Morata de Jalón'),(624,54290,'Morata de Jiloca'),(624,54291,'Morés'),(624,54292,'Moros'),(624,54293,'Movera'),(624,54294,'Moyuela'),(624,54295,'Mozota'),(624,54296,'Muel'),(624,54297,'La Muela'),(624,54299,'Murero'),(624,54300,'Murillo de Gállego'),(624,54301,'Navardún'),(624,54304,'Nonaspe'),(624,54305,'Novallas'),(624,54307,'Novillas'),(624,54308,'Nuévalos'),(624,54309,'Nuez de Ebro'),(624,54311,'Olvés'),(624,54312,'Ontinar del Saz'),(624,54314,'Orera'),(624,54315,'Ores'),(624,54317,'Osera de Ebro'),(624,54318,'Paniza'),(624,54319,'Paracuellos de Jiloca'),(624,54320,'Paracuellos de la Ribera'),(624,54322,'Pastriz'),(624,54324,'Pedrola'),(624,54325,'Las Pedrosas'),(624,54326,'Peñaflor'),(624,54328,'Perdiguera'),(624,54331,'Pina de Ebro'),(624,54332,'Pinseque'),(624,54335,'Plasencia de Jalón'),(624,54340,'Pozuelo de Aragón'),(624,54341,'Pradilla de Ebro'),(624,54343,'Puebla de Alfindén'),(624,54344,'Puendeluna'),(624,54346,'Purroy'),(624,54348,'Quinto'),(624,54349,'Remolinos'),(624,54351,'Ricla'),(624,54352,'Rivas'),(624,54354,'Romanos'),(624,54355,'Rueda de Jalón'),(624,54357,'Ruesta'),(624,54359,'Sadaba'),(624,54360,'Salillas de Jalón'),(624,54364,'San Juan de Mozarrifar'),(624,54365,'San Martín de la Virgen del Mo'),(624,54366,'San Mateo de Gállego'),(624,54369,'Santa Bárbara'),(624,54370,'Santa Cruz de Grío'),(624,54372,'Santa engracia'),(624,54374,'Santa Fe'),(624,54375,'Santa Isabel'),(624,54377,'Sástago'),(624,54378,'Saviñan'),(624,54379,'Sediles'),(624,54383,'Sierra de Luna'),(624,54386,'Sobradiel'),(624,54388,'Sos del Rey Católico'),(624,54389,'Tabuenca'),(624,54391,'Tarazona'),(624,54392,'Tauste'),(624,54393,'Terrer'),(624,54394,'Tierga'),(624,54395,'Tiermas'),(624,54396,'Tobed'),(624,54397,'Tomillares'),(624,54398,'Torralba de los Frailes'),(624,54400,'Torralbilla'),(624,54402,'Torrehermosa'),(624,54403,'Torrelapaja'),(624,54404,'Torrellas'),(624,54405,'Torres'),(624,54406,'Torres de Berrellén'),(624,54407,'Torrijo de la Cañada'),(624,54411,'Trasobares'),(624,54412,'Uncastillo'),(624,54413,'Undués de Lerda'),(624,54417,'Urbanización Virgen de la Fuen'),(624,54418,'Urrea de Jalón'),(624,54419,'Urriés'),(624,54420,'Used'),(624,54421,'Utebo'),(624,54422,'Val de San Martín'),(624,54423,'Valareña'),(624,54425,'Valmadrid'),(624,54426,'Valpalmas'),(624,54429,'Velilla de Ebro'),(624,54432,'Vera de Moncayo'),(624,54435,'Villadoz'),(624,54437,'Villafranca de Ebro'),(624,54441,'Villanueva de Gállego'),(624,54442,'Villanueva de Huerva'),(624,54446,'Villarrapa'),(624,54447,'Villarreal de Huerva'),(624,54448,'Villarroya de la Sierra'),(624,54450,'Vistabella'),(624,54451,'Viver de la Sierra'),(624,54452,'La Zaida'),(624,54453,'Zaragoceta'),(624,54454,'Zaragoza'),(624,54455,'Urbanización el Zorongo'),(624,54456,'Zuera'),(625,54457,'El Abrigo'),(625,54458,'Adeje'),(625,54459,'Agua García'),(625,54460,'Aguamansa'),(625,54461,'Agulo'),(625,54462,'Alajeró'),(625,54463,'Alcala'),(625,54464,'Aldea Blanca'),(625,54465,'Alojera'),(625,54466,'El Amparo'),(625,54467,'Los Angeles'),(625,54468,'Arafo'),(625,54469,'Arguayo'),(625,54470,'Arico'),(625,54471,'Arico el Nuevo'),(625,54472,'Arico el Viejo'),(625,54473,'Arona'),(625,54474,'Arure'),(625,54475,'Bajamar'),(625,54476,'Barlovento'),(625,54477,'Barranco Hondo'),(625,54478,'Benchijigua'),(625,54479,'Breña Alta'),(625,54480,'Breña Baja'),(625,54481,'Buenavista del Norte'),(625,54482,'Cabo Blanco'),(625,54483,'La Calera'),(625,54484,'La Caleta'),(625,54485,'Las Caletas'),(625,54486,'Candelaria'),(625,54487,'Las Casas'),(625,54488,'Los Cristianos'),(625,54489,'Cruz Santa'),(625,54490,'Las Cuevecitas'),(625,54491,'El Charco'),(625,54492,'Chiguergue'),(625,54493,'Chimiche'),(625,54494,'Chio'),(625,54495,'Chipude'),(625,54496,'Chirche'),(625,54497,'Erese'),(625,54498,'Erjos'),(625,54499,'El Escobonal'),(625,54500,'Fasnia'),(625,54501,'Frontera'),(625,54502,'El Frontón'),(625,54503,'Fuencaliente de la Palma'),(625,54504,'El Fuerte'),(625,54505,'Las Galletas'),(625,54506,'Garachico'),(625,54507,'Garafía'),(625,54508,'Geneto'),(625,54509,'Granadilla de Abona'),(625,54510,'El Granel'),(625,54511,'Guamasa'),(625,54512,'La Guancha'),(625,54513,'Guarazoca'),(625,54514,'Guaza'),(625,54515,'Guía de Isora'),(625,54516,'Güímar'),(625,54517,'Hermigua'),(625,54518,'La Hidalga'),(625,54519,'Hoya la'),(625,54520,'Icod de los Vinos'),(625,54521,'Icor'),(625,54522,'Igueste'),(625,54523,'Igueste de San Andrés'),(625,54524,'Las Indias'),(625,54525,'Isora'),(625,54526,'Izaña'),(625,54527,'Jedey'),(625,54528,'La Laguna'),(625,54529,'Laja la'),(625,54530,'Llanillos los'),(625,54531,'Llano del moro'),(625,54532,'Llano negro'),(625,54533,'Los Llanos de Aridane'),(625,54534,'Llanos los'),(625,54535,'Manchas las'),(625,54536,'Masca'),(625,54537,'El Médano'),(625,54538,'Mercedes las'),(625,54539,'Mesa del Mar'),(625,54540,'Mesitas las'),(625,54542,'Mirca'),(625,54543,'Mocanal'),(625,54544,'Mocanes los'),(625,54546,'La Orotava'),(625,54547,'Ortigal el'),(625,54548,'Palmar el'),(625,54549,'Palo Blanco'),(625,54550,'Palomas las'),(625,54551,'El Paso'),(625,54552,'Pedro Álvarez'),(625,54553,'Perdoma la'),(625,54554,'Poris de Abona'),(625,54555,'Portezuelo el'),(625,54556,'Pueblo el'),(625,54557,'Puertito el'),(625,54558,'Puerto de Guimar'),(625,54559,'Puerto de la Cruz'),(625,54560,'Puerto de la Estaca'),(625,54561,'Puerto de Santiago'),(625,54562,'Puerto Naos'),(625,54563,'Punta del Hidalgo'),(625,54564,'Punta la'),(625,54565,'Puntagorda'),(625,54566,'Puntallana'),(625,54567,'Quemados los'),(625,54568,'Rajita la'),(625,54569,'Rarelo'),(625,54570,'Realejo Bajo'),(625,54571,'Los Realejos'),(625,54572,'Restinga la'),(625,54573,'El Río'),(625,54574,'Romantica la'),(625,54575,'Roque el'),(625,54577,'El Rosario'),(625,54578,'Rosas las'),(625,54579,'Ruigomez'),(625,54580,'Sabinita la'),(625,54581,'Sabinosa'),(625,54582,'San Andrés'),(625,54583,'San Andrés'),(625,54585,'San Isidro'),(625,54586,'San juan'),(625,54587,'San Juan de la Rambla'),(625,54588,'San juan perales'),(625,54589,'San marcos'),(625,54590,'San Miguel'),(625,54591,'San Pedro'),(625,54592,'San Sebastián de la Gomera'),(625,54593,'San simon'),(625,54594,'Santa Cruz de la Palma'),(625,54595,'Santa Cruz de Tenerife'),(625,54596,'Santa maria del mar'),(625,54597,'Santa Úrsula'),(625,54598,'Santiago'),(625,54599,'Santiago del Teide'),(625,54600,'Sauces los'),(625,54601,'El Sauzal'),(625,54602,'Los Silos'),(625,54603,'Sobradillo el'),(625,54604,'Socorro el'),(625,54605,'Tabaiba'),(625,54606,'Tablero el'),(625,54607,'Taco'),(625,54608,'Tacoronte'),(625,54609,'Taganana'),(625,54610,'Taibique'),(625,54611,'Tajuya'),(625,54612,'Tamaimo'),(625,54613,'El Tanque'),(625,54614,'Tazacorte'),(625,54615,'Villa de Mazo'),(625,54616,'Tegueste'),(625,54617,'Tejina'),(625,54618,'Tenagua'),(625,54619,'Tigaday'),(625,54620,'Tigalate'),(625,54622,'Tijarafe'),(625,54623,'Tiñor'),(625,54624,'Toscas las'),(625,54625,'Tricias las'),(625,54626,'Urbanizacion playa de las amer'),(625,54627,'Valverde'),(625,54628,'Valle de arriba'),(625,54629,'Valle de guerra'),(625,54630,'Valle Gran Rey'),(625,54631,'Vallehermoso'),(625,54632,'Vega la'),(625,54633,'Vegas las'),(625,54634,'La Victoria de Acentejo'),(625,54635,'Vilaflor'),(625,54636,'Zarza la'),(626,54637,'Abadia'),(626,54638,'Abertura'),(626,54639,'Acebo'),(626,54640,'Acehuche'),(626,54641,'Aceituna'),(626,54642,'Aceitunilla la'),(626,54643,'Ahigal'),(626,54644,'Alagon del caudillo'),(626,54645,'Albala'),(626,54646,'Alcantara'),(626,54647,'Alcollarin'),(626,54649,'Alcuéscar'),(626,54650,'Aldea de trujillo'),(626,54651,'Aldea del cano'),(626,54652,'Aldeacentenera'),(626,54653,'Aldeanueva de la Vera'),(626,54654,'Aldeanueva del camino'),(626,54655,'Aldehuela'),(626,54656,'Aldehuela del jerte'),(626,54657,'Alia'),(626,54658,'Aliseda'),(626,54659,'Almaraz'),(626,54660,'Almoharín'),(626,54661,'Alonso de ojeda'),(626,54662,'Arco'),(626,54663,'Arrolobos'),(626,54664,'Arroyo de la Luz'),(626,54665,'Arroyomolinos de la vera'),(626,54666,'Arroyomolinos de montanchez'),(626,54667,'Avellanar'),(626,54668,'Azabal'),(626,54669,'Baños de montemayor'),(626,54670,'Barquilla de pinares'),(626,54671,'Barrado'),(626,54672,'Batan el'),(626,54673,'Belvis de monroy'),(626,54676,'Berzocana'),(626,54677,'Bohonal de ibor'),(626,54678,'Botija'),(626,54679,'Bronco'),(626,54680,'Brozas'),(626,54681,'Cabañas del castillo'),(626,54682,'Cabezabellosa'),(626,54684,'Cabezuela del Valle'),(626,54685,'Cabrero'),(626,54686,'Cáceres'),(626,54688,'Cadalso'),(626,54690,'Calzadilla'),(626,54691,'Cambron'),(626,54692,'Caminomorisco'),(626,54693,'Campillo de deleitosa'),(626,54694,'Campo lugar'),(626,54695,'Cañamero'),(626,54696,'Cañaveral'),(626,54697,'Carbajo'),(626,54698,'Carcaboso'),(626,54699,'Carrascalejo'),(626,54700,'Casar de Cáceres'),(626,54701,'Casar de miajadas'),(626,54702,'Casar de palomero'),(626,54705,'Casas de don gomez'),(626,54706,'Casas de millan'),(626,54708,'Casas del castañar'),(626,54709,'Casas del monte'),(626,54710,'Casatejada'),(626,54711,'Casillas de coria'),(626,54712,'Castañar de ibor'),(626,54713,'Castillo'),(626,54714,'Ceclavín'),(626,54716,'Cerezo'),(626,54717,'Cilleros'),(626,54718,'Collado'),(626,54719,'Coria'),(626,54720,'Cortijo suertes de abajo'),(626,54721,'Cuacos de yuste'),(626,54722,'Cumbre la'),(626,54723,'Deleitosa'),(626,54725,'Eljas'),(626,54726,'Erias'),(626,54727,'Escurial'),(626,54729,'Fontañera la'),(626,54730,'Fragosa'),(626,54731,'Fresnedoso de ibor'),(626,54732,'Galisteo'),(626,54733,'Garciaz'),(626,54735,'Garganta la olla'),(626,54736,'Gargantilla'),(626,54737,'Gargsera'),(626,54738,'Garrovillas'),(626,54739,'Garvin'),(626,54740,'Gata'),(626,54742,'Granja la'),(626,54745,'Guadalupe'),(626,54747,'Guijo de galisteo'),(626,54748,'Guijo de granadilla'),(626,54749,'Guijo de santa barbara'),(626,54750,'Herguijuela'),(626,54751,'Hernan perez'),(626,54752,'Herrera de alcantara'),(626,54753,'Herreruela'),(626,54754,'Hervás'),(626,54755,'Higuera'),(626,54756,'Hinojal'),(626,54757,'Holguera'),(626,54759,'Hoyos'),(626,54760,'Huelaga'),(626,54762,'Huertas de animas'),(626,54764,'Ibahernando'),(626,54765,'Jaraicejo'),(626,54766,'Jaraíz de la Vera'),(626,54767,'Jarandilla de la Vera'),(626,54768,'Jarilla'),(626,54769,'Jerte'),(626,54772,'Ladrillar'),(626,54773,'Logrosán'),(626,54774,'Losar de la Vera'),(626,54775,'Madrigal de la vera'),(626,54776,'Madrigalejo'),(626,54777,'Madroñera'),(626,54778,'Majadas'),(626,54779,'Malpartida de Cáceres'),(626,54780,'Malpartida de Plasencia'),(626,54781,'Marchagaz'),(626,54782,'Mata de alcantara'),(626,54783,'Membrio'),(626,54786,'Mestas las'),(626,54787,'Miajadas'),(626,54788,'Millanes'),(626,54789,'Mirabel'),(626,54790,'Moheda la'),(626,54791,'Mohedas'),(626,54792,'Monroy'),(626,54793,'Montánchez'),(626,54794,'Montehermoso'),(626,54795,'Moraleja'),(626,54796,'Morcillo'),(626,54797,'Muela la'),(626,54798,'Navaconcejo'),(626,54799,'Navalmoral de la Mata'),(626,54800,'Navalvillar de ibor'),(626,54801,'Navas del madroño'),(626,54802,'Navatrasierra'),(626,54803,'Navezuelas'),(626,54804,'Nuñomoral'),(626,54806,'Ovejuela'),(626,54807,'Palomero'),(626,54809,'Pasaron de la vera'),(626,54810,'Pedro muñoz'),(626,54812,'Peraleda de la mata'),(626,54813,'Peraleda de san roman'),(626,54814,'Perales del puerto'),(626,54815,'Pescueza'),(626,54816,'Pesga la'),(626,54817,'Piedras albas'),(626,54819,'Pinofranqueado'),(626,54820,'Piornal'),(626,54821,'Pizarro'),(626,54822,'Plasencia'),(626,54823,'Plasenzuela'),(626,54825,'Portaje'),(626,54826,'Portezuelo'),(626,54827,'Pozuelo de zarzon'),(626,54829,'Puebla de argeme'),(626,54830,'Pueblonuevo de miramontes'),(626,54831,'Puerto de santa cruz'),(626,54832,'Rebollar'),(626,54833,'Retamosa'),(626,54834,'Ribera oveja'),(626,54835,'Rincon de ballesteros'),(626,54836,'Rincon del obispo'),(626,54837,'Riolobos'),(626,54838,'Riomalo de abajo'),(626,54839,'Riomalo de arriba'),(626,54840,'Robledillo de gata'),(626,54841,'Robledillo de la vera'),(626,54842,'Robledillo de trujillo'),(626,54844,'Robledollano'),(626,54847,'Rosalejo'),(626,54848,'Roturas'),(626,54850,'Salorino'),(626,54854,'Santa ana'),(626,54855,'Santa cruz de la sierra'),(626,54856,'Santa cruz de paniagua'),(626,54857,'Santa maria de las lomas'),(626,54858,'Santa marta de magasca'),(626,54859,'Santiago de alcantara'),(626,54860,'Santiago del campo'),(626,54861,'Santibañez el alto'),(626,54862,'Santibañez el bajo'),(626,54864,'Saucedilla'),(626,54865,'Segura de toro'),(626,54866,'Serradilla'),(626,54867,'Serrejon'),(626,54868,'Sierra de fuentes'),(626,54869,'Solana'),(626,54870,'Talavan'),(626,54871,'Talaveruela'),(626,54872,'Talayuela'),(626,54873,'Tejeda de tietar'),(626,54874,'Tietar del caudillo'),(626,54876,'Toril'),(626,54877,'Tornavacas'),(626,54878,'Torno el'),(626,54880,'Torre de santa maria'),(626,54881,'Torrecilla de los angeles'),(626,54882,'Torrecillas de la tiesa'),(626,54883,'Torrejon el rubio'),(626,54884,'Torrejoncillo'),(626,54885,'Torremenga'),(626,54886,'Torremocha'),(626,54887,'Torreorgaz'),(626,54888,'Torrequemada'),(626,54890,'Trevejo'),(626,54891,'Trujillo'),(626,54892,'Valdastillas'),(626,54894,'Valdefuentes'),(626,54895,'Valdehuncar'),(626,54896,'Valdeiñigos'),(626,54897,'Valdelacasa de tajo'),(626,54898,'Valdemorales'),(626,54899,'Valdeobispo'),(626,54900,'Valdesalor'),(626,54901,'Valencia de Alcántara'),(626,54902,'Valverde de la vera'),(626,54903,'Valverde del Fresno'),(626,54904,'Vegas de coria'),(626,54905,'Vegaviana'),(626,54906,'Viandar de la vera'),(626,54907,'Villa del campo'),(626,54908,'Villa del rey'),(626,54910,'Villamesias'),(626,54911,'Villamiel'),(626,54912,'Villanueva de la sierra'),(626,54913,'Villanueva de la Vera'),(626,54914,'Villar de plasencia'),(626,54918,'Zarza de granadilla'),(626,54919,'Zarza de montanchez'),(626,54920,'Zarza la  mayor'),(626,54921,'Zorita'),(627,54922,'Abanades'),(627,54923,'Ablanque'),(627,54924,'Adobes'),(627,54925,'Aguilar de anguita'),(627,54926,'Alaminos'),(627,54927,'Alarilla'),(627,54928,'Albalate de zorita'),(627,54929,'Albares'),(627,54930,'Albendiego'),(627,54932,'Alcocer'),(627,54934,'Alcolea del pinar'),(627,54935,'Alcorlo'),(627,54936,'Alcoroches'),(627,54939,'Aldeanueva de guadalajara'),(627,54940,'Aldehuela'),(627,54943,'Algora'),(627,54944,'Alhondiga'),(627,54946,'Almadrones'),(627,54948,'Almiruete'),(627,54949,'Almoguera'),(627,54950,'Almonacid de zorita'),(627,54951,'Alocen'),(627,54952,'Alovera'),(627,54955,'Alustante'),(627,54960,'Anguita'),(627,54963,'Aragoncillo'),(627,54964,'Aragosa'),(627,54965,'Aranzueque'),(627,54966,'Arbancon'),(627,54968,'Archilla'),(627,54971,'Armuña de tajuña'),(627,54974,'Atienza'),(627,54976,'Azañon'),(627,54977,'Azuqueca de Henares'),(627,54978,'Baides'),(627,54980,'Balconete'),(627,54984,'Barriopedro'),(627,54985,'Beleña de sorbe'),(627,54986,'Berninches'),(627,54988,'Bochones'),(627,54989,'Bodera la'),(627,54990,'Brihuega'),(627,54991,'Budia'),(627,54993,'Bujalaro'),(627,54996,'Cabanillas del Campo'),(627,54999,'Cabrera la'),(627,55001,'Campillo de dueñas'),(627,55004,'Canales de molina'),(627,55006,'Canredondo'),(627,55009,'Cañizar'),(627,55016,'Casar de Talamanca'),(627,55028,'Cendejas de la torre'),(627,55029,'Cendejas del padrastro'),(627,55032,'Cifuentes'),(627,55040,'Codes'),(627,55042,'Cogolludo'),(627,55049,'Corcoles'),(627,55051,'Cortes de tajuña'),(627,55052,'Cubillas'),(627,55058,'Checa'),(627,55060,'Chiloeches'),(627,55061,'Chillaron del rey'),(627,55062,'Driebes'),(627,55063,'Duron'),(627,55065,'Escalera'),(627,55070,'Espinosa de henares'),(627,55071,'Esplegares'),(627,55072,'Estables'),(627,55074,'Fontanar'),(627,55078,'Fuentelaencina'),(627,55080,'Fuentelsaz'),(627,55082,'Fuentenovilla'),(627,55085,'Galapagos'),(627,55086,'Galve de sorbe'),(627,55088,'Gargoles de abajo'),(627,55089,'Gargoles de arriba'),(627,55091,'Guadalajara'),(627,55094,'Henche'),(627,55100,'Hita'),(627,55103,'Hontoba'),(627,55104,'Horche'),(627,55108,'Huermeces del cerro'),(627,55109,'Huertahernando'),(627,55110,'Huertapelayo'),(627,55112,'Hueva'),(627,55113,'Humanes'),(627,55114,'Illana'),(627,55116,'Iniestola'),(627,55118,'Iriepal'),(627,55119,'Irueste'),(627,55120,'Jadraque'),(627,55121,'Jirueque'),(627,55126,'Lebrancon'),(627,55129,'Loranca de tajuña'),(627,55130,'Luzaga'),(627,55131,'Luzon'),(627,55133,'Majaelrayo'),(627,55134,'Malacuera'),(627,55135,'Malaga del fresno'),(627,55136,'Malaguilla'),(627,55138,'Mantiel'),(627,55140,'Marchamalo'),(627,55144,'Matillas'),(627,55146,'Mazuecos'),(627,55149,'Membrillera'),(627,55150,'Mesones'),(627,55154,'Millana'),(627,55156,'Mirabueno'),(627,55159,'Mohernando'),(627,55160,'Mojares'),(627,55161,'Molina de Aragón'),(627,55163,'Mondéjar'),(627,55164,'Montarron'),(627,55165,'Moranchel'),(627,55169,'Morillejo'),(627,55176,'Negredo'),(627,55185,'Oter'),(627,55193,'Pardos'),(627,55195,'Pareja'),(627,55196,'Pastrana'),(627,55201,'Peñalver'),(627,55202,'Peralejos de las truchas'),(627,55207,'Pioz'),(627,55213,'Pozo de guadalajara'),(627,55214,'Pradena de atienza'),(627,55216,'Prados redondos'),(627,55218,'Puebla de valles'),(627,55219,'Puerta la'),(627,55220,'Quer'),(627,55229,'Riba de saelices'),(627,55232,'Rillo de gallo'),(627,55233,'Riofrio del llano'),(627,55235,'Robledillo de mohernando'),(627,55239,'Romanones'),(627,55243,'Sacedon'),(627,55245,'Salmeron'),(627,55249,'Santa maria del espino'),(627,55254,'Sayaton'),(627,55258,'Sigüenza'),(627,55260,'Somolinos'),(627,55265,'Tamajon'),(627,55266,'Taracena'),(627,55270,'Tendilla'),(627,55271,'Teroleja'),(627,55273,'Tierzo'),(627,55276,'Tomellosa'),(627,55279,'Tordelloso'),(627,55283,'Torija'),(627,55285,'Torre del burgo'),(627,55291,'Torrejón del Rey'),(627,55293,'Torremocha del campo'),(627,55297,'Torronteras'),(627,55299,'Tortola de henares'),(627,55302,'Tortuero'),(627,55304,'Trijueque'),(627,55305,'Trillo'),(627,55307,'Uceda'),(627,55321,'Valdeaveruelo'),(627,55326,'Valdenoches'),(627,55327,'Valdenuño fernandez'),(627,55329,'Valdepinillos'),(627,55331,'Valdesaz'),(627,55347,'Villaescusa de palositos'),(627,55350,'Villanueva de la Torre'),(627,55361,'Yebes'),(627,55362,'Yebra'),(627,55363,'Yela'),(627,55364,'Yelamos de abajo'),(627,55366,'Yunquera de Henares'),(627,55367,'Yunta la'),(627,55368,'Zorita de los canes'),(628,55369,'Adanero'),(628,55370,'La Adrada'),(628,55371,'El Ajo'),(628,55372,'Alamedilla del Berrocal'),(628,55373,'El Alamo'),(628,55374,'Albornos'),(628,55375,'Aldea del Rey'),(628,55376,'Aldealabad del Mirón'),(628,55377,'Aldeanueva de Santa Cruz'),(628,55378,'Aldeaseca'),(628,55379,'Aldeavieja'),(628,55382,'Altamiros'),(628,55383,'Amavida'),(628,55385,'El Arenal'),(628,55386,'Arenas de San Pedro'),(628,55387,'Arevalillo'),(628,55388,'Arévalo'),(628,55389,'Aveinte'),(628,55390,'Avellaneda'),(628,55391,'Ávila'),(628,55394,'El Barco de Ávila'),(628,55396,'Barraco'),(628,55397,'El Barrio'),(628,55399,'Baterna'),(628,55401,'Becedillas'),(628,55402,'Benitos'),(628,55404,'Las Berlanas'),(628,55407,'Berrocalejo de Aragona'),(628,55409,'Blascojimeno'),(628,55410,'Blascomillán'),(628,55415,'Bohoyo'),(628,55416,'Bonilla de la Sierra'),(628,55417,'Brabos'),(628,55420,'Burgohondo'),(628,55421,'Cabañas'),(628,55422,'Cabezas Altas'),(628,55427,'Canales'),(628,55428,'Candeleda'),(628,55429,'Cantiveros'),(628,55430,'La Cañada'),(628,55431,'Cardeñosa'),(628,55433,'La Carrera'),(628,55435,'Casas del Puerto de Villatoro'),(628,55436,'Casasola'),(628,55437,'Casavieja'),(628,55438,'Casillas'),(628,55439,'Castellanos de Zapardiel'),(628,55440,'Cebreros'),(628,55444,'Cisla'),(628,55445,'La Colilla'),(628,55449,'Constanzana'),(628,55452,'Crespos'),(628,55453,'Los Cuartos'),(628,55454,'Cuevas del Valle'),(628,55463,'Flores de Ávila'),(628,55465,'Fontiveros'),(628,55467,'El Fresno'),(628,55472,'Gavilanes'),(628,55473,'Gemuño'),(628,55477,'Gotarrendura'),(628,55479,'Guareña'),(628,55485,'Hernansancho'),(628,55486,'El Herradón'),(628,55489,'La Higuera'),(628,55490,'La Hija de Dios'),(628,55492,'La Horcajada'),(628,55493,'Horcajo de la Ribera'),(628,55494,'Horcajo de las Torres'),(628,55496,'El Hornillo'),(628,55497,'El Hoyo de Pinares'),(628,55498,'Hoyocasero'),(628,55502,'Hoyos del Espino'),(628,55505,'Junciana'),(628,55506,'Langa'),(628,55507,'Lanzahíta'),(628,55511,'Madrigal de las Altas Torres'),(628,55513,'Magazos'),(628,55514,'Malpartida de Corneja'),(628,55519,'Martiherrero'),(628,55522,'Mediana de Voltoya'),(628,55527,'Mijares'),(628,55528,'Mingorría'),(628,55529,'El Mirón'),(628,55530,'Mironcillo'),(628,55532,'Mombeltrán'),(628,55534,'Moraleja de Matacabras'),(628,55535,'Muñana'),(628,55536,'Muñez'),(628,55538,'Muñochas'),(628,55539,'Muñogalindo'),(628,55545,'Muñoyerro'),(628,55550,'Narros del Castillo'),(628,55553,'Nava de Arévalo'),(628,55559,'Navahondilla'),(628,55562,'Navalmoral'),(628,55564,'Navalosa'),(628,55565,'Navalperal de Pinares'),(628,55567,'Navaluenga'),(628,55573,'Navarredonda de Gredos'),(628,55574,'Navarredondilla'),(628,55575,'Navarrevisca'),(628,55576,'Las Navas del Marqués'),(628,55578,'Navatalgordo'),(628,55582,'Noharre'),(628,55587,'El Oso'),(628,55588,'Padiernos'),(628,55591,'Palacios de Goda'),(628,55592,'Palacios Rubios'),(628,55594,'La Parra'),(628,55599,'Pedro Bernardo'),(628,55603,'Peñalba de Ávila'),(628,55604,'Piedrahita'),(628,55605,'Piedralaves'),(628,55607,'Poyales del Hoyo'),(628,55608,'Pozanco'),(628,55611,'Ramacastañas'),(628,55612,'El Raso'),(628,55613,'Rasueros'),(628,55615,'Rinconada'),(628,55617,'Riocabado'),(628,55628,'San Bartolomé de Pinares'),(628,55633,'San Esteban del Valle'),(628,55636,'San Juan de la Nava'),(628,55638,'San Juan del Molinillo'),(628,55645,'San Pedro del Arroyo'),(628,55650,'Sanchidrián'),(628,55653,'Santa Cruz del Valle'),(628,55655,'Santa María de los Caballeros'),(628,55657,'Santa María  del Berrocal'),(628,55658,'Santa María  del Tietar'),(628,55665,'Serranillos'),(628,55666,'Sinlabajos'),(628,55667,'Solana'),(628,55668,'Solana de Rioalmar'),(628,55669,'Solosancho'),(628,55670,'Sotalvo'),(628,55671,'Sotillo de la Adrada'),(628,55673,'El Tiemblo'),(628,55674,'Tinosillos'),(628,55679,'La Torre'),(628,55683,'Urraca-Miguel'),(628,55693,'Vicolozano'),(628,55694,'Villaflor'),(628,55695,'Villafranca de la Sierra'),(628,55697,'Villanueva de Ávila'),(628,55701,'Villar de Corneja'),(628,55704,'Villarejo del Valle'),(628,55705,'Villatoro'),(628,55707,'Vinaderos'),(628,55709,'Viñegra'),(628,55711,'Vita'),(628,55714,'La Zarza'),(629,55716,'Ajofrín'),(629,55717,'Alameda de la Sagra'),(629,55718,'Alares los'),(629,55719,'Albarreal de tajo'),(629,55720,'Alberche del caudillo'),(629,55721,'Alcabon'),(629,55722,'Alcañizo'),(629,55723,'Alcaudete de la jara'),(629,55724,'Alcolea de tajo'),(629,55725,'Aldeancabo de escalona'),(629,55726,'Aldeanueva de barbarroya'),(629,55727,'Aldeanueva de san bartolome'),(629,55728,'Almendral de la cañada'),(629,55729,'Almonacid de toledo'),(629,55730,'Almorox'),(629,55731,'Añover de Tajo'),(629,55732,'Arcicollar'),(629,55733,'Argés'),(629,55734,'Arisgotas'),(629,55735,'Azucaica'),(629,55736,'Azutan'),(629,55737,'Barcience'),(629,55738,'Bargas'),(629,55739,'Belvis de la jara'),(629,55740,'Bercial el'),(629,55741,'Bernuy'),(629,55742,'Borox'),(629,55743,'Buenasbodas'),(629,55744,'Buenaventura'),(629,55745,'Burguillos de toledo'),(629,55746,'Burujon'),(629,55747,'Cabañas de la sagra'),(629,55748,'Cabañas de yepes'),(629,55749,'Cabezamesada'),(629,55750,'Calera y Chozas'),(629,55752,'Calzada de oropesa la'),(629,55753,'Camarena'),(629,55754,'Camarenilla'),(629,55756,'Camuñas'),(629,55757,'Cardiel de los montes'),(629,55758,'Carmena'),(629,55759,'El Carpio de Tajo'),(629,55760,'Carranque'),(629,55761,'Carriches'),(629,55762,'Casalgordo'),(629,55763,'Casar de escalona el'),(629,55765,'Casarrubios del Monte'),(629,55767,'Casasbuenas'),(629,55769,'Castillo de bayuela'),(629,55770,'Cazalegas'),(629,55771,'Cebolla'),(629,55772,'Cedillo del condado'),(629,55773,'Cerralbos los'),(629,55774,'Cervera de los montes'),(629,55775,'Ciruelos'),(629,55776,'Cobeja'),(629,55777,'Cobisa'),(629,55778,'Consuegra'),(629,55779,'Corchuela'),(629,55780,'Corral de Almaguer'),(629,55781,'Cuerva'),(629,55782,'Chozas de canales'),(629,55783,'Chueca'),(629,55784,'Domingo-perez'),(629,55785,'Dosbarrios'),(629,55786,'Erustes'),(629,55787,'Escalona'),(629,55788,'Escalonilla'),(629,55789,'Espinoso del rey'),(629,55790,'Esquivias'),(629,55791,'Estrella la'),(629,55792,'Fresneda la'),(629,55793,'Fuensalida'),(629,55795,'Gálvez'),(629,55796,'Gamonal'),(629,55798,'Gargantilla'),(629,55799,'Gerindote'),(629,55800,'Guadamur'),(629,55801,'La Guardia'),(629,55802,'Herencias las'),(629,55804,'Hinojosa de san vicente'),(629,55806,'Hormigos'),(629,55807,'Huecas'),(629,55808,'Huerta de valdecarabanos'),(629,55810,'Iglesuela la'),(629,55811,'Illan de vacas'),(629,55812,'Illescas'),(629,55813,'Lagartera'),(629,55814,'Layos'),(629,55815,'Lominchar'),(629,55816,'Lucillos'),(629,55817,'Madridejos'),(629,55818,'Magan'),(629,55819,'Malpica de tajo'),(629,55821,'Maqueda'),(629,55822,'Marjaliza'),(629,55824,'Mascaraque'),(629,55825,'Mata la'),(629,55826,'Mazarambroz'),(629,55829,'Membrillo el'),(629,55830,'Menasalbas'),(629,55831,'Méntrida'),(629,55832,'Mesegar'),(629,55833,'Miguel Esteban'),(629,55834,'Minas de santa quiteria'),(629,55835,'Mocejón'),(629,55836,'Mohedas de la jara'),(629,55839,'Montesclaros'),(629,55840,'Mora'),(629,55841,'Nambroca'),(629,55842,'Nava de ricomalillo la'),(629,55843,'Navahermosa'),(629,55844,'Navalcán'),(629,55846,'Los Navalmorales'),(629,55848,'Los Navalucillos'),(629,55849,'Navamorcuende'),(629,55851,'Noblejas'),(629,55852,'Noez'),(629,55853,'Nombela'),(629,55854,'Noves'),(629,55855,'Numancia de la Sagra'),(629,55856,'Nuño gomez'),(629,55857,'Ocaña'),(629,55858,'Olías del Rey'),(629,55859,'Ontigola'),(629,55860,'Oreja'),(629,55861,'Orgaz'),(629,55862,'Oropesa'),(629,55863,'Otero'),(629,55864,'Palomeque'),(629,55865,'Pantoja'),(629,55866,'Paredes de escalona'),(629,55867,'Parrillas'),(629,55868,'Pelahustan'),(629,55869,'Pepino'),(629,55871,'Polán'),(629,55872,'Poligono industrial'),(629,55873,'Portillo de Toledo'),(629,55874,'La Puebla de Almoradiel'),(629,55875,'La Puebla de Montalbán'),(629,55876,'La Pueblanueva'),(629,55877,'Puente del arzobispo el'),(629,55878,'Puerto de san vicente'),(629,55879,'Puerto rey'),(629,55880,'Pulgar'),(629,55881,'Quero'),(629,55882,'Quintanar de la Orden'),(629,55883,'Quismondo'),(629,55884,'Real de san vicente el'),(629,55885,'Recas'),(629,55886,'Retamoso'),(629,55887,'Rielves'),(629,55889,'Robledillo'),(629,55890,'Robledo del buey'),(629,55892,'Romeral el'),(629,55894,'San martin de montalban'),(629,55895,'San martin de pusa'),(629,55896,'San Pablo de los Montes'),(629,55897,'San pedro'),(629,55898,'San roman de los montes'),(629,55899,'Santa ana de pusa'),(629,55900,'Santa Cruz de la Zarza'),(629,55901,'Santa Cruz del Retamar'),(629,55902,'Santa Olalla'),(629,55903,'Santo domingo caudilla'),(629,55905,'Segurilla'),(629,55906,'Seseña'),(629,55907,'Seseña nuevo'),(629,55909,'Sonseca'),(629,55911,'Talavera de la Reina'),(629,55912,'Talavera la nueva'),(629,55913,'Tembleque'),(629,55914,'El Toboso'),(629,55915,'Toledo'),(629,55917,'Torre de esteban hambran la'),(629,55919,'Torrico'),(629,55920,'Torrijos'),(629,55922,'Turleque'),(629,55923,'Ugena'),(629,55924,'Urda'),(629,55925,'Valdeazores'),(629,55927,'Valmojado'),(629,55929,'Velada'),(629,55931,'Ventas con peña aguilera las'),(629,55932,'Ventas de retamosa las'),(629,55933,'Ventas de san julian las'),(629,55934,'La Villa de Don Fadrique'),(629,55935,'Villacañas'),(629,55936,'Villafranca de los Caballeros'),(629,55937,'Villaluenga'),(629,55938,'Villamiel de toledo'),(629,55939,'Villaminaya'),(629,55940,'Villamuelas'),(629,55941,'Villanueva de Alcardete'),(629,55942,'Villanueva de bogas'),(629,55944,'Villarrubia de Santiago'),(629,55945,'Villaseca de la Sagra'),(629,55946,'Villasequilla'),(629,55947,'Villatobas'),(629,55948,'Viso de s. juan el'),(629,55949,'Los Yébenes'),(629,55950,'Yeles'),(629,55951,'Yepes'),(629,55952,'Yuncler'),(629,55953,'Yunclillos'),(629,55954,'Yuncos'),(630,55955,'Adzaneta'),(630,55956,'Ahin'),(630,55957,'Albocacer'),(630,55958,'Alcala de chivert'),(630,55959,'Alcora'),(630,55960,'Alcossebre'),(630,55961,'Alcudia de veo'),(630,55962,'Alfondeguilla'),(630,55963,'Algimia de almonacid'),(630,55964,'Almassora'),(630,55965,'Almedijar'),(630,55966,'Almenara'),(630,55967,'Alquerias de santa barbara'),(630,55968,'Alquerías del Niño Perdido'),(630,55969,'Altura'),(630,55970,'Araia'),(630,55971,'Arañuel'),(630,55972,'Ares del maestrat'),(630,55973,'Argelita'),(630,55974,'Artana'),(630,55976,'Ayodar'),(630,55977,'Azafranes'),(630,55978,'Azuebar'),(630,55979,'Ballestar'),(630,55981,'Barracas'),(630,55983,'Bejis'),(630,55984,'Bel'),(630,55986,'Benafigos'),(630,55987,'Benasal'),(630,55988,'Benicarló'),(630,55989,'Benicássim'),(630,55990,'Benlloch'),(630,55991,'Betxí'),(630,55993,'Borriol'),(630,55994,'Burriana'),(630,55995,'Cabanes'),(630,55996,'Calig'),(630,55997,'Calpes los'),(630,55998,'Canales'),(630,55999,'Canet lo roig'),(630,56001,'Castell de cabres'),(630,56002,'Castell el'),(630,56003,'Castellfort'),(630,56004,'Castellnovo'),(630,56005,'Castellón de la Plana'),(630,56006,'Castillo de villamalefa'),(630,56007,'Cati'),(630,56008,'Caudiel'),(630,56009,'Cedraman'),(630,56010,'Cervera del maestrat'),(630,56011,'Cinctorres'),(630,56012,'Cirat'),(630,56014,'Cortes de arenoso'),(630,56015,'Costur'),(630,56016,'Cuevas de vinroma'),(630,56017,'Chilches'),(630,56018,'Chodos'),(630,56020,'Eslida'),(630,56023,'Fanzara'),(630,56024,'Figueroles'),(630,56027,'Forcall'),(630,56028,'Fredes'),(630,56030,'Fuentes de ayodar'),(630,56034,'Geldo'),(630,56035,'Grau de borriana el'),(630,56036,'Grau de moncofar el'),(630,56040,'Ivarsos els'),(630,56041,'Jana la'),(630,56042,'Jerica'),(630,56043,'Ludiente'),(630,56044,'Llosa la'),(630,56045,'Llucena del cid'),(630,56053,'Mas de foiatxenta'),(630,56055,'Mas de la parra'),(630,56061,'Mas de vilas'),(630,56063,'Mata de morella la'),(630,56065,'Molinar el'),(630,56066,'Moncofar'),(630,56067,'Montan'),(630,56068,'Montanejos'),(630,56069,'Morella'),(630,56070,'Morella la vella'),(630,56071,'Navajas'),(630,56073,'Nules'),(630,56074,'Olocau del rey'),(630,56075,'Onda'),(630,56076,'Oropesa'),(630,56080,'Pelejaneta la'),(630,56081,'Peñalba'),(630,56082,'Peñíscola'),(630,56083,'Pina de montalgrao'),(630,56084,'Platja de la torre la'),(630,56086,'Pobla tornesa'),(630,56092,'Ribesalbes'),(630,56093,'Rosell'),(630,56094,'Rosildos els'),(630,56095,'Sacañet'),(630,56096,'Salsadella'),(630,56097,'San joan de moro'),(630,56099,'San rafael del rio'),(630,56100,'San vicente'),(630,56101,'Sant joan de penyagolosa'),(630,56102,'Sant jordi'),(630,56103,'Sant mateu'),(630,56105,'Santa magdalena de pulpis'),(630,56107,'Segorbe'),(630,56108,'Sierra engarceran'),(630,56109,'Soneja'),(630,56110,'Sot de ferrer'),(630,56111,'Sueras'),(630,56112,'Talaies valdanches'),(630,56113,'Tales'),(630,56115,'Tirig'),(630,56116,'Todolella'),(630,56118,'Toras'),(630,56120,'Toro el'),(630,56121,'Torralba del pinar'),(630,56122,'Torre de embesora'),(630,56123,'Torre de endomenech'),(630,56126,'Torreblanca'),(630,56127,'Torrechiva'),(630,56128,'Torrenostra'),(630,56129,'Traiguera'),(630,56130,'Useres les'),(630,56131,'Vall d\'Alba'),(630,56132,'La Vall d\'Uixó'),(630,56133,'Vall de almonacid'),(630,56137,'Venta de san vicent'),(630,56138,'Vilafames'),(630,56139,'Vilafranca del maestrat'),(630,56141,'Vilanova d\'alcolea'),(630,56143,'Villanueva de viver'),(630,56144,'Villar de canes'),(630,56145,'Villarreal'),(630,56146,'Villavieja'),(630,56149,'Vinarós'),(630,56150,'Vistabella del maestrat'),(630,56151,'Viver'),(630,56152,'Xert'),(630,56153,'Xiva de morella'),(630,56154,'Zorita del maestrazgo'),(630,56155,'Zucaina'),(631,56156,'Aguilo'),(631,56157,'Aiguamurcia'),(631,56158,'Aiguaviva'),(631,56159,'Albarca'),(631,56160,'Albinyana'),(631,56161,'Albiol l\''),(631,56162,'Alcanar'),(631,56163,'Alcanar platje'),(631,56164,'Alcover'),(631,56165,'L\'Aldea'),(631,56166,'Aldover'),(631,56167,'Aleixar l\''),(631,56168,'Alfara dels ports'),(631,56169,'Alforja'),(631,56170,'Algars'),(631,56171,'Alio'),(631,56172,'Almoster'),(631,56173,'Altafulla'),(631,56174,'L\'Ametlla de Mar'),(631,56175,'L\'Ampolla'),(631,56176,'Amposta'),(631,56177,'L\'Arboç'),(631,56178,'Arboli'),(631,56179,'Ardiaca'),(631,56180,'Argentera l\''),(631,56181,'Arnes'),(631,56182,'Arrabassada l\''),(631,56183,'Asco'),(631,56184,'Balada'),(631,56185,'Banyeres del Penedés'),(631,56186,'Barbera de la conca'),(631,56187,'Batea'),(631,56188,'Belvei del Penedés'),(631,56189,'Bellavista'),(631,56190,'Bellmunt del priorat'),(631,56192,'Benifallet'),(631,56193,'Benissanet'),(631,56194,'Bisbal de falset la'),(631,56195,'La Bisbal del Penedés'),(631,56196,'Bitem'),(631,56197,'Biure'),(631,56198,'Blancafort'),(631,56199,'Bonastre'),(631,56200,'Bonavista'),(631,56201,'Borges del camp les'),(631,56202,'Bosquet'),(631,56203,'Bot'),(631,56204,'Botarell'),(631,56206,'Brafim'),(631,56207,'Cabassers'),(631,56208,'Cabra del camp'),(631,56209,'Cadeneta la'),(631,56210,'Cal canonjo'),(631,56211,'Cala nova'),(631,56212,'Calafat'),(631,56213,'Calafell'),(631,56214,'Cambrils'),(631,56215,'Camerles'),(631,56216,'Camp-redo'),(631,56217,'Camposines'),(631,56220,'Canonja la'),(631,56221,'Capafonts'),(631,56222,'Capçanes'),(631,56225,'Les Cases d\'Alcanar'),(631,56226,'Castellvell'),(631,56228,'El Catllar de Gaiá'),(631,56229,'Cava la'),(631,56232,'Colldejou'),(631,56233,'Coma-ruga'),(631,56235,'Constantí'),(631,56236,'Corbera d\'ebre'),(631,56238,'Cornudella de montsant'),(631,56240,'Creixel de mar'),(631,56241,'Cunit'),(631,56243,'Duesaigses'),(631,56244,'Esblada'),(631,56245,'Escornalbou'),(631,56246,'Espanyol l\''),(631,56247,'L\'Espluga de Francolí'),(631,56249,'Falset'),(631,56250,'Farena'),(631,56251,'Fatarrella la'),(631,56255,'Figuerola del camp'),(631,56256,'Flix'),(631,56258,'Fontscaldes'),(631,56260,'Freginals'),(631,56261,'Galera la'),(631,56263,'Gandesa'),(631,56264,'Garcia'),(631,56265,'Garidells els'),(631,56268,'Ginestar d\'ebro'),(631,56269,'Godall'),(631,56271,'Gratallops'),(631,56273,'Guiamets els'),(631,56274,'Gunyoles les'),(631,56275,'Horta de sant joan'),(631,56276,'L\'Hospitalet de l\'Infant'),(631,56277,'Hostal del alls l\''),(631,56279,'Illa l\''),(631,56280,'Irles les'),(631,56281,'Jesus'),(631,56282,'Jesus i maria'),(631,56283,'Juncosa'),(631,56284,'L_almadrava'),(631,56285,'Ligallo el'),(631,56286,'Llaveria'),(631,56287,'Lleger'),(631,56288,'Lloa'),(631,56294,'Margalef'),(631,56296,'Mas d_en bosc'),(631,56298,'Mas de barberans'),(631,56305,'Masbarrat'),(631,56306,'Mascat'),(631,56307,'Masdemboquera'),(631,56308,'Masdenverge'),(631,56309,'Masllorenc'),(631,56311,'Masnou el'),(631,56312,'Maso la'),(631,56313,'Maspuyols'),(631,56314,'Masriudoms'),(631,56315,'Masroig el'),(631,56318,'Miralba la'),(631,56319,'Miravet'),(631,56320,'Molar el'),(631,56321,'Molnars'),(631,56323,'Mont-Roig del Camp'),(631,56325,'Montblanc'),(631,56326,'Montbrio de la marca'),(631,56327,'Montbrio del camp'),(631,56328,'Montferri'),(631,56330,'Móra d\'Ebre'),(631,56331,'Móra la Nova'),(631,56332,'El Morell'),(631,56334,'Nou de gaia la'),(631,56337,'Ordes les'),(631,56338,'Padres'),(631,56339,'Palma debre la'),(631,56340,'Els Pallaresos'),(631,56342,'Pasls dels ports'),(631,56344,'Perafort'),(631,56345,'El Perelló'),(631,56347,'Picamoixons'),(631,56348,'Piles de gaia les'),(631,56350,'Pineda la'),(631,56351,'Pinell de bray el'),(631,56352,'Pira'),(631,56354,'Pla de santa maria el'),(631,56355,'Planes les'),(631,56357,'Platja de miami la'),(631,56359,'Pobla de farran la'),(631,56360,'Pobla de mafumet la'),(631,56361,'Pobla de massaluca la'),(631,56362,'Pobla de montornes la'),(631,56363,'Poblenou del delta el'),(631,56364,'Pobles les'),(631,56366,'Poblet'),(631,56367,'Poboleda'),(631,56368,'Pont d\'armentera el'),(631,56369,'Porrera'),(631,56370,'Pradell de la teixeta'),(631,56371,'Prat de comte'),(631,56372,'Pratdip'),(631,56374,'Puigpelat'),(631,56378,'Raco de salou el'),(631,56379,'Rasquera'),(631,56380,'Rauric'),(631,56381,'Raval de crist'),(631,56382,'Reguers els'),(631,56383,'Regues'),(631,56385,'Renau'),(631,56386,'Reus'),(631,56387,'Riba la'),(631,56388,'Riba-roja d\'Ebre'),(631,56389,'Riera de gaia la'),(631,56390,'Riudecanyes'),(631,56391,'Riudecois'),(631,56392,'Riudoms'),(631,56393,'Riumar'),(631,56394,'Rocafort de queralt'),(631,56395,'Roda de Bará'),(631,56396,'Rodonya'),(631,56397,'Rojals'),(631,56399,'Roquetes'),(631,56400,'Salomo'),(631,56401,'Salou'),(631,56403,'Sant Carles de la Rápita'),(631,56404,'Sant Jaume d\'Enveja'),(631,56405,'Sant jaume dels domenys'),(631,56406,'Santa Bárbara'),(631,56407,'Santa Coloma de Queralt'),(631,56408,'Santa Oliva'),(631,56409,'Santa perpetua de gaia'),(631,56410,'Santes creus'),(631,56411,'Sarral'),(631,56413,'Savinosa la'),(631,56414,'Secuita la'),(631,56415,'Seguer'),(631,56417,'La Selva del Camp'),(631,56419,'La Sénia'),(631,56420,'Serra d\'almos la'),(631,56421,'Serres les'),(631,56422,'Solivella'),(631,56423,'Tamarit de mar'),(631,56424,'Tarragona'),(631,56425,'Tivenys'),(631,56426,'Tivissa'),(631,56428,'Torre del l\'espanyol la'),(631,56429,'Torre la'),(631,56430,'Torredembarra'),(631,56431,'Torreforta'),(631,56432,'Torroja de priorat'),(631,56433,'Tortosa'),(631,56434,'Toscar el'),(631,56436,'Ulldecona'),(631,56437,'Ulldemolins'),(631,56439,'Uriola'),(631,56440,'Valdeperes'),(631,56441,'Valentins els'),(631,56442,'Valverd de queralt'),(631,56443,'Vallclara'),(631,56444,'Valldossera'),(631,56447,'Vallmoll'),(631,56448,'Valls'),(631,56449,'Vandellós'),(631,56450,'El Vendrell'),(631,56454,'Vespella de gaia'),(631,56456,'Vila-rodona'),(631,56457,'Vilabella del camp'),(631,56458,'Vilafortuny'),(631,56459,'Vilallonga del camp'),(631,56461,'Vilaperdius'),(631,56462,'Vilaplana del camp'),(631,56463,'Vilaseca'),(631,56464,'Vilaverd'),(631,56466,'Vilella baixa la'),(631,56467,'Villalba del arcs'),(631,56468,'Villanova d\'escornalbou'),(631,56469,'Vimbodi'),(631,56470,'Vinallop'),(631,56471,'Vinebre'),(631,56472,'Voltes les'),(631,56473,'Xerta'),(632,56474,'Abadín'),(632,56475,'Aborbo'),(632,56476,'Acedre san roman'),(632,56477,'Ada santa baia'),(632,56478,'Adai'),(632,56479,'Adelan'),(632,56480,'Agueira a'),(632,56481,'Agustin'),(632,56484,'Albeiro o'),(632,56485,'Albeiros'),(632,56486,'Alfoz'),(632,56487,'Alta'),(632,56488,'Amarante'),(632,56490,'Anafreita'),(632,56491,'Antas de Ulla'),(632,56492,'Arante'),(632,56493,'Arcos'),(632,56496,'Argozon'),(632,56498,'Arneiro'),(632,56500,'Arxua'),(632,56501,'Asma'),(632,56503,'Aspai'),(632,56505,'Baamonde'),(632,56507,'Bacoi'),(632,56509,'Baleira'),(632,56510,'Bande'),(632,56511,'Baralla'),(632,56514,'Barreiros'),(632,56516,'Barrela a'),(632,56517,'Bazar'),(632,56519,'Becerreá'),(632,56520,'Begonte'),(632,56521,'Belesar'),(632,56522,'Benquerencia'),(632,56524,'Betote'),(632,56525,'Biville'),(632,56526,'Bolaño'),(632,56527,'Bonxe'),(632,56530,'Boveda'),(632,56531,'Boveda'),(632,56538,'Budian'),(632,56539,'Burela'),(632,56542,'Cabanas'),(632,56543,'Cabarcos'),(632,56544,'Cabreiros'),(632,56546,'Calde'),(632,56550,'Camporramiro santa mar_a'),(632,56551,'Camposo'),(632,56555,'Candamil'),(632,56559,'Cangas'),(632,56561,'Carballedo'),(632,56562,'Carballeira'),(632,56563,'Carballido'),(632,56569,'Cartelos'),(632,56570,'Casablanca'),(632,56572,'Castelo'),(632,56575,'Castro'),(632,56576,'Castro de Rei'),(632,56578,'Castro'),(632,56581,'Castrocan'),(632,56582,'Castroverde'),(632,56584,'Cedofeita'),(632,56586,'Celeiro'),(632,56588,'Cerceda'),(632,56591,'Cervela'),(632,56592,'Cervo'),(632,56599,'O Corgo'),(632,56601,'Corvelle'),(632,56604,'Cospeito'),(632,56605,'Costa a'),(632,56606,'Cota'),(632,56608,'Covas'),(632,56609,'Cruz de incio'),(632,56611,'Currelos'),(632,56613,'Chantada'),(632,56614,'Chantado'),(632,56616,'Chavin'),(632,56620,'Devesa'),(632,56622,'Distriz'),(632,56628,'Donis'),(632,56631,'Entrambasaugas'),(632,56634,'Ermida a'),(632,56635,'Escairon'),(632,56637,'Faro'),(632,56638,'Fazouro'),(632,56639,'Ferreira'),(632,56645,'Ferreria'),(632,56651,'Foilebar santa mar_a'),(632,56654,'Folgoso do courel'),(632,56659,'A Fonsagrada'),(632,56660,'Fontaneira a'),(632,56667,'Foz'),(632,56668,'Frades'),(632,56674,'Friol'),(632,56675,'Froian'),(632,56683,'Galegos'),(632,56684,'Globos'),(632,56686,'Goiriz'),(632,56691,'Grolos'),(632,56695,'Guitiriz'),(632,56698,'Guntín'),(632,56700,'Hospital'),(632,56706,'Lago o'),(632,56707,'Laiosa san martiño'),(632,56708,'Lamaigrexa'),(632,56709,'Lamas'),(632,56711,'Láncara'),(632,56712,'Landrove'),(632,56713,'Lanzos'),(632,56718,'Laxosa'),(632,56722,'Liñares'),(632,56727,'Lourenzá'),(632,56729,'Lousada'),(632,56730,'Lousadela'),(632,56734,'Ludrio'),(632,56735,'Lugo'),(632,56736,'Maceda'),(632,56739,'Magazos'),(632,56743,'Mao'),(632,56745,'Mariz'),(632,56749,'Masma'),(632,56754,'Maxofrio'),(632,56755,'Meilan'),(632,56757,'Meira'),(632,56760,'Mera'),(632,56761,'Merille'),(632,56764,'Miranda'),(632,56769,'Mondoñedo'),(632,56771,'Monforte de Lemos'),(632,56775,'Monterroso'),(632,56778,'Mos'),(632,56781,'Mosteiro'),(632,56791,'Murias'),(632,56792,'Nadela'),(632,56794,'Naron'),(632,56795,'Navia de suarna'),(632,56796,'Negradas'),(632,56797,'Negueira de muñiz'),(632,56798,'Neira de rei'),(632,56801,'Nespereira'),(632,56808,'Nogais as'),(632,56811,'Nogueira de miño'),(632,56814,'Oleiros'),(632,56819,'Ourol'),(632,56823,'Outeiro de Rei'),(632,56824,'Outeiro'),(632,56828,'Pacios'),(632,56834,'Palas de Rei'),(632,56836,'Pantón'),(632,56840,'Paramo o'),(632,56842,'Parga'),(632,56846,'A Pastoriza'),(632,56847,'Pazo'),(632,56850,'Pedrafita'),(632,56859,'Penela a'),(632,56861,'Pereiro'),(632,56863,'Piedrafita docebreiro'),(632,56868,'Pintin'),(632,56874,'Piugos'),(632,56875,'Pobra de san xian'),(632,56876,'A Pobra do Brollón'),(632,56877,'Pol'),(632,56879,'A Pontenova'),(632,56881,'Porras'),(632,56883,'Portocelo'),(632,56884,'Portomarin'),(632,56894,'Quiroga'),(632,56896,'Rabade'),(632,56897,'Ramil'),(632,56900,'Rebordaos'),(632,56904,'Reinante'),(632,56913,'Ribadeo'),(632,56914,'Ribado'),(632,56915,'Ribas de miño'),(632,56917,'Ribeira'),(632,56918,'Ribeira de piquin'),(632,56921,'Rinlo'),(632,56926,'Riotorto'),(632,56931,'Roimil'),(632,56934,'Rosende'),(632,56936,'Rua'),(632,56941,'Saavedra'),(632,56943,'Sabarei'),(632,56944,'Salcedo'),(632,56947,'Samos'),(632,56948,'San ciprian'),(632,56950,'San pantaleon de cabanas'),(632,56951,'San pedro'),(632,56956,'Santa comba'),(632,56958,'Santa euxea'),(632,56959,'Santaballa'),(632,56961,'Santo tome'),(632,56962,'Sargadelos'),(632,56963,'Sarria'),(632,56967,'Seoane'),(632,56972,'Sindran'),(632,56976,'Sober'),(632,56981,'Taboada'),(632,56985,'Teixeiro'),(632,56989,'Tor'),(632,56994,'Trabada'),(632,56995,'Trascastro santa eulalia'),(632,56996,'Triacastela'),(632,57000,'Tuiriz'),(632,57003,'Valadouro'),(632,57005,'Valdocainzo'),(632,57006,'Vales'),(632,57007,'Valonga'),(632,57011,'O Vicedo'),(632,57012,'Vicinte'),(632,57014,'Vieiro'),(632,57026,'Vilaestrofe'),(632,57027,'Vilagocende'),(632,57028,'Vilalba'),(632,57039,'Vilanova'),(632,57046,'Vilar de frades'),(632,57055,'Vilarxoan san lourenzo'),(632,57056,'Vilasouto san mamede'),(632,57061,'Vilela'),(632,57062,'Viloalle'),(632,57063,'Villafernando'),(632,57066,'Viveiro  (san pedro)'),(632,57067,'Viveiro'),(632,57068,'Xermade'),(632,57069,'Xia'),(632,57070,'Xove'),(632,57073,'Zoñan'),(633,57074,'Abalos'),(633,57075,'Agoncillo'),(633,57076,'Aguilar del rio alhama'),(633,57077,'Ajamil'),(633,57078,'Albelda de Iregua'),(633,57079,'Alberite'),(633,57080,'Alcanadre'),(633,57081,'Aldealobos'),(633,57082,'Aldeanueva de cameros'),(633,57083,'Aldeanueva de Ebro'),(633,57084,'Alesanco'),(633,57086,'Alfaro'),(633,57087,'Almarza de cameros'),(633,57088,'Amunartia'),(633,57089,'Anguciana'),(633,57090,'Anguiano'),(633,57091,'Arbiza'),(633,57094,'Arnedillo'),(633,57095,'Arnedo'),(633,57096,'Arrubal'),(633,57097,'Ausejo'),(633,57098,'Autol'),(633,57100,'Azarruya'),(633,57101,'Azofra'),(633,57102,'Badaran'),(633,57103,'Bañares'),(633,57104,'Baños de rio tobia'),(633,57105,'Baños de rioja'),(633,57106,'Berceo'),(633,57107,'Bergasa'),(633,57108,'Bergasillas bajera'),(633,57109,'Bergasillas somera'),(633,57111,'Bobadilla'),(633,57113,'Briñas'),(633,57114,'Briones'),(633,57115,'Bucesta'),(633,57117,'Cabreton'),(633,57118,'Calahorra'),(633,57119,'Camprovin'),(633,57122,'Cañas'),(633,57123,'Carbonera'),(633,57124,'Cardenas'),(633,57125,'Casalarreina'),(633,57126,'Casas blancas'),(633,57127,'Castañares de las cuevas'),(633,57128,'Castañares de rioja'),(633,57129,'Castejon'),(633,57130,'Castilseco'),(633,57133,'Cenicero'),(633,57134,'Cervera del Río Alhama'),(633,57136,'Cihuri'),(633,57137,'Ciriñuela'),(633,57139,'Cordovin'),(633,57140,'Corera'),(633,57141,'Cornago'),(633,57143,'Cortijo el'),(633,57144,'Cuzcurrita rio tiron'),(633,57145,'Cuzcurritilla'),(633,57146,'Daroca de rioja'),(633,57147,'Enciso'),(633,57148,'Entrena'),(633,57149,'Estacion la'),(633,57151,'Ezcaray'),(633,57152,'Foncea'),(633,57154,'Fuenmayor'),(633,57156,'Galilea'),(633,57159,'Gimileo'),(633,57160,'Grañon'),(633,57162,'Haro'),(633,57163,'Herce'),(633,57167,'Hormilla'),(633,57168,'Hormilleja'),(633,57170,'Hornos de moncalvillo'),(633,57171,'Huercanos'),(633,57172,'Igea'),(633,57175,'Jalon de cameros'),(633,57178,'Laguna de cameros'),(633,57179,'Lagunilla de jubera'),(633,57180,'Lardero'),(633,57181,'Larriba'),(633,57184,'Leza de rio leza'),(633,57185,'Logroño'),(633,57186,'Lugar del rio'),(633,57187,'Lumbreras'),(633,57189,'Manjarres'),(633,57190,'Mansilla'),(633,57191,'Manzanares de rioja'),(633,57192,'Matute'),(633,57193,'Medrano'),(633,57196,'Morales'),(633,57197,'Munilla'),(633,57198,'Murillo de calahorra'),(633,57199,'Murillo de rioleza'),(633,57200,'Muro de aguas'),(633,57202,'Nájera'),(633,57203,'Nalda'),(633,57205,'Navarrete'),(633,57206,'Nestares'),(633,57207,'Nieva de cameros'),(633,57208,'Ocon'),(633,57211,'Ollauri'),(633,57212,'Ortigosa'),(633,57215,'Pazuengos'),(633,57217,'Pedroso'),(633,57219,'Peroblasco'),(633,57220,'Pinillos'),(633,57223,'Pradejón'),(633,57224,'Pradillo'),(633,57225,'Prejano'),(633,57227,'Quel'),(633,57230,'Rasillo el'),(633,57231,'Redal el'),(633,57233,'Ribafrecha'),(633,57234,'Rincon de olivedo'),(633,57235,'Rincón de Soto'),(633,57238,'Rodezno'),(633,57242,'San andres'),(633,57244,'San asensio'),(633,57246,'San bartolome'),(633,57248,'San millan de la cogolla'),(633,57250,'San roman de cameros'),(633,57252,'San vicente de la sonsierra'),(633,57253,'San vicente de robres'),(633,57256,'Santa engracia de jubera'),(633,57257,'Santa eulalia bajera'),(633,57261,'Santo Domingo de la Calzada'),(633,57262,'Santurde'),(633,57263,'Santurdejo'),(633,57264,'Sojuela'),(633,57266,'Sorzano'),(633,57267,'Sotes'),(633,57269,'Tabladas'),(633,57271,'Terroba'),(633,57272,'Tirgo'),(633,57273,'Tobia'),(633,57275,'Tormantos'),(633,57277,'Torrecilla en cameros'),(633,57281,'Treviana'),(633,57282,'Trevijano'),(633,57283,'Tricio'),(633,57284,'Tudelilla'),(633,57286,'Union de los tres ejercitos la'),(633,57288,'Uruñuela'),(633,57290,'Vadillos'),(633,57295,'Valverde'),(633,57296,'Varea'),(633,57299,'Ventas blancas'),(633,57302,'Ventrosa'),(633,57303,'Viguera'),(633,57304,'Villalba de rioja'),(633,57306,'Villamediana de Iregua'),(633,57308,'Villar de arnedo el'),(633,57310,'Villar el'),(633,57312,'Villarroya'),(633,57314,'Villaseca'),(633,57315,'Villavelayo'),(633,57317,'Villoslada de cameros'),(633,57318,'Viniegra de abajo'),(633,57320,'Zaldierna'),(633,57321,'Zarraton'),(633,57322,'Zarzosa'),(634,57325,'Ceuta'),(635,57326,'Abarán'),(635,57327,'Águilas'),(635,57328,'Agulas las'),(635,57329,'Albarda'),(635,57330,'Alberca la'),(635,57331,'Albudeite'),(635,57332,'Albujon'),(635,57333,'Alcantarilla'),(635,57334,'Los Alcázares'),(635,57335,'Aledo'),(635,57336,'Algar el'),(635,57337,'Algezares'),(635,57338,'Alguazas'),(635,57339,'Alhama de Murcia'),(635,57340,'Aljorra la'),(635,57341,'Almagros los'),(635,57342,'Almendricos'),(635,57343,'Almudema'),(635,57344,'Alporchones'),(635,57345,'Alqueria la'),(635,57346,'Alquerias'),(635,57347,'Alquerias las'),(635,57348,'Altobordo'),(635,57349,'Alumbres'),(635,57350,'Anchurica la'),(635,57351,'Aparecida la'),(635,57352,'Archena'),(635,57353,'Archivel'),(635,57354,'Arejos los'),(635,57355,'Ascoy'),(635,57356,'Atalaya la'),(635,57357,'Aviles'),(635,57358,'Avileses'),(635,57359,'Azohia la'),(635,57360,'Balneario fortuna'),(635,57361,'Balsapintada'),(635,57362,'Balsicas'),(635,57363,'Baños de archena'),(635,57364,'Baños de mula'),(635,57365,'Baños y mendigo'),(635,57366,'Barinas'),(635,57367,'Barqueros'),(635,57368,'Barranda'),(635,57369,'Beal'),(635,57370,'Beatos los'),(635,57371,'Belones los'),(635,57372,'Beniajan'),(635,57373,'Beniel'),(635,57374,'Benizar'),(635,57376,'Berro el'),(635,57377,'Blanca'),(635,57378,'Bolnuevo'),(635,57380,'Bullas'),(635,57381,'Cabezo de la plata'),(635,57382,'Cabezo de torres'),(635,57383,'Cabildo y la campana'),(635,57384,'Cabo de palos'),(635,57385,'Calar de la santa'),(635,57386,'Calasparra'),(635,57388,'Campana la'),(635,57389,'Campillo de abajo'),(635,57390,'Campo coy'),(635,57392,'Campos del Río'),(635,57393,'Canara'),(635,57394,'Canovas'),(635,57395,'Canteras'),(635,57396,'Canton el'),(635,57397,'Cañada de gallego'),(635,57398,'Cañada de la cruz'),(635,57399,'Cañada de la leña'),(635,57400,'Cañada del trigo'),(635,57401,'Capres'),(635,57402,'Caravaca de la Cruz'),(635,57403,'Carrasquilla'),(635,57405,'Cartagena'),(635,57406,'Casas de los cerrillares'),(635,57407,'Casas del puerto'),(635,57408,'Casas nuevas'),(635,57410,'Casicas las'),(635,57411,'Cehegín'),(635,57413,'Central almadenes'),(635,57414,'Ceutí'),(635,57415,'Cieza'),(635,57416,'Cocon el'),(635,57417,'Copa la'),(635,57418,'Cope'),(635,57420,'Corvera'),(635,57421,'Coy'),(635,57422,'Cuesta blanca'),(635,57424,'Cuevas de reyllo'),(635,57425,'Chopillo el'),(635,57426,'Dolores'),(635,57427,'Dolores los'),(635,57428,'Encarnacion la'),(635,57431,'Escombreras'),(635,57432,'Esparragal'),(635,57433,'Espinardo'),(635,57434,'Estrecho el'),(635,57435,'Fenazar'),(635,57436,'Fortuna'),(635,57437,'Fuensanta'),(635,57438,'Fuente blanca'),(635,57439,'Fuente del pino'),(635,57440,'Fuente librilla'),(635,57441,'Galife'),(635,57442,'Garapacha'),(635,57443,'Garres los'),(635,57446,'Guadalupe'),(635,57448,'Hinojar'),(635,57450,'Hoya del campo'),(635,57451,'Hoya la'),(635,57452,'Jabali nuevo'),(635,57453,'Jabali viejo'),(635,57454,'Jimenado'),(635,57455,'Jumilla'),(635,57457,'Leiva'),(635,57458,'Librilla'),(635,57459,'Lobosillo'),(635,57460,'Lorca'),(635,57461,'Lorquí'),(635,57462,'Llano el'),(635,57463,'Macisvenda'),(635,57464,'Mahoya'),(635,57465,'Marfagones'),(635,57466,'Martinez los'),(635,57467,'Mazarrón'),(635,57468,'Mazuza y las nogueras'),(635,57469,'Mirador el'),(635,57470,'Mojon el'),(635,57471,'Molina de Segura'),(635,57472,'Molinos los'),(635,57473,'Monteagudo'),(635,57474,'Moral el'),(635,57476,'Morata'),(635,57477,'Moratalla'),(635,57478,'Mula'),(635,57479,'Murcia'),(635,57480,'Murta la'),(635,57481,'Nietos los'),(635,57482,'Niño el'),(635,57483,'Nora la'),(635,57484,'Ojos'),(635,57485,'Paca la'),(635,57486,'Pagan lo'),(635,57487,'Palas las'),(635,57488,'Palma la'),(635,57489,'El Palmar'),(635,57490,'Palmero el'),(635,57491,'Pareton el'),(635,57493,'Pastrana'),(635,57494,'Pinilla la'),(635,57495,'Pliego'),(635,57496,'Portman'),(635,57497,'Portus'),(635,57499,'Pozo estrecho'),(635,57500,'Puebla de mula'),(635,57501,'Puebla la'),(635,57502,'Puerto de mazarron'),(635,57503,'Puerto Lumbreras'),(635,57504,'Puntas de calnegre'),(635,57505,'Purias'),(635,57506,'Raiguero'),(635,57507,'Raiguero bajo'),(635,57508,'Ramonete'),(635,57509,'Ramos los'),(635,57510,'Raspay'),(635,57511,'Rellano el'),(635,57512,'Retamalejo'),(635,57513,'Ricote'),(635,57514,'Rincon el'),(635,57515,'Rocas las'),(635,57516,'Roche'),(635,57517,'Roda'),(635,57518,'Roldan'),(635,57519,'Royos'),(635,57521,'San anton de abad'),(635,57522,'San javier'),(635,57523,'San Pedro del Pinatar'),(635,57524,'Sangonera la verde'),(635,57525,'Santa ana'),(635,57526,'Santa lucia'),(635,57527,'Santiago de la ribera'),(635,57528,'Santomera'),(635,57529,'Serrano'),(635,57530,'Singla'),(635,57531,'Siscar el'),(635,57532,'Sucina'),(635,57533,'Tallante'),(635,57535,'Tercia la'),(635,57536,'Terreras las'),(635,57537,'Torre del negro'),(635,57538,'Torre-Pacheco'),(635,57539,'Torreaguera'),(635,57541,'Las Torres de Cotillas'),(635,57542,'Totana'),(635,57543,'Ullea'),(635,57544,'Umbria la'),(635,57545,'La Unión'),(635,57546,'Urrutias los'),(635,57547,'Valderas'),(635,57549,'Valientes los'),(635,57550,'Valladolises'),(635,57551,'Venta de la paloma'),(635,57552,'Venta de la virgen'),(635,57554,'Venta manolita'),(635,57555,'Villanueva del Río Segura'),(635,57556,'Yecla'),(635,57557,'Yechar'),(635,57558,'Zarcilla de ramos'),(635,57559,'Zarza la'),(635,57561,'Zarzadilla de totana'),(635,57562,'Zeneta'),(635,57563,'Zuñiga y la juncosa'),(636,57564,'Abusejo'),(636,57565,'Agallas'),(636,57566,'Agueda del caudillo'),(636,57567,'Ahigal de los aceiteros'),(636,57568,'Ahigal de villarino'),(636,57569,'Alameda de gardon la'),(636,57570,'Alamedilla la'),(636,57571,'Alaraz'),(636,57572,'Alba de Tormes'),(636,57573,'Alba de yeltes'),(636,57574,'Alberca la'),(636,57575,'Albergueria de argañan la'),(636,57576,'Alconada'),(636,57577,'Aldea del obispo'),(636,57579,'Aldeadavila de la ribera'),(636,57582,'Aldealengua'),(636,57583,'Aldeanueva de figueroa'),(636,57584,'Aldeanueva de la sierra'),(636,57585,'Aldearrodrigo'),(636,57586,'Aldearrubia'),(636,57587,'Aldeaseca de alba'),(636,57588,'Aldeaseca de la frontera'),(636,57589,'Aldeatejada'),(636,57590,'Aldeavieja de tormes'),(636,57593,'Aldehuela de yeltes'),(636,57594,'Almenara de tormes'),(636,57595,'Almendra'),(636,57596,'Amatos'),(636,57597,'Anaya de alba'),(636,57598,'Añover de tormes'),(636,57599,'Arabayona'),(636,57600,'Arapiles'),(636,57601,'Arcediano'),(636,57602,'Armenteros'),(636,57603,'Atalaya la'),(636,57604,'Babilafuente'),(636,57606,'Bañobarez'),(636,57607,'Baños'),(636,57608,'Barbadillo'),(636,57610,'Barceino'),(636,57612,'Barreras'),(636,57613,'Barruecopardo'),(636,57615,'Béjar'),(636,57616,'Beleña'),(636,57617,'Berceo'),(636,57618,'Bercimuelle'),(636,57619,'Berganciano'),(636,57620,'Bermellar'),(636,57624,'Boadilla'),(636,57626,'Bodon el'),(636,57627,'Bogajo'),(636,57629,'Brincones'),(636,57630,'Buenamadre'),(636,57631,'Buenavista'),(636,57632,'Cabaco el'),(636,57633,'Cabeza de bejar la'),(636,57636,'Cabeza del caballo'),(636,57639,'Cabrerizos'),(636,57640,'Cabrillas'),(636,57641,'Calvarrasa de abajo'),(636,57642,'Calvarrasa de arriba'),(636,57645,'Calzada de valdunciel'),(636,57651,'Campo de peñaranda el'),(636,57653,'Candelario'),(636,57654,'Canillas de abajo'),(636,57655,'Cantagallo'),(636,57656,'Cantalapiedra'),(636,57657,'Cantalpino'),(636,57658,'Cantaracillo'),(636,57659,'Carbajosa de armuña'),(636,57660,'Carbajosa de la Sagrada'),(636,57663,'Carrascal de barregas'),(636,57664,'Carrascal del obispo'),(636,57670,'Casillas de flores'),(636,57671,'Castañeda'),(636,57672,'Castellanos de moriscos'),(636,57673,'Castellanos de villiquera'),(636,57678,'Centenares'),(636,57679,'Cepeda'),(636,57684,'Cerro el'),(636,57685,'Cespedosa'),(636,57686,'Cespedosa de agadones'),(636,57687,'Cilleros de la bastida'),(636,57689,'Cilloruelo'),(636,57690,'Ciperez'),(636,57691,'Ciudad Rodrigo'),(636,57694,'Colmenar de montemayor'),(636,57695,'Collado de malvarin'),(636,57696,'Cordovilla'),(636,57697,'Corporario'),(636,57698,'Cortos de la sierra'),(636,57699,'Cristobal'),(636,57701,'Cubo de don sancho el'),(636,57704,'Dios le guarde'),(636,57706,'Doñinos de salamanca'),(636,57709,'Encina la'),(636,57710,'Encinas de abajo'),(636,57711,'Encinas de arriba'),(636,57712,'Encinasola de los comendadores'),(636,57714,'Escuernavacas'),(636,57715,'Escurial de la sierra'),(636,57716,'Espadaña'),(636,57718,'Espino de la orbada'),(636,57720,'Florida de liebana'),(636,57721,'Forfoleda'),(636,57722,'Frades de la sierra'),(636,57723,'Fregeneda la'),(636,57724,'Fresnedoso'),(636,57725,'Fresno-alhandiga'),(636,57726,'Fuente de san esteban la'),(636,57727,'Fuenteguinaldo'),(636,57730,'Fuentes de bejar'),(636,57732,'Fuentes de oñoro'),(636,57734,'Galindo y perahuy'),(636,57735,'Galinduste'),(636,57737,'Gallegos de argañan'),(636,57740,'Garcibuey'),(636,57742,'Garcihernandez'),(636,57743,'Garcirrey'),(636,57746,'Gema'),(636,57749,'Gomecello'),(636,57752,'Groo el'),(636,57754,'Guadramiro'),(636,57757,'Guijuelo'),(636,57759,'Herguijuela de la sierra'),(636,57761,'Hinojosa del duero'),(636,57763,'Horcajo-medianero'),(636,57764,'Hoya la'),(636,57766,'Huerta'),(636,57770,'Ituero de azaba'),(636,57772,'Juzbado'),(636,57773,'Lagunilla'),(636,57775,'Ledesma'),(636,57776,'Ledrada'),(636,57777,'Linares de riofrio'),(636,57778,'Lumbrales'),(636,57779,'Macotera'),(636,57780,'Machacon'),(636,57782,'Magdalena la'),(636,57783,'Maillo el'),(636,57786,'Mancera de abajo'),(636,57789,'Martiago'),(636,57790,'Martin de yeltes'),(636,57791,'Martinamor'),(636,57792,'Masueco'),(636,57793,'Mata de arriba'),(636,57794,'Mata de ledesma la'),(636,57796,'Matilla de los caños del rio'),(636,57797,'Maya la'),(636,57799,'Mieza'),(636,57801,'Miranda de azan'),(636,57802,'Miranda del castañar'),(636,57803,'Mogarraz'),(636,57804,'Molinillo'),(636,57805,'Monforte de la sierra'),(636,57806,'Monleon'),(636,57810,'Montemayor del rio'),(636,57811,'Monterrubio de armuña'),(636,57812,'Monterrubio de la sierra'),(636,57815,'Morasverdes'),(636,57816,'Morille'),(636,57818,'Moriscos'),(636,57821,'Mozarbez'),(636,57822,'Muñoz'),(636,57823,'Narros de matalayegua'),(636,57824,'Nava de bejar'),(636,57825,'Nava de francia'),(636,57829,'Navales'),(636,57832,'Navarredonda de la rinconada'),(636,57834,'Navasfrias'),(636,57839,'Palacinos'),(636,57841,'Palacios de salvatierra'),(636,57842,'Palaciosrubios'),(636,57844,'Palomares'),(636,57848,'Paradinas de san juan'),(636,57851,'Payo el'),(636,57852,'Pedraza de alba'),(636,57853,'Pedrosillo de alba'),(636,57854,'Pedrosillo de los aires'),(636,57856,'Pedroso de la armuña el'),(636,57858,'Pelabravo'),(636,57859,'Pelarrodriguez'),(636,57862,'Peña de cabra'),(636,57864,'Peñacaballera'),(636,57865,'Peñaparda'),(636,57866,'Peñaranda de Bracamonte'),(636,57868,'Peralejos de abajo'),(636,57870,'Pereña'),(636,57871,'Peromingo'),(636,57875,'Pitiegua'),(636,57876,'Pizarral'),(636,57878,'Poveda de las cintas'),(636,57882,'Puebla de yeltes'),(636,57883,'Puente del congosto'),(636,57885,'Puertas'),(636,57887,'Puerto seguro'),(636,57888,'Quejigal'),(636,57889,'Ragama'),(636,57892,'Retortillo'),(636,57894,'Rinconada de la sierra la'),(636,57896,'Robleda'),(636,57897,'Robledo hermoso'),(636,57899,'Robliza de cojos'),(636,57900,'Rollan'),(636,57903,'Sagrada la'),(636,57904,'Salamanca'),(636,57905,'Saldeana'),(636,57906,'Salmoral'),(636,57908,'Salvatierra de tormes'),(636,57909,'Sambellin'),(636,57910,'San cristobal de la cuesta'),(636,57911,'San cristobal de los mochuelos'),(636,57912,'San esteban de la sierra'),(636,57913,'San felices de los gallegos'),(636,57915,'San martin del castañar'),(636,57916,'San miguel de valero'),(636,57917,'San miguel del robledo'),(636,57919,'San muñoz'),(636,57920,'San pedro de rozados'),(636,57922,'San pelayo de guareña'),(636,57923,'Sancti-spiritus'),(636,57927,'Sando'),(636,57929,'Santa ines'),(636,57930,'Santa maria de sando'),(636,57932,'Santa Marta de Tormes'),(636,57933,'Santa olalla'),(636,57934,'Santa teresa'),(636,57936,'Santibañez de bejar'),(636,57937,'Santibañez de la sierra'),(636,57941,'Santos los'),(636,57943,'Saucelle'),(636,57947,'Sequeros'),(636,57949,'Serradilla del llano'),(636,57953,'Siete iglesias de tormes'),(636,57954,'Sobradillo'),(636,57955,'Sorihuela'),(636,57956,'Sotoserrano'),(636,57957,'Tabera de abajo'),(636,57960,'Tamames'),(636,57961,'Tarazona de guareña'),(636,57962,'Tardaguila'),(636,57965,'Tejares'),(636,57966,'Tejeda y segoyuela'),(636,57968,'Terradillos'),(636,57969,'Topas'),(636,57971,'Tordillos'),(636,57974,'Torres las'),(636,57975,'Torresmenudas'),(636,57976,'Trabanca'),(636,57979,'Turra'),(636,57983,'Valdecarros'),(636,57984,'Valdefuentes de sangusin'),(636,57986,'Valdelacasa'),(636,57988,'Valdelosa'),(636,57990,'Valderrodrigo'),(636,57995,'Valero'),(636,57998,'Valverdon'),(636,57999,'Vallejera de riofrio'),(636,58000,'Vecinos'),(636,58001,'Vega de tirados'),(636,58002,'Vegas de domingo rey'),(636,58003,'Veguillas las'),(636,58005,'Velles la'),(636,58006,'Ventosa del rio almar'),(636,58007,'Vidola la'),(636,58008,'Vilvestre'),(636,58009,'Villaflores'),(636,58010,'Villagonzalo de tormes'),(636,58011,'Villagordo'),(636,58012,'Villalba de los llanos'),(636,58013,'Villamayor'),(636,58015,'Villanueva del conde'),(636,58017,'Villar de gallimazo'),(636,58018,'Villar de la yegua'),(636,58019,'Villar de peralonso'),(636,58021,'Villar del ciervo'),(636,58022,'Villares de la Reina'),(636,58024,'Villarino'),(636,58025,'Villarmayor'),(636,58027,'Villasbuenas'),(636,58029,'Villaseco de los gamitos'),(636,58031,'Villasrubias'),(636,58032,'Villaverde de guareña'),(636,58033,'Villavieja de yeltes'),(636,58034,'Villoria'),(636,58035,'Villoruela'),(636,58036,'Vitigudino'),(636,58037,'Yecla de yeltes'),(636,58039,'Zamarra'),(636,58040,'Zamayon'),(636,58042,'Zarza de pumareda la'),(636,58043,'Zorita'),(636,58044,'Zorita de la frontera'),(637,58045,'Adalia'),(637,58046,'Aguasal'),(637,58047,'Aguilar de campos'),(637,58048,'Alaejos'),(637,58049,'Alcazaren'),(637,58050,'Aldea de san miguel'),(637,58051,'Aldealbar'),(637,58052,'Aldeamayor de san martin'),(637,58053,'Aldeayuso'),(637,58055,'Almenara de adaja'),(637,58056,'Amusquillo'),(637,58058,'Arrabal del portillo'),(637,58059,'Arroyo'),(637,58060,'Asorona'),(637,58061,'Ataquines'),(637,58062,'Bahabon'),(637,58063,'Barcial de la loma'),(637,58064,'Barruelo'),(637,58067,'Bercero'),(637,58068,'Berceruelo'),(637,58070,'Bobadilla del campo'),(637,58071,'Bocigas'),(637,58073,'Boecillo'),(637,58074,'Bolaños de campos'),(637,58077,'Cabezón'),(637,58078,'Cabezón de Valderaduey'),(637,58079,'Cabreros del monte'),(637,58080,'Calabazas'),(637,58081,'Campaspero'),(637,58083,'Camporredondo'),(637,58084,'Canalejas de peñafiel'),(637,58085,'Canillas de esgueva'),(637,58086,'Carpio'),(637,58087,'Casasola'),(637,58088,'Casasola de arion'),(637,58089,'Castillo de duero'),(637,58090,'Castrejon'),(637,58093,'Castrodeza'),(637,58094,'Castromembibre'),(637,58095,'Castromonte'),(637,58096,'Castronuevo de esgueva'),(637,58097,'Castronuño'),(637,58098,'Castroponce'),(637,58099,'Castroverde de cerrato'),(637,58100,'Ceinos de campos'),(637,58102,'Cigales'),(637,58103,'Ciguñuela'),(637,58104,'Cistérniga'),(637,58105,'Cogeces de iscar'),(637,58106,'Cogeces del monte'),(637,58107,'Corcos'),(637,58108,'Corrales de duero'),(637,58110,'Cubillas de santa marta'),(637,58111,'Cuenca de campos'),(637,58113,'Encinas de esgueva'),(637,58114,'Esguevillas de esgueva'),(637,58115,'Fombellida'),(637,58116,'Fompedraza'),(637,58118,'Fontihoyuelo'),(637,58119,'Fresno el viejo'),(637,58120,'Fuensaldaña'),(637,58121,'Fuente el sol'),(637,58122,'Fuente olmedo'),(637,58125,'Geria'),(637,58126,'Gomeznarro'),(637,58129,'Herrera de duero'),(637,58133,'Hornillos'),(637,58134,'Íscar'),(637,58135,'Jaramiel de arriba'),(637,58136,'Laguna de Duero'),(637,58137,'Langayo'),(637,58138,'Lomoviejo'),(637,58140,'Manzanillo'),(637,58141,'Marzales'),(637,58142,'Matapozuelos'),(637,58143,'Matilla de los caños'),(637,58144,'Mayorga'),(637,58145,'Medina de Rioseco'),(637,58146,'Medina del Campo'),(637,58147,'Megezes'),(637,58148,'Melgar de abajo'),(637,58149,'Melgar de arriba'),(637,58150,'Melida'),(637,58151,'Mojados'),(637,58152,'Molpeceres'),(637,58154,'Montealegre'),(637,58155,'Montemayor de pililla'),(637,58156,'Moral de la reina'),(637,58157,'Moraleja de las panaderas'),(637,58158,'Morales de campos'),(637,58159,'Mota del marques'),(637,58160,'Mucientes'),(637,58161,'Mudarra la'),(637,58163,'Nava del Rey'),(637,58164,'Nueva villa de las torres'),(637,58165,'Olivares de duero'),(637,58166,'Olmedo'),(637,58167,'Olmos de esgueva'),(637,58168,'Olmos de peñafiel'),(637,58169,'Otero el'),(637,58170,'Padilla de duero'),(637,58171,'Palacios de campos'),(637,58173,'Parrilla la'),(637,58174,'Pedraja del portillo la'),(637,58175,'Pedrajas de San Esteban'),(637,58176,'Pedrosa del rey'),(637,58177,'Pedroso de la abadesa'),(637,58178,'Peñafiel'),(637,58179,'Peñaflor de hornija'),(637,58180,'Pesquera de duero'),(637,58181,'Pesqueruela'),(637,58182,'Pinar de antequera'),(637,58183,'Piña de esgueva'),(637,58184,'Piñel de abajo'),(637,58185,'Piñel de arriba'),(637,58189,'Pollos'),(637,58190,'Portillo'),(637,58191,'Pozal de gallinas'),(637,58192,'Pozaldez'),(637,58193,'Pozuelo de la orden'),(637,58194,'Puente duero-esparragal'),(637,58195,'Puras'),(637,58196,'Quintanilla de arriba'),(637,58197,'Quintanilla de onesimo'),(637,58198,'Quintanilla de trigueros'),(637,58199,'Quintanilla del molar'),(637,58200,'Rabano'),(637,58202,'Renedo'),(637,58204,'Rodilana'),(637,58205,'Roturas'),(637,58206,'Rubi de bracamonte'),(637,58207,'Rueda'),(637,58208,'Saelices de mayorga'),(637,58209,'San andres'),(637,58210,'San bernardo'),(637,58211,'San cebrian de mazote'),(637,58212,'San llorente'),(637,58214,'San martin de valveni'),(637,58215,'San miguel del arroyo'),(637,58216,'San miguel del pino'),(637,58217,'San pablo de la moraleja'),(637,58218,'San pedro de latarce'),(637,58219,'San pelayo'),(637,58220,'San roman de hornija'),(637,58221,'San salvador'),(637,58222,'San vicente del palacio'),(637,58223,'Santa eufemia del arroyo'),(637,58226,'Santibañez de valcorba'),(637,58227,'Santovenia de Pisuerga'),(637,58228,'Sardon de duero'),(637,58229,'Seca la'),(637,58230,'Serrada'),(637,58231,'Siete iglesias de trabancos'),(637,58232,'Simancas'),(637,58233,'Tamariz de campos'),(637,58234,'Tiedra'),(637,58235,'Tordehumos'),(637,58236,'Tordesillas'),(637,58239,'Torrecilla de la abadesa'),(637,58240,'Torrecilla de la orden'),(637,58243,'Torrelobaton'),(637,58245,'Traspinedo'),(637,58246,'Trigueros del valle'),(637,58247,'Tudela de Duero'),(637,58248,'Union de campos la'),(637,58249,'Urones de castroponce'),(637,58250,'Urueña'),(637,58251,'Valbuena de duero'),(637,58253,'Valdenebro de los valles'),(637,58254,'Valdestillas'),(637,58255,'Valdunquillo'),(637,58256,'Valoria la buena'),(637,58258,'Valladolid'),(637,58259,'Vega de ruiponce'),(637,58261,'Vega sicilia'),(637,58262,'Velascalvaro'),(637,58263,'Velilla'),(637,58265,'Ventosa de la cuesta'),(637,58266,'Viana de cega'),(637,58267,'Viloria'),(637,58268,'Villabañez'),(637,58269,'Villabaruz de campos'),(637,58270,'Villabragima'),(637,58271,'Villacarralon'),(637,58273,'Villaco'),(637,58275,'Villaesper'),(637,58278,'Villafrades de campos'),(637,58279,'Villafranca de duero'),(637,58280,'Villafrechos'),(637,58281,'Villafuerte'),(637,58282,'Villagarcia de campos'),(637,58284,'Villalón de Campos'),(637,58285,'Villalar de los comuneros'),(637,58287,'Villalba de la loma'),(637,58288,'Villalba de los alcores'),(637,58289,'Villalbarba'),(637,58290,'Villalon de campos'),(637,58291,'Villamarciel'),(637,58293,'Villan de tordesillas'),(637,58294,'Villanubla'),(637,58295,'Villanueva de duero'),(637,58297,'Villanueva de los caballeros'),(637,58300,'Villardefrades'),(637,58301,'Villarmentero de esgueva'),(637,58302,'Villasexmir'),(637,58303,'Villavaquerin'),(637,58304,'Villavellid'),(637,58305,'Villaverde de medina'),(637,58306,'Villavicencio de los caballero'),(637,58308,'Wamba'),(637,58309,'Zaratán'),(637,58310,'Zarza la'),(637,58311,'Zorita de la loma'),(638,58312,'Acebuchal el'),(638,58313,'Agracea'),(638,58314,'Agrupacion de mogon'),(638,58315,'Agrupacion santo tome'),(638,58316,'Albanchez de ubeda'),(638,58317,'Alcalá la Real'),(638,58318,'Alcaparrosa'),(638,58319,'Alcaudete'),(638,58320,'Aldeahermosa'),(638,58321,'Aliseda la'),(638,58323,'Andújar'),(638,58324,'Arbuniel'),(638,58325,'Arjona'),(638,58326,'Arjonilla'),(638,58327,'Arquillos'),(638,58328,'Arroyo del Ojanco'),(638,58329,'Atico el'),(638,58330,'Aulabar'),(638,58331,'Baeza'),(638,58332,'Bailén'),(638,58333,'Baños de la Encina'),(638,58334,'Beas de Segura'),(638,58335,'Bedmar y Garcíez'),(638,58336,'Begíjar'),(638,58338,'Belmez'),(638,58339,'Belmez de la moraleda'),(638,58340,'Benatae'),(638,58341,'Berjada'),(638,58343,'Bobadilla'),(638,58344,'Bonache'),(638,58346,'Burunchel'),(638,58347,'Cabra del Santo Cristo'),(638,58348,'Cambil'),(638,58349,'Campillo de Arenas'),(638,58350,'Campillo del rio'),(638,58353,'Canena'),(638,58354,'Cañada de la madera'),(638,58356,'Carboneros'),(638,58357,'Carchalejo'),(638,58358,'Carchel'),(638,58359,'La Carolina'),(638,58361,'Casablanca'),(638,58363,'Casas de estepa'),(638,58365,'Casillas las'),(638,58366,'Castellar de santisteban'),(638,58367,'Castillo de Locubín'),(638,58368,'Cazalilla'),(638,58369,'Cazorla'),(638,58372,'Centenillo el'),(638,58373,'Cerezo el'),(638,58375,'Colonia de la cruz'),(638,58376,'Condesa la'),(638,58379,'Cortijo nuevo'),(638,58380,'Cortijos nuevos'),(638,58381,'Coto rios'),(638,58382,'Charilla'),(638,58383,'Chiclana de segura'),(638,58384,'Chilluevar'),(638,58385,'Chorro el'),(638,58387,'Ermita nueva'),(638,58388,'Escañuela'),(638,58389,'Escoriales los'),(638,58390,'Espeluy'),(638,58392,'Frailes'),(638,58395,'Fuensanta de Martos'),(638,58396,'Fuente alamo'),(638,58399,'Fuerte del rey'),(638,58400,'Garciez'),(638,58401,'Genave'),(638,58405,'Guadalmar'),(638,58407,'La Guardia de Jaén'),(638,58408,'Guarromán'),(638,58409,'Gutar'),(638,58410,'Haza alta'),(638,58412,'Higuera de arjona'),(638,58413,'Higuera de calatrava'),(638,58414,'Hinojares'),(638,58415,'Hornos'),(638,58416,'Hornos de peal'),(638,58418,'Huelma'),(638,58419,'Huesa'),(638,58420,'Ibros'),(638,58421,'Infantas las'),(638,58422,'Iruela la'),(638,58423,'Isabela'),(638,58424,'Iznatoraf'),(638,58425,'Jabalcuz'),(638,58426,'Jabalquinto'),(638,58427,'Jaén'),(638,58428,'Jamilena'),(638,58429,'Jimena'),(638,58430,'Jódar'),(638,58431,'Larva'),(638,58432,'Lendinez'),(638,58433,'Linares'),(638,58434,'Lopera'),(638,58435,'Lugar nuevo'),(638,58436,'Lupion'),(638,58438,'Llanos del sotillo los'),(638,58439,'Machena'),(638,58440,'Mancha Real'),(638,58442,'Marmol el'),(638,58443,'Marmolejo'),(638,58444,'Martin malo'),(638,58445,'Martos'),(638,58446,'Mengíbar'),(638,58447,'Mesa la'),(638,58449,'Miraelrio'),(638,58450,'Miranda del rey'),(638,58451,'Mochuelos los'),(638,58452,'Mogon'),(638,58453,'Molar el'),(638,58454,'Monte lopez alvarez'),(638,58455,'Montizón'),(638,58456,'Mures'),(638,58458,'Navas de San Juan'),(638,58459,'Navas de tolosa'),(638,58460,'Neveral el'),(638,58461,'Noalejo'),(638,58462,'Noguerones'),(638,58465,'Orcera'),(638,58466,'Otiñar'),(638,58471,'Peal de Becerro'),(638,58473,'Pegalajar'),(638,58475,'Peñolite'),(638,58476,'Pontones'),(638,58477,'Porcuna'),(638,58478,'Porrosa la'),(638,58479,'Porrosillo el'),(638,58481,'Pozo Alcón'),(638,58482,'Pozo de la sarten'),(638,58483,'Puente de Génave'),(638,58484,'Puente del obispo'),(638,58485,'La Puerta de Segura'),(638,58487,'Quesada'),(638,58488,'Quinteria la'),(638,58491,'Ribera alta'),(638,58493,'Rus'),(638,58494,'Sabariego'),(638,58495,'Sabiote'),(638,58496,'San jose'),(638,58497,'San miguel'),(638,58499,'Santa ana'),(638,58500,'Santa elena'),(638,58501,'Santa eulalia'),(638,58502,'Santiago'),(638,58503,'Santiago de calatrava'),(638,58504,'Santiago de la espada'),(638,58505,'Santisteban del Puerto'),(638,58506,'Santo Tomé'),(638,58507,'Segura de la sierra'),(638,58509,'Siles'),(638,58510,'Solana de torralba'),(638,58511,'Solera'),(638,58512,'Sorihuela del guadalimar'),(638,58516,'Torre del Campo'),(638,58518,'Torre del vinagre'),(638,58519,'Torreblascopedro'),(638,58520,'Torredonjimeno'),(638,58521,'Torreperogil'),(638,58522,'Torrequebradilla'),(638,58523,'Torres'),(638,58524,'Torres de albanchez'),(638,58526,'Toya'),(638,58528,'Úbeda'),(638,58530,'Vado de torralba'),(638,58532,'Valdemarin'),(638,58533,'Valdepeñas de Jaén'),(638,58536,'Venta de los santos'),(638,58537,'Ventas del carrizal'),(638,58538,'Ventosilla'),(638,58540,'Vilches'),(638,58541,'Villacarrillo'),(638,58542,'Villagordo'),(638,58543,'Villalobos'),(638,58544,'Villanueva de la Reina'),(638,58545,'Villanueva del Arzobispo'),(638,58546,'Villardompardo'),(638,58547,'Villares de andujar los'),(638,58548,'Los Villares'),(638,58549,'Villarrodrigo'),(638,58550,'Vites'),(638,58551,'Yedra la'),(638,58552,'Zocueca'),(639,58553,'Adri'),(639,58554,'Age'),(639,58555,'Agullana'),(639,58556,'Aiguablava'),(639,58558,'Aiguaviva'),(639,58559,'Albanya'),(639,58560,'Albons'),(639,58561,'Alegries les'),(639,58562,'Alguaviva park'),(639,58563,'Alp'),(639,58565,'Amer'),(639,58566,'Anglades les'),(639,58567,'Anglés'),(639,58568,'Arbúcies'),(639,58569,'Argelaguer'),(639,58570,'Armentera l\''),(639,58572,'Avinyonet de puigventos'),(639,58573,'Balet'),(639,58575,'Banyoles'),(639,58576,'Bascara'),(639,58577,'Baseia'),(639,58578,'Beget'),(639,58579,'Begur'),(639,58580,'Bell-lloc'),(639,58581,'Bellcaire d\'emporda'),(639,58582,'Besalú'),(639,58583,'Bescanó'),(639,58585,'La Bisbal d\'Empordá'),(639,58586,'Biure'),(639,58587,'Blanes'),(639,58588,'Boadella d\'emporda'),(639,58589,'Bolvir'),(639,58590,'Bomba la'),(639,58591,'Bonmati'),(639,58592,'Bordils'),(639,58593,'Borrassa'),(639,58594,'Breda'),(639,58595,'Bruguera'),(639,58597,'Brunyola'),(639,58600,'Cabanelles'),(639,58601,'Cabanes'),(639,58602,'Cadaqués'),(639,58604,'Caldes de Malavella'),(639,58605,'Calella'),(639,58606,'Calonge'),(639,58607,'Camallera'),(639,58609,'Campdevánol'),(639,58610,'Campelles'),(639,58612,'Campmany'),(639,58613,'Camprodon'),(639,58616,'Canapost'),(639,58617,'Canet de adri'),(639,58618,'Cantallops'),(639,58619,'Canya la'),(639,58620,'Canyelles'),(639,58621,'Canyet de mar'),(639,58623,'Casavells'),(639,58624,'Cassá de la Selva'),(639,58626,'Castell d\'Aro'),(639,58627,'Castell d_emporda'),(639,58631,'Castellfollit de la roca'),(639,58632,'Castelló d\'Empúries'),(639,58634,'Celrá'),(639,58635,'La Cellera de Ter'),(639,58637,'Cervia de ter'),(639,58638,'Cistella'),(639,58640,'Colera'),(639,58641,'Colomers'),(639,58643,'Corça'),(639,58644,'Cornella de terri'),(639,58648,'Crespia'),(639,58649,'Cros el'),(639,58650,'Cruilles'),(639,58651,'Darnius'),(639,58652,'Das'),(639,58654,'Domeny'),(639,58657,'Empuria brava'),(639,58661,'Escadarcs'),(639,58662,'L\'Escala'),(639,58663,'Esclanya'),(639,58664,'Esparra l\''),(639,58667,'Espinosa'),(639,58668,'Espolla'),(639,58669,'Esponella'),(639,58670,'Estacio l\''),(639,58671,'Estela l\''),(639,58676,'Fenells'),(639,58677,'Figueres'),(639,58679,'Flaça'),(639,58680,'Foixa'),(639,58681,'Fontanilles'),(639,58682,'Fontcoberta'),(639,58683,'Fornells de la selva'),(639,58684,'Fornells de mar'),(639,58685,'Fortia'),(639,58686,'Fosca la'),(639,58687,'Galliners'),(639,58689,'Garrigas'),(639,58691,'Garriguella'),(639,58693,'Ger'),(639,58694,'Girona'),(639,58700,'Grions'),(639,58701,'Gualta'),(639,58703,'Hostalets els'),(639,58704,'Hostalric'),(639,58705,'Isovol'),(639,58706,'Joanetes'),(639,58707,'La Jonquera'),(639,58708,'Juia'),(639,58711,'Llafranc'),(639,58712,'Llagostera'),(639,58713,'Llampaies'),(639,58714,'Llanars'),(639,58715,'Llançá'),(639,58717,'Llers'),(639,58718,'Llofriu'),(639,58719,'Llora'),(639,58720,'Lloret de Mar'),(639,58723,'Maçanes'),(639,58724,'Macanet de cabrenys'),(639,58725,'Maçanet de la Selva'),(639,58726,'Madremanya'),(639,58727,'Maia de montcal'),(639,58729,'Martorell de la selva'),(639,58731,'Mas fumats el'),(639,58734,'Masos de pals els'),(639,58740,'Mieres'),(639,58742,'Molina la'),(639,58744,'Mollet de peralada'),(639,58746,'Monells'),(639,58747,'Mont-ras'),(639,58748,'Montagut'),(639,58749,'Montdois'),(639,58750,'Montfulla'),(639,58757,'Navata'),(639,58759,'Ogassa'),(639,58763,'Olopte'),(639,58764,'Olot'),(639,58765,'Ordis'),(639,58767,'Osor'),(639,58768,'Palafrugell'),(639,58769,'Palamós'),(639,58772,'Palau-saverdera'),(639,58775,'Palmerola'),(639,58776,'Palol d\'onyar'),(639,58777,'Palol de revardit'),(639,58778,'Pals'),(639,58780,'Parlara'),(639,58781,'Parroquia de ripoll'),(639,58782,'Pau'),(639,58783,'Pedret'),(639,58784,'Penedes'),(639,58785,'Pera la'),(639,58786,'Peralada'),(639,58790,'Planes d\'hostoles les'),(639,58792,'Platja d\'haro'),(639,58793,'Pols'),(639,58794,'Pont de molins'),(639,58795,'Pontos'),(639,58796,'Porqueres'),(639,58797,'Port de la selva el'),(639,58798,'Port de llança el'),(639,58799,'Portbou'),(639,58800,'Prades'),(639,58801,'Preses les'),(639,58803,'Puigcerdá'),(639,58806,'Quart'),(639,58807,'Queixans'),(639,58808,'Queixas'),(639,58809,'Queralbs'),(639,58810,'Rabo\'s'),(639,58812,'Regencos'),(639,58814,'Ribes de Freser'),(639,58815,'Riells'),(639,58816,'Riells de Montseny'),(639,58818,'Rigolisa'),(639,58819,'Ripoll'),(639,58820,'Riudarenes'),(639,58822,'Riudellots'),(639,58823,'Riudellots de la selva'),(639,58825,'Roses'),(639,58826,'Ruimors'),(639,58828,'S\'agaro'),(639,58829,'Sa riera'),(639,58832,'Sala la'),(639,58835,'Salt'),(639,58841,'Sant andreu salou'),(639,58842,'Sant aniol de finestres'),(639,58843,'Sant antoni de calonge'),(639,58846,'Sant climent sessebes'),(639,58847,'Sant daniel'),(639,58848,'Sant esteve d\'en bas'),(639,58849,'Sant feliu de buixalleu'),(639,58850,'Sant Feliu de Guíxols'),(639,58851,'Sant feliu de pallerolls'),(639,58854,'Sant Gregori'),(639,58855,'Sant Hilari Sacalm'),(639,58856,'Sant jaume de frontanya'),(639,58857,'Sant jaume de llierca'),(639,58858,'Sant Joan de les Abadesses'),(639,58859,'Sant joan de mollet'),(639,58860,'Sant Joan les Fonts'),(639,58861,'Sant jordi desvalls'),(639,58863,'Sant Juliá de Ramis'),(639,58869,'Sant marti de llemena'),(639,58872,'Sant marti sesserres'),(639,58873,'Sant marti vell'),(639,58876,'Sant miquel de fluvia'),(639,58878,'Sant mori'),(639,58879,'Sant pau de seguries'),(639,58880,'Sant pere del bosc'),(639,58881,'Sant pere espuig'),(639,58882,'Sant pere pescador'),(639,58883,'Sant pol'),(639,58884,'Sant privat d\'en bas'),(639,58885,'Sant sadurni de l\'heura'),(639,58886,'Sant salvador de bianya'),(639,58887,'Santa Coloma de Farners'),(639,58889,'Santa Cristina d\'Aro'),(639,58890,'Santa llogaia d\'alquema'),(639,58891,'Santa margarita'),(639,58893,'Santa pau'),(639,58894,'Santa pellaia'),(639,58896,'Sarit roc'),(639,58897,'Sarriá de Ter'),(639,58899,'Selva de mar la'),(639,58901,'Serinya'),(639,58903,'Serra de daro'),(639,58907,'Sils'),(639,58909,'Siuret'),(639,58910,'Sobrestany'),(639,58914,'Taiala'),(639,58916,'Tamariu'),(639,58917,'Tapies'),(639,58918,'Taravaus'),(639,58919,'Tarradelles'),(639,58920,'Terrades'),(639,58923,'Tor'),(639,58924,'Torre del vent'),(639,58926,'Torroella de fluvia'),(639,58927,'Torroella de Montgrí'),(639,58928,'Tortella'),(639,58929,'Toses'),(639,58930,'Tossa de Mar'),(639,58933,'Ulla'),(639,58934,'Ullestret'),(639,58935,'Urtx'),(639,58938,'Vall de bianya la'),(639,58940,'Vall-sobrega'),(639,58945,'Ventallo'),(639,58947,'Verges'),(639,58950,'Vidrieres'),(639,58951,'Vila-saura'),(639,58952,'Vilabertran'),(639,58953,'Vilablareix'),(639,58955,'Viladamat'),(639,58957,'Vilademuls'),(639,58959,'Viladrau'),(639,58960,'Vilafant'),(639,58961,'Vilajuiga'),(639,58964,'Vilamacolum'),(639,58965,'Vilamaniscle'),(639,58967,'Vilanant'),(639,58968,'Vilanova'),(639,58969,'Vilapriu'),(639,58970,'Vilarig'),(639,58978,'Vilosa la'),(639,58979,'Vilobí d\'Onyar'),(639,58981,'Yoanet'),(640,58982,'Acequias'),(640,58983,'Acula'),(640,58984,'Agron'),(640,58985,'Albolote'),(640,58986,'Albondon'),(640,58987,'Albuñan'),(640,58988,'Albuñol'),(640,58989,'Albuñuelas'),(640,58990,'Alcázar'),(640,58991,'Alcudia de guadix'),(640,58992,'Aldeilla'),(640,58993,'Aldeire'),(640,58994,'Alfacar'),(640,58995,'Alfornon'),(640,58996,'Algarinejo'),(640,58997,'Alhama de Granada'),(640,58998,'Alhendín'),(640,58999,'Alicun de ortega'),(640,59000,'Almaciles'),(640,59001,'Almegijar'),(640,59002,'Almendral el'),(640,59003,'Almontaras'),(640,59004,'Almuñécar'),(640,59005,'Alomartes'),(640,59006,'Alqueria la'),(640,59007,'Alquife'),(640,59008,'Ambroz'),(640,59009,'Apeadero la loma'),(640,59010,'Arenales'),(640,59011,'Arenas del rey'),(640,59012,'Armilla'),(640,59013,'Arqueria la'),(640,59014,'Arroyo-pinares'),(640,59015,'Arrozuelas'),(640,59016,'Atarfe'),(640,59017,'Bacor oliva'),(640,59018,'Balax'),(640,59019,'Balcones los'),(640,59020,'Baños de zujar'),(640,59022,'Barcinas'),(640,59024,'Baul'),(640,59025,'Baza'),(640,59026,'Beas de granada'),(640,59027,'Beas de guadix'),(640,59028,'Benalúa de Guadix'),(640,59029,'Benalúa de las Villas'),(640,59030,'Benamaurel'),(640,59031,'Berchules'),(640,59032,'Beznar'),(640,59034,'Bracana'),(640,59035,'Bubion'),(640,59036,'Buenavista'),(640,59038,'Busquistar'),(640,59040,'Cabra montes la'),(640,59041,'Cacin'),(640,59042,'Cadiar'),(640,59043,'Cájar'),(640,59044,'Calahonda'),(640,59045,'Calicasas'),(640,59047,'Campotejar'),(640,59048,'Caniles'),(640,59050,'Cañar'),(640,59051,'Caparecena'),(640,59052,'Capileira'),(640,59053,'Carataunas'),(640,59054,'Carchuna'),(640,59055,'Carriones los'),(640,59056,'Casa nueva'),(640,59057,'Casas de don juan'),(640,59058,'Castaras'),(640,59059,'Castell de ferro'),(640,59060,'Castillejar'),(640,59061,'Castillo de baños'),(640,59062,'Castillo de tajarda'),(640,59063,'Castril'),(640,59067,'Cenes de la Vega'),(640,59068,'Cijuela'),(640,59069,'Cogollos de guadix'),(640,59070,'Cogollos vega'),(640,59071,'Cojayar'),(640,59072,'Colomera'),(640,59073,'Conchar'),(640,59074,'Cortes'),(640,59075,'Cortes de Baza'),(640,59076,'Cortijo de becerra'),(640,59080,'Cozvijar'),(640,59081,'Cucharetas las'),(640,59084,'Cuevas de luna'),(640,59086,'Cuevas del Campo'),(640,59087,'Cúllar'),(640,59088,'Cúllar Vega'),(640,59089,'Cura el'),(640,59090,'Chaparral'),(640,59091,'Charches'),(640,59092,'Chauchina'),(640,59093,'Cherin'),(640,59094,'Chimeneas'),(640,59095,'Chite'),(640,59096,'Churriana de la Vega'),(640,59097,'Darro'),(640,59098,'Dehesa de guadix'),(640,59099,'Dehesas viejas'),(640,59100,'Deifontes'),(640,59101,'Delgadillo'),(640,59102,'Diezma'),(640,59103,'Dilar'),(640,59104,'Dolar'),(640,59105,'Domingo perez'),(640,59106,'Dudar'),(640,59107,'Dúrcal'),(640,59108,'Escuzar'),(640,59109,'Esfiliana'),(640,59110,'Esperanza la'),(640,59111,'Estacion la'),(640,59112,'Fargue'),(640,59113,'Fatima'),(640,59114,'Ferreira'),(640,59115,'Fonelas'),(640,59116,'Fornes'),(640,59118,'Fregenite'),(640,59119,'Freila'),(640,59120,'Fuensanta'),(640,59122,'Fuente nueva'),(640,59123,'Fuente Vaqueros'),(640,59124,'Fuente vera'),(640,59125,'Fuentes camacho'),(640,59126,'Fuentes de cesna'),(640,59127,'Gabia la chica'),(640,59128,'Las Gabias'),(640,59129,'Galco'),(640,59130,'Galera'),(640,59131,'Gallardos los'),(640,59132,'Garcias los'),(640,59133,'Garnatilla la'),(640,59134,'Gobernador'),(640,59135,'Gójar'),(640,59136,'Gor'),(640,59137,'Gorafe'),(640,59138,'Gorgoracha la'),(640,59139,'Graena'),(640,59140,'Granada'),(640,59141,'Güejar Sierra'),(640,59142,'Gsevejar'),(640,59143,'Guadahortuna'),(640,59144,'Guadix'),(640,59145,'Guajar alto'),(640,59146,'Guajar faragsit'),(640,59147,'Guajar fondon'),(640,59148,'Gualchos'),(640,59149,'Hernan valle'),(640,59150,'Herradura la'),(640,59151,'Hijar'),(640,59152,'Huelago'),(640,59153,'Hueneja'),(640,59154,'Huéscar'),(640,59155,'Huetor santillan'),(640,59156,'Huétor Tájar'),(640,59157,'Huétor Vega'),(640,59158,'Illora'),(640,59159,'Itrabo'),(640,59161,'Iznalloz'),(640,59162,'Jata'),(640,59163,'Jatar'),(640,59164,'Jayena'),(640,59165,'Jeres del marquesado'),(640,59166,'Jete'),(640,59167,'Jorairatar'),(640,59168,'Jun'),(640,59169,'Juntas las'),(640,59170,'Juviles'),(640,59171,'Laborcillas'),(640,59172,'Lacalahorra'),(640,59173,'Láchar'),(640,59175,'Lanjarón'),(640,59176,'Lanteira'),(640,59177,'Laroles'),(640,59178,'Lecrín'),(640,59179,'Lenteji'),(640,59180,'Limones'),(640,59181,'Lobras'),(640,59182,'Lobres'),(640,59183,'Loja'),(640,59185,'Loreto'),(640,59186,'Lugros'),(640,59187,'Lujar'),(640,59188,'Mairena'),(640,59189,'Mala'),(640,59190,'Mamola la'),(640,59191,'Maracena'),(640,59192,'Marchal'),(640,59193,'Margen el'),(640,59194,'Martin'),(640,59195,'Mecina alfahar'),(640,59196,'Mecina bombaron'),(640,59197,'Mecina tedel'),(640,59198,'Melegis'),(640,59201,'Moclín'),(640,59203,'Molvízar'),(640,59204,'Monachil'),(640,59206,'Mondujar'),(640,59207,'Monte almendras'),(640,59208,'Montefrío'),(640,59209,'Montejícar'),(640,59210,'Montillana'),(640,59211,'Moraleda de Zafayona'),(640,59212,'Moreda'),(640,59213,'Motril'),(640,59214,'Murchas'),(640,59215,'Murtas'),(640,59216,'Narila'),(640,59218,'Nigselas'),(640,59219,'Nivar'),(640,59220,'Notaez'),(640,59221,'Ogíjares'),(640,59222,'Olivar'),(640,59223,'Olmos los'),(640,59224,'Onitar'),(640,59225,'Orce'),(640,59226,'Órgiva'),(640,59227,'Otivar'),(640,59228,'Otura'),(640,59229,'Padul'),(640,59230,'Pago'),(640,59231,'Pampaneira'),(640,59232,'Pedro martinez'),(640,59233,'Pedro ruiz'),(640,59234,'Peligros'),(640,59236,'Peñuelas'),(640,59237,'Peza la'),(640,59238,'Picena'),(640,59239,'Pilas de algaida'),(640,59240,'Pinos del valle'),(640,59241,'Pinos genil'),(640,59242,'Pinos Puente'),(640,59243,'Piñar'),(640,59244,'Pitres'),(640,59245,'Policar'),(640,59246,'Polopos'),(640,59247,'Poloria'),(640,59248,'Portugos'),(640,59249,'Prado llano'),(640,59250,'Puebla de Don Fadrique'),(640,59253,'Puerto lopez'),(640,59254,'Pulianas'),(640,59256,'Purchil'),(640,59257,'Purullena'),(640,59258,'Quentar'),(640,59259,'Raposo el'),(640,59261,'Restabal'),(640,59262,'Riofrio'),(640,59263,'Romilla'),(640,59265,'Salar'),(640,59267,'Salobreña'),(640,59268,'Salomar 2000'),(640,59269,'San clemente'),(640,59270,'Santa cruz del comercio'),(640,59271,'Santa Fe'),(640,59272,'Serval el'),(640,59274,'Sillar baja'),(640,59275,'Soportujar'),(640,59276,'Sorvilan'),(640,59277,'Tablones los'),(640,59279,'Tarifa'),(640,59281,'Tiena'),(640,59282,'Timar'),(640,59283,'Tocon'),(640,59285,'Torre cardela'),(640,59286,'Torrenueva'),(640,59287,'Torres las'),(640,59288,'Torvizcon'),(640,59290,'Tozar'),(640,59291,'Trasmulas'),(640,59292,'Trevelez'),(640,59293,'Trujillo'),(640,59294,'Turon'),(640,59295,'Turro el'),(640,59296,'Ugíjar'),(640,59298,'Valderrubio'),(640,59300,'Valor'),(640,59301,'Varadero el'),(640,59302,'Vélez de Benaudalla'),(640,59303,'Velilla'),(640,59306,'Venta del peral'),(640,59308,'Ventas de huelma'),(640,59309,'Ventas de zafarraya'),(640,59310,'Ventorros de balarma'),(640,59311,'Ventorros de san jose'),(640,59312,'Villanueva de las torres'),(640,59313,'Villanueva Mesía'),(640,59314,'Villares los'),(640,59315,'Viñas las'),(640,59316,'Viznar'),(640,59317,'Yator'),(640,59318,'Yegen'),(640,59319,'Zafarraya'),(640,59320,'Zagra'),(640,59321,'La Zubia'),(640,59322,'Zujaira'),(640,59323,'Zújar'),(641,59324,'Abdet'),(641,59325,'Abio'),(641,59326,'Adsubia'),(641,59327,'La Adsubia'),(641,59328,'Aduanas del Mar'),(641,59329,'Agost'),(641,59330,'Agres'),(641,59331,'Albatera'),(641,59332,'Albir'),(641,59333,'Alborada'),(641,59334,'Albufereta'),(641,59335,'Alcalalí'),(641,59336,'Alcocer de Planes'),(641,59337,'Alcolecha'),(641,59338,'La Alcoraya'),(641,59339,'Alcoy'),(641,59340,'Alcudia'),(641,59341,'Alfafara'),(641,59342,'Alfaz del Pi'),(641,59343,'Algars'),(641,59344,'Algoda-Matola'),(641,59345,'Algorfa'),(641,59346,'Algorox'),(641,59347,'Algueña'),(641,59348,'Alhama Esprings'),(641,59349,'Alicante'),(641,59351,'Almoradí'),(641,59352,'Almudaina'),(641,59354,'Alquerja de Aznar'),(641,59355,'Altabix'),(641,59356,'Altea'),(641,59357,'Altea la Vieja'),(641,59358,'El Altet'),(641,59360,'Arenales del Sol'),(641,59361,'Ares'),(641,59362,'Arneva'),(641,59363,'Aspe'),(641,59364,'Asprillas'),(641,59365,'Bacarot'),(641,59366,'Balones'),(641,59367,'Bañeres'),(641,59368,'Barbarroja'),(641,59369,'Barchell'),(641,59372,'Bayas las'),(641,59373,'Benamar'),(641,59374,'Benasau'),(641,59375,'Benejama'),(641,59376,'Benejúzar'),(641,59377,'Benferri'),(641,59378,'Benialfaqui'),(641,59379,'Beniali'),(641,59380,'Beniarbeig'),(641,59381,'Beniard'),(641,59382,'Beniarrés'),(641,59383,'Beniaya'),(641,59384,'Benichembla'),(641,59385,'Benidoleig'),(641,59386,'Benidorm'),(641,59387,'Benifallim'),(641,59388,'Benifato'),(641,59389,'Benijófar'),(641,59390,'Benilloba'),(641,59391,'Benillup'),(641,59392,'Benimantell'),(641,59393,'Benimarco'),(641,59394,'Benimasot'),(641,59395,'Benimaurell'),(641,59397,'Benirrama'),(641,59398,'Benisa'),(641,59400,'Benisiva'),(641,59401,'Benitachell'),(641,59403,'Bernia'),(641,59404,'Biar'),(641,59405,'Bigastro'),(641,59408,'Bonalba Alta'),(641,59409,'Boqueres'),(641,59410,'Buenavista'),(641,59411,'Busot'),(641,59412,'La Caballusa'),(641,59413,'Cabo Roig'),(641,59414,'La Cala'),(641,59415,'Calpe'),(641,59416,'Callosa d\'en Sarriá'),(641,59417,'Callosa de Segura'),(641,59418,'Callosilla'),(641,59420,'Campell'),(641,59421,'Campello'),(641,59422,'Campo de Mirra'),(641,59423,'La Canalosa'),(641,59424,'Canastell'),(641,59426,'Cañada'),(641,59428,'La Carrosa'),(641,59429,'Carrus'),(641,59431,'Casas de Alenda'),(641,59435,'Casas del Cap'),(641,59436,'Casas del Faldar'),(641,59438,'Casas del Señor'),(641,59439,'Casicas'),(641,59440,'Castalla'),(641,59441,'Castell de Castells'),(641,59442,'Catamarruch'),(641,59443,'Catral'),(641,59444,'Cautivador'),(641,59446,'Cocentaina'),(641,59447,'Colonia Montiboli'),(641,59450,'Complejo Turístico el Torrejón'),(641,59451,'Confrides'),(641,59453,'Cox'),(641,59454,'Crevillente'),(641,59458,'Crio. las Hermosas'),(641,59460,'Culebrón'),(641,59462,'Chirles'),(641,59463,'Daimes'),(641,59464,'Daya Nueva'),(641,59465,'Daya Vieja de los Comendadores'),(641,59466,'Dehesa de Campoamor'),(641,59467,'Dénia'),(641,59468,'Derramador'),(641,59469,'Desamparados'),(641,59470,'Dolores'),(641,59472,'Elche'),(641,59473,'Elchepsar'),(641,59474,'Elda'),(641,59476,'La Ermita'),(641,59477,'El Escorratel'),(641,59479,'L\' Estació'),(641,59482,'Estación del Norte'),(641,59483,'La Estación'),(641,59486,'Famorca'),(641,59487,'Finestrat'),(641,59488,'Fleix'),(641,59489,'Formentera del Segura'),(641,59490,'Forna'),(641,59491,'Gata de Gorgos'),(641,59492,'Gayanes'),(641,59493,'Gorga'),(641,59495,'Granja de Rocamora'),(641,59496,'Guadalest'),(641,59497,'Guardamar del Segura'),(641,59498,'Hondón'),(641,59499,'Hondón de las Nieves'),(641,59500,'Hondón de los Frailes'),(641,59501,'La Hoya'),(641,59503,'Hurchillo'),(641,59504,'Ibi'),(641,59505,'Jacarilla'),(641,59506,'Jalon'),(641,59507,'La Jara'),(641,59508,'Jávea'),(641,59509,'Jesus Pobre'),(641,59510,'Jijona'),(641,59511,'Jubalcoy'),(641,59513,'Lorcha'),(641,59515,'Llíber'),(641,59516,'Llombay'),(641,59518,'Maitino'),(641,59519,'Margarida'),(641,59520,'La Marina'),(641,59523,'Lo Martinez'),(641,59524,'Media Legua'),(641,59526,'Millena'),(641,59527,'Miraflor'),(641,59529,'La Mola'),(641,59531,'Molins'),(641,59532,'Monforte del Cid'),(641,59535,'Monóvar'),(641,59536,'Los Montesinos'),(641,59537,'Moraira'),(641,59538,'Moralet'),(641,59539,'Muchamiel'),(641,59540,'La Murada'),(641,59541,'Murla'),(641,59542,'Muro de Alcoy'),(641,59544,'Novelda'),(641,59545,'La Nucía'),(641,59546,'L\' Olla'),(641,59547,'Ondara'),(641,59548,'Onil'),(641,59549,'Orba'),(641,59550,'Orcheta'),(641,59551,'Orihuela'),(641,59552,'Orito'),(641,59553,'Palmeral'),(641,59554,'El Palmeral'),(641,59555,'Parcent'),(641,59557,'Parroquia de Matanza'),(641,59558,'Patro'),(641,59560,'Pedreguer'),(641,59561,'La Pedrera'),(641,59562,'Pego'),(641,59563,'Penáguila'),(641,59565,'Petrer'),(641,59566,'Pilar de la Horadada'),(641,59567,'El Pinar de Campoverde'),(641,59568,'El Pinet'),(641,59569,'Pinos'),(641,59570,'Pinoso'),(641,59571,'La Plana'),(641,59572,'Planes'),(641,59573,'Plans'),(641,59575,'Polop'),(641,59578,'Pusol'),(641,59579,'Rafal'),(641,59580,'Rafol de Almunia'),(641,59582,'Raspeig'),(641,59583,'El Realengo'),(641,59585,'Rebolledo'),(641,59586,'Redován'),(641,59587,'Relleu'),(641,59588,'Rincón de Bonanza'),(641,59589,'Rincón de Loix'),(641,59590,'Rocio del Mar'),(641,59592,'Rojales'),(641,59593,'La Romana'),(641,59595,'Les Rotes'),(641,59597,'El Saladar'),(641,59598,'El Salar'),(641,59599,'Salinas'),(641,59600,'Salse el'),(641,59601,'San Cristóbal'),(641,59602,'San Felipe Neri'),(641,59603,'San Fulgencio'),(641,59604,'San Isidro de Albatera'),(641,59605,'San Jorge'),(641,59606,'San jose'),(641,59607,'San Juan de Alicante'),(641,59608,'San Miguel de Salinas'),(641,59609,'San Rafael'),(641,59611,'San Vicente del Raspeig'),(641,59612,'Sanet y Negrals'),(641,59614,'Santa Faz'),(641,59615,'Santa Pola'),(641,59616,'Sax'),(641,59617,'Seguro'),(641,59618,'Sella'),(641,59619,'Senija'),(641,59620,'Setla'),(641,59622,'Tangel'),(641,59625,'Teix de Arriba'),(641,59626,'Teulada'),(641,59627,'Tibi'),(641,59628,'Toix'),(641,59629,'Tollos'),(641,59630,'Tormos'),(641,59632,'Torrelamata'),(641,59633,'Torrellano'),(641,59634,'Torremanzanas'),(641,59635,'Torremendo'),(641,59636,'Torres'),(641,59637,'Torresella'),(641,59638,'Torrevieja'),(641,59641,'Ubeda'),(641,59643,'Universidad'),(641,59645,'Valverde'),(641,59647,'Vall de Ebo'),(641,59648,'La Vallonga'),(641,59649,'Verdegas'),(641,59650,'Vereda de los Cubos'),(641,59651,'Vergel'),(641,59652,'Villafranqueza'),(641,59653,'Villajoyosa'),(641,59654,'Villena'),(641,59657,'La Zafra'),(641,59659,'La Zenia'),(642,59660,'Adamuz'),(642,59661,'Aguila el'),(642,59662,'Aguilar de la Frontera'),(642,59663,'Alameda del obispo'),(642,59664,'Albendin'),(642,59665,'Alcaracejos'),(642,59666,'Alcolea'),(642,59667,'Alcornocal el'),(642,59668,'Aldea quintana'),(642,59669,'Algallarin'),(642,59670,'Algar'),(642,59671,'Algarbes los'),(642,59672,'Aljabaras las'),(642,59673,'Almedinilla'),(642,59674,'Almodóvar del Río'),(642,59675,'Angeles los'),(642,59676,'Añora'),(642,59677,'Arandas los'),(642,59678,'Arenal el'),(642,59679,'Arenales'),(642,59680,'Argallon'),(642,59681,'Arrecife'),(642,59682,'Azuel'),(642,59683,'Baena'),(642,59684,'Ballesta la'),(642,59685,'Belalcázar'),(642,59686,'Belmez'),(642,59689,'Benamejí'),(642,59691,'Blazquez los'),(642,59692,'Buenavista'),(642,59693,'Bujalance'),(642,59694,'Cabra'),(642,59695,'Cabril el'),(642,59696,'Calonge el'),(642,59697,'Campo nubes'),(642,59699,'Cañada del gamo'),(642,59700,'Cañada del hornillo'),(642,59701,'Cañete de las Torres'),(642,59703,'Carcabuey'),(642,59704,'Cardenchosa la'),(642,59705,'Cardeña'),(642,59706,'La Carlota'),(642,59707,'El Carpio'),(642,59708,'Castellar el'),(642,59709,'Castil de campo'),(642,59710,'Castro del Río'),(642,59711,'Celada la'),(642,59712,'Central termica de puente nu'),(642,59713,'Cerro muriano'),(642,59714,'Cespedes'),(642,59715,'Concepcion la'),(642,59716,'Conquista'),(642,59717,'Córdoba'),(642,59718,'Cordobilla'),(642,59719,'Cordovilla'),(642,59720,'Coronada la'),(642,59721,'Cuenca'),(642,59722,'Doña Mencía'),(642,59724,'Dos Torres'),(642,59725,'Encinarejo de cordoba'),(642,59726,'Encinas Reales'),(642,59727,'Entredicho el'),(642,59729,'Espejo'),(642,59730,'Espiel'),(642,59731,'Estacion de belalcazar'),(642,59732,'Estacion la'),(642,59733,'Fernán-Núñez'),(642,59734,'Fontanar el'),(642,59735,'Fuencubierta la'),(642,59736,'Fuente carretero'),(642,59737,'Fuente grande la'),(642,59738,'Fuente la lancha'),(642,59739,'Fuente Obejuna'),(642,59740,'Fuente Palmera'),(642,59741,'Fuente tojar'),(642,59743,'Fuentidueña'),(642,59744,'Gaena casas gallegas'),(642,59745,'Garabato el'),(642,59746,'Graja la'),(642,59747,'Granjuela la'),(642,59748,'Guadalcazar'),(642,59749,'Guijarrosa la'),(642,59750,'Guijo'),(642,59752,'Higueral el'),(642,59754,'Higueron el'),(642,59755,'Hinojosa del Duque'),(642,59756,'Hornachuelos'),(642,59757,'Hoyo el'),(642,59758,'Hoz la'),(642,59759,'Iznájar'),(642,59760,'Jarata'),(642,59761,'Jauja'),(642,59762,'Judio nuevo'),(642,59763,'Lagunillas las'),(642,59764,'Las quemadas'),(642,59766,'Lucena'),(642,59767,'Luque'),(642,59768,'Llanos de don juan'),(642,59769,'Llanos del espinar'),(642,59770,'Majaneque'),(642,59771,'Maruanas'),(642,59772,'Mesas de guadalora'),(642,59773,'Mina la'),(642,59774,'Mochos los'),(642,59775,'Montalbán de Córdoba'),(642,59776,'Monte alto'),(642,59777,'Montemayor'),(642,59778,'Montiela la'),(642,59779,'Montilla'),(642,59780,'Montoro'),(642,59781,'Monturque'),(642,59782,'Morales los'),(642,59783,'Morenos los'),(642,59784,'Morente'),(642,59785,'Moriles'),(642,59786,'Nacimiento el'),(642,59788,'Navas del selpillar'),(642,59789,'Nueva Carteya'),(642,59790,'Obejo'),(642,59791,'Ochavillo del rio'),(642,59792,'Ojuelos altos'),(642,59794,'Palenciana'),(642,59795,'Palma del Río'),(642,59796,'Palomar'),(642,59798,'Paz la'),(642,59799,'Pedro Abad'),(642,59801,'Pedroche'),(642,59802,'Peñalosa'),(642,59803,'Peñarroya-Pueblonuevo'),(642,59807,'Poleo el'),(642,59808,'Porvenir el'),(642,59809,'Posadas'),(642,59810,'Posadilla'),(642,59811,'Pozoblanco'),(642,59813,'Priego de Córdoba'),(642,59814,'Puente Genil'),(642,59815,'Puerto alegre'),(642,59816,'La Rambla'),(642,59818,'Ribera alta'),(642,59819,'Ribera baja'),(642,59822,'Rute'),(642,59823,'San antonio'),(642,59824,'San calixto'),(642,59825,'San sebastian de los ballester'),(642,59827,'Santa cruz'),(642,59828,'Santa eufemia'),(642,59829,'Santa maria de trassierra'),(642,59830,'Santaella'),(642,59832,'Sileras'),(642,59833,'Silillos'),(642,59836,'Tejar el'),(642,59837,'Todosaires'),(642,59838,'Torrecampo'),(642,59839,'Torres cabrera'),(642,59840,'Vacar el'),(642,59841,'Vadofresno'),(642,59842,'Valchillon'),(642,59843,'Valdeinfierno'),(642,59844,'Valenzuela'),(642,59845,'Valsequillo'),(642,59846,'Venta del charco'),(642,59848,'Ventilla la'),(642,59849,'Victoria la'),(642,59850,'Villa del Río'),(642,59851,'Villafranca de Córdoba'),(642,59852,'Villaharta'),(642,59853,'Villalon'),(642,59854,'Villanueva de Córdoba'),(642,59855,'Villanueva del duque'),(642,59856,'Villanueva del rey'),(642,59857,'Villaralto'),(642,59858,'Villares los'),(642,59859,'Villarrubia'),(642,59860,'Villaseca'),(642,59861,'Villaviciosa de Córdoba'),(642,59862,'El Viso'),(642,59863,'Zagrilla'),(642,59864,'Zambra'),(642,59865,'Zamoranos'),(642,59866,'Zuheros'),(643,59867,'Abejuela'),(643,59868,'Abengibre'),(643,59869,'Agra'),(643,59870,'Agramon'),(643,59871,'Aguas Nuevas'),(643,59872,'Alatoz'),(643,59873,'Albacete'),(643,59874,'Albatana'),(643,59875,'Alborea'),(643,59876,'Alcadozo'),(643,59877,'Alcalá del Júcar'),(643,59878,'Alcaraz'),(643,59880,'Los Alejos'),(643,59882,'Almansa'),(643,59883,'Alpera'),(643,59885,'Las Anorias'),(643,59886,'Argamason'),(643,59887,'El Arguellite'),(643,59888,'Arroyofrio'),(643,59889,'Arteaga de Abajo'),(643,59891,'La Atalaya'),(643,59892,'Ayna'),(643,59894,'Balazote'),(643,59895,'Balsa de Ves'),(643,59896,'El Ballestero'),(643,59897,'Baños de Fuente Podrida'),(643,59898,'Baños de Tus'),(643,59899,'Barrax'),(643,59902,'Bienservida'),(643,59907,'Bogarra'),(643,59908,'Bonete'),(643,59909,'El Bonillo'),(643,59910,'Bormate'),(643,59911,'Buenavista'),(643,59915,'Campillo de las Doblas'),(643,59916,'Campoalbillo'),(643,59918,'Cancarix'),(643,59921,'Cañadaberosa'),(643,59922,'Carcelén'),(643,59923,'Casa Berruga'),(643,59926,'Casa de Cabeza Morena'),(643,59937,'Casas de Abajo'),(643,59939,'Casas de Juan Gil'),(643,59940,'Casas de Juan Núñez'),(643,59942,'Casas de Lázaro'),(643,59943,'Casas de los Mateos'),(643,59946,'Casas de Ves'),(643,59947,'Casas del Campillo'),(643,59949,'Casas del Padre Moreno'),(643,59953,'Casas-Ibáñez'),(643,59956,'Casillas de Marín de Arriba'),(643,59958,'Caudete'),(643,59959,'Cenizate'),(643,59965,'El Corral de Navarro'),(643,59966,'Corral Rubio'),(643,59967,'Cotillas'),(643,59969,'Cubas'),(643,59970,'El Cubillo'),(643,59972,'C. del Pino'),(643,59973,'Chinchilla de Monte Aragón'),(643,59974,'Los Chospes'),(643,59976,'La Dehesa'),(643,59981,'Elche de la Sierra'),(643,59982,'Empalme Paules'),(643,59984,'Fábricas de San Juan de Alcaraz'),(643,59986,'Férez'),(643,59987,'Fte. Higuera'),(643,59989,'Fuensanta'),(643,59991,'Fuente Álamo'),(643,59992,'Fuente del Taif'),(643,59993,'Fuente Higuera'),(643,59994,'Fuentealbilla'),(643,59995,'La Gila'),(643,59997,'La Gineta'),(643,59998,'El Ginete'),(643,59999,'Golosalvo'),(643,60001,'Hellín'),(643,60002,'La Herrera'),(643,60006,'Higueruela'),(643,60007,'Hijar'),(643,60008,'La Horca'),(643,60009,'El Horcajo'),(643,60011,'Hoya Gonzalo'),(643,60013,'Isso'),(643,60015,'El Jardín'),(643,60016,'Jorquera'),(643,60017,'El Laminador'),(643,60018,'Letur'),(643,60019,'Lezuza'),(643,60020,'Liétor'),(643,60023,'Madrigueras'),(643,60024,'El Madroño'),(643,60025,'Mahora'),(643,60031,'Minaya'),(643,60032,'Moharras'),(643,60033,'Molinicos'),(643,60034,'Montalvos'),(643,60035,'Montealegre del Castillo'),(643,60040,'Moropeche'),(643,60041,'Motilleja'),(643,60043,'Munera'),(643,60045,'Nava de Abajo'),(643,60048,'Navas de Jorquera'),(643,60049,'Nerpio'),(643,60050,'Ontur'),(643,60051,'Oran'),(643,60052,'Ossa de Montiel'),(643,60053,'El Pardal'),(643,60057,'Paterna del Madera'),(643,60058,'Pedro Andrés'),(643,60061,'Peñas de San Pedro'),(643,60064,'Pétrola'),(643,60070,'Povedilla'),(643,60071,'Pozo Cañada'),(643,60072,'Pozo Lorente'),(643,60073,'Pozohondo'),(643,60074,'Pozuelo'),(643,60075,'Pradorredondo'),(643,60077,'Los Puercos'),(643,60080,'La Rambla'),(643,60082,'La Recueja'),(643,60085,'Riópar'),(643,60086,'Robledo'),(643,60087,'La Roda'),(643,60093,'San Pedro'),(643,60094,'Santa Ana'),(643,60097,'La Sarguilla'),(643,60101,'Socovos'),(643,60106,'Tarazona de la Mancha'),(643,60108,'Tinajeros'),(643,60109,'Tiriez'),(643,60110,'Tobarra'),(643,60111,'Tolosa'),(643,60116,'Valdeganga'),(643,60117,'Vandelaras de Abajo'),(643,60120,'Vianos'),(643,60124,'Villalgordo de Júcar'),(643,60125,'Villamalea'),(643,60126,'Villapalacios'),(643,60130,'Villares'),(643,60131,'Villarrobledo'),(643,60132,'Villatoya'),(643,60133,'Villavaliente'),(643,60134,'Villaverde'),(643,60135,'Villaverde de Guadalimar'),(643,60137,'Viveros'),(643,60138,'Los Yesares'),(643,60139,'Yeste'),(643,60143,'Zulema'),(644,60144,'Abia de la obispalia'),(644,60145,'Acebron el'),(644,60146,'Alarcon'),(644,60147,'Albaladejito'),(644,60148,'Albaladejo del cuende'),(644,60149,'Albalate de nogueras'),(644,60150,'Albendea'),(644,60151,'La Alberca de Záncara'),(644,60152,'Alcahozo'),(644,60153,'Alcala de la vega'),(644,60154,'Alcantud'),(644,60155,'Alcazar del rey'),(644,60156,'Alcohujate'),(644,60157,'Alconchel de la estrella'),(644,60158,'Algarra'),(644,60159,'Aliaguilla'),(644,60160,'Almarcha la'),(644,60161,'Almendros'),(644,60162,'Almodovar del pinar'),(644,60163,'Almonacid del marquesado'),(644,60166,'Arcas'),(644,60168,'Arcos de la sierra'),(644,60169,'Arguisuelas'),(644,60170,'Arrancacepas'),(644,60171,'Atalaya del cañavate'),(644,60172,'Barajas de melo'),(644,60178,'Belinchon'),(644,60179,'Belmonte'),(644,60181,'Beteta'),(644,60182,'Bolliga'),(644,60184,'Bonilla'),(644,60186,'Buenache de alarcon'),(644,60188,'Buendia'),(644,60190,'Campillo de altobuey'),(644,60192,'Campillos sierra'),(644,60193,'Canalejas del arroyo'),(644,60194,'Cañada del hoyo'),(644,60196,'Cañadajuncosa'),(644,60197,'Cañamares'),(644,60198,'Cañavate el'),(644,60200,'Cañaveras'),(644,60202,'Cañete'),(644,60204,'Cañizares'),(644,60205,'Caracenilla'),(644,60206,'Carboneras de guadazaon'),(644,60207,'Cardenete'),(644,60208,'Carrascosa'),(644,60209,'Carrascosa de haro'),(644,60210,'Carrascosa del campo'),(644,60212,'Casa de tejadillos'),(644,60213,'Casas de benitez'),(644,60214,'Casas de fernando alonso'),(644,60217,'Casas de haro'),(644,60219,'Casas de la loma'),(644,60220,'Casas de las minas'),(644,60221,'Casas de los pinos'),(644,60222,'Casas de santa cruz'),(644,60226,'Casas nuevas'),(644,60227,'Casasimarro'),(644,60229,'Castejon'),(644,60232,'Castillejo del romeral'),(644,60235,'Castillo de garcimuñoz'),(644,60236,'Cervera del llano'),(644,60238,'Collados'),(644,60241,'Cubillo el'),(644,60242,'Cuenca'),(644,60243,'Cuesta de contreras'),(644,60244,'Cueva del hierro'),(644,60245,'Cuevas de velasco'),(644,60246,'Culebras'),(644,60247,'Chillaron de cuenca'),(644,60248,'Chumillas'),(644,60251,'Enguidanos'),(644,60254,'Fresneda de la sierra'),(644,60255,'Frontera la'),(644,60256,'Fuente de pedro naharro'),(644,60259,'Fuentes'),(644,60262,'Fuertescusa'),(644,60265,'Garcinarro'),(644,60267,'Graja de campalbo'),(644,60268,'Graja de iniesta'),(644,60269,'Henarejos'),(644,60270,'Herrumblar el'),(644,60271,'Hinojosa la'),(644,60272,'Hinojosos los'),(644,60273,'Hito el'),(644,60274,'Honrubia'),(644,60275,'Hontanaya'),(644,60277,'Horcajada de la torre'),(644,60278,'Horcajo de Santiago'),(644,60280,'Huelamo'),(644,60282,'Huerguina la'),(644,60284,'Huerta de la obispalia'),(644,60287,'Huete'),(644,60288,'Iniesta'),(644,60289,'Jabaga'),(644,60292,'Lagunaseca'),(644,60293,'Landete'),(644,60294,'Langa la'),(644,60295,'Las pedroñeras'),(644,60296,'Ledaña'),(644,60297,'Leganiel'),(644,60299,'Majadas las'),(644,60301,'Mariana'),(644,60302,'Masegosa'),(644,60303,'Mazarulleque'),(644,60304,'Melgosa la'),(644,60305,'Las Mesas'),(644,60306,'Minglanilla'),(644,60307,'Mira'),(644,60309,'Molinos de papel'),(644,60311,'Monreal del llano'),(644,60313,'Montalbo'),(644,60314,'Monteagudo de las salinas'),(644,60315,'Mota de altarejos'),(644,60316,'Mota del Cuervo'),(644,60317,'Motilla del Palancar'),(644,60321,'Navalon'),(644,60322,'Nohales'),(644,60324,'Olivares de jucar'),(644,60326,'Olmeda del rey'),(644,60328,'Olmedilla de alarcon'),(644,60331,'Olmedilla del campo'),(644,60332,'Osa de la vega'),(644,60334,'Pajares'),(644,60338,'Palomares del campo'),(644,60340,'Paracuellos'),(644,60341,'Paredes'),(644,60342,'Parra de las vegas la'),(644,60343,'Pedernoso el'),(644,60345,'Peral el'),(644,60346,'Peraleja la'),(644,60349,'Picazo el'),(644,60350,'Pinarejo'),(644,60352,'Piqueras del castillo'),(644,60354,'Portilla'),(644,60355,'Poveda de la obispalia'),(644,60356,'Poyatos'),(644,60360,'Priego'),(644,60361,'El Provencio'),(644,60364,'Quintanar del Rey'),(644,60366,'Reillo'),(644,60367,'Ribagorda'),(644,60371,'Rozalen del monte'),(644,60373,'Rubielos bajos'),(644,60374,'Rus'),(644,60378,'Saelices'),(644,60379,'Salinas del manzano'),(644,60380,'Salmeroncillos de abajo'),(644,60381,'Salmeroncillos de arriba'),(644,60382,'Salto de villalba'),(644,60384,'San Clemente'),(644,60385,'San lorenzo de la parrilla'),(644,60386,'San martin de boniches'),(644,60389,'Santa maria de los llanos'),(644,60390,'Santa maria del campo rus'),(644,60391,'Santa maria del val'),(644,60394,'Sisante'),(644,60397,'Sotos'),(644,60398,'Talayuelas'),(644,60399,'Tarancón'),(644,60400,'Tebar'),(644,60401,'Tejadillos'),(644,60402,'Tinajas'),(644,60403,'Tobar el'),(644,60404,'Tondos'),(644,60405,'Torralba'),(644,60407,'Torrecilla'),(644,60408,'Torrejoncillo del rey'),(644,60410,'Torrubia del campo'),(644,60411,'Torrubia del castillo'),(644,60412,'Tortola'),(644,60413,'Tragacete'),(644,60415,'Tribaldos'),(644,60416,'Ucles'),(644,60417,'Uña'),(644,60418,'Vadillos'),(644,60419,'Valdecabras'),(644,60423,'Valdecolmenas de arriba'),(644,60425,'Valdemeca'),(644,60430,'Valera de abajo'),(644,60431,'Valeria'),(644,60437,'Valverde del jucar'),(644,60439,'Vara del rey'),(644,60440,'Vega del codorno'),(644,60441,'Vellisca'),(644,60445,'Ventosa la'),(644,60448,'Villaconejos de trabaque'),(644,60449,'Villaescusa de haro'),(644,60450,'Villagarcia del llano'),(644,60451,'Villalba de la sierra'),(644,60452,'Villalba del rey'),(644,60454,'Villalgordo del marquesado'),(644,60455,'Villalpardo'),(644,60456,'Villamayor de Santiago'),(644,60458,'Villanueva de la Jara'),(644,60459,'Villanueva de los escuderos'),(644,60461,'Villar de cañas'),(644,60462,'Villar de domingo garcia'),(644,60464,'Villar de olalla'),(644,60465,'Villar del aguila'),(644,60466,'Villar del horno'),(644,60467,'Villar del humo'),(644,60471,'Villar del saz de navalon'),(644,60472,'Villarejo de fuentes'),(644,60473,'Villarejo de la peñuela'),(644,60475,'Villarejo periesteban'),(644,60477,'Villarejo sobrehuerta'),(644,60478,'Villares del saz'),(644,60479,'Villarrubio'),(644,60480,'Villarta'),(644,60481,'Villas viejas'),(644,60483,'Villaverde y pasaconsol'),(644,60484,'Villora'),(644,60487,'Zafra de zancara'),(644,60489,'Zarza de tajo'),(645,60491,'Abalo'),(645,60492,'Acebeiro'),(645,60493,'Acevedo'),(645,60494,'Achas'),(645,60495,'Adina'),(645,60496,'Agolada'),(645,60497,'Agrucheve'),(645,60498,'Aguete'),(645,60499,'Aguions'),(645,60500,'Albeos'),(645,60501,'Aldan'),(645,60502,'Almofrei'),(645,60503,'Alxen'),(645,60506,'Amil'),(645,60507,'Amoedo'),(645,60510,'Andras'),(645,60514,'Añobre'),(645,60515,'Aranes'),(645,60517,'Arbo'),(645,60519,'Arcade'),(645,60520,'Arcos'),(645,60522,'Ardan'),(645,60523,'Area'),(645,60524,'Areas'),(645,60526,'Armenteira'),(645,60529,'Arocha'),(645,60530,'Arousa'),(645,60532,'Atios'),(645,60534,'Baiña'),(645,60536,'Baiona'),(645,60538,'Baloira'),(645,60539,'Bamio'),(645,60540,'Bandeira'),(645,60541,'Barbudo'),(645,60542,'Barcala'),(645,60543,'Barcela'),(645,60544,'Barcia'),(645,60545,'Barcia de mera'),(645,60546,'Baredo'),(645,60547,'Barrantes'),(645,60549,'Barro'),(645,60552,'Beade'),(645,60553,'Belesar'),(645,60554,'Beluso'),(645,60555,'Bembibre'),(645,60556,'Bendoiro'),(645,60557,'Berducido'),(645,60558,'Bermes'),(645,60559,'Berredo'),(645,60562,'Bertola'),(645,60566,'Bonaval'),(645,60567,'Bora'),(645,60569,'Botos'),(645,60570,'Bouzas'),(645,60577,'Budiño'),(645,60578,'Bueu'),(645,60579,'Bugarin'),(645,60581,'Burgo o'),(645,60582,'Burgueira'),(645,60583,'Busto'),(645,60584,'Cabeiras'),(645,60587,'Caldas de Reis'),(645,60588,'Caldelas'),(645,60589,'Caleiro'),(645,60590,'Calzada'),(645,60591,'Cambados'),(645,60592,'Cambeses'),(645,60593,'Camos'),(645,60594,'Campaña'),(645,60595,'Campaño'),(645,60596,'Campelo'),(645,60597,'Campo Lameiro'),(645,60598,'Campo'),(645,60600,'Camposancos'),(645,60602,'Cangas'),(645,60603,'Canido'),(645,60604,'A Cañiza'),(645,60605,'Carballal'),(645,60607,'Carbia'),(645,60612,'Carracido'),(645,60613,'Carril'),(645,60615,'Casal'),(645,60617,'Castrelo'),(645,60619,'Castrogudin'),(645,60620,'Catoira'),(645,60621,'Cela'),(645,60623,'Celto'),(645,60625,'Cequeliños'),(645,60626,'Cequeril'),(645,60627,'Cerceda'),(645,60628,'Cercedo'),(645,60631,'Cernedo'),(645,60634,'Cimadevila'),(645,60635,'Cira'),(645,60636,'Coaxe'),(645,60638,'Cobres'),(645,60639,'Codeseda'),(645,60640,'Coiro'),(645,60641,'Combarro'),(645,60644,'Coron'),(645,60645,'Cortegada'),(645,60648,'Coruto'),(645,60649,'Corzans'),(645,60650,'Cotobade'),(645,60651,'Couso'),(645,60657,'Couso (7)'),(645,60658,'Couto o'),(645,60659,'Couto (8)'),(645,60661,'Covelo o'),(645,60663,'Crecente'),(645,60665,'Cristimil'),(645,60668,'Cuntis'),(645,60669,'Curro'),(645,60670,'Cutian'),(645,60671,'Chain'),(645,60673,'Chapa'),(645,60674,'Chapela'),(645,60675,'Chenlo'),(645,60676,'Darbo'),(645,60677,'Dena'),(645,60679,'Dimo'),(645,60681,'Domaio'),(645,60683,'Don ramiro'),(645,60684,'Donas'),(645,60685,'Donon'),(645,60686,'Dorron'),(645,60687,'Duas igrexas'),(645,60689,'Eiras'),(645,60691,'Ermelo'),(645,60694,'Espino'),(645,60697,'A Estrada'),(645,60698,'Ferreiros'),(645,60700,'Figueirido'),(645,60702,'Filgueira'),(645,60707,'Folgoso'),(645,60709,'Fontans'),(645,60713,'Forcadela'),(645,60714,'Forcarei'),(645,60715,'Fornelos'),(645,60716,'Fornelos'),(645,60718,'Forzans'),(645,60720,'Fozara'),(645,60722,'Fragoso'),(645,60723,'Franqueira a'),(645,60724,'Freixerio'),(645,60728,'Gatomorto'),(645,60729,'Gaxate'),(645,60731,'Goian'),(645,60732,'Goias'),(645,60733,'Gondar'),(645,60734,'Gondomar'),(645,60735,'Goruxo'),(645,60736,'Graba'),(645,60742,'O Grove'),(645,60743,'Grove o san vicente'),(645,60744,'A Guarda'),(645,60746,'Guillar'),(645,60747,'Gulans'),(645,60748,'Gurgullon'),(645,60749,'Hio'),(645,60752,'Lalín'),(645,60753,'A Lama'),(645,60754,'Lamas'),(645,60756,'Lantaño'),(645,60757,'Laro'),(645,60758,'Lavadores'),(645,60763,'Liñares'),(645,60764,'Lira'),(645,60769,'Lougares'),(645,60770,'Louredo'),(645,60771,'Loureiro'),(645,60773,'Lourido'),(645,60776,'Maceira'),(645,60778,'Madriñan'),(645,60781,'Marcon'),(645,60782,'Marín'),(645,60783,'Matalobos'),(645,60784,'Matama'),(645,60785,'Meaño'),(645,60787,'Meder'),(645,60789,'Meira'),(645,60791,'Meirol'),(645,60792,'Meis'),(645,60794,'Merza'),(645,60795,'Millarada a'),(645,60796,'Moalde'),(645,60797,'Moaña'),(645,60798,'Mogor'),(645,60801,'Mondariz'),(645,60802,'Mondariz balneario'),(645,60803,'Monte'),(645,60807,'Moreira'),(645,60809,'Mos'),(645,60810,'Moscoso'),(645,60811,'Mosende'),(645,60813,'Mosteiro'),(645,60815,'Motillon de arriba'),(645,60816,'Mougas'),(645,60820,'Nantes'),(645,60821,'Negros'),(645,60822,'Nerga'),(645,60823,'Nespereira'),(645,60824,'As Neves'),(645,60826,'Nigrán'),(645,60828,'Nogueira'),(645,60829,'Nogueirido'),(645,60831,'Oca'),(645,60832,'Oia'),(645,60838,'Ons'),(645,60841,'Ouzande'),(645,60842,'Padrons'),(645,60844,'Pancenteo'),(645,60845,'Panxon'),(645,60846,'Parada'),(645,60850,'Paraños'),(645,60851,'Paravedra'),(645,60852,'Pardavila'),(645,60853,'Pardemarin'),(645,60854,'Parderrubias'),(645,60855,'Paredes'),(645,60856,'Pasaxe o'),(645,60858,'Pazos'),(645,60859,'Pazos de Borbén'),(645,60862,'Pedornes'),(645,60864,'Peitieiros'),(645,60865,'Pereira'),(645,60868,'Petelos'),(645,60869,'Pias'),(645,60871,'Pigarzos'),(645,60873,'Piñeiro'),(645,60876,'Poio'),(645,60877,'Poio (san xoan)'),(645,60878,'Ponte'),(645,60879,'Ponte borela'),(645,60880,'Ponte Caldelas'),(645,60881,'Ponte sampaio'),(645,60882,'Ponteareas'),(645,60883,'Pontecesures'),(645,60884,'Pontellas'),(645,60885,'Pontevedra'),(645,60886,'O Porriño'),(645,60887,'Portas'),(645,60888,'Portela'),(645,60891,'Porto'),(645,60893,'Portocelo'),(645,60894,'Portodemouros'),(645,60895,'Portonovo'),(645,60897,'Pousada'),(645,60898,'Prado de canda'),(645,60899,'Prado'),(645,60903,'Priegue'),(645,60904,'Quintela'),(645,60906,'Quireza'),(645,60907,'Ramallosa a'),(645,60908,'Randufe'),(645,60909,'Raxo'),(645,60911,'Rebordechan'),(645,60913,'Redonde'),(645,60914,'Redondela'),(645,60915,'Refoxos'),(645,60916,'Reigosa'),(645,60917,'Rendal'),(645,60918,'Revolta'),(645,60919,'Ribadelouro'),(645,60920,'Ribadumia'),(645,60922,'Ribarteme (san xose)'),(645,60923,'Ribarteme (santiago)'),(645,60924,'Ribeira'),(645,60926,'Riobo'),(645,60927,'Riofrio'),(645,60928,'Roca'),(645,60930,'Rodeiro'),(645,60933,'Romai'),(645,60934,'O Rosal'),(645,60935,'Rouxique'),(645,60937,'Rubios'),(645,60938,'Sabaxans'),(645,60939,'Sabrexo'),(645,60940,'Sabucedo'),(645,60942,'Salceda de Caselas'),(645,60943,'Salvaterra de Miño'),(645,60944,'Samieira'),(645,60946,'San cibran'),(645,60947,'San pedro'),(645,60948,'San roque'),(645,60950,'San vicente do mar'),(645,60952,'Santa cruz'),(645,60955,'Sanxenxo'),(645,60958,'Seixo'),(645,60964,'Sevil'),(645,60967,'Silleda'),(645,60968,'Simes'),(645,60969,'Sisan'),(645,60971,'Sobrada'),(645,60973,'Soutelo de montes'),(645,60978,'Soutomaior'),(645,60979,'Tabagon'),(645,60983,'Taborda'),(645,60984,'Tebra'),(645,60985,'Tiran'),(645,61308,'Tomeza'),(645,61309,'Tomiño'),(645,61311,'Torneiros'),(645,61314,'Touron'),(645,61316,'Trasmaño'),(645,61320,'Troans'),(645,61321,'Tui'),(645,61322,'Uma'),(645,61324,'Val'),(645,61325,'Valadares'),(645,61326,'Valboa'),(645,61328,'Valga'),(645,61330,'Valongo'),(645,61332,'Veiga'),(645,61333,'Vemil'),(645,61334,'Ventin'),(645,61335,'Ventosela'),(645,61336,'Viascon'),(645,61338,'Vigo'),(645,61339,'Vila de Cruces'),(645,61340,'Vilaboa'),(645,61341,'Vilacova'),(645,61343,'Viladesuso'),(645,61344,'Vilagarcía de Arousa'),(645,61345,'Vilalonga'),(645,61346,'Vilamean'),(645,61347,'Vilanova'),(645,61348,'Vilanova de Arousa'),(645,61349,'Vilanoviña'),(645,61351,'Vilar'),(645,61356,'Vilar (6)'),(645,61357,'Vilardematos'),(645,61358,'Vilariño'),(645,61359,'Vilariño'),(645,61363,'Vilasobroso'),(645,61364,'Vilatuxe'),(645,61365,'Vilaxoan'),(645,61366,'Vilaza'),(645,61367,'Vincios'),(645,61368,'Vinseiro'),(645,61369,'Virlachan'),(645,61370,'Xesta'),(645,61372,'Xesteira'),(645,61373,'Xeve'),(645,61374,'Xil'),(645,61375,'Xinzo'),(645,61377,'Xuqueiras as'),(645,61378,'Xustans'),(646,60987,'Ababuj'),(646,60988,'Abejuela'),(646,60989,'Abenfigo'),(646,60990,'Aguaton'),(646,60991,'Aguaviva'),(646,60992,'Aguilar del alfambra'),(646,60993,'Alacon'),(646,60994,'Alagones los'),(646,60995,'Alba'),(646,60996,'Albalate del Arzobispo'),(646,60997,'Albarracin'),(646,61000,'Alcala de la selva'),(646,61001,'Alcañiz'),(646,61002,'Alcorisa'),(646,61003,'Alcotas'),(646,61006,'Alfambra'),(646,61008,'Aliaga'),(646,61009,'Almohaja'),(646,61011,'Alpeñes'),(646,61013,'Alloza'),(646,61014,'Allueva'),(646,61015,'Anadon'),(646,61016,'Andorra'),(646,61017,'Arcos de las salinas'),(646,61018,'Arens de lledo'),(646,61020,'Ariño'),(646,61025,'Baguena'),(646,61026,'Baltasares los'),(646,61028,'Barrachina'),(646,61029,'Barrio de sierra menera'),(646,61032,'Beceite'),(646,61033,'Belmonte de san jose'),(646,61034,'Bello'),(646,61035,'Berge'),(646,61036,'Bezas'),(646,61038,'Blesa'),(646,61039,'Bordon'),(646,61040,'Bronchales'),(646,61041,'Bueña'),(646,61045,'Calaceite'),(646,61046,'Calamocha'),(646,61047,'Calanda'),(646,61049,'Camañas'),(646,61051,'Camarillas'),(646,61052,'Caminreal'),(646,61053,'Campillo'),(646,61054,'Campos'),(646,61055,'Cantavieja'),(646,61058,'Cañada vellida'),(646,61061,'Cañizar del olivar'),(646,61062,'Casas de bucar'),(646,61066,'Castel de cabra'),(646,61068,'Castelseras'),(646,61071,'Castellote'),(646,61072,'Castralvo'),(646,61073,'Caude'),(646,61074,'Cedrillas'),(646,61076,'Cella'),(646,61083,'Codoñera la'),(646,61084,'Colladico el'),(646,61088,'Corbaton'),(646,61091,'Cretas'),(646,61093,'Cuba la'),(646,61094,'Cubla'),(646,61097,'Cuervo el'),(646,61101,'Cuevas labradas'),(646,61105,'Escorihuela'),(646,61107,'Escucha'),(646,61114,'Fortanete'),(646,61116,'Fresneda la'),(646,61117,'Frias de albarracin'),(646,61119,'Fuenferrada'),(646,61120,'Fuentes calientes'),(646,61121,'Fuentes claras'),(646,61122,'Fuentes de rubielos'),(646,61123,'Fuentespalda'),(646,61124,'Galve'),(646,61126,'Gea de albarracin'),(646,61127,'Ginebrosa la'),(646,61130,'Guadalaviar'),(646,61131,'Gudar'),(646,61132,'Hijar'),(646,61137,'Jabaloyas'),(646,61140,'Jatiel'),(646,61141,'Jorcas'),(646,61144,'Lagueruela'),(646,61147,'Lechago'),(646,61149,'Lidon'),(646,61150,'Linares de mora'),(646,61151,'Loscos'),(646,61156,'Manzanera'),(646,61157,'Martin del rio'),(646,61158,'Mas del navarrete'),(646,61161,'Mata de los olmos la'),(646,61162,'Mazaleon'),(646,61163,'Mezquita de jarque'),(646,61166,'Mirambel'),(646,61170,'Monreal del Campo'),(646,61171,'Monroyo'),(646,61172,'Montalban'),(646,61176,'Mora de rubielos'),(646,61177,'Moscardon'),(646,61178,'Mosqueruela'),(646,61179,'Muniesa'),(646,61180,'Navarrete del rio'),(646,61181,'Noguera'),(646,61186,'Odon'),(646,61187,'Ojos negros'),(646,61191,'Olmos los'),(646,61193,'Orihuela del tremedal'),(646,61194,'Orrios'),(646,61195,'Palomar de arroyos'),(646,61196,'Pancrudo'),(646,61197,'Paraiso alto'),(646,61203,'Peñarroya de tastavins'),(646,61205,'Peracense'),(646,61206,'Peralejos'),(646,61207,'Perales del alfambra'),(646,61208,'Piedrahita'),(646,61213,'Portalrrubio'),(646,61219,'Puebla de hijar la'),(646,61220,'Puebla de valverde la'),(646,61223,'Rafales'),(646,61227,'Rodenas'),(646,61228,'Royuela'),(646,61231,'Rubielos de mora'),(646,61235,'Samper de calanda'),(646,61236,'San agustin'),(646,61237,'San blas'),(646,61240,'Santa eulalia'),(646,61242,'Sarrion'),(646,61249,'Teruel'),(646,61250,'Toril'),(646,61252,'Tornos'),(646,61253,'Torralba de los sisones'),(646,61254,'Torre de arcas'),(646,61255,'Torre del compte'),(646,61265,'Torrijo del campo'),(646,61267,'Tramacastiel'),(646,61268,'Tramacastilla'),(646,61269,'Tronchon'),(646,61270,'Urrea de gaen'),(646,61271,'Utrillas'),(646,61272,'Valacloche'),(646,61273,'Valbona'),(646,61274,'Valdealgorfa'),(646,61275,'Valdecebro'),(646,61277,'Valdecuenca'),(646,61279,'Valdeltormo'),(646,61280,'Valderrobres'),(646,61281,'Valjunquera'),(646,61282,'Valmuel'),(646,61284,'Vallecillo el'),(646,61288,'Villafranca del campo'),(646,61290,'Villalba baja'),(646,61291,'Villalba de los morales'),(646,61292,'Villalva alta'),(646,61297,'Villarluengo'),(646,61298,'Villarquemado'),(646,61299,'Villarroya de los pinares'),(646,61300,'Villaspesa'),(646,61301,'Villastar'),(646,61302,'Villel'),(646,61303,'Vinaceite'),(646,61304,'Visiedo'),(646,61305,'Vivel del rio martin'),(646,61306,'Zoma la'),(647,61379,'Melilla'),(648,61380,'Abrera'),(648,61381,'Aguilar de Segarra'),(648,61382,'Aiguafreda'),(648,61383,'Alella'),(648,61384,'Alou'),(648,61385,'Alpens'),(648,61386,'L\'Ametlla de Merola'),(648,61387,'L\'Ametlla'),(648,61388,'L\'Amunt'),(648,61389,'L\'Anizar'),(648,61390,'Antius'),(648,61391,'Arenys de Mar'),(648,61392,'Arenys de Munt'),(648,61393,'Argençola'),(648,61394,'Argensola'),(648,61395,'Argentona'),(648,61396,'Artés'),(648,61397,'L\'Astor'),(648,61398,'L\'Ametlla del Vallés'),(648,61399,'Aviá'),(648,61400,'Avinyó'),(648,61401,'Badalona'),(648,61402,'Bagá'),(648,61403,'Balsareny'),(648,61404,'La Barata'),(648,61405,'Barcelona'),(648,61406,'El Bardoc'),(648,61408,'La Beguda Alta'),(648,61409,'La Beguda Baja'),(648,61410,'Begues'),(648,61411,'Bellprat'),(648,61412,'Berga'),(648,61413,'Bergus'),(648,61415,'Boixadors'),(648,61416,'Bonavista'),(648,61417,'Borredá'),(648,61419,'El Bruc'),(648,61420,'El Brull'),(648,61422,'Cabrera'),(648,61423,'Cabrianes'),(648,61424,'Cabrils'),(648,61425,'Cal Janet'),(648,61426,'Calaf'),(648,61427,'Calders'),(648,61428,'Caldes d\'Estrac'),(648,61429,'Caldes de Montbui'),(648,61430,'Calella'),(648,61431,'Calonge de Segarra'),(648,61432,'Calldetenes'),(648,61433,'Callús'),(648,61434,'Campins'),(648,61435,'Camps'),(648,61436,'Can Corominas'),(648,61437,'Can Gras'),(648,61439,'Can Noguera'),(648,61440,'Can Roca'),(648,61441,'Can Rosell'),(648,61442,'Can Sabaté'),(648,61443,'Can Serra y Padro'),(648,61444,'Can Sisplau'),(648,61445,'Can Via'),(648,61446,'Can Vidal'),(648,61447,'Cancervera'),(648,61448,'Canet de Mar'),(648,61449,'Canovelles'),(648,61450,'Canoves'),(648,61451,'Cantalloops'),(648,61452,'Canyamars'),(648,61453,'Canyelles'),(648,61454,'Capellades'),(648,61455,'Capolat'),(648,61456,'Carbasi'),(648,61457,'Cardedeu'),(648,61458,'Cardona'),(648,61459,'Carme'),(648,61460,'Carrer del dart el'),(648,61461,'Cases noves'),(648,61462,'Casesnoves de cal pardo les'),(648,61464,'Casetes les'),(648,61465,'Casserras'),(648,61466,'Castanya la'),(648,61468,'Castellar'),(648,61469,'Castellar de n\'hug'),(648,61470,'Castellar del riu'),(648,61471,'Castellbell i el Villar'),(648,61472,'Castellbisbal'),(648,61474,'Castelldefels'),(648,61475,'Castelldral'),(648,61476,'Castellet'),(648,61477,'Castellfollit de riubregos'),(648,61478,'Castellfollit del boix'),(648,61479,'Castellgalí'),(648,61480,'Castellnou de bages'),(648,61481,'Castellolí'),(648,61483,'Castellví de la Marca'),(648,61484,'Castellví de Rosanes'),(648,61485,'Centelles'),(648,61486,'Cercs'),(648,61487,'Cerdanyola'),(648,61488,'Cerdanyola del Vallés'),(648,61489,'Cervelló'),(648,61492,'Clint el'),(648,61493,'La Colonia Rosal'),(648,61494,'La Colonia Sedó'),(648,61495,'La Colonia Valls'),(648,61496,'Collbató'),(648,61497,'Collsuspina'),(648,61499,'Conanglell'),(648,61500,'Conill'),(648,61501,'Copons'),(648,61502,'Corbera de Llobregat'),(648,61503,'Cornella de Llobregat'),(648,61504,'Cornet'),(648,61505,'Coromina la'),(648,61506,'Corró d\'Amunt'),(648,61507,'Costa la'),(648,61509,'Cubelles'),(648,61511,'Les Cunilleres'),(648,61512,'Cussons'),(648,61513,'Dosrius'),(648,61514,'Durfort'),(648,61515,'Enfesta'),(648,61516,'Espadamala'),(648,61517,'Esparreguera'),(648,61518,'L\'Espelt'),(648,61519,'Espiells'),(648,61520,'Espinalbet'),(648,61521,'Esplugues de Llobregat'),(648,61522,'L\' Espunyola'),(648,61523,'L\'Estany'),(648,61525,'Fals'),(648,61528,'Figols Vell'),(648,61529,'El Figueró'),(648,61530,'La Floresta'),(648,61531,'Fogar de Tordera'),(648,61532,'Fogars de Montclús'),(648,61533,'Folgueroles'),(648,61534,'Fonollosa'),(648,61535,'Font-Rubí'),(648,61536,'Gaiá'),(648,61537,'Gallifa'),(648,61539,'Garraf'),(648,61540,'La Garriga'),(648,61541,'Gavá'),(648,61542,'Gelida'),(648,61543,'Gironella'),(648,61545,'La Granada'),(648,61546,'Granera'),(648,61547,'Granollers'),(648,61549,'Gravalosa'),(648,61550,'Greixer'),(648,61552,'Gualba de Dalt'),(648,61553,'La Guardia'),(648,61555,'Guardiola'),(648,61556,'Guardiola de Berguedá'),(648,61558,'Les Gunyoles'),(648,61559,'Gurb'),(648,61560,'Hortsavinyá'),(648,61561,'L\' Hospitalet de Llobregat'),(648,61562,'Els Hostalets de Pierola'),(648,61563,'Els Hostalets'),(648,61564,'Igualada'),(648,61565,'Jorba'),(648,61567,'Les Lombardes'),(648,61568,'Llacuna la'),(648,61569,'La Llagosta'),(648,61571,'Llerona'),(648,61572,'Lliçá d\'Amunt'),(648,61573,'Llinars del Vallés'),(648,61574,'Lluissa de Vall'),(648,61577,'Malanyeu'),(648,61578,'Malgrat de Mar'),(648,61579,'Malla'),(648,61580,'Manlleu'),(648,61581,'Manresa'),(648,61584,'Martorell'),(648,61585,'Martorelles'),(648,61586,'El Mas Bado'),(648,61587,'Les Masies de Roda'),(648,61588,'El Masnou'),(648,61589,'Masquefa'),(648,61591,'Matadepera'),(648,61592,'Mataró'),(648,61593,'Mediona'),(648,61594,'Mirambell'),(648,61595,'Moiá'),(648,61596,'Moja'),(648,61597,'La Molina'),(648,61598,'Molins de Rei'),(648,61599,'Mollet'),(648,61600,'Monistrol d\'Anoia'),(648,61602,'Monistrol de Montserrat'),(648,61604,'Montcada i Reixac'),(648,61606,'Montesquiu'),(648,61607,'Montgat'),(648,61608,'Montmajor'),(648,61609,'Montmaneu'),(648,61610,'Montmany'),(648,61611,'Montmeló'),(648,61612,'Montnegre'),(648,61613,'Montornés del Vallés'),(648,61614,'Montseny'),(648,61615,'La Mora'),(648,61616,'El Mujal'),(648,61618,'Mura'),(648,61619,'Navarcles'),(648,61620,'Navás'),(648,61621,'La Nou de Berguedá'),(648,61622,'Ódena'),(648,61623,'Olérdola'),(648,61624,'Olesa de Bonesvalls'),(648,61625,'Olesa de Montserrat'),(648,61626,'Olivella'),(648,61627,'Olost'),(648,61628,'Olvan'),(648,61629,'Olzinelles'),(648,61631,'Oris'),(648,61633,'Orpi'),(648,61634,'Orrius'),(648,61635,'Palafolls'),(648,61636,'Palau-solitá i Plegamans'),(648,61637,'Pallejá'),(648,61638,'La Panadella'),(648,61639,'El Papiol'),(648,61640,'Parets del Vallés'),(648,61641,'El Parrot'),(648,61643,'Piera'),(648,61644,'Pierola'),(648,61645,'Pineda de Mar'),(648,61648,'La Pobla de Claramunt'),(648,61649,'La Pobla de lillet'),(648,61651,'Polinyá'),(648,61652,'El Pont de Vilmara'),(648,61653,'Pontons'),(648,61655,'El Prat de Llobregat'),(648,61656,'Prats de Lluçanes'),(648,61657,'Els Prats de Rei'),(648,61658,'Premiá de Mar'),(648,61660,'Puig-reig'),(648,61663,'El Pujol de Planes'),(648,61664,'La Quar'),(648,61665,'La Raboia'),(648,61666,'Rajadell'),(648,61667,'Ramio'),(648,61668,'El Raval'),(648,61669,'Rectoria de San Pablo'),(648,61670,'Renillars'),(648,61671,'Riells del Fai'),(648,61672,'El Rieral'),(648,61673,'Ripollet'),(648,61674,'La Roca del Vallés'),(648,61675,'Rocafort'),(648,61676,'Roda de Ter'),(648,61679,'La Rovirola'),(648,61680,'Rubí'),(648,61681,'Rubio'),(648,61682,'Rupit'),(648,61683,'Sabadell'),(648,61684,'Sagás'),(648,61685,'Saldes'),(648,61686,'Salelles'),(648,61687,'Salo'),(648,61689,'Sallent'),(648,61690,'Sant Agustí de Lluçanés'),(648,61691,'Sant Andreu de Far'),(648,61692,'Sant Andreu de la Barca'),(648,61693,'Sant Andreu de Llavaneres'),(648,61694,'Sant Antoni de Vilamajor'),(648,61695,'Sant Bartomeu del Grau'),(648,61696,'Sant Boi de Llobregat'),(648,61697,'Sant Boi de Lluçanés'),(648,61698,'Sant Cebriá de Vallalta'),(648,61699,'Sant Celoni'),(648,61700,'Sant Climent de Llobregat'),(648,61701,'Sant Cugat del Vallés'),(648,61702,'Sant Cugat Sesgarriges'),(648,61703,'Sant Esteve de Palautordera'),(648,61704,'Sant Esteve Sesrovires'),(648,61705,'Sant Feliu'),(648,61706,'Sant Feliu de Codines'),(648,61707,'Sant Feliu de Lluelles'),(648,61709,'Sant Feliu Sasserra'),(648,61710,'Sant Fost de Campsentelles'),(648,61711,'Sant Fruitós de Bages'),(648,61712,'Sant Hipólit de Voltregá'),(648,61716,'Sant Joan de Montdarn'),(648,61717,'Sant Joan de Vilatorrada'),(648,61718,'Sant Joan Despí'),(648,61719,'Sant Juliá de Cerdanyola'),(648,61720,'Sant Juliá de Vilatorta'),(648,61721,'Sant Just Desvern'),(648,61722,'Sant Llorenç d\'Hortons'),(648,61723,'Sant Llorenç Savall'),(648,61724,'Sant Martí d\'Albars'),(648,61725,'Sant Martí de Centelles'),(648,61726,'Sant Martí de Tous'),(648,61727,'Sant Martí Sarroca'),(648,61728,'Sant Martí Sescorts'),(648,61733,'Sant Pere de Copons'),(648,61734,'Sant Pere de Ribes'),(648,61735,'Sant Pere de Riudebitlles'),(648,61736,'Sant Pere de Torelló'),(648,61737,'Sant Pere de Vilamajor'),(648,61740,'Sant Pesselaç'),(648,61741,'Sant Pol de Mar'),(648,61743,'Sant Quirze de Besora'),(648,61745,'Sant Quirze del Vallés'),(648,61746,'Sant Quirze Safaja'),(648,61747,'Sant Sadurní d\'Anoia'),(648,61748,'Sant Sadurní d\'Osormort'),(648,61749,'Sant Salvador de Guardiola'),(648,61750,'Sant Salvador de Torroella'),(648,61751,'Sant Vicenç de Castellet'),(648,61752,'Sant Vicenç de Montalt'),(648,61753,'Sant Viçenç de Torello'),(648,61754,'Sant Vicenç dels Horts'),(648,61755,'Santa Agnés de Malanyanes'),(648,61756,'Santa Cecília de Voltregá'),(648,61757,'Santa Coloma'),(648,61758,'Santa Coloma de Cervelló'),(648,61759,'Santa Coloma de Gramenet'),(648,61761,'Santa Eugénia de Berga'),(648,61762,'Santa Eulalia'),(648,61763,'Santa Eulália de Riuprimer'),(648,61764,'Santa Eulália de Ronçana'),(648,61765,'Santa Margarida de Montbui'),(648,61766,'Santa Margarida i els Monjos'),(648,61767,'Santa Maria d\'Horta'),(648,61769,'Santa Maria de Besora'),(648,61770,'Santa Maria de Corcó'),(648,61772,'Santa Maria de Miralles'),(648,61773,'Santa Maria de Palautordera'),(648,61774,'Santa Perpétua de Mogoda'),(648,61775,'Santa Susanna'),(648,61776,'Santpedor'),(648,61777,'Sant Bartolomeu'),(648,61778,'Sant Pere Molanta'),(648,61779,'Segur'),(648,61780,'Sentmenat'),(648,61781,'Serrateix'),(648,61782,'Seva'),(648,61783,'Sitges'),(648,61784,'Sobremunt'),(648,61785,'El Sole'),(648,61786,'Sora'),(648,61787,'Sorba'),(648,61788,'Santa Candia'),(648,61790,'Súria'),(648,61791,'Tagamanent'),(648,61792,'Talamanca'),(648,61793,'Taradell'),(648,61794,'Taravil'),(648,61797,'Teiá'),(648,61798,'Terrassa'),(648,61799,'Tiana'),(648,61800,'Tona'),(648,61801,'Tordera'),(648,61802,'Torelló'),(648,61803,'La Torre d\'Oristá'),(648,61804,'La Torre de Claramunt'),(648,61805,'Torre Marimon'),(648,61807,'Torregassa'),(648,61808,'Torrelavit'),(648,61809,'Torrelles de Foix'),(648,61810,'Torrelles de Llobregat'),(648,61811,'Torrelletes'),(648,61812,'Torrents'),(648,61814,'Ullastrell'),(648,61816,'Vacarisses'),(648,61817,'Vallbona d\'Anoia'),(648,61818,'Vallcarca'),(648,61819,'Vallcebre'),(648,61820,'Valldeneu'),(648,61821,'Vallgorguina'),(648,61822,'Vallirana'),(648,61823,'Vallpineda'),(648,61824,'Vallvidrera'),(648,61825,'Veciana'),(648,61826,'Verti'),(648,61827,'Vic'),(648,61828,'Vilada'),(648,61829,'Viladecans'),(648,61831,'Viladecavalls'),(648,61833,'Vilafranca del Penedés'),(648,61834,'Vilafruns'),(648,61837,'Vilanova de Sau'),(648,61838,'Vilanova del Camí'),(648,61839,'Vilanova i la Geltrú'),(648,61840,'Vilardell'),(648,61841,'Vilassar de Dalt'),(648,61842,'Vilassar de Mar'),(648,61843,'Viladomiu'),(648,61844,'Vilobí del Penedés'),(648,61845,'Vinyoles d\'Orís'),(648,61846,'Viver'),(649,61847,'Acedera'),(649,61848,'Aceuchal'),(649,61849,'Ahillones'),(649,61850,'Alange'),(649,61851,'La Albufera'),(649,61852,'Alburquerque'),(649,61853,'Alcazaba'),(649,61854,'Alconchel'),(649,61855,'Alconera'),(649,61856,'Aljucén'),(649,61857,'Almendral'),(649,61858,'Almendralejo'),(649,61859,'Almorchon'),(649,61860,'Arroyo de San Serván'),(649,61861,'Atalaya'),(649,61862,'Azuaga'),(649,61863,'Badajoz'),(649,61864,'Balboa'),(649,61865,'Barbaño'),(649,61866,'Barcarrota'),(649,61867,'Baterno'),(649,61868,'Bazana la'),(649,61869,'Benquerencia de la Serena'),(649,61870,'Berlanga'),(649,61871,'Bienvenida'),(649,61872,'Bodonal de la Sierra'),(649,61873,'Bohonal'),(649,61874,'Brovales'),(649,61875,'Burguillos del Cerro'),(649,61876,'Cabeza del Buey'),(649,61877,'Cabeza la Vaca'),(649,61878,'Calamonte'),(649,61879,'Calera de León'),(649,61880,'Calzadilla de los Barros'),(649,61881,'Campanario'),(649,61882,'Campillo de Llerena'),(649,61883,'Cantalgallo'),(649,61884,'Capilla'),(649,61885,'La Cardenchosa'),(649,61886,'Carmonita'),(649,61887,'El Carrascalejo'),(649,61888,'Casas de Don Pedro'),(649,61890,'Casas de Reina'),(649,61892,'Castilblanco'),(649,61893,'Castuera'),(649,61894,'La Codosera'),(649,61895,'Conquista del Guadiana'),(649,61896,'Cordobilla de Lácara'),(649,61897,'La Coronada'),(649,61898,'Corte de Peleas'),(649,61899,'Cortegana'),(649,61900,'Cortijo del Cura'),(649,61901,'Cristina'),(649,61902,'Cheles'),(649,61903,'Don Álvaro'),(649,61904,'Don Benito'),(649,61906,'Entrerios'),(649,61908,'Entrín Bajo'),(649,61909,'Esparragalejo'),(649,61910,'Esparragosa de la Serena'),(649,61911,'Esparragosa de Lares'),(649,61912,'Feria'),(649,61913,'Fregenal de la Sierra'),(649,61914,'Fuenlabrada de los Montes'),(649,61915,'Fuente de Cantos'),(649,61916,'Fuente del Arco'),(649,61917,'Fuente del Maestre'),(649,61918,'Fuentes de León'),(649,61919,'Galizuela'),(649,61920,'Garbayuela'),(649,61921,'Gargaligas'),(649,61922,'Garlitos'),(649,61923,'La Garrovilla'),(649,61924,'Gevora'),(649,61925,'Granja de Torrehermosa'),(649,61926,'Guadajira'),(649,61927,'Los Guadalperales'),(649,61928,'Guadiana del Caudillo'),(649,61930,'Guareña'),(649,61931,'La Haba'),(649,61932,'Helechal'),(649,61933,'Helechosa'),(649,61934,'Hernán Cortés'),(649,61935,'Herrera del Duque'),(649,61936,'Higuera de la Serena'),(649,61937,'Higuera de Llerena'),(649,61938,'Higuera de Vargas'),(649,61939,'Higuera la Real'),(649,61940,'Hinojosa del Valle'),(649,61941,'Hornachos'),(649,61942,'Hoya de Santa María'),(649,61943,'Jerez de los Caballeros'),(649,61944,'La Lapa'),(649,61945,'Lobón'),(649,61946,'Llera'),(649,61947,'Llerena'),(649,61948,'Magacela'),(649,61949,'Maguilla'),(649,61950,'Malcocinado'),(649,61951,'Malpartida de la Serena'),(649,61952,'Manchita'),(649,61953,'Medellín'),(649,61954,'Medina de las Torres'),(649,61955,'Mengabril'),(649,61956,'Mérida'),(649,61957,'Mirandilla'),(649,61959,'Monesterio'),(649,61960,'Montemolín'),(649,61961,'Monterrubio de la Serena'),(649,61962,'Montijo'),(649,61963,'Morera la'),(649,61964,'La Nava de Santiago'),(649,61965,'Nava la'),(649,61966,'Navalvillar de Pela'),(649,61967,'Nogales'),(649,61968,'Novelda'),(649,61969,'Obando'),(649,61970,'Oliva de la Frontera'),(649,61971,'Oliva de Mérida'),(649,61972,'Olivenza'),(649,61973,'Orellana de la sierra'),(649,61974,'Orellana la Vieja'),(649,61975,'Palazuelo'),(649,61976,'Palomas'),(649,61977,'Pallares'),(649,61978,'La Parra'),(649,61979,'Peloche'),(649,61980,'Peñalsordo'),(649,61981,'Peraleda del zaucejo'),(649,61982,'Pollatas las'),(649,61983,'Puebla de Alcocer'),(649,61984,'Puebla de la Calzada'),(649,61985,'Puebla de la reina'),(649,61986,'Puebla de Obando'),(649,61987,'Puebla de Sancho Pérez'),(649,61988,'Puebla del alcollarin'),(649,61989,'Puebla del maestre'),(649,61990,'Puebla del prior'),(649,61991,'Pueblonuevo'),(649,61992,'Puerto de la nava'),(649,61993,'Puerto hurraco'),(649,61994,'Puerto mejeral'),(649,61995,'Quintana de la Serena'),(649,61996,'Reina'),(649,61997,'Rena la'),(649,61998,'Retamal'),(649,62000,'Ribera del Fresno'),(649,62001,'Risco'),(649,62002,'La Roca de la Sierra'),(649,62005,'Ruecas'),(649,62006,'Sagrajas'),(649,62007,'Salvaleón'),(649,62008,'Salvatierra de los Barros'),(649,62009,'San benito de la contienda'),(649,62010,'San francisco de olivenza'),(649,62012,'San pedro de merida'),(649,62013,'San rafael de olivenza'),(649,62014,'San Vicente de Alcántara'),(649,62015,'Sancti spiritus'),(649,62016,'Santa Amalia'),(649,62017,'Santa Marta'),(649,62019,'Los Santos de Maimona'),(649,62020,'Segura de León'),(649,62021,'Siruela'),(649,62022,'Solana de los Barros'),(649,62023,'Talarrubias'),(649,62024,'Talavera la Real'),(649,62025,'Taliga'),(649,62026,'Tamurejo'),(649,62027,'Torre de Miguel Sesmero'),(649,62028,'Torrefresneda'),(649,62029,'Torremayor'),(649,62030,'Torremejia'),(649,62031,'Torviscal el'),(649,62032,'Trasierra'),(649,62033,'Trujillanos'),(649,62034,'Usagre'),(649,62035,'Valdecaballeros'),(649,62036,'Valdehornillos'),(649,62037,'Valdelacalzada'),(649,62038,'Valdetorres'),(649,62039,'Valdivia'),(649,62040,'Valencia de las torres'),(649,62041,'Valencia del mombuey'),(649,62042,'Valencia del Ventoso'),(649,62043,'Valuengo'),(649,62044,'Valverde de burguillos'),(649,62045,'Valverde de Leganés'),(649,62046,'Valverde de llerena'),(649,62047,'Valverde de Mérida'),(649,62048,'Valle de la Serena'),(649,62049,'Valle de matamoros'),(649,62050,'Valle de Santa Ana'),(649,62051,'Vegas altas'),(649,62052,'Venta del culebrin'),(649,62053,'Villafranca de los Barros'),(649,62054,'Villafranco'),(649,62055,'Villagarcia de la Torre'),(649,62056,'Villagonzalo'),(649,62057,'Villalba de los Barros'),(649,62058,'Villanueva de la Serena'),(649,62059,'Villanueva del Fresno'),(649,62060,'Villar de Rena'),(649,62061,'Villar del Rey'),(649,62062,'Villarta de los montes'),(649,62063,'Vivares'),(649,62065,'Zafra'),(649,62066,'Zahínos'),(649,62067,'Zalamea de la Serena'),(649,62068,'Zarza capilla'),(649,62069,'Zarza de alange'),(649,62070,'Zurbaran'),(650,62071,'La Acebeda'),(650,62072,'Ajalvir'),(650,62073,'Alalpardo'),(650,62074,'Alameda del Valle'),(650,62075,'El Álamo'),(650,62076,'Alcalá de Henares'),(650,62077,'Alcobendas'),(650,62078,'Alcorcón'),(650,62079,'Aldea del Fresno'),(650,62080,'Algete'),(650,62081,'Algodor'),(650,62082,'Alpedrete'),(650,62083,'Ambite'),(650,62084,'Anchuelo'),(650,62085,'Aoslos'),(650,62086,'Aranjuez'),(650,62087,'Arganda del Rey'),(650,62088,'Arroyomolinos'),(650,62089,'El Atazar'),(650,62090,'Barajas'),(650,62091,'Batres'),(650,62092,'Becerril de la Sierra'),(650,62093,'Belmonte de Tajo'),(650,62094,'Belvis'),(650,62095,'Belvis del Jarama'),(650,62096,'El Berrueco'),(650,62097,'Berzosa del Lozoya'),(650,62098,'Boadilla del Monte'),(650,62099,'El Boalo'),(650,62100,'Braojos'),(650,62101,'Brea de Tajo'),(650,62102,'Brunete'),(650,62103,'Buitrago de Lozoya'),(650,62104,'Bustarviejo'),(650,62105,'Cabanillas de la Sierra'),(650,62106,'La Cabrera'),(650,62107,'Cadalso de los Vidrios'),(650,62108,'Camarma de Esteruelas'),(650,62109,'Camarma del Caño'),(650,62110,'Camorritos'),(650,62111,'Campo Real'),(650,62112,'Canencia'),(650,62113,'Carabaña'),(650,62114,'Casarrubuelos'),(650,62115,'Castillejo'),(650,62116,'Cenicientos'),(650,62117,'Cerceda'),(650,62118,'Cercedilla'),(650,62120,'Ciempozuelos'),(650,62121,'Cinco Villas'),(650,62122,'Cobeña'),(650,62123,'Colmenar de Oreja'),(650,62124,'Colmenar del Arroyo'),(650,62125,'Colmenar Viejo'),(650,62126,'Colmenarejo'),(650,62127,'Collado Mediano'),(650,62128,'Collado Villalba'),(650,62129,'Corpa'),(650,62130,'Coslada'),(650,62131,'El Cuadrón'),(650,62132,'Cubas'),(650,62133,'Chapinería'),(650,62134,'Chinchón'),(650,62135,'Daganzo de Arriba'),(650,62136,'El Escorial'),(650,62137,'El Espartal'),(650,62138,'Estremera'),(650,62139,'La Flamenca'),(650,62140,'Fresnedillas de la Oliva'),(650,62141,'Fresno de Torote'),(650,62142,'Fuenlabrada'),(650,62143,'Fuente del Fresno'),(650,62144,'Fuente el Saz de Jarama'),(650,62145,'Fuentidueña de Tajo'),(650,62146,'Galapagar'),(650,62147,'Gandullas'),(650,62149,'Gargantilla de Lozoya'),(650,62150,'Gascones'),(650,62151,'Getafe'),(650,62152,'Gozquez de Abajo'),(650,62153,'Gozquez de Arriba'),(650,62154,'Griñón'),(650,62155,'Guadalix de la Sierra'),(650,62156,'Guadarrama'),(650,62157,'Las Herreras'),(650,62158,'La Hiruela'),(650,62159,'Horcajo de la Sierra'),(650,62160,'Horcajuelo de la Sierra'),(650,62161,'La Hoya'),(650,62162,'Hoyo de Manzanares'),(650,62163,'Los Hueros'),(650,62164,'Humanes de Madrid'),(650,62165,'Humera'),(650,62166,'Las Infantas'),(650,62167,'Leganés'),(650,62168,'Loeches'),(650,62169,'Lozoya'),(650,62170,'Lozoyuela'),(650,62171,'Madarcos'),(650,62172,'Madrid'),(650,62173,'Majadahonda'),(650,62174,'Manjiron'),(650,62175,'Manzanares el Real'),(650,62176,'La Marañosa'),(650,62177,'Mataelpino'),(650,62178,'Meco'),(650,62179,'Mejorada del Campo'),(650,62180,'Miraflores de la Sierra'),(650,62181,'El Molar'),(650,62182,'Los Molinos'),(650,62183,'Monte Robledal'),(650,62184,'Montejo de la Sierra'),(650,62185,'Moraleja de Enmedio'),(650,62186,'Moralzarzal'),(650,62187,'Morata de Tajuña'),(650,62188,'Móstoles'),(650,62189,'Navacerrada'),(650,62191,'Navalagamella'),(650,62192,'Navalcarnero'),(650,62193,'Navalespino'),(650,62194,'Navarredonda'),(650,62195,'Las Navas de Buitrago'),(650,62196,'Navas del Rey'),(650,62197,'Nuevo Baztán'),(650,62199,'Orusco'),(650,62200,'Oteruelo del Valle'),(650,62201,'Pajares'),(650,62202,'Paracuellos de Jarama'),(650,62203,'La Paradilla'),(650,62204,'El Pardo'),(650,62205,'Paredes de Buitrago'),(650,62206,'Parla'),(650,62208,'Pedrezuela'),(650,62209,'Pelayos de la Presa'),(650,62210,'Peralejo'),(650,62211,'Perales de Tajuña'),(650,62212,'Perales del Río'),(650,62213,'Pezuelas de las Torres'),(650,62214,'El Pimpollar'),(650,62216,'Pinilla del Valle'),(650,62217,'Pinto'),(650,62219,'Pozuelo de Alarcón'),(650,62220,'Pozuelo del Rey'),(650,62222,'Puebla de la Sierra'),(650,62223,'Quijorna'),(650,62224,'Rascafría'),(650,62226,'Ribatejada'),(650,62227,'Rivas de Jarama'),(650,62228,'Rivas Vaciamadrid'),(650,62230,'Robledillo de la Jara'),(650,62231,'Robledo de Chavela'),(650,62232,'Robledondo'),(650,62234,'Rozas de Puerto Real'),(650,62235,'Las Rozas'),(650,62236,'San Agustín de Guadalix'),(650,62237,'San Fernando de Henares'),(650,62238,'San Isidro'),(650,62239,'San Lorenzo de El Escorial'),(650,62240,'San Mamés'),(650,62241,'San Martín de la Vega'),(650,62242,'San Martín de Valdeiglesias'),(650,62243,'San Sebastián de los Reyes'),(650,62244,'Sanatorio'),(650,62245,'Santa María de la Alameda'),(650,62246,'Santorcaz'),(650,62247,'Los Santos de la Humosa'),(650,62248,'La Serna del Monte'),(650,62249,'Serracines'),(650,62251,'Serranillos del Valle'),(650,62252,'Sevilla la Nueva'),(650,62253,'Sieteiglesias'),(650,62254,'Somosierra'),(650,62255,'Soto del Real'),(650,62256,'Talamanca de Jarama'),(650,62257,'Tielmes'),(650,62258,'Titulcia'),(650,62259,'Torrejón de Ardoz'),(650,62260,'Torrejón de la Calzada'),(650,62261,'Torrejón de Velasco'),(650,62262,'Torrelaguna'),(650,62263,'Torrelodones'),(650,62264,'Torremocha'),(650,62265,'Torres de la Alameda'),(650,62266,'Tres Cantos'),(650,62267,'Valdeavero'),(650,62269,'Valdemanco'),(650,62271,'Valdemorillo'),(650,62272,'Valdemoro'),(650,62273,'Valdeolmos'),(650,62275,'Valderacete'),(650,62276,'Valdetorres de Jarama'),(650,62278,'Valverde de Alcalá'),(650,62279,'Vallecas'),(650,62280,'Velilla de San Antonio'),(650,62281,'El Vellón'),(650,62282,'Venturada'),(650,62283,'Vicálvaro'),(650,62284,'Villa del Prado'),(650,62285,'Villaconejos'),(650,62286,'Villalbilla'),(650,62287,'Villamanrique de Tajo'),(650,62288,'Villamanta'),(650,62289,'Villamantilla'),(650,62290,'Villamejor'),(650,62291,'Villanueva de la Cañada'),(650,62292,'Villanueva de Perales'),(650,62293,'Villanueva del Pardillo'),(650,62294,'Villar del Olmo'),(650,62295,'Villarejo de Salvanés'),(650,62296,'Villaviciosa de Odón'),(650,62297,'Villavieja del Lozoya'),(650,62298,'Zarzalejo'),(651,62299,'Adriano'),(651,62300,'Aguadulce'),(651,62301,'Alamo el'),(651,62302,'Alanis'),(651,62303,'Albaida del Aljarafe'),(651,62304,'Alcalá de Guadaíra'),(651,62305,'Alcalá del Río'),(651,62306,'Alcolea del Río'),(651,62307,'Alcornocosa la'),(651,62308,'Alfonso xiii'),(651,62309,'La Algaba'),(651,62312,'Almensilla'),(651,62313,'Arahal'),(651,62315,'Arroyo de la plata'),(651,62317,'Aznalcázar'),(651,62318,'Aznalcóllar'),(651,62319,'Badolatosa'),(651,62320,'Bellavista'),(651,62321,'Benacazón'),(651,62322,'Bollullos de la Mitación'),(651,62323,'Bormujos'),(651,62324,'Brenes'),(651,62325,'Burguillos'),(651,62326,'Las Cabezas de San Juan'),(651,62327,'Camas'),(651,62328,'La Campana'),(651,62329,'Campillo el'),(651,62331,'Cantillana'),(651,62332,'Cañada Rosal'),(651,62333,'Cañuelo el'),(651,62334,'Carmona'),(651,62335,'Carrión de los Céspedes'),(651,62336,'Casariche'),(651,62337,'Castilblanco de los Arroyos'),(651,62339,'Castilleja de la Cuesta'),(651,62340,'Castilleja del campo'),(651,62341,'Castillo de las guardas'),(651,62342,'Cazalla de la Sierra'),(651,62344,'Cerro perea'),(651,62345,'Constantina'),(651,62346,'Corcoya'),(651,62348,'Coria del Río'),(651,62349,'Coripe'),(651,62350,'El Coronil'),(651,62351,'Los Corrales'),(651,62355,'El Cuervo de Sevilla'),(651,62357,'Don rodrigo'),(651,62358,'Dos Hermanas'),(651,62359,'Écija'),(651,62360,'Escobar'),(651,62361,'Espartinas'),(651,62362,'Esquivel'),(651,62363,'Estepa'),(651,62365,'Fuentes de Andalucía'),(651,62366,'Galeon el'),(651,62369,'Gelves'),(651,62370,'Gerena'),(651,62371,'Gilena'),(651,62372,'Gines'),(651,62374,'Guadalcanal'),(651,62376,'Guillena'),(651,62377,'Herrera'),(651,62379,'Isla Redonda'),(651,62381,'Juan gallego'),(651,62382,'La Lantejuela'),(651,62383,'Lebrija'),(651,62385,'Lora del Río'),(651,62386,'La Luisiana'),(651,62388,'Mairena del Alcor'),(651,62389,'Mairena del Aljarafe'),(651,62390,'Marchena'),(651,62391,'Maribañez'),(651,62392,'Marinaleda'),(651,62393,'Marismillas'),(651,62394,'Martín de la Jara'),(651,62397,'Minas de el castillo de las gu'),(651,62398,'Los Molares'),(651,62399,'Monjas las'),(651,62400,'Montellano'),(651,62401,'Montequinto'),(651,62402,'Morón de la Frontera'),(651,62404,'Navas de la concepcion las'),(651,62405,'Olivares'),(651,62406,'Osuna'),(651,62408,'Los Palacios y Villafranca'),(651,62409,'Palmar de troya'),(651,62410,'Palomares del Río'),(651,62411,'Paradas'),(651,62412,'Pedrera'),(651,62414,'El Pedroso'),(651,62415,'Peñaflor'),(651,62419,'Pilas'),(651,62420,'Pintado el'),(651,62422,'Priorato el'),(651,62423,'Pruna'),(651,62424,'La Puebla de Cazalla'),(651,62425,'La Puebla de los Infantes'),(651,62426,'La Puebla del Río'),(651,62427,'Puerto de la encina'),(651,62429,'Real de la jara el'),(651,62431,'La Rinconada'),(651,62432,'La Roda de Andalucía'),(651,62434,'Rosales los'),(651,62435,'El Rubio'),(651,62436,'Sacramento'),(651,62438,'Saltares'),(651,62440,'San jose de la rinconada'),(651,62441,'San Juan de Aznalfarache'),(651,62443,'San nicolas del puerto'),(651,62444,'Sanlúcar la Mayor'),(651,62445,'Santiponce'),(651,62446,'El Saucejo'),(651,62447,'Setefilla'),(651,62448,'Sevilla'),(651,62449,'Tocina'),(651,62450,'Tomares'),(651,62452,'Torre de la reina'),(651,62453,'Torreblanca de los caños'),(651,62456,'Umbrete'),(651,62457,'Utrera'),(651,62459,'Valencina de la Concepción'),(651,62460,'Vegas de almenara'),(651,62463,'Viar el'),(651,62464,'Vilafranco del guadalquivir'),(651,62466,'Villamanrique de la Condesa'),(651,62467,'Villanueva de san juan'),(651,62468,'Villanueva del Ariscal'),(651,62469,'Villanueva del rey'),(651,62470,'Villanueva del rio'),(651,62471,'Villanueva del Río y Minas'),(651,62472,'Villar'),(651,62473,'Villaverde del Río'),(651,62474,'El Viso del Alcor'),(652,62475,'Ademuz'),(652,62476,'Ador'),(652,62477,'Adzaneta de albaida'),(652,62478,'Agullent'),(652,62479,'Ahillas'),(652,62480,'Aielo de Malferit'),(652,62481,'Alaquás'),(652,62482,'Albaida'),(652,62483,'Albal'),(652,62484,'Albalat de la Ribera'),(652,62485,'Albalat dels tarongers'),(652,62486,'Alberic'),(652,62487,'Alborache'),(652,62488,'Alboraya'),(652,62489,'Alboy'),(652,62490,'Albuixec'),(652,62491,'Alcásser'),(652,62492,'Alcantera'),(652,62493,'Alcoceres los'),(652,62494,'Alcublas'),(652,62495,'L\'Alcúdia de Crespins'),(652,62496,'Aldaia'),(652,62497,'Alfafar'),(652,62498,'Alfara de Algimia'),(652,62499,'Alfarp'),(652,62500,'Alfarrasi'),(652,62501,'Alfauir'),(652,62502,'Algar de palancia'),(652,62503,'Algemesí'),(652,62505,'Alginet'),(652,62506,'Almássera'),(652,62508,'Almiserat'),(652,62509,'Almoines'),(652,62510,'Almussafes'),(652,62511,'Alpuente'),(652,62513,'Alzira'),(652,62515,'Anna'),(652,62516,'Antella'),(652,62517,'Aras de alpuente'),(652,62520,'Ayelo de rugat'),(652,62521,'Ayora'),(652,62523,'Barx'),(652,62524,'Barxeta'),(652,62525,'Belgida'),(652,62526,'Bellreguar'),(652,62527,'Bellus'),(652,62528,'Benageber'),(652,62529,'Benaguasil'),(652,62530,'Benavites'),(652,62531,'Beneixida'),(652,62532,'Benetússer'),(652,62533,'Beniarjo'),(652,62534,'Beniatjar'),(652,62535,'Benicolet'),(652,62536,'Benicull'),(652,62537,'Benifaió'),(652,62538,'Benifairo'),(652,62539,'Benifairo de valldigna'),(652,62540,'Benigánim'),(652,62541,'Benimodo'),(652,62542,'Benimuslem'),(652,62543,'Beniparrell'),(652,62544,'Benirredra'),(652,62545,'Benisano'),(652,62546,'Benisoda'),(652,62548,'Bétera'),(652,62549,'Bicorp'),(652,62550,'Bocairent'),(652,62551,'Bolbaite'),(652,62552,'Bonrepós i Mirambell'),(652,62553,'Brosquil el'),(652,62556,'Buñol'),(652,62557,'Burjassot'),(652,62558,'Cabezo royo'),(652,62560,'Calles'),(652,62562,'Campo de abajo'),(652,62563,'Camporrobles'),(652,62564,'Canals'),(652,62565,'Canet d\'En Berenguer'),(652,62567,'Cañada la'),(652,62568,'Cañada seca'),(652,62569,'Carcaixent'),(652,62570,'Cárcer'),(652,62572,'Carlet'),(652,62574,'Casas altas'),(652,62578,'Casas de cuadra'),(652,62579,'Casas de enmedio'),(652,62585,'Casas de moya'),(652,62586,'Casas de prada'),(652,62588,'Casas del collado de san juan'),(652,62589,'Casas del rey'),(652,62590,'Casas del rio'),(652,62592,'Casinos'),(652,62593,'Castelló de Rugat'),(652,62594,'Castellonet'),(652,62595,'Castielfabib'),(652,62596,'Catadau'),(652,62597,'Catarroja'),(652,62599,'Cerda'),(652,62604,'Corbera'),(652,62606,'Corrales los'),(652,62613,'Cullera'),(652,62615,'Chella'),(652,62616,'Chera'),(652,62617,'Cheste'),(652,62618,'Chiva'),(652,62620,'Chulilla'),(652,62621,'Daimús'),(652,62624,'Dos aguas'),(652,62627,'L\'Eliana'),(652,62628,'Enguera'),(652,62629,'Enova l\''),(652,62630,'Estacion del piaquart'),(652,62631,'Estenas'),(652,62632,'Estivella'),(652,62634,'Faura'),(652,62635,'Favara'),(652,62637,'Foios'),(652,62638,'La Font d\'En Carrós'),(652,62639,'La Font de la Figuera'),(652,62640,'Fontanars o l\'alfori'),(652,62641,'Fortaleny'),(652,62642,'Fuenterrobles'),(652,62643,'Gandia'),(652,62645,'Gavarda'),(652,62646,'Genovés'),(652,62648,'Gilet'),(652,62649,'Godella'),(652,62650,'Godelleta'),(652,62651,'Granja de la costera la'),(652,62652,'Grau el'),(652,62653,'Guadassequies'),(652,62654,'Guadassuar'),(652,62655,'Guardamar'),(652,62656,'Herreros los'),(652,62657,'Higueruelas'),(652,62658,'Hontanar el'),(652,62661,'Hortunas'),(652,62663,'Jalance'),(652,62664,'Jarafuel'),(652,62667,'Loriguilla'),(652,62668,'Losa del obispo'),(652,62670,'Llauri'),(652,62671,'Llíria'),(652,62672,'Llocnou de fenollet'),(652,62673,'Llocnou de sant jeroni'),(652,62674,'Llombai'),(652,62675,'La Llosa de Ranes'),(652,62676,'Llutxent'),(652,62678,'Malva-rosa la'),(652,62680,'Manises'),(652,62681,'Manuel'),(652,62686,'Mareny sant llorenç'),(652,62687,'Marines'),(652,62695,'Massalaves'),(652,62696,'Massalfassar'),(652,62697,'Massamagrell'),(652,62698,'Massanassa'),(652,62699,'Meliana'),(652,62701,'Miramar'),(652,62702,'Mislata'),(652,62703,'Moixent'),(652,62704,'Moncada'),(652,62706,'Montaverner'),(652,62708,'Montesa'),(652,62709,'Montitxelvo'),(652,62710,'Montroy'),(652,62711,'Montserrat'),(652,62714,'Museros'),(652,62715,'Naquera'),(652,62717,'Navarres'),(652,62718,'Nazaret'),(652,62720,'Nogueras las'),(652,62721,'Novele'),(652,62722,'Ochandos los'),(652,62723,'Oliva'),(652,62726,'L\'Olleria'),(652,62727,'Ontinyent'),(652,62731,'Otos'),(652,62732,'Paiporta'),(652,62733,'Palma de gandia'),(652,62736,'Palomar'),(652,62738,'Paterna'),(652,62742,'Perello el'),(652,62744,'Petres'),(652,62745,'Picanya'),(652,62746,'Picassent'),(652,62747,'Piles'),(652,62748,'Pinedo'),(652,62749,'Pinet'),(652,62750,'La Pobla de Farnals'),(652,62751,'La Pobla de Vallbona'),(652,62752,'La Pobla del Duc'),(652,62753,'La Pobla Llarga'),(652,62755,'Polinyá de Xúquer'),(652,62756,'Port el'),(652,62758,'Porton el'),(652,62759,'Potries'),(652,62760,'Puçol'),(652,62762,'Puig'),(652,62763,'Quart de les valls'),(652,62764,'Quart de Poblet'),(652,62765,'Quartell'),(652,62766,'Quatretonda'),(652,62767,'Quesa'),(652,62769,'Rafelbunyol'),(652,62770,'Rafelcofer'),(652,62771,'Rafelguaraf'),(652,62774,'Real de gandia'),(652,62777,'Requena'),(652,62778,'Riba Roja de Túria'),(652,62779,'Riola'),(652,62780,'Rocafort'),(652,62782,'Rotgla i corbera'),(652,62783,'Rotova'),(652,62784,'Rugat'),(652,62786,'Sagunto'),(652,62787,'Salem'),(652,62788,'Saler el'),(652,62790,'Sant Antonio'),(652,62791,'San Antonio de Benagéber'),(652,62793,'Sant joan d\'enova'),(652,62794,'Sant juan'),(652,62796,'Sardineros los'),(652,62797,'Sedaví'),(652,62801,'Senyera'),(652,62802,'Serra'),(652,62805,'Silla'),(652,62806,'Simat de la Valldigna'),(652,62807,'Sinarcas'),(652,62808,'Sollana'),(652,62810,'Sueca'),(652,62811,'Sumacarcer'),(652,62812,'Tavernes Blanques'),(652,62813,'Tavernes de la Valldigna'),(652,62816,'Teulada'),(652,62818,'Torre alta'),(652,62820,'Torre del cap'),(652,62821,'Torre la'),(652,62823,'Torre tallada'),(652,62824,'Torrebaja'),(652,62825,'Torrella'),(652,62826,'Torrent'),(652,62828,'Tous'),(652,62829,'Tuejar'),(652,62830,'Turís'),(652,62831,'Utiel'),(652,62833,'Valencia'),(652,62834,'Vallada'),(652,62835,'Vallanca'),(652,62836,'Vallés'),(652,62837,'Vega la'),(652,62839,'Venta del moro'),(652,62840,'Venta del poyo'),(652,62842,'Vilamarsant'),(652,62843,'Vilanova de castello'),(652,62845,'Villalonga'),(652,62846,'Villanueva'),(652,62849,'Villar del Arzobispo'),(652,62851,'Virgen del Carmen'),(652,62852,'Xátiva'),(652,62853,'Xeraco'),(652,62854,'Xeresa'),(652,62855,'Xirivella'),(652,62856,'Yatova'),(652,62858,'Zarra'),(653,62859,'Abalario el'),(653,62860,'Acebuche'),(653,62861,'Acebuche el'),(653,62862,'Aguafria'),(653,62863,'Alajar'),(653,62864,'Alamillo el'),(653,62865,'Aldea de tejada'),(653,62866,'Aljaraque'),(653,62867,'Almendro el'),(653,62868,'Almonaster la real'),(653,62869,'Almonte'),(653,62870,'Alosno'),(653,62871,'Alto de la mesa'),(653,62872,'Antilla la'),(653,62873,'Aracena'),(653,62874,'Aroche'),(653,62875,'Arroyo'),(653,62876,'Arroyomolinos de leon'),(653,62877,'Asperillo'),(653,62878,'Ayamonte'),(653,62879,'Barca la'),(653,62880,'Beas'),(653,62881,'Berrocal'),(653,62882,'Bodegones los'),(653,62883,'Bollullos Par del Condado'),(653,62884,'Bonares'),(653,62886,'Buitron el'),(653,62887,'Cabezas del pasto'),(653,62888,'Cabezas rubias'),(653,62889,'Cabezudos los'),(653,62890,'Cala'),(653,62892,'El Campillo'),(653,62893,'Campofrio'),(653,62894,'Canaleja'),(653,62895,'Candon'),(653,62896,'Cañaveral de leon'),(653,62897,'Carboneras'),(653,62898,'Cartaya'),(653,62899,'Castaño del robledo'),(653,62900,'Castañuelo'),(653,62901,'Cefiñas las'),(653,62902,'El Cerro de Andévalo'),(653,62903,'Colonia de tejada'),(653,62904,'Contienda la'),(653,62906,'Corrales'),(653,62908,'Corteconcepcion'),(653,62909,'Cortegana'),(653,62910,'Cortelazor'),(653,62911,'Corterrangel'),(653,62912,'Cortijo del bruno'),(653,62914,'Cumbres de enmedio'),(653,62915,'Cumbres Mayores'),(653,62916,'Chinas las'),(653,62917,'Chucena'),(653,62918,'Dehesa la'),(653,62919,'Delgadas las'),(653,62921,'Encinasola'),(653,62922,'Escacena del Campo'),(653,62923,'Fuente de la corcha'),(653,62924,'Fuenteheridos'),(653,62925,'Galaroza'),(653,62926,'Gibraleón'),(653,62927,'Gil marquez'),(653,62928,'Granada de rio tinto la'),(653,62929,'Granado el'),(653,62930,'Herrerias'),(653,62931,'Higuera de la sierra'),(653,62932,'Hinojales'),(653,62933,'Hinojos'),(653,62934,'Huelva'),(653,62935,'Isla canela'),(653,62936,'Isla Cristina'),(653,62937,'Isla del moral'),(653,62938,'Jabugo'),(653,62939,'Jabuguillo'),(653,62940,'Joya la'),(653,62941,'Judio el'),(653,62942,'Lepe'),(653,62943,'Linares de la sierra'),(653,62944,'Lucena del Puerto'),(653,62945,'Manzanilla'),(653,62946,'Marigenta'),(653,62947,'Marines los'),(653,62948,'Matalascañas'),(653,62949,'Matilla la'),(653,62950,'Mediana la'),(653,62952,'Minas de cala'),(653,62953,'Minas de Riotinto'),(653,62954,'Moguer'),(653,62958,'Nava la'),(653,62960,'Nerva'),(653,62961,'Niebla'),(653,62962,'La Palma del Condado'),(653,62963,'Palos de la Frontera'),(653,62964,'Paterna del Campo'),(653,62965,'Patras'),(653,62966,'Paymogo'),(653,62967,'Peñuela la'),(653,62968,'Perrunal'),(653,62969,'Pinos del mar'),(653,62970,'Portil el'),(653,62971,'Pozo del camino'),(653,62972,'Pozuelo el'),(653,62973,'Puebla de Guzmán'),(653,62974,'Puerto de la laja'),(653,62975,'Puerto gil'),(653,62976,'Puerto lucia'),(653,62977,'Puerto moral'),(653,62978,'Punta Umbría'),(653,62979,'Rabida la'),(653,62980,'Redondela la'),(653,62981,'Repilado el'),(653,62982,'Rivera la'),(653,62983,'Rociana del Condado'),(653,62984,'Rocio el'),(653,62986,'Rompido el'),(653,62987,'Rosal de la frontera'),(653,62988,'San Bartolomé de la Torre'),(653,62989,'San Juan del Puerto'),(653,62990,'San silvestre de guzman'),(653,62991,'San telmo'),(653,62992,'Sanlucar de guadiana'),(653,62993,'Santa ana la real'),(653,62994,'Santa barbara de casa'),(653,62995,'Santa Olalla del Cala'),(653,62996,'Silos de calañas'),(653,62997,'Sotiel coronada'),(653,62998,'Tariquejos'),(653,62999,'Terron el'),(653,63000,'Tharsis'),(653,63001,'Torera la'),(653,63002,'Trigueros'),(653,63003,'Tujena'),(653,63004,'Tumbalejo'),(653,63005,'Umbria la'),(653,63006,'Valdelamusa'),(653,63007,'Valdelarco'),(653,63009,'Valverde del Camino'),(653,63011,'Veredas'),(653,63013,'Villablanca'),(653,63014,'Villalba del Alcor'),(653,63015,'Villanueva de las cruces'),(653,63016,'Villanueva de los Castillejos'),(653,63017,'Villar el'),(653,63018,'Villarrasa'),(653,63019,'Zalamea la Real'),(653,63020,'Zufre'),(654,63021,'Abella de la conca'),(654,63022,'Adons'),(654,63023,'Adrall'),(654,63024,'Ager'),(654,63025,'Agramunt'),(654,63026,'Aguda l\''),(654,63027,'Aguilella'),(654,63028,'Agullo'),(654,63029,'Aidi'),(654,63030,'Aiguabella'),(654,63032,'Aineto'),(654,63033,'Aitona'),(654,63034,'Alamus els'),(654,63035,'Alas'),(654,63036,'Albages l\''),(654,63037,'Albatarrec'),(654,63039,'Albesa'),(654,63040,'Albi l\''),(654,63041,'Alcano'),(654,63042,'Alcarrás'),(654,63043,'Alcoletge'),(654,63044,'Alentorn'),(654,63045,'Alfarras'),(654,63046,'Alfes'),(654,63047,'Algerri'),(654,63048,'Alguaire'),(654,63050,'Alinya'),(654,63051,'Almacelles'),(654,63052,'Almacelletes'),(654,63053,'Almassor'),(654,63054,'Almatret'),(654,63055,'Almenar'),(654,63056,'Alos d\'ensil'),(654,63057,'Alos de balaguer'),(654,63059,'Alta-riba'),(654,63060,'Altadill'),(654,63066,'Ametlla l\''),(654,63067,'Andani'),(654,63068,'Anglesola'),(654,63074,'Aramunt'),(654,63076,'Aransis'),(654,63080,'Ardevol'),(654,63084,'Aristot'),(654,63085,'Arres'),(654,63088,'Arros'),(654,63090,'Ars'),(654,63093,'Artesa de lleida'),(654,63094,'Artesa de Segre'),(654,63097,'Aspa'),(654,63098,'Aubert'),(654,63099,'Avellanes i santa linya les'),(654,63100,'Avellanet'),(654,63102,'Aynet de cardos'),(654,63104,'Baguergue'),(654,63105,'Balaguer'),(654,63106,'Baldomar'),(654,63108,'Baqueira-beret'),(654,63110,'Barbens'),(654,63116,'Basses d\'alpicat les'),(654,63119,'Belianes'),(654,63120,'Bellvís'),(654,63121,'Bell-lloc d\'Urgell'),(654,63122,'Bellaguarda'),(654,63124,'Bellmunt d\'urgell'),(654,63125,'Bellmunt de segarra'),(654,63126,'Bellpuig'),(654,63127,'Bellpuig d\'urgell'),(654,63128,'Bellver de cerdanya'),(654,63131,'Benavent de segria'),(654,63132,'Berclaire d\'urgell'),(654,63136,'Betlan'),(654,63137,'Betren'),(654,63138,'Biosca'),(654,63141,'Boi'),(654,63145,'Bor'),(654,63147,'Bordes es'),(654,63148,'Bordeta la'),(654,63151,'Bossost'),(654,63152,'Bovera'),(654,63159,'Butsenit d\'urgel'),(654,63165,'Calbinya'),(654,63167,'Camarasa'),(654,63168,'Cambrils'),(654,63173,'Canos el'),(654,63176,'Cardosa la'),(654,63177,'Caregue'),(654,63181,'Casau'),(654,63184,'Castellciutat'),(654,63185,'Castelldans'),(654,63190,'Castellnou de montsec'),(654,63191,'Castellnou de seana'),(654,63192,'Castello de farfanya'),(654,63194,'Castellsera'),(654,63196,'Cava'),(654,63200,'Cervera'),(654,63202,'Cervia de les garriques'),(654,63206,'Cirera la'),(654,63207,'Ciutadilla'),(654,63210,'Clara'),(654,63212,'Claravalls'),(654,63213,'Claret'),(654,63215,'Clua'),(654,63222,'Colls'),(654,63223,'Coma la'),(654,63224,'Comiols'),(654,63226,'Concabella'),(654,63228,'Corbins'),(654,63229,'Corroncui'),(654,63231,'Cosco'),(654,63233,'Cubells'),(654,63237,'Ducro'),(654,63239,'Els omellons'),(654,63240,'Eller'),(654,63241,'Enviny'),(654,63245,'Eroles'),(654,63247,'Ertorm'),(654,63248,'Escalarre'),(654,63252,'Escas'),(654,63253,'Escos'),(654,63254,'Escunhau'),(654,63256,'Espluga calva l\''),(654,63257,'Espot'),(654,63261,'Estamariu'),(654,63262,'Estaon'),(654,63263,'Estaras'),(654,63265,'Esterri d\'aneu'),(654,63266,'Esterri de cardos'),(654,63270,'Ferran'),(654,63274,'Figuerola d\'orcan'),(654,63276,'Figuerosa la'),(654,63277,'Florejacs'),(654,63279,'Fondarella'),(654,63282,'Fontdepou'),(654,63283,'Fontllonga'),(654,63284,'Foradada'),(654,63287,'Fuliola la'),(654,63288,'Fulleda'),(654,63290,'Garos'),(654,63292,'Gausac'),(654,63293,'Gavarra'),(654,63296,'Gerb'),(654,63299,'Gessa'),(654,63300,'Giminells'),(654,63302,'Golmes'),(654,63303,'Gosol'),(654,63305,'Gra'),(654,63307,'Granadella la'),(654,63308,'Granja d\'escarp la'),(654,63310,'Granyena'),(654,63311,'Granyena de les garrigues'),(654,63312,'Granyena de segarra'),(654,63314,'Gualda'),(654,63321,'Guimera'),(654,63322,'Guiro'),(654,63323,'Guissona'),(654,63327,'Hestalfrancs'),(654,63328,'Hortoneda'),(654,63330,'Hospital de vielha l\''),(654,63336,'Isona'),(654,63337,'Ivars d\'urgell'),(654,63338,'Ivars de noguera'),(654,63342,'Juncosa'),(654,63343,'Juneda'),(654,63344,'Junyent'),(654,63345,'L_alzina'),(654,63348,'Lavorre'),(654,63349,'Les'),(654,63350,'Les Borges Blanques'),(654,63352,'Linyola'),(654,63353,'Lladorre'),(654,63356,'Llanera'),(654,63357,'Llardecans'),(654,63358,'Llavorsi'),(654,63359,'Lleida'),(654,63362,'Lles'),(654,63363,'Llesp'),(654,63364,'Llessui'),(654,63367,'Llinars'),(654,63368,'Llivia'),(654,63369,'Llor el'),(654,63370,'Llorda'),(654,63371,'Llovera'),(654,63377,'Magraners els'),(654,63378,'Maials'),(654,63379,'Malda'),(654,63380,'Malgrat'),(654,63382,'Malpartit'),(654,63383,'Malpas'),(654,63387,'Martinet'),(654,63393,'Masies les'),(654,63395,'Massalcoreig'),(654,63399,'Menarguens'),(654,63404,'Miralcamp'),(654,63410,'Mollerussa'),(654,63411,'Mont-ros'),(654,63419,'Montcalb'),(654,63421,'Montcortes'),(654,63426,'Montferrer'),(654,63429,'Montmagastre'),(654,63430,'Montoliu de lleida'),(654,63431,'Montoliu de segarra'),(654,63433,'Montpalau'),(654,63440,'Muller'),(654,63443,'Nas'),(654,63451,'Oliana'),(654,63452,'Oliola'),(654,63453,'Olius'),(654,63455,'Olugues les'),(654,63456,'Omells de na gaia els'),(654,63458,'Organya'),(654,63461,'Os de balaguer'),(654,63463,'Osso de sio'),(654,63465,'Palau d\'anglesola el'),(654,63466,'Palau de tora'),(654,63467,'Pallargues les'),(654,63468,'Pallars jussa'),(654,63473,'Parroquia d\'horto al'),(654,63482,'Peramola'),(654,63486,'Pessonada'),(654,63489,'Pinos'),(654,63490,'Pla de la font el'),(654,63491,'Pla de sant tirs el'),(654,63492,'Plana de mont-ros la'),(654,63495,'Poal el'),(654,63496,'Pobella'),(654,63498,'La Pobla de Segur'),(654,63501,'Pont de bar el'),(654,63502,'El Pont de Suert'),(654,63504,'Ponts'),(654,63505,'Portell'),(654,63506,'Portella la'),(654,63508,'Prades'),(654,63509,'Prats'),(654,63510,'Preixana'),(654,63512,'Prullans'),(654,63516,'Puiggros'),(654,63518,'Puigverd de lleida'),(654,63521,'Pujol'),(654,63524,'Raimat'),(654,63525,'Rapita la'),(654,63528,'Reuant'),(654,63529,'Rialb de nogueira'),(654,63532,'Ribera de cardos'),(654,63535,'Riudovelles'),(654,63536,'Rivert'),(654,63540,'Romadriu'),(654,63541,'Roni'),(654,63542,'Rosselló'),(654,63547,'Salardu'),(654,63548,'Salas de pallars'),(654,63555,'Sant adria de la conca'),(654,63557,'Sant antoli i vilanova'),(654,63560,'Sant domi'),(654,63561,'Sant guim de freixenet'),(654,63566,'Sant llorenç de montgai'),(654,63567,'Sant llorenç de morunys'),(654,63568,'Sant marti de malda'),(654,63570,'Sant ramon'),(654,63571,'Sant roma d\'abella'),(654,63578,'Santa susanna'),(654,63583,'Sarroca de lleida'),(654,63593,'Sentiu de sio la'),(654,63594,'Sero'),(654,63595,'Seros'),(654,63597,'La Seu d\'Urgell'),(654,63600,'Sidamon'),(654,63602,'Sisquer'),(654,63607,'Solsona'),(654,63610,'Sorpe'),(654,63612,'Sort'),(654,63613,'Soses'),(654,63614,'Soterranya'),(654,63617,'Suchs'),(654,63618,'Sudanell'),(654,63622,'Talarn'),(654,63623,'Talavera'),(654,63626,'Talltendre'),(654,63627,'Tárrega'),(654,63628,'Tarrés'),(654,63629,'Tarroja de segarra'),(654,63631,'Tartareu'),(654,63637,'Timoneda'),(654,63641,'Toloriu'),(654,63643,'Tora'),(654,63646,'Torms els'),(654,63647,'Tornabous'),(654,63652,'Torre de tamurcia la'),(654,63655,'Torre-serona'),(654,63656,'Torrebesses'),(654,63657,'Torrec'),(654,63659,'Torrefarrera'),(654,63660,'Torrefeta'),(654,63661,'Torregrossa'),(654,63662,'Torrelameu'),(654,63665,'Torres de sanui les'),(654,63666,'Torres de segre'),(654,63671,'Tremp'),(654,63674,'Unarre'),(654,63676,'Valencia d\'aneu'),(654,63678,'Vall d\'ora la'),(654,63683,'Vallfogona de balaguer'),(654,63684,'Vallmanya'),(654,63685,'Vensillo'),(654,63686,'Verdu'),(654,63689,'Viella'),(654,63690,'Vila'),(654,63691,'Vila-sana'),(654,63692,'Vilac'),(654,63693,'Vilagrassa'),(654,63695,'Vilaller'),(654,63697,'Vilamitjana'),(654,63701,'Vilanova d\'alpicat'),(654,63702,'Vilanova de bellpuig'),(654,63704,'Vilanova de la barca'),(654,63705,'Vilanova de las avellanes'),(654,63706,'Vilanova de meia'),(654,63707,'Vilanova de segria'),(654,63708,'Vilaplana'),(654,63710,'Vilosell el'),(654,63711,'Vilves'),(654,63712,'Vinaixa'),(654,63713,'Viu de llevata'),(654,63714,'Viver de segarra'),(654,63715,'Xerallo'),(655,63716,'Abano'),(655,63717,'Abelgas de luna'),(655,63718,'Acebes del paramo'),(655,63719,'Acebo'),(655,63720,'Adrados de ordas'),(655,63721,'Adrados'),(655,63722,'Albares de la ribera'),(655,63723,'Albires'),(655,63724,'Aldea del puente la'),(655,63725,'Aleje'),(655,63726,'Algadefe'),(655,63727,'Alija del infantado'),(655,63728,'Almagarinos'),(655,63729,'Almanza'),(655,63730,'Almazcara'),(655,63731,'Ambasaguas de cureño'),(655,63733,'Amio'),(655,63734,'Andiñuela'),(655,63735,'Anllares del sil'),(655,63737,'Antigua la'),(655,63738,'Antimio'),(655,63740,'Aralla'),(655,63741,'Arbas del puerto'),(655,63742,'Arcahueja'),(655,63743,'Ardon'),(655,63744,'Ardoncinos'),(655,63745,'Arganza'),(655,63750,'Armellada'),(655,63752,'Astorga'),(655,63754,'Azadinos'),(655,63756,'Azares del paramo'),(655,63757,'Babia'),(655,63758,'Baillo'),(655,63759,'Balboa'),(655,63761,'Banamarias'),(655,63763,'Banuncias'),(655,63764,'La Bañeza'),(655,63765,'Barcena de la abadia'),(655,63766,'Barcena del rio'),(655,63769,'Barniedo de la reina'),(655,63771,'Barrientos'),(655,63772,'Barrillos'),(655,63774,'Barrio de la puente'),(655,63775,'Barrio de nuestra señora'),(655,63776,'Barrios de gordon los'),(655,63777,'Barrios de luna los'),(655,63780,'Beberino'),(655,63781,'Bembibre'),(655,63782,'Benamariel'),(655,63783,'Benavides de orbigo'),(655,63784,'Benllera'),(655,63786,'Bercianos del paramo'),(655,63787,'Bercianos del real camino'),(655,63788,'Berlanga del bierzo'),(655,63790,'Bobia'),(655,63791,'Boca de huergano'),(655,63792,'Boeza'),(655,63793,'Boisan'),(655,63794,'Boñar'),(655,63795,'Borrenes'),(655,63796,'Bouzas'),(655,63797,'Braña la'),(655,63798,'Brañuelas'),(655,63799,'Brazuelo'),(655,63801,'Buiza'),(655,63802,'Burbia'),(655,63803,'Burgo ranero el'),(655,63804,'Buron'),(655,63805,'Busdongo de arbas'),(655,63808,'Bustillo de cea'),(655,63809,'Bustillo del paramo'),(655,63812,'Cabañas'),(655,63814,'Cabañas raras'),(655,63815,'Cabarcos'),(655,63817,'Caboalles de abajo'),(655,63818,'Caboalles de arriba'),(655,63819,'Cabornera'),(655,63820,'Cabrera de almanza'),(655,63821,'Cabreros del rio'),(655,63823,'Cacabelos'),(655,63825,'Cain'),(655,63826,'Caldas de luna'),(655,63828,'Calzada del coto'),(655,63829,'Calzadilla de los hermanillos'),(655,63831,'Caminayo'),(655,63834,'Campo de villavidel'),(655,63835,'Campo'),(655,63837,'Campohermoso'),(655,63838,'Camponaraya'),(655,63840,'Canales'),(655,63843,'Candanedo de fenar'),(655,63845,'Canseco'),(655,63847,'Carande'),(655,63848,'Carbajal'),(655,63852,'Cariseda'),(655,63853,'Carmenes'),(655,63854,'Carracedelo'),(655,63855,'Carracedo'),(655,63857,'Carrizo de la ribera'),(655,63858,'Carrocera'),(655,63859,'Carucedo'),(655,63860,'Carvajal de valderaduey'),(655,63861,'Casares de arbas'),(655,63863,'Casasuertes'),(655,63866,'Castellanos'),(655,63867,'Castilfale'),(655,63868,'Castillo el'),(655,63871,'Castrillo de cepeda'),(655,63872,'Castrillo de la ribera'),(655,63874,'Castrillo de los polvazares'),(655,63875,'Castrillo de porma'),(655,63876,'Castrillo de san pelayo'),(655,63877,'Castrillo de valderaduey'),(655,63880,'Castro'),(655,63883,'Castrocalbon'),(655,63884,'Castrocontrigo'),(655,63887,'Castromudarra'),(655,63889,'Castropodame'),(655,63890,'Castroquilame'),(655,63891,'Castrotierra'),(655,63892,'Castrotierra de la valduerna'),(655,63893,'Castrovega de valmadrigal'),(655,63895,'Cea'),(655,63897,'Cebrones del rio'),(655,63901,'Celada'),(655,63903,'Cembranos'),(655,63904,'Cerecedo'),(655,63907,'Cimanes de la vega'),(655,63908,'Cimanes del tejar'),(655,63909,'Ciñera'),(655,63911,'Cistierna'),(655,63913,'Cofiñal'),(655,63914,'Coladilla'),(655,63916,'Columbrianos'),(655,63919,'Congosto'),(655,63920,'Corbillos de los oteros'),(655,63922,'Cordiñanes'),(655,63924,'Corporales'),(655,63925,'Corral de las arrimadas el'),(655,63926,'Corrales'),(655,63928,'Cortiguera'),(655,63929,'Corullon'),(655,63931,'Cremenes'),(655,63932,'Cuadros'),(655,63934,'Cubillas de los oteros'),(655,63935,'Cubillas de rueda'),(655,63936,'Cubillos del sil'),(655,63938,'Cuesta la'),(655,63939,'Cueta la'),(655,63940,'Cuevas del sil'),(655,63947,'Chozas de Abajo'),(655,63949,'Dehesas'),(655,63950,'Destriana'),(655,63952,'Devesa de curueño'),(655,63954,'Donillas'),(655,63956,'Encinedo'),(655,63959,'Espanillo'),(655,63960,'Espejos de la reina los'),(655,63962,'Espina la'),(655,63963,'Espino el'),(655,63965,'Espinosa de la ribera'),(655,63966,'Espinoso de compludo'),(655,63967,'Estebanez'),(655,63969,'Fabero'),(655,63971,'Faro'),(655,63975,'Ferradillo'),(655,63976,'Ferral de bernesga'),(655,63981,'Fojedo'),(655,63982,'Folgoso de la ribera'),(655,63985,'Fontanil de los oteros'),(655,63987,'Fontoria'),(655,63992,'Fresnellino del monte'),(655,63993,'Fresno de la valduerna'),(655,63994,'Fresno de la vega'),(655,63996,'Fuentes de carbajal'),(655,63997,'Fuentes nuevas'),(655,63998,'Gallegos de curueño'),(655,63999,'Galleguillos de campos'),(655,64000,'Ganso el'),(655,64001,'Garaño'),(655,64002,'Garfin'),(655,64003,'Garrafe de torio'),(655,64005,'Gavilanes de orbigo'),(655,64012,'Getino'),(655,64014,'Gordaliza del pino'),(655,64015,'Gordoncillo'),(655,64016,'Gradefes'),(655,64017,'Grajal de campos'),(655,64019,'Grandoso'),(655,64021,'Grulleros'),(655,64025,'Gusendos de los oteros'),(655,64027,'Herreros de jamuz'),(655,64032,'Hospital de orbigo'),(655,64033,'Huerga de frailes'),(655,64034,'Huergas de babia'),(655,64035,'Huergas y el millar'),(655,64036,'Igseña'),(655,64037,'Inicio'),(655,64040,'Isoba'),(655,64041,'Izagre'),(655,64043,'Jimenez de jamuz'),(655,64045,'Joarilla de las matas'),(655,64046,'Labaniego'),(655,64047,'Labaña'),(655,64048,'Lago de babia'),(655,64049,'Lago de carucedo'),(655,64050,'Laguna dalga'),(655,64051,'Laguna de negrillos'),(655,64053,'Langre'),(655,64054,'Lario'),(655,64057,'León'),(655,64059,'Liegos'),(655,64060,'Lillo del bierzo'),(655,64061,'Lindoso'),(655,64062,'Lois'),(655,64063,'Lomba'),(655,64064,'Lorenzana'),(655,64065,'Losada'),(655,64066,'Losadilla'),(655,64067,'Luclillo'),(655,64072,'Lusio'),(655,64073,'Luyego de somoza'),(655,64077,'Llamas de la ribera'),(655,64079,'Llamas de rueda'),(655,64081,'Llanos los'),(655,64082,'Llombera'),(655,64084,'Magdalena la'),(655,64087,'Maluenga la'),(655,64088,'Mallo de luna'),(655,64090,'Mansilla'),(655,64091,'Mansilla de las mulas'),(655,64092,'Mansilla mayor'),(655,64093,'Manzanal del puerto'),(655,64096,'Manzanedo de valdueza'),(655,64098,'Marialba de la ribera'),(655,64099,'Marne'),(655,64105,'Matachana'),(655,64106,'Matadeon de los oteros'),(655,64107,'Matalavilla'),(655,64109,'Mataluenga'),(655,64110,'Matallana'),(655,64111,'Matallana de torio'),(655,64112,'Matanza'),(655,64113,'Matarrosa del sil'),(655,64114,'Matueca de torio'),(655,64115,'Medulas las'),(655,64116,'Meizara'),(655,64119,'Milla del paramo la'),(655,64120,'Milla del rio la'),(655,64122,'Miñambres'),(655,64126,'Molinaseca'),(655,64127,'Mondreganes'),(655,64128,'Montejos del camino'),(655,64129,'Montes de valdueza'),(655,64130,'Montrondo'),(655,64131,'Mora de luna'),(655,64133,'Morgovejo'),(655,64134,'Morilla de los oteros'),(655,64136,'Morriondo'),(655,64138,'Mozos de cea'),(655,64139,'Murias de paredes'),(655,64141,'Murias de ponjos'),(655,64145,'Naredo de fenar'),(655,64146,'Nava de los oteros'),(655,64147,'Navafria'),(655,64148,'Nistal'),(655,64149,'Noceda'),(655,64151,'Nocedo de curueño'),(655,64152,'Nogar'),(655,64153,'Nogarejas'),(655,64154,'Nora la'),(655,64155,'Ocejo de la peña'),(655,64156,'Ocero'),(655,64157,'Odollo'),(655,64159,'Olleros de alba'),(655,64160,'Olleros de sabero'),(655,64163,'Onamio'),(655,64164,'Onzonilla'),(655,64165,'Orallo'),(655,64173,'Otero de las dueñas'),(655,64174,'Otero de naragantes'),(655,64176,'Oville'),(655,64177,'Pajares'),(655,64178,'Pajares de los oteros'),(655,64179,'Palacio de torio'),(655,64180,'Palacio de valdellorma'),(655,64182,'Palacios de la valduerna'),(655,64184,'Palacios del sil'),(655,64185,'Palanquinos'),(655,64187,'Palazuelo de boñar'),(655,64190,'Pallide'),(655,64191,'Pandorado'),(655,64192,'Parada de soto'),(655,64194,'Paradela del rio'),(655,64197,'Paradilla de la sobarriba'),(655,64199,'Paramo del sil'),(655,64201,'Pardave'),(655,64202,'Pardesivil'),(655,64205,'Pedrun de torio'),(655,64208,'Peñalba de los cilleros'),(655,64210,'Villaroquel'),(655,64211,'Villarrin del paramo'),(655,64212,'Villarroañe'),(655,64215,'Villasabariego'),(655,64216,'Villaseca de laciana'),(655,64219,'Villasimpliz'),(655,64222,'Villaturiel'),(655,64225,'Villavente'),(655,64226,'Villaverde de abajo'),(655,64228,'Villaverde de arriba'),(655,64230,'Villaverde de la abadia'),(655,64231,'Villaviciosa de la ribera'),(655,64237,'Villeza'),(655,64239,'Villiguer'),(655,64240,'Villomar'),(655,64241,'Villoria de orbigo'),(655,64243,'Viñayo'),(655,64244,'Virgen del camino la'),(655,64246,'Voces'),(655,64248,'Yeres'),(655,64249,'Yugueros'),(655,64250,'Zacos'),(655,64252,'Zambroncinos del paramo'),(655,64253,'Zotes del paramo'),(655,64254,'Zuares del paramo'),(655,64255,'Zuela'),(655,787182,'Peranzanes'),(655,787185,'Pereje'),(655,787189,'Piedrasecha'),(655,787192,'Pio'),(655,787193,'Piornedo'),(655,787198,'Pobladura de las regueras'),(655,787201,'Pobladura de pelayo garcia'),(655,787203,'Pobladura de yuso'),(655,787204,'Pola de gordon la'),(655,787205,'Poladura de la tercia'),(655,787207,'Pombriego'),(655,787208,'Ponferrada'),(655,787213,'Portela de aguiar'),(655,787219,'Posada del bierzo'),(655,787223,'Prada'),(655,787226,'Pradilla'),(655,787227,'Prado de la guzpeña'),(655,787230,'Priaranza del bierzo'),(655,787232,'Prioro'),(655,787233,'Puebla de lillo'),(655,787234,'Puente almuhey'),(655,787236,'Puente de domingo florez'),(655,787240,'Quintana de monte'),(655,787241,'Quintana de rueda'),(655,787242,'Quintana del castillo'),(655,787243,'Quintana del marco'),(655,787245,'Quintanilla'),(655,787246,'Quintanilla de babia'),(655,787250,'Quintanilla de losada'),(655,787254,'Quintanilla del valle'),(655,787260,'Rabanal del camino'),(655,787262,'Rebollar de los oteros'),(655,787267,'Regueras de arriba'),(655,787268,'Reliegos'),(655,787274,'Requejo'),(655,787276,'Reyero'),(655,787277,'Riaño'),(655,787279,'Ribera la'),(655,787282,'Riego de la vega'),(655,787286,'Rimor'),(655,787287,'Riofrio'),(655,787289,'Rioscuro'),(655,787290,'Rioseco de tapia'),(655,787291,'Riosequino de torio'),(655,787292,'Robla la'),(655,787294,'Robledo de caldas'),(655,787299,'Robles de la valcueva'),(655,787300,'Robles de laciana'),(655,787304,'Rodiezmo'),(655,787309,'Ruitelan'),(655,787310,'Sabero'),(655,787312,'Saelices de payuelo'),(655,787313,'Saelices de sabero'),(655,787314,'Saelices del rio'),(655,787315,'Sahagun'),(655,787316,'Sahechores'),(655,787317,'Salamon'),(655,787318,'Salas de la ribera'),(655,787319,'Salas las'),(655,787320,'Salce'),(655,787322,'Saludes de castroponce'),(655,787324,'San adrian del valle'),(655,787326,'San andres del rabanedo'),(655,787327,'San bartolome de rueda'),(655,787330,'San cipriano del condado'),(655,787332,'San cristobal de la polantera'),(655,787334,'San emiliano'),(655,787339,'San feliz de la valderia'),(655,787340,'San feliz de las lavanderas'),(655,787341,'San feliz de torio'),(655,787343,'San juan de la mata'),(655,787344,'San justo de cabanillas'),(655,787345,'San justo de la vega'),(655,787346,'San lorenzo'),(655,787347,'San mames'),(655,787348,'San marin del camino'),(655,787351,'San martin de la falamosa'),(655,787358,'San miguel de las dueñas'),(655,787360,'San miguel del camino'),(655,787361,'San millan de los caballeros'),(655,787362,'San pedro'),(655,787363,'San pedro bercianos'),(655,787365,'San pedro de las dueñas'),(655,787366,'San pedro de olleros'),(655,787368,'San pedro de trones'),(655,787372,'San roman'),(655,787373,'San roman de bembibre'),(655,787374,'San roman de la vega'),(655,787375,'San roman de los caballeros'),(655,787377,'San vicente del condado'),(655,787379,'Santa ana'),(655,787380,'Santa catalina de somoza'),(655,787382,'Santa colomba de somoza'),(655,787383,'Santa cristina de valmadrigal'),(655,787384,'Santa cruz del sil'),(655,787387,'Santa lucia'),(655,787388,'Santa maria de la isla'),(655,787392,'Santa maria del paramo'),(655,787393,'Santa maria del rio'),(655,787398,'Santa marinica'),(655,787401,'Santa olaja de porma'),(655,787404,'Santas martas'),(655,787405,'Santiago'),(655,787406,'Santiago del molinillo'),(655,787408,'Santibañez de la isla'),(655,787409,'Santibañez de ordas'),(655,787412,'Santibañez'),(655,787414,'Santovenia de la valdoncina'),(655,787415,'Sardonedo'),(655,787416,'Sariegos'),(655,787417,'Seca la'),(655,787420,'Sena de luna'),(655,787421,'Senra'),(655,787423,'Sesamo'),(655,787426,'Silvan'),(655,787432,'Sopeña de carneros'),(655,787433,'Sopeña de curueño'),(655,787434,'Sorbeda del sil'),(655,787437,'Sorribos de alba'),(655,787438,'Sosas de laciana'),(655,787441,'Sotelo'),(655,787444,'Sotillos'),(655,787445,'Soto de la vega'),(655,787447,'Soto de valdeon'),(655,787449,'Soto y amio'),(655,787454,'Suertes'),(655,787455,'Susañe del sil'),(655,787458,'Tabuyo del monte'),(655,787460,'Taranilla'),(655,787462,'Tejedo del sil'),(655,787463,'Tejeira'),(655,787464,'Tejerina'),(655,787466,'Tombrio de abajo'),(655,787468,'Toral'),(655,787469,'Toral de los guzmanes'),(655,787470,'Toral de los vados'),(655,787471,'Toral de merayo'),(655,787472,'Toreno'),(655,787476,'Torre del bierzo'),(655,787478,'Torrestio'),(655,787479,'Trabadelo'),(655,787481,'Trascastro'),(655,787483,'Tremor de arriba'),(655,787484,'Trobajo del cerecedo'),(655,787485,'Truchas'),(655,787487,'Truebano'),(655,787488,'Turcia'),(655,787489,'Turienzo castañero'),(655,787492,'Urdiales del paramo'),(655,787493,'Urz la'),(655,787495,'Val de san lorenzo'),(655,787496,'Valbuena'),(655,787497,'Valbuena de la encomienda'),(655,787498,'Valcavado del paramo'),(655,787499,'Valcueva la'),(655,787501,'Valdavido'),(655,787505,'Valdecastillo'),(655,787507,'Valdefresno'),(655,787510,'Valdelafuente'),(655,787512,'Valdelugueros'),(655,787514,'Valdemora'),(655,787516,'Valdepielago'),(655,787517,'Valdepolo'),(655,787518,'Valderas'),(655,787520,'Valderrueda'),(655,787522,'Valdesandinas'),(655,787529,'Valdevimbre'),(655,787531,'Valduvieco'),(655,787532,'Valencia de don juan'),(655,787535,'Valporquero de rueda'),(655,787539,'Valverde de la virgen'),(655,787540,'Valverde-enrique'),(655,787541,'Valverde'),(655,787543,'Valverdin'),(655,787544,'Valle de finolledo'),(655,787545,'Valle de las casas el'),(655,787547,'Valle de vegacervera'),(655,787550,'Vallejo'),(655,787552,'Vecilla de curueño la'),(655,787553,'Vega de almanza la'),(655,787556,'Vega de espinareda'),(655,787557,'Vega de gordon'),(655,787558,'Vega de infanzones'),(655,787559,'Vega de los arboles'),(655,787562,'Vega de valcarce'),(655,787564,'Vega de yeres'),(655,787565,'Vegacerneja'),(655,787566,'Vegacervera'),(655,787568,'Vegaquemada'),(655,787570,'Vegas del condado'),(655,787571,'Veguellina'),(655,787572,'Veguellina de orbigo'),(655,787575,'Velilla de la reina'),(655,787578,'Velilla la'),(655,787579,'Ventas de albares las'),(655,787583,'Vid la'),(655,787584,'Vidanes'),(655,787589,'Vilaquilambre'),(655,787590,'Villabalter'),(655,787591,'Villabandin'),(655,787592,'Villablino'),(655,787594,'Villaburbula'),(655,787596,'Villacalbiel'),(655,787598,'Villacedre'),(655,787599,'Villacelama'),(655,787601,'Villacil'),(655,787603,'Villacontilde'),(655,787604,'Villadangos del paramo'),(655,787606,'Villademor de la vega'),(655,787607,'Villadepalos'),(655,787609,'Villafale'),(655,787610,'Villafañe'),(655,787611,'Villafeliz de babia'),(655,787612,'Villafer'),(655,787613,'Villafranca del bierzo'),(655,787615,'Villagallegos'),(655,787617,'Villager de laciana'),(655,787618,'Villalboñe'),(655,787624,'Villalobar'),(655,787625,'Villalquite'),(655,787627,'Villamanin'),(655,787628,'Villamañan'),(655,787629,'Villamarco'),(655,787631,'Villamartin del sil'),(655,787632,'Villamayor del condado'),(655,787633,'Villameca'),(655,787634,'Villamejil'),(655,787635,'Villamizar'),(655,787639,'Villamor'),(655,787640,'Villamoratiel de las matas'),(655,787642,'Villamuñio'),(655,787644,'Villanueva'),(655,787645,'Villanueva de carrizo'),(655,787648,'Villanueva de las manzanas'),(655,787650,'Villaobispo'),(655,787652,'Villaornate'),(655,787653,'Villapadierna'),(655,787655,'Villaquejida'),(655,787660,'Villar de las traviesas'),(655,787661,'Villar de mazarife'),(655,787668,'Villarejo de orbigo'),(655,787669,'Villarente'),(655,787670,'Villares de orbigo'),(655,787672,'Villarino'),(655,787676,'Villarmun'),(655,787677,'Villarnera'),(656,64256,'Alaior'),(656,64257,'Alaró'),(656,64258,'Alcúdia'),(656,64259,'Algaida'),(656,64260,'Alqueria blanca'),(656,64261,'Andratx'),(656,64262,'Aranjassa s\''),(656,64263,'Arenal s\''),(656,64264,'Ariany'),(656,64265,'Arraco s\''),(656,64266,'Artá'),(656,64267,'Banyos de sant joan'),(656,64268,'Bayalbufar'),(656,64269,'Biniamar'),(656,64270,'Biniaraix'),(656,64271,'Binibeca'),(656,64272,'Binissalem'),(656,64273,'Buger'),(656,64274,'Bunyola'),(656,64275,'Cabaneta sa'),(656,64276,'Caimari'),(656,64277,'Cala blava'),(656,64278,'Cala bona'),(656,64279,'Cala d\'alcaufar'),(656,64280,'Cala d\'or'),(656,64281,'Cala en porter'),(656,64282,'Cala figuera'),(656,64283,'Cala gracio'),(656,64284,'Cala millor'),(656,64285,'Cala moreia'),(656,64286,'Cala morell'),(656,64287,'Cala morlanda'),(656,64288,'Cala murada'),(656,64289,'Cala ratjada'),(656,64290,'Cala santa galdana'),(656,64291,'Calo es'),(656,64292,'Calonge'),(656,64293,'Calviá'),(656,64294,'Campanet'),(656,64295,'Campos del port'),(656,64296,'Can clavo'),(656,64297,'Can creu'),(656,64298,'Can pastilla'),(656,64299,'Can picafort'),(656,64300,'Can singala'),(656,64301,'Canal sa'),(656,64302,'Canar es'),(656,64303,'Capdella'),(656,64304,'Capdepera'),(656,64305,'Cas catala'),(656,64306,'Cas concos'),(656,64307,'Casa blanca sa'),(656,64308,'Cases novas'),(656,64309,'Cases vellas de formentor'),(656,64310,'Es Castell'),(656,64311,'Ciutadella de Menorca'),(656,64312,'Colonia de sant jordi'),(656,64313,'Colonia de sant pere sa'),(656,64314,'Coll d\'en rabassa'),(656,64315,'Consell'),(656,64316,'Costitx'),(656,64317,'Creu vermella sa'),(656,64318,'Deia'),(656,64319,'Eivissa'),(656,64320,'Escorca'),(656,64321,'Esporles'),(656,64322,'Establiments'),(656,64323,'Estanyol de mitjorn'),(656,64324,'Estellencs'),(656,64325,'Felanitx'),(656,64326,'Ferreries'),(656,64327,'Fornalutx'),(656,64328,'Fornells'),(656,64329,'Galilea'),(656,64330,'Genova'),(656,64331,'Inca'),(656,64332,'Jesus'),(656,64333,'Llombards es'),(656,64334,'Lloret de vista alegre'),(656,64335,'Lloseta'),(656,64336,'Llubi'),(656,64337,'Llucalcari'),(656,64338,'Llucmajor'),(656,64339,'Mahon'),(656,64340,'Manacor'),(656,64341,'Mancor de la vall'),(656,64342,'Maria de la Salut'),(656,64343,'Marratxí'),(656,64344,'Es Mercadal'),(656,64346,'Migjorn gran es'),(656,64347,'Montuiri'),(656,64348,'Moscari'),(656,64349,'Muro'),(656,64350,'Orient'),(656,64351,'Palma de Mallorca'),(656,64352,'Palma nova'),(656,64353,'Palmer es'),(656,64354,'Peguera'),(656,64355,'Petra'),(656,64356,'Pina'),(656,64357,'Sa Pobla'),(656,64358,'Pollença'),(656,64359,'Pont d\'inca'),(656,64360,'Porreres'),(656,64361,'Port d\'andratx'),(656,64362,'Port de soller'),(656,64363,'Port es'),(656,64364,'Portal nous'),(656,64365,'Portinatx'),(656,64366,'Porto colom'),(656,64367,'Porto cristo'),(656,64368,'Porto petro'),(656,64369,'Puigpunyent'),(656,64370,'Pujols es'),(656,64371,'Punta prima'),(656,64372,'S_esgleieta'),(656,64373,'Sa rapita'),(656,64374,'Sant agusti'),(656,64375,'Sant antoni abat'),(656,64376,'Sant climent'),(656,64377,'Sant ferran'),(656,64378,'Sant francesc de formentera'),(656,64379,'Sant francesc de ses salines'),(656,64380,'Sant jaume'),(656,64381,'Sant Joan'),(656,64382,'Sant joan baptista'),(656,64383,'Sant jordi'),(656,64384,'Sant Josep'),(656,64385,'Sant Llorenç des Cardassar'),(656,64386,'Sant Lluís'),(656,64387,'Sant mateu'),(656,64388,'Sant miquel'),(656,64389,'Sant rafel'),(656,64390,'Sant telm'),(656,64391,'Sant tomas'),(656,64392,'Santa agnes'),(656,64393,'Santa eugenia'),(656,64394,'Santa Eulalia des Riu'),(656,64395,'Santa gertrudis'),(656,64396,'Santa Margalida'),(656,64397,'Santa María del Camí'),(656,64398,'Santa ponça'),(656,64399,'Santanyí'),(656,64400,'Sant. agustin'),(656,64401,'Sant. carles'),(656,64402,'Sant. jordi'),(656,64403,'Sant. vicent'),(656,64404,'Savina sa'),(656,64405,'Seca de la real'),(656,64406,'Selva'),(656,64407,'Sencelles'),(656,64409,'Ses salines'),(656,64410,'Sineu'),(656,64411,'Sóller'),(656,64412,'Solleric'),(656,64413,'Son ferriol'),(656,64414,'Son sardina'),(656,64415,'Son serra'),(656,64416,'Son Servera'),(656,64417,'Talamanca'),(656,64418,'Valldemossa'),(656,64419,'Verge des pilar sa'),(656,64420,'Vilafranca de Bonany'),(657,64421,'Abajas'),(657,64422,'Acedillo'),(657,64423,'Adrada de haza'),(657,64424,'Ages'),(657,64425,'Aguas candidas'),(657,64426,'Aguera'),(657,64427,'Aguilar de bureba'),(657,64428,'Aguilera la'),(657,64429,'Aguillo'),(657,64431,'Ajarte'),(657,64432,'Alarcia'),(657,64433,'Alba'),(657,64434,'Albaina'),(657,64435,'Albillos'),(657,64436,'Alcocero de mola'),(657,64437,'Aldea del pinar'),(657,64438,'Aldea del portillo del busto'),(657,64441,'Amaya'),(657,64443,'Angosto'),(657,64444,'Anguix'),(657,64445,'Angulo'),(657,64446,'Anzo'),(657,64447,'Añastro'),(657,64449,'Aranda de Duero'),(657,64450,'Arandilla'),(657,64451,'Arauzo de miel'),(657,64452,'Arauzo de salce'),(657,64453,'Arauzo de torre'),(657,64455,'Arconada'),(657,64456,'Arcos'),(657,64457,'Arenillas de muño'),(657,64458,'Arenillas de riopisuerga'),(657,64459,'Arenillas de villadiego'),(657,64461,'Arija'),(657,64462,'Arlanzon'),(657,64463,'Armentia'),(657,64464,'Arnedo'),(657,64467,'Arrieta'),(657,64468,'Arroyal'),(657,64473,'Atapuerca'),(657,64475,'Avellanosa del paramo'),(657,64477,'Ayuelas'),(657,64478,'Bahabon de esgueva'),(657,64479,'Bajauri'),(657,64480,'Balbases los'),(657,64482,'Baños de valdearados'),(657,64483,'Bañuelos de bureba'),(657,64486,'Barbadillo de herreros'),(657,64487,'Barbadillo del mercado'),(657,64488,'Barbadillo del pez'),(657,64489,'Barcenas'),(657,64490,'Barcenillas de cerezos'),(657,64491,'Barcenillas del ribero'),(657,64493,'Barcina del barco'),(657,64494,'Barrasa'),(657,64495,'Barriga'),(657,64497,'Barrio de diaz ruiz'),(657,64499,'Barrio-panizares'),(657,64500,'Barrios de bureba los'),(657,64501,'Barrios de colina'),(657,64502,'Barrios de villadiego'),(657,64508,'Bascuñana'),(657,64509,'Bascuñuelos'),(657,64510,'Bayas'),(657,64511,'Bedon'),(657,64513,'Belorado'),(657,64514,'Bentretea'),(657,64515,'Berberana'),(657,64520,'Bezana'),(657,64522,'Boada de roa'),(657,64526,'Boveda de la ribera'),(657,64527,'Bozoo'),(657,64532,'Briviesca'),(657,64535,'Bugedo'),(657,64536,'Buniel'),(657,64537,'Burceña'),(657,64538,'Burgos'),(657,64539,'Busnela'),(657,64541,'Busto de bureba'),(657,64543,'Cabañas de virtus'),(657,64544,'Cabañes de esgueva'),(657,64545,'Cabezon de la sierra'),(657,64546,'Cabia'),(657,64547,'Caborredondo'),(657,64549,'Caleruega'),(657,64558,'Canicosa de la sierra'),(657,64560,'Cantabrana'),(657,64563,'Carazo'),(657,64564,'Carcedo de burgos'),(657,64565,'Cardeñadijo'),(657,64566,'Cardeñajimeno'),(657,64567,'Cardeñuel-riopico'),(657,64569,'Casanova'),(657,64571,'Cascajares de la sierra'),(657,64572,'Casillas'),(657,64573,'Castañares'),(657,64584,'Castrillo de la vega'),(657,64585,'Castrillo de murcia'),(657,64588,'Castrillo de solarana'),(657,64589,'Castrillo del val'),(657,64591,'Castrojeriz'),(657,64593,'Cayuela'),(657,64595,'Cebrecos'),(657,64597,'Celadas las'),(657,64599,'Cerezo de riotiron'),(657,64600,'Cernegula'),(657,64602,'Cespedes'),(657,64603,'Ciadoncha'),(657,64604,'Ciella'),(657,64606,'Cilleruelo de arriba'),(657,64607,'Cilleruelo de bezana'),(657,64608,'Ciruelos de cervera'),(657,64611,'Cogollos'),(657,64620,'Cotar'),(657,64622,'Covarrubias'),(657,64623,'Crespo'),(657,64631,'Cucho'),(657,64633,'Cueva de juarros'),(657,64637,'Cuevas de san clemente'),(657,64640,'C. de bureba'),(657,64641,'Dobro'),(657,64651,'Escaño'),(657,64653,'Escobados de arriba'),(657,64654,'Escuderos'),(657,64656,'Espinosa de los Monteros'),(657,64659,'Estepar'),(657,64660,'Eterna'),(657,64663,'Frandovinez'),(657,64665,'Fresnedo'),(657,64667,'Fresnillo de dueñas'),(657,64669,'Fresno de riotiron'),(657,64670,'Fresno de rodilla'),(657,64671,'Frias'),(657,64674,'Fuente urbel'),(657,64675,'Fuentebureba'),(657,64676,'Fuentecen'),(657,64677,'Fuentelcesped'),(657,64679,'Fuentemolinos'),(657,64680,'Fuentenebro'),(657,64681,'Fuentespina'),(657,64683,'Galarde'),(657,64684,'Galbarros'),(657,64685,'Gallega la'),(657,64689,'Gijano'),(657,64690,'Golernio'),(657,64694,'Guadilla de villamar'),(657,64696,'Gumiel de hizan'),(657,64697,'Gumiel de mercado'),(657,64698,'Guzman'),(657,64703,'Haza'),(657,64705,'Hermosilla'),(657,64713,'Hinojar del rey'),(657,64715,'Hontanas'),(657,64720,'Hontoria del pinar'),(657,64721,'Hormaza'),(657,64722,'Hormazuela'),(657,64728,'Horra la'),(657,64731,'Hoyales de roa'),(657,64734,'Hoz de arreba'),(657,64737,'Hozalla'),(657,64739,'Huerta de abajo'),(657,64741,'Huerta del rey'),(657,64745,'Humienta'),(657,64746,'Hurones'),(657,64747,'Ibeas de juarros'),(657,64751,'Iglesias'),(657,64753,'Ircio'),(657,64754,'Irus'),(657,64755,'Isar'),(657,64756,'Itero del castillo'),(657,64757,'Jaramillo de la fuente'),(657,64760,'Laño'),(657,64762,'Las quintanillas'),(657,64769,'Lerma'),(657,64771,'Leva'),(657,64773,'Linares'),(657,64779,'Lorilla'),(657,64781,'Llano de bureba'),(657,64783,'Madrid de las caderechas'),(657,64786,'Mahamud'),(657,64787,'Maltrana'),(657,64798,'Mata'),(657,64802,'Mazuela'),(657,64804,'Mecerreyes'),(657,64806,'Medina de Pomar'),(657,64807,'Melgar de fernamental'),(657,64814,'Milagros'),(657,64815,'Miñon'),(657,64817,'Miranda de Ebro'),(657,64818,'Miraveche'),(657,64820,'Modubar de la emparedada'),(657,64823,'Momediano'),(657,64824,'Monasterio de la sierra'),(657,64828,'Moneo'),(657,64831,'Montejo de cebas'),(657,64832,'Monterrubio de demanda'),(657,64834,'Montorio'),(657,64835,'Montoto'),(657,64836,'Montuenga'),(657,64855,'Nebreda'),(657,64856,'Neila'),(657,64860,'Nofuentes'),(657,64869,'Olmillos de sasamon'),(657,64872,'Oña'),(657,64875,'Orbaneja-riopico'),(657,64876,'Orbañanos'),(657,64879,'Orden la'),(657,64880,'Oron'),(657,64881,'Oteo'),(657,64882,'Padilla de abajo'),(657,64886,'Palacios de la sierra'),(657,64890,'Palazuelos de muño'),(657,64891,'Palazuelos de villadiego'),(657,64892,'Pampliega'),(657,64893,'Pancorbo'),(657,64897,'Pardilla'),(657,64899,'Pariza'),(657,64902,'Paules de agua'),(657,64904,'Pedrosa'),(657,64906,'Pedrosa de muño'),(657,64907,'Pedrosa de rio urbel'),(657,64908,'Pedrosa de tobalina'),(657,64909,'Pedrosa del paramo'),(657,64910,'Pedrosa del principe'),(657,64915,'Peñaranda de duero'),(657,64917,'Peral de arlanza'),(657,64920,'Pesadas de burgos'),(657,64924,'Pineda de la sierra'),(657,64929,'Pinilla-trasmonte'),(657,64933,'Poza de la sal'),(657,64938,'Pradoluengo'),(657,64939,'Presencio'),(657,64941,'Puebla del arganzon la'),(657,64942,'Puente arenas'),(657,64944,'Puentedura'),(657,64946,'Puras de villafranca'),(657,64948,'Quemada'),(657,64950,'Quintana de los prados'),(657,64955,'Quintana-martin galindez'),(657,64960,'Quintanadueñas'),(657,64966,'Quintanaopio'),(657,64967,'Quintanaortuño'),(657,64969,'Quintanar de la sierra'),(657,64974,'Quintanavides'),(657,64978,'Quintanilla de la mata'),(657,64982,'Quintanilla de pienza'),(657,64985,'Quintanilla del agua'),(657,64986,'Quintanilla del coco'),(657,64988,'Quintanilla-escalada'),(657,64992,'Quintanilla-somuño'),(657,64995,'Quintanilla-vivar'),(657,64996,'Quintanillabon'),(657,65001,'Rabe de los escuderos'),(657,65002,'Ranera'),(657,65007,'Redecilla del camino'),(657,65008,'Redecilla del campo'),(657,65009,'Regumiel de la sierra'),(657,65023,'Revillarruz'),(657,65027,'Ribota de ordunte'),(657,65028,'Rio de losa'),(657,65036,'Rioseras'),(657,65037,'Roa'),(657,65040,'Robredo-temiño'),(657,65042,'Ros'),(657,65046,'Rubena'),(657,65049,'Rucandio'),(657,65055,'Salas de los Infantes'),(657,65056,'Salazar'),(657,65058,'Saldaña de burgos'),(657,65059,'Salguero de juarros'),(657,65068,'San felices'),(657,65069,'San juan'),(657,65073,'San llorente de la vega'),(657,65075,'San mames de burgos'),(657,65077,'San martin de humada'),(657,65080,'San martin de rubiales'),(657,65081,'San martin de ubierna'),(657,65086,'San miguel de pedroso'),(657,65092,'San pedro samuel'),(657,65094,'San quirce'),(657,65099,'Sandoval de la reina'),(657,65100,'Santa cecilia'),(657,65104,'Santa cruz de juarros'),(657,65105,'Santa cruz de la salceda'),(657,65107,'Santa cruz del valle urbion'),(657,65109,'Santa gadea del cid'),(657,65110,'Santa ines'),(657,65112,'Santa maria de mercadillo'),(657,65113,'Santa maria del campo'),(657,65115,'Santa maria-ribarredonda'),(657,65125,'Santibañez-zarzaguda'),(657,65128,'Santo domingo de silos'),(657,65131,'Santovenia de oca'),(657,65135,'Sarracin'),(657,65136,'Sasamon'),(657,65138,'Sedano'),(657,65140,'Sinovas'),(657,65145,'Soncillo'),(657,65148,'Sotillo de la ribera'),(657,65149,'Sotopalacios'),(657,65150,'Sotovellanos'),(657,65151,'Sotragero'),(657,65157,'Tagarrosa'),(657,65159,'Tamaron'),(657,65160,'Tapia'),(657,65162,'Tardajos'),(657,65166,'Termiño'),(657,65168,'Terradillos de sedano'),(657,65169,'Terrazas'),(657,65176,'Tobera'),(657,65178,'Tolbaños de abajo'),(657,65179,'Tolbaños de arriba'),(657,65186,'Torrelara'),(657,65188,'Torrepadre'),(657,65189,'Torres'),(657,65192,'Torresandino'),(657,65193,'Tortoles de esgueva'),(657,65196,'Tremellos los'),(657,65197,'Trespaderne'),(657,65198,'Treviño'),(657,65200,'Tubilla del agua'),(657,65201,'Tubilla del lago'),(657,65204,'Ubierna'),(657,65206,'Urbel del castillo'),(657,65207,'Urrez'),(657,65208,'Vadocondes'),(657,65220,'Valdorros'),(657,65222,'Valmala'),(657,65225,'Valverde'),(657,65229,'Vallejo de Mena'),(657,65233,'Vallunquera'),(657,65234,'Vegas las'),(657,65240,'Vileña'),(657,65242,'Vilviestre del pinar'),(657,65248,'Villadiego'),(657,65255,'Villafria de burgos'),(657,65256,'Villafria de san zadornil'),(657,65258,'Villafuertes'),(657,65260,'Villagonzalo-pedernales'),(657,65264,'Villahizan de treviño'),(657,65265,'Villahoz'),(657,65266,'Villalacre'),(657,65269,'Villalba de duero'),(657,65270,'Villalba de losa'),(657,65271,'Villalbilla de burgos'),(657,65272,'Villalbilla de gumiel'),(657,65276,'Villalmanzo'),(657,65280,'Villaluenga'),(657,65282,'Villamartin de villadiego'),(657,65283,'Villamayor de los montes'),(657,65285,'Villamayor del rio'),(657,65288,'Villamezan'),(657,65290,'Villamiel de muño'),(657,65292,'Villamoron'),(657,65293,'Villamudria'),(657,65295,'Villandiego'),(657,65298,'Villanueva de argaña'),(657,65301,'Villanueva de la oca'),(657,65304,'Villanueva de puerta'),(657,65307,'Villanueva la blanca'),(657,65308,'Villanueva-matamala'),(657,65312,'Villarcayo'),(657,65314,'Villariezo'),(657,65315,'Villarmero'),(657,65317,'Villasana de mena'),(657,65319,'Villasante'),(657,65321,'Villasilos'),(657,65322,'Villasur de herreros'),(657,65323,'Villataras'),(657,65326,'Villatoro'),(657,65329,'Villavedeo'),(657,65332,'Villaverde del monte'),(657,65340,'Villimar'),(657,65344,'Villovela de esgueva'),(657,65346,'Villusto'),(657,65350,'Vivar del cid'),(657,65351,'Vizcainos'),(657,65355,'Zael'),(657,65356,'Zalduendo'),(657,65360,'Zumel'),(657,65362,'Zurbitu'),(657,65363,'Zuzones'),(658,65364,'Abellada'),(658,65365,'Abenozas'),(658,65366,'Abi'),(658,65367,'Abiego'),(658,65368,'Abizanda'),(658,65369,'Acin'),(658,65370,'Acumuer'),(658,65371,'Adahuesca'),(658,65372,'Aguas'),(658,65375,'Aguilar'),(658,65376,'Aguinaliu'),(658,65377,'Aineto'),(658,65378,'Ainsa sobrarbe'),(658,65379,'Aisa'),(658,65380,'Alacort'),(658,65382,'Alastuey'),(658,65383,'Albalate de cinca'),(658,65384,'Albalatillo'),(658,65385,'Albelda'),(658,65386,'Albella'),(658,65387,'Albero alto'),(658,65388,'Albero bajo'),(658,65389,'Alberuela de liena'),(658,65390,'Alberuela de tubo'),(658,65393,'Alcampell'),(658,65395,'Alcolea de cinca'),(658,65396,'Alcubierre'),(658,65404,'Almudévar'),(658,65405,'Almunia de san juan'),(658,65408,'Almuniente'),(658,65409,'Alquezar'),(658,65410,'Altorricon'),(658,65412,'Anciles'),(658,65413,'Aneto'),(658,65416,'Anso'),(658,65421,'Ara'),(658,65424,'Aragues del puerto'),(658,65426,'Arascues'),(658,65428,'Arbanies'),(658,65432,'Aren'),(658,65441,'Artasona'),(658,65443,'Arto'),(658,65450,'Asques'),(658,65456,'Ayerbe'),(658,65459,'Azara'),(658,65461,'Azpe'),(658,65466,'Bailo'),(658,65467,'Baldellou'),(658,65470,'Ballobar'),(658,65473,'Banastas'),(658,65479,'Barbaruens'),(658,65480,'Barbastro'),(658,65482,'Barbues'),(658,65487,'Basaran'),(658,65488,'Bastaras'),(658,65489,'Belber de cinca'),(658,65491,'Belsierre'),(658,65495,'Benabarre'),(658,65496,'Benasque'),(658,65501,'Berbegal'),(658,65505,'Bernues'),(658,65515,'Bielsa'),(658,65516,'Bierge'),(658,65517,'Biescas'),(658,65519,'Binaced'),(658,65521,'Binéfar'),(658,65527,'Bolea'),(658,65528,'Boltaña'),(658,65529,'Bonansa'),(658,65532,'Borau'),(658,65536,'Broto'),(658,65538,'Buera'),(658,65539,'Buerba'),(658,65543,'Burceat'),(658,65550,'Caldearenas'),(658,65552,'Callen'),(658,65553,'Campamento'),(658,65554,'Campo'),(658,65559,'Candasnos'),(658,65560,'Canfranc'),(658,65564,'Capdesaso'),(658,65568,'Cartuja de monegros la'),(658,65571,'Casanovas'),(658,65573,'Casbas de huesca'),(658,65580,'Castejon de monegros'),(658,65582,'Castejon de sos'),(658,65584,'Castelflorite'),(658,65587,'Castigaleu'),(658,65589,'Castillazuelo'),(658,65598,'Cerler'),(658,65601,'Cofita'),(658,65603,'Corrales los'),(658,65610,'Cregenzan'),(658,65612,'Cuarte'),(658,65624,'Enate'),(658,65627,'Eresue'),(658,65629,'Eriste'),(658,65630,'Escalona'),(658,65641,'Espierre'),(658,65644,'Esplus'),(658,65648,'Estada'),(658,65649,'Estadilla'),(658,65654,'Estopiñan del castillo'),(658,65655,'Fago'),(658,65658,'Fañanas'),(658,65659,'Fenillosa'),(658,65662,'Fiscal'),(658,65664,'Fonz'),(658,65667,'Formigales'),(658,65668,'Fornillos'),(658,65670,'Fosado alto'),(658,65672,'Fraga'),(658,65673,'Fragen'),(658,65674,'Frula'),(658,65678,'Gavin'),(658,65683,'Gistain'),(658,65684,'Grado el'),(658,65685,'Grañén'),(658,65686,'Graus'),(658,65688,'Gsel'),(658,65690,'Guasillo'),(658,65692,'Gurrea de gallego'),(658,65693,'Hecho'),(658,65694,'Hospitaled'),(658,65696,'Hoz de barbastro'),(658,65698,'Huerrios'),(658,65700,'Huerto'),(658,65701,'Huesca'),(658,65704,'Ibieca'),(658,65705,'Igries'),(658,65706,'Ilche'),(658,65710,'Isin'),(658,65712,'Jaca'),(658,65713,'Janovas'),(658,65714,'Jasa'),(658,65720,'Juseu'),(658,65721,'Labata'),(658,65722,'Labuerda'),(658,65725,'Laguarres'),(658,65727,'Lagunarota'),(658,65729,'Lalueza'),(658,65731,'Lanaja'),(658,65734,'Laperdiguera'),(658,65746,'Laspaules'),(658,65747,'Laspuña'),(658,65755,'Leres'),(658,65764,'Loarre'),(658,65768,'Lupiñen'),(658,65774,'Martes'),(658,65775,'Martillue'),(658,65780,'Miralsot'),(658,65784,'Mondot'),(658,65787,'Monflorite las casas'),(658,65788,'Mongay'),(658,65792,'Montanuy'),(658,65796,'Montmesa'),(658,65797,'Monzón'),(658,65810,'Naval'),(658,65820,'Nueno'),(658,65824,'Olson'),(658,65826,'Ontiñena'),(658,65828,'Orillena'),(658,65831,'Oros bajo'),(658,65832,'Ortilla'),(658,65837,'Osso de cinca'),(658,65840,'Oto'),(658,65845,'Panticosa'),(658,65846,'Panzano'),(658,65847,'Pardina la'),(658,65850,'Paternoy'),(658,65855,'Peñalba'),(658,65856,'Peralta de alcofea'),(658,65860,'Permisan'),(658,65861,'Pertusa'),(658,65862,'Piedrafita de jaca'),(658,65865,'Piraces'),(658,65866,'Plan'),(658,65869,'Poleñino'),(658,65871,'Pomar'),(658,65872,'Pompenillo'),(658,65874,'Puebla de castro la'),(658,65875,'Puebla de fantova la'),(658,65877,'Puebla de roda la'),(658,65885,'Pueyo de fañanas'),(658,65888,'Pueyo de santa cruz'),(658,65891,'Purroy de la solana'),(658,65895,'Quicena'),(658,65896,'Quinzano'),(658,65898,'Ramastue'),(658,65902,'Riglos'),(658,65905,'Robres'),(658,65906,'Rocafor'),(658,65908,'Rodellar'),(658,65909,'Run el'),(658,65911,'Sabiñánigo'),(658,65918,'Salillas'),(658,65923,'Salinas de trillo'),(658,65924,'Sallent de gallego'),(658,65926,'Samper'),(658,65928,'San esteban de litera'),(658,65933,'San juan del flumen'),(658,65947,'Sangarren'),(658,65954,'Santa lecina'),(658,65956,'Santa lucia'),(658,65960,'Santorens'),(658,65963,'Sardas'),(658,65964,'Sariñena'),(658,65965,'Sarsa de surta'),(658,65966,'Sarsamarcuello'),(658,65967,'Sarvise'),(658,65974,'Seira'),(658,65977,'Senegues'),(658,65986,'Sesa'),(658,65987,'Sesue'),(658,65991,'Sietamo'),(658,65994,'Sinues'),(658,66004,'Sorripas'),(658,66009,'Tamarite de Litera'),(658,66010,'Tardienta'),(658,66012,'Temple el'),(658,66014,'Tierz'),(658,66015,'Tolva'),(658,66023,'Torrelisa'),(658,66024,'Torrente de cinca'),(658,66025,'Torres de alcanadre'),(658,66026,'Torres de barbues'),(658,66027,'Torres de montes'),(658,66031,'Torruellola de la plana'),(658,66032,'Tramacastilla de tena'),(658,66043,'Valcarca'),(658,66046,'Valsalada'),(658,66047,'Velilla del cinca'),(658,66048,'Velillas'),(658,66049,'Vencillon'),(658,66055,'Villanova'),(658,66056,'Villanovilla'),(658,66057,'Villanua'),(658,66064,'Viu'),(658,66069,'Yesero'),(658,66070,'Yeste'),(658,66073,'Zaidin'),(658,66074,'Zurita'),(658,66075,'Zuriza'),(659,66076,'Abandames'),(659,66077,'Acebal'),(659,66078,'Aciera'),(659,66079,'Agones'),(659,66080,'Aguamestas'),(659,66081,'Aguda'),(659,66082,'Aguera'),(659,66084,'Alava'),(659,66085,'Alea'),(659,66086,'Alesga'),(659,66087,'Alevia'),(659,66088,'Almuña'),(659,66089,'Almurce'),(659,66090,'Alles'),(659,66091,'Ambiedes'),(659,66092,'Amieva'),(659,66093,'Andes'),(659,66094,'Andrin'),(659,66095,'Anes'),(659,66096,'Anieves'),(659,66097,'Anleo'),(659,66098,'Antoñana'),(659,66099,'Antromero'),(659,66100,'Arancedo'),(659,66101,'Arangas'),(659,66102,'Arboleya'),(659,66104,'Arbon'),(659,66105,'Arcallana'),(659,66106,'Arcellana'),(659,66107,'Ardisana'),(659,66108,'La Arena'),(659,66109,'Las Arenas'),(659,66111,'Arenas'),(659,66114,'Arganza'),(659,66115,'Argañosa'),(659,66116,'Argañoso'),(659,66117,'Arguero'),(659,66118,'Argul'),(659,66119,'Arlos'),(659,66120,'Armada'),(659,66121,'Arriondas'),(659,66122,'Arroes'),(659,66123,'Arrojo'),(659,66124,'Artedo'),(659,66125,'Artedosa'),(659,66126,'Asiego'),(659,66127,'Aveno'),(659,66128,'Avilés'),(659,66129,'Ayones'),(659,66130,'Balbona'),(659,66131,'Balmonte'),(659,66132,'Balmori'),(659,66133,'Ballota'),(659,66134,'Bandujo'),(659,66135,'Bañugues'),(659,66136,'Barcia'),(659,66138,'Barredos'),(659,66139,'Barres'),(659,66140,'Barro'),(659,66141,'Barzana'),(659,66142,'Barzana del Monasterio'),(659,66143,'Barzano'),(659,66145,'Bayo'),(659,66147,'San Juan de Beleño'),(659,66149,'Belmonte'),(659,66151,'Bello'),(659,66152,'Bendición'),(659,66153,'Benia'),(659,66155,'Berducedo'),(659,66157,'Bernueces'),(659,66159,'Besullo'),(659,66161,'Biescas'),(659,66162,'Bimeda'),(659,66163,'Blimea'),(659,66164,'Boal'),(659,66166,'Boinas'),(659,66167,'Boiro'),(659,66169,'Boo'),(659,66170,'Boquerizo'),(659,66171,'Borbolla'),(659,66172,'Borres'),(659,66174,'Brañalonga'),(659,66175,'Brañavieja'),(659,66176,'Brañes'),(659,66177,'Brañuas'),(659,66180,'Brieves'),(659,66182,'Buelna'),(659,66188,'Buseco'),(659,66189,'Buslavin'),(659,66192,'Busmeon'),(659,66194,'La Busta'),(659,66196,'Bustapena'),(659,66197,'Bustiello'),(659,66198,'Bustio'),(659,66199,'Busto'),(659,66200,'Bustoto'),(659,66201,'Cabañaquinta'),(659,66203,'Caborana'),(659,66205,'Caborno'),(659,66206,'Los Cabos'),(659,66207,'Cabruñana'),(659,66208,'Cabueñes'),(659,66209,'Cadavedo'),(659,66210,'Cadenaba'),(659,66211,'Las Caldas'),(659,66212,'Caleao'),(659,66213,'Los Callejos'),(659,66214,'Callezuela'),(659,66215,'Camarmeña'),(659,66216,'Camas'),(659,66217,'La Camocha'),(659,66218,'Campañones'),(659,66219,'Campo de Caso'),(659,66220,'Campomanes'),(659,66222,'Camuño'),(659,66223,'Cancienes'),(659,66225,'Candanedo'),(659,66226,'Candas'),(659,66227,'Canero'),(659,66228,'Canga'),(659,66229,'Cangas de Narcea'),(659,66230,'Cangas de Onís'),(659,66232,'Cañedo'),(659,66233,'Caño'),(659,66234,'Carabanzo'),(659,66238,'Carballo'),(659,66239,'Carbayin'),(659,66242,'Carcarosa'),(659,66243,'Carcedo'),(659,66244,'Cardo'),(659,66246,'La Caridad'),(659,66247,'El Carmen'),(659,66249,'Carreña'),(659,66250,'Los Carriles'),(659,66251,'Cartavio'),(659,66252,'Casomera'),(659,66255,'Castañedo'),(659,66257,'Castiello'),(659,66259,'Castrillón'),(659,66260,'Castropol'),(659,66262,'Caunedo'),(659,66263,'Cayes'),(659,66264,'Cazo'),(659,66265,'Ceceda'),(659,66267,'Cedemonio'),(659,66268,'Celorio'),(659,66269,'Cemango'),(659,66270,'Ceneya'),(659,66274,'Cereijeria'),(659,66275,'Cerredo'),(659,66276,'Cervera'),(659,66277,'Ciaño'),(659,66279,'Cibuyo'),(659,66281,'Coalla'),(659,66282,'Coaña'),(659,66284,'Coba'),(659,66285,'Coceña'),(659,66286,'Cofiño'),(659,66287,'Cogollo'),(659,66288,'Colombres'),(659,66289,'Colunga'),(659,66290,'Collada'),(659,66291,'Collanzo'),(659,66292,'Collia'),(659,66293,'Colloto'),(659,66294,'El Condado'),(659,66296,'Corao'),(659,66300,'Corigos'),(659,66302,'Cornellana'),(659,66305,'La Corrada'),(659,66306,'Corralin'),(659,66307,'La Corredona'),(659,66308,'Corros'),(659,66309,'Cortina'),(659,66311,'El Crucero'),(659,66312,'La Cruz'),(659,66314,'El Cuadro'),(659,66315,'Cudillero'),(659,66316,'Cue'),(659,66318,'Cuerrias'),(659,66319,'Las Cuestas'),(659,66320,'La Cueva'),(659,66321,'Cuevas'),(659,66324,'Degaña'),(659,66326,'Deva'),(659,66327,'Doriga'),(659,66328,'Las Dueñas'),(659,66329,'Endriga'),(659,66331,'El Entrego'),(659,66332,'Entrepeñas'),(659,66334,'El Escamplero'),(659,66336,'La Espina'),(659,66339,'Faedal'),(659,66340,'Faedo'),(659,66341,'Fano'),(659,66342,'Felechosa'),(659,66343,'Felgueras'),(659,66344,'La Felguerina'),(659,66345,'Fenolleda'),(659,66346,'La Figal'),(659,66347,'La Figar'),(659,66348,'Figaredo'),(659,66349,'Figares'),(659,66350,'La Figuerina'),(659,66352,'La Florida'),(659,66353,'Folgueiras'),(659,66354,'Fondos de la Vega'),(659,66355,'Fornos'),(659,66356,'La Foz'),(659,66357,'La Franca'),(659,66358,'El Franco'),(659,66359,'La Fresneda'),(659,66360,'Fresnedo'),(659,66365,'Fuensanta'),(659,66367,'Fuentes de las Montañas'),(659,66368,'Gamonedo'),(659,66369,'Gargantada'),(659,66370,'Gedrez'),(659,66371,'Genestoso'),(659,66372,'Gera'),(659,66374,'Gijón'),(659,66375,'Giranes'),(659,66377,'Godan'),(659,66378,'Goje'),(659,66379,'Grado'),(659,66380,'Granda'),(659,66381,'Grandas de Salime'),(659,66382,'Grandiella'),(659,66384,'Grullos'),(659,66386,'Heria'),(659,66387,'Hevia'),(659,66388,'Hospital'),(659,66391,'Iguanzo'),(659,66392,'Illano'),(659,66394,'Infiesto'),(659,66396,'La Isla'),(659,66399,'Javita'),(659,66400,'Jomezana'),(659,66401,'Labra'),(659,66404,'Lago'),(659,66405,'Langreo'),(659,66406,'Lantero'),(659,66408,'Lastres'),(659,66409,'Lavares'),(659,66412,'Leitariegos'),(659,66414,'Levinco'),(659,66416,'Lieres'),(659,66417,'Limanes'),(659,66419,'Linares'),(659,66422,'Lindes'),(659,66423,'Logresana'),(659,66424,'Loredo'),(659,66427,'Loza'),(659,66428,'Luanco'),(659,66429,'Luarca'),(659,66431,'Lue'),(659,66432,'Lugo de Llanera'),(659,66433,'Lugones'),(659,66434,'Luiña'),(659,66437,'Llamigo'),(659,66439,'Llamoso'),(659,66440,'Las Llanas'),(659,66443,'Llanes'),(659,66445,'El Llano'),(659,66447,'Llanos'),(659,66449,'Llantrales'),(659,66452,'Llerices'),(659,66453,'Llonin'),(659,66454,'Llovio'),(659,66456,'Manzaneda'),(659,66459,'Mar'),(659,66462,'La Marea'),(659,66464,'Margolles'),(659,66465,'Martimporra'),(659,66467,'La Mata'),(659,66468,'El Mazuco'),(659,66469,'Melendreros'),(659,66472,'Mere'),(659,66475,'Merodio'),(659,66477,'Mestas de Con'),(659,66478,'Las Mestas'),(659,66481,'Mier'),(659,66482,'Mieres'),(659,66483,'Mildon'),(659,66485,'Miranda'),(659,66486,'Miudes'),(659,66487,'Miyeres'),(659,66495,'La Montaña'),(659,66496,'El Monte'),(659,66497,'Monteana'),(659,66499,'Montes de Sebares'),(659,66501,'Moñeca'),(659,66502,'Moriana'),(659,66503,'Morre'),(659,66505,'La Mortera'),(659,66507,'Muño'),(659,66508,'Muñón Cimero'),(659,66509,'Muñón Fondero'),(659,66511,'Murias'),(659,66515,'Muriellos'),(659,66517,'Muros de Nalón'),(659,66518,'Musel'),(659,66520,'Naraval'),(659,66521,'Narganes'),(659,66522,'Nava'),(659,66525,'Navelgas'),(659,66526,'Navia'),(659,66527,'Nembra'),(659,66528,'Nievares'),(659,66530,'La Nisal'),(659,66531,'Noreña'),(659,66533,'Novellana'),(659,66534,'Nubledo'),(659,66535,'Nueva'),(659,66536,'La Nueva'),(659,66538,'Oceño'),(659,66539,'Oles'),(659,66540,'Olloniego'),(659,66541,'Ondes'),(659,66543,'Ordaliego'),(659,66546,'Ortiguera'),(659,66547,'Otero'),(659,66549,'Otur'),(659,66551,'Oviedo'),(659,66552,'Oyanco'),(659,66553,'El Padrun'),(659,66554,'Paiandi'),(659,66555,'Palacio'),(659,66556,'Pandenes'),(659,66557,'Panes'),(659,66558,'Paramios'),(659,66559,'Paramo'),(659,66560,'Parana'),(659,66561,'La Paranza'),(659,66563,'Paredes'),(659,66564,'Parlero'),(659,66565,'Parres'),(659,66567,'El Pedregal'),(659,66569,'Pedroso'),(659,66573,'El Peligro'),(659,66574,'Pendones'),(659,66575,'Pendueles'),(659,66576,'Pentanes'),(659,66579,'Peñafuente'),(659,66581,'Peon'),(659,66582,'La Peral'),(659,66584,'Perlin'),(659,66585,'Perlora'),(659,66586,'Perlumes'),(659,66587,'Pernus'),(659,66588,'Pesoz'),(659,66590,'Pianton'),(659,66591,'Piedrafita'),(659,66593,'Piedras Blancas'),(659,66595,'Piloneta'),(659,66596,'Pimiango'),(659,66598,'El Pino'),(659,66599,'Pintueles'),(659,66600,'Piñera'),(659,66601,'El Pito'),(659,66602,'La Plaza'),(659,66603,'Podes'),(659,66604,'Pojos'),(659,66605,'Pola de Allande'),(659,66606,'Pola de Laviana'),(659,66607,'Pola de Siero'),(659,66608,'Pola de Somiedo'),(659,66609,'Pola del Pino'),(659,66611,'Ponteo'),(659,66612,'Ponticiella'),(659,66614,'Poo'),(659,66616,'Porceyo'),(659,66621,'Porrua'),(659,66622,'Posada'),(659,66623,'Posada (llanera)'),(659,66624,'Pousadoiro'),(659,66625,'Poveda'),(659,66626,'El Pozón'),(659,66628,'Pradias'),(659,66629,'Pradiela'),(659,66630,'Prado'),(659,66631,'Pravia'),(659,66633,'Prendes'),(659,66635,'Priesca'),(659,66636,'Proaza'),(659,66637,'Prubia'),(659,66640,'Puente de los Fierros'),(659,66643,'Puertas'),(659,66645,'Puerto de Vega'),(659,66646,'El Puerto'),(659,66647,'Pumarabule'),(659,66650,'Quintanal'),(659,66651,'Quintes'),(659,66652,'Quintueles'),(659,66653,'Quinzanas'),(659,66654,'Rales'),(659,66655,'Rañeces'),(659,66656,'La Rebollada'),(659,66657,'La Rebollada'),(659,66658,'Rebollar'),(659,66661,'Rellanos'),(659,66664,'Rendaliego'),(659,66666,'Riaño'),(659,66667,'Ribadesella'),(659,66668,'Riberas'),(659,66669,'Ricabo'),(659,66672,'La Riera'),(659,66674,'Rioseco'),(659,66675,'Rioturbio'),(659,66677,'Robledo'),(659,66678,'La Roda'),(659,66679,'Rodical'),(659,66680,'Rodiles'),(659,66684,'Ruenes'),(659,66685,'Sabugo'),(659,66687,'Salas'),(659,66688,'Salcedo'),(659,66689,'Sales'),(659,66691,'Salinas'),(659,66692,'Sama'),(659,66695,'San Andrés'),(659,66696,'San Antolin de Ibias'),(659,66697,'San Cucao'),(659,66698,'San Esteban de las Cruces'),(659,66699,'San Esteban de Pravia'),(659,66700,'San Esteban'),(659,66702,'San Ignacio'),(659,66703,'San Juan de Nieva'),(659,66704,'San Julián'),(659,66705,'San Martín de Lodón'),(659,66706,'San Martín de Oscos'),(659,66708,'San Miguel'),(659,66711,'San Roque'),(659,66713,'San Sebastián'),(659,66714,'San Tirso'),(659,66716,'Sandamias'),(659,66717,'Santa Bárbara'),(659,66718,'Santa Cruz'),(659,66719,'Santa Eulalia de Oscos'),(659,66720,'Santa Eulalia'),(659,66723,'Santa Marina'),(659,66725,'Santa Rosa'),(659,66726,'Santianes'),(659,66732,'Santullano'),(659,66735,'Sarceda'),(659,66738,'Seares'),(659,66744,'Serandinas'),(659,66745,'Serantes'),(659,66747,'Sevares'),(659,66748,'Siejo'),(659,66752,'Siones'),(659,66755,'Somado'),(659,66756,'Somio'),(659,66757,'Sotiello'),(659,66758,'Soto'),(659,66759,'Soto de Cangas'),(659,66761,'Soto de los Infantes'),(659,66762,'Soto de Luiña'),(659,66763,'Soto de Ribera'),(659,66764,'Soto del Barco'),(659,66765,'Sotres'),(659,66766,'Sotrondio'),(659,66767,'St. Cruz'),(659,66768,'Suarias'),(659,66769,'Sueiro'),(659,66772,'S. Román'),(659,66773,'Tabaza'),(659,66775,'Tamallanes'),(659,66776,'Tamon'),(659,66779,'Tapia de Casariego'),(659,66780,'Taramundi'),(659,66783,'Tarna'),(659,66785,'Tazones'),(659,66789,'Telledo'),(659,66790,'Tene'),(659,66793,'Las Tiendas'),(659,66794,'Tineo'),(659,66795,'Tiñana'),(659,66799,'Tolivia'),(659,66803,'Los Tornos'),(659,66810,'Tresali'),(659,66811,'Tresano'),(659,66815,'Treve'),(659,66816,'Trevias'),(659,66818,'Troncedo'),(659,66820,'Trubia'),(659,66821,'Tudela Veguin'),(659,66823,'Tuiza'),(659,66825,'Turon'),(659,66826,'Ujo'),(659,66827,'Urbies'),(659,66830,'Valdemora'),(659,66831,'Valdepares'),(659,66832,'Valdesoto'),(659,66834,'Valle'),(659,66839,'Vega'),(659,66840,'Vega de Peridiello'),(659,66842,'Vega del Ciego'),(659,66843,'La Vega'),(659,66844,'La Vega'),(659,66845,'Vegadeo'),(659,66851,'Venta del Pobre'),(659,66852,'La Venta'),(659,66854,'Venta las Ranas'),(659,66858,'Veranes'),(659,66859,'Verdicio'),(659,66860,'Veriña'),(659,66861,'Viavelez'),(659,66862,'Vibaño'),(659,66866,'Viella'),(659,66868,'Vigo'),(659,66870,'Villa'),(659,66872,'Villabona'),(659,66873,'Villabre'),(659,66876,'Villadun'),(659,66877,'Villaestremeri'),(659,66878,'Villafria'),(659,66882,'Villallana'),(659,66883,'Villamarcel'),(659,66885,'Villamayor'),(659,66888,'Villanueva de Oscos'),(659,66889,'Villanueva'),(659,66895,'Villanueva (7)'),(659,66897,'Villapedre'),(659,66898,'Villar'),(659,66899,'Villar de Bullaso'),(659,66901,'Villar de Vildas'),(659,66902,'Villares de Abajo'),(659,66903,'Villarin'),(659,66904,'Villarpedre'),(659,66908,'Villaverde'),(659,66910,'Villaviciosa'),(659,66911,'Villayón'),(659,66912,'Villazon'),(659,66913,'Villmarzo'),(659,66916,'Viñon'),(659,66917,'Viobes'),(659,66918,'Vioño'),(659,66919,'Yernes'),(659,66920,'Zureda'),(660,66921,'Alameda'),(660,66922,'Alcaucin'),(660,66923,'Alfarnate'),(660,66924,'Alfarnatejo'),(660,66925,'Algarrobo'),(660,66926,'Algatocin'),(660,66927,'Alhaurín de la Torre'),(660,66928,'Alhaurín el Grande'),(660,66929,'Aljaima'),(660,66930,'Almachar'),(660,66931,'Almargen'),(660,66932,'Almayate bajo'),(660,66933,'Almogía'),(660,66934,'Álora'),(660,66935,'Alozaina'),(660,66937,'Alqueria'),(660,66938,'Ampliacion de cartana'),(660,66939,'Antequera'),(660,66940,'Archez'),(660,66941,'Archidona'),(660,66942,'Ardales'),(660,66943,'Arenas'),(660,66944,'Arriate'),(660,66945,'Arroyo de la miel'),(660,66946,'Atajate'),(660,66947,'Atalaya la'),(660,66949,'Benagalbon'),(660,66950,'Benahavís'),(660,66951,'Benajarafe'),(660,66953,'Benalmádena'),(660,66954,'Benamargosa'),(660,66955,'Benamocarra'),(660,66956,'Benaojan'),(660,66957,'Benarraba'),(660,66958,'Bobadilla'),(660,66959,'Borge el'),(660,66960,'El Burgo'),(660,66961,'Cajiz'),(660,66962,'La Cala del Moral'),(660,66963,'Caleta la'),(660,66964,'Campanillas'),(660,66965,'Campillos'),(660,66966,'Cancelada'),(660,66967,'Canillas de Aceituno'),(660,66968,'Canillas de albaida'),(660,66969,'Cañete la Real'),(660,66972,'Cártama'),(660,66973,'Cartaojal'),(660,66975,'Casabermeja'),(660,66976,'Casapalma'),(660,66978,'Casares'),(660,66979,'Cerralba'),(660,66980,'Coín'),(660,66982,'Colmenar el'),(660,66983,'Comares'),(660,66984,'Cómpeta'),(660,66985,'Cortes de la Frontera'),(660,66988,'Cuevas bajas'),(660,66989,'Cuevas de San Marcos'),(660,66991,'Cutar'),(660,66992,'Chaparral'),(660,66993,'Chilches'),(660,66996,'Churriana'),(660,66997,'Daimalos'),(660,66998,'Doña ana'),(660,66999,'Elviria'),(660,67000,'Estacion de cartama'),(660,67001,'Estepona'),(660,67003,'Faro el'),(660,67004,'Frigiliana'),(660,67005,'Fuengirola'),(660,67006,'Fuente de Piedra'),(660,67007,'Gaucin'),(660,67010,'Guadalmansa'),(660,67011,'Guadalmar'),(660,67012,'Guaro'),(660,67014,'Huit'),(660,67015,'Humilladero'),(660,67016,'Igualeja'),(660,67018,'Iznate'),(660,67021,'Jubrique'),(660,67022,'Juzcar'),(660,67023,'Lagos'),(660,67024,'Llanos de antequera los'),(660,67025,'Macharaviaya'),(660,67026,'Málaga'),(660,67027,'Manilva'),(660,67028,'Marbella'),(660,67029,'Maro'),(660,67031,'Mellizas las'),(660,67032,'Mijas'),(660,67033,'Moclinejo'),(660,67034,'Mollina'),(660,67035,'Monda'),(660,67038,'Montejaque'),(660,67039,'Morche el'),(660,67041,'Nerja'),(660,67042,'Nueva andalucia'),(660,67043,'Ojén'),(660,67045,'Palo el'),(660,67046,'Parauta'),(660,67050,'Periana'),(660,67051,'Pizarra'),(660,67052,'Playa bella'),(660,67054,'Puente de salia'),(660,67055,'Puerto sol'),(660,67057,'Rincón de la Victoria'),(660,67058,'Rio de la miel'),(660,67059,'Riogordo'),(660,67060,'Romanes los'),(660,67061,'Ronda'),(660,67062,'Salares'),(660,67063,'Salto del negro'),(660,67064,'San pedro de alcantara'),(660,67065,'Santa fe de los boliches'),(660,67066,'Santa rosa'),(660,67067,'Santa rosalia'),(660,67069,'Sayalonga'),(660,67070,'Sedella'),(660,67071,'Sierra de Yeguas'),(660,67072,'Teba'),(660,67073,'Tolox'),(660,67074,'Torre de benagalbon'),(660,67075,'Torre de calahonda'),(660,67076,'Torre del mar'),(660,67077,'Torremolinos'),(660,67078,'Torremuelle'),(660,67079,'Torrox'),(660,67080,'Totalan'),(660,67082,'Triana'),(660,67083,'Valdes'),(660,67085,'Valle de Abdalajís'),(660,67087,'Vélez-Málaga'),(660,67088,'Venta del jaro'),(660,67093,'Villanueva de Algaidas'),(660,67094,'Villanueva de cauche'),(660,67095,'Villanueva de la concepcion'),(660,67097,'Villanueva del Rosario'),(660,67098,'Villanueva del Trabuco'),(660,67099,'Viñuela'),(660,67100,'Yunquera'),(660,67101,'Zalea'),(660,67102,'Zubia la');
/*!40000 ALTER TABLE `poblaciones` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `polizas`
--

DROP TABLE IF EXISTS `polizas`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `polizas` (
  `cod_poliza` int(11) NOT NULL,
  `cod_persona` int(11) NOT NULL,
  `email` varchar(45) NOT NULL,
  `tarjeta` varchar(45) NOT NULL,
  PRIMARY KEY (`cod_poliza`),
  KEY `poliza_cod_persona_fk` (`cod_persona`),
  CONSTRAINT `poliza_cod_persona_fk` FOREIGN KEY (`cod_persona`) REFERENCES `personas` (`cod_persona`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `polizas`
--

LOCK TABLES `polizas` WRITE;
/*!40000 ALTER TABLE `polizas` DISABLE KEYS */;
INSERT INTO `polizas` VALUES (12345,1,'josemariano.garcia@correo.net','TM-0001'),(12346,2,'lola@correo.net','TM-0002');
/*!40000 ALTER TABLE `polizas` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prestadores`
--

DROP TABLE IF EXISTS `prestadores`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prestadores` (
  `cod_persona` int(11) NOT NULL,
  `cod_especialidad` int(11) NOT NULL,
  PRIMARY KEY (`cod_persona`,`cod_especialidad`),
  KEY `cod_especialidad_fk` (`cod_especialidad`),
  CONSTRAINT `cod_especialidad_fk` FOREIGN KEY (`cod_especialidad`) REFERENCES `especialidades` (`cod_especialidad`),
  CONSTRAINT `cod_persona2_fk` FOREIGN KEY (`cod_persona`) REFERENCES `personas` (`cod_persona`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prestadores`
--

LOCK TABLES `prestadores` WRITE;
/*!40000 ALTER TABLE `prestadores` DISABLE KEYS */;
INSERT INTO `prestadores` VALUES (1,1),(2,1),(1,2);
/*!40000 ALTER TABLE `prestadores` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `provincias`
--

DROP TABLE IF EXISTS `provincias`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `provincias` (
  `cod_provincia` int(11) NOT NULL AUTO_INCREMENT,
  `provincia` varchar(25) CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`cod_provincia`),
  CONSTRAINT `provincias_cod_provincia_fk` FOREIGN KEY (`cod_provincia`) REFERENCES `poblaciones` (`cod_provincia`)
) ENGINE=InnoDB AUTO_INCREMENT=661 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `provincias`
--

LOCK TABLES `provincias` WRITE;
/*!40000 ALTER TABLE `provincias` DISABLE KEYS */;
INSERT INTO `provincias` VALUES (609,'Las Palmas'),(610,'Soria'),(611,'Palencia'),(612,'Zamora'),(613,'Cádiz'),(614,'Navarra'),(615,'Ourense'),(616,'Segovia'),(617,'Guipúzcoa'),(618,'Ciudad Real'),(619,'Vizcaya'),(620,'Álava'),(621,'A Coruña'),(622,'Cantabria'),(623,'Almería'),(624,'Zaragoza'),(625,'Santa Cruz de Tenerife'),(626,'Cáceres'),(627,'Guadalajara'),(628,'Ávila'),(629,'Toledo'),(630,'Castellón'),(631,'Tarragona'),(632,'Lugo'),(633,'La Rioja'),(634,'Ceuta'),(635,'Murcia'),(636,'Salamanca'),(637,'Valladolid'),(638,'Jaén'),(639,'Girona'),(640,'Granada'),(641,'Alacant'),(642,'Córdoba'),(643,'Albacete'),(644,'Cuenca'),(645,'Pontevedra'),(646,'Teruel'),(647,'Melilla'),(648,'Barcelona'),(649,'Badajoz'),(650,'Madrid'),(651,'Sevilla'),(652,'Valencia'),(653,'Huelva'),(654,'Lleida'),(655,'León'),(656,'Illes Balears'),(657,'Burgos'),(658,'Huesca'),(659,'Asturias'),(660,'Málaga');
/*!40000 ALTER TABLE `provincias` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `puntos_asistencia`
--

DROP TABLE IF EXISTS `puntos_asistencia`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `puntos_asistencia` (
  `cod_punto_asistencia` int(11) NOT NULL,
  `cod_especialidad` int(11) NOT NULL,
  `cod_domicilio` int(11) NOT NULL,
  `nombre` varchar(45) NOT NULL,
  `NIF` varchar(9) NOT NULL,
  `telefono` varchar(13) DEFAULT NULL,
  `email` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`cod_punto_asistencia`,`cod_especialidad`,`cod_domicilio`),
  KEY `especialidades_fk` (`cod_especialidad`),
  KEY `domicilios_fk` (`cod_domicilio`),
  CONSTRAINT `domicilios_fk` FOREIGN KEY (`cod_domicilio`) REFERENCES `domicilios` (`cod_domicilio`),
  CONSTRAINT `especialidades_fk` FOREIGN KEY (`cod_especialidad`) REFERENCES `especialidades` (`cod_especialidad`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `puntos_asistencia`
--

LOCK TABLES `puntos_asistencia` WRITE;
/*!40000 ALTER TABLE `puntos_asistencia` DISABLE KEYS */;
INSERT INTO `puntos_asistencia` VALUES (1,1,3,'HOSPITAL CENTRAL','A1234123','915555555','hospital@hospitalcentral.es'),(1,6,3,'HOSPITAL CENTRAL','A1234123','915555555','hospital@hospitalcentral.es'),(1,7,3,'HOSPITAL CENTRAL','A1234123','915555555','hospital@hospitalcentral.es'),(1,8,3,'HOSPITAL CENTRAL','A1234123','915555555','hospital@hospitalcentral.es'),(1,9,3,'HOSPITAL CENTRAL','A1234123','915555555','hospital@hospitalcentral.es'),(1,10,3,'HOSPITAL CENTRAL','A1234123','915555555','hospital@hospitalcentral.es'),(1,11,3,'HOSPITAL CENTRAL','A1234123','915555555','hospital@hospitalcentral.es'),(1,12,3,'HOSPITAL CENTRAL','A1234123','915555555','hospital@hospitalcentral.es'),(1,13,3,'HOSPITAL CENTRAL','A1234123','915555555','hospital@hospitalcentral.es'),(1,15,3,'HOSPITAL CENTRAL','A1234123','915555555','hospital@hospitalcentral.es'),(2,1,5,'CLÍNICA MAJADAHONDA','B1234567','916666666','clinica@clinicamajadahonda.es'),(2,8,5,'CLÍNICA MAJADAHONDA','B1234567','916666666','clinica@clinicamajadahonda.es'),(2,11,5,'CLÍNICA MAJADAHONDA','B1234567','916666666','clinica@clinicamajadahonda.es'),(2,13,5,'CLÍNICA MAJADAHONDA','B1234567','916666666','clinica@clinicamajadahonda.es'),(3,1,6,'CLÍNICA PARQUE','B9876543','917777777','clinica@clinicaparque.es'),(4,1,7,'CÍNICA GRACIA','C1234567','931111111','clinica@clinicagracia.es');
/*!40000 ALTER TABLE `puntos_asistencia` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tipos_usuario`
--

DROP TABLE IF EXISTS `tipos_usuario`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tipos_usuario` (
  `cod_tipo` tinyint(4) NOT NULL,
  `tipo` varchar(45) NOT NULL,
  PRIMARY KEY (`cod_tipo`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tipos_usuario`
--

LOCK TABLES `tipos_usuario` WRITE;
/*!40000 ALTER TABLE `tipos_usuario` DISABLE KEYS */;
INSERT INTO `tipos_usuario` VALUES (1,'coordinador medico'),(2,'asegurado');
/*!40000 ALTER TABLE `tipos_usuario` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tipos_vias`
--

DROP TABLE IF EXISTS `tipos_vias`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tipos_vias` (
  `cod_tipo` tinyint(4) NOT NULL,
  `tipovia` varchar(20) NOT NULL,
  PRIMARY KEY (`cod_tipo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tipos_vias`
--

LOCK TABLES `tipos_vias` WRITE;
/*!40000 ALTER TABLE `tipos_vias` DISABLE KEYS */;
INSERT INTO `tipos_vias` VALUES (1,'PASEO'),(2,'CALLE'),(3,'AVENIDA');
/*!40000 ALTER TABLE `tipos_vias` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `usuarios`
--

DROP TABLE IF EXISTS `usuarios`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `usuarios` (
  `cod_usuario` int(11) NOT NULL,
  `usuario` varchar(10) NOT NULL,
  `clave` varchar(32) NOT NULL,
  `poliza` int(11) DEFAULT NULL,
  `tipo_usuario` tinyint(4) NOT NULL,
  PRIMARY KEY (`cod_usuario`),
  KEY `tipo_usuario_fk` (`tipo_usuario`),
  CONSTRAINT `tipo_usuario_fk` FOREIGN KEY (`tipo_usuario`) REFERENCES `tipos_usuario` (`cod_tipo`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `usuarios`
--

LOCK TABLES `usuarios` WRITE;
/*!40000 ALTER TABLE `usuarios` DISABLE KEYS */;
INSERT INTO `usuarios` VALUES (1,'jgarcialue','81dc9bdb52d04dc20036dbd8313ed055',12345,1),(2,'lgil','202cb962ac59075b964b07152d234b70',12345,2),(3,'robert','202cb962ac59075b964b07152d234b70',NULL,1);
/*!40000 ALTER TABLE `usuarios` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Dumping routines for database 'iCMED_db'
--
/*!50003 DROP PROCEDURE IF EXISTS `sp_iCMED` */;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8 */ ;
/*!50003 SET character_set_results = utf8 */ ;
/*!50003 SET collation_connection  = utf8_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50020 DEFINER=`root`@`localhost`*/ /*!50003 PROCEDURE `sp_iCMED`(
	IN opc SMALLINT, IN var1 VARCHAR(50), IN var2 VARCHAR(50), IN var3 VARCHAR(50),
	IN var4 VARCHAR(50), IN var5 VARCHAR(50))
BEGIN
--
-- Las opciones (opc) validas son:
--		1 -> Devuelve todas las provincias donde hay cuadro médico. Se usa en buscar medicos.
--		2 -> Devuelve todas las poblaciones de una provincia donde hay cuadro médico. Se usa en buscar medicos var1 = cod_provincia.
--		3 -> Devuelve las especialidades con servicio en una poblacion. Se usa en buscar medicos.
--
--		10 -> Devuelve los datos del asegurado si este esta contratado por la compañia. Se usa en buscar asegurado 
--			var1 = nombre
--			var2 = apellido1
--			var3 = apellido2
--			var4 = NIF
--			var5 = tarjeta
--
--		20 -> Devuelve los datos de usuario. Se usa en login donde va1 = usuario.
--		22 -> Devuelve la clave de usuario. Se usa en el cambio de clave var1 = cod_usuario.
--		23 -> Actualiza la clave de usuario. Se usa en el cambio de clave var1 = cod_usuario.
--
--		30 -> Devuelve las opciones de la aplicación a las que tiene acceso un usuario. var1 = tipo_usuario
--
--		40 -> Devuelve los médicos y centros existentes en una población y que tengan la especialidad médica elegida.


	DECLARE S VARCHAR (5000);

	CASE opc 
		WHEN 1 THEN
			(SELECT provincias.cod_provincia, provincias.provincia 
			FROM provincias, prestadores, personas, domicilios
			WHERE provincias.cod_provincia = domicilios.cod_provincia AND
				domicilios.cod_domicilio = personas.cod_domicilio AND
				personas.cod_persona = prestadores.cod_persona
			GROUP BY provincias.cod_provincia, provincias.provincia)

		  UNION DISTINCT

			(SELECT provincias.cod_provincia, provincias.provincia 
			FROM provincias, puntos_asistencia, domicilios
			WHERE provincias.cod_provincia = domicilios.cod_provincia AND
				domicilios.cod_domicilio = puntos_asistencia.cod_domicilio
			GROUP BY provincias.cod_provincia, provincias.provincia)

		  ORDER BY cod_provincia, provincia;

		WHEN 2 THEN
			(SELECT poblaciones.cod_poblacion, poblaciones.poblacion 
			FROM poblaciones, provincias, prestadores, personas, domicilios 
			WHERE poblaciones.cod_provincia = provincias.cod_provincia AND 
				domicilios.cod_provincia = provincias.cod_provincia AND
				domicilios.cod_poblacion = poblaciones.cod_poblacion AND
				personas.cod_persona = prestadores.cod_persona AND
				personas.cod_domicilio = domicilios.cod_domicilio AND
				provincias.cod_provincia = var1
			GROUP BY poblaciones.cod_poblacion, poblaciones.poblacion)

		  UNION DISTINCT

			(SELECT poblaciones.cod_poblacion, poblaciones.poblacion 
			FROM poblaciones, provincias, puntos_asistencia, domicilios 
			WHERE poblaciones.cod_provincia = provincias.cod_provincia AND 
				domicilios.cod_provincia = provincias.cod_provincia AND
				domicilios.cod_poblacion = poblaciones.cod_poblacion AND
				puntos_asistencia.cod_domicilio = domicilios.cod_domicilio AND
				provincias.cod_provincia = var1
			GROUP BY poblaciones.cod_poblacion, poblaciones.poblacion)

		  ORDER BY poblacion;

		WHEN 3 THEN
			(SELECT 
				especialidades.cod_especialidad, especialidad 
			FROM 
				especialidades, prestadores, personas, 
				domicilios, provincias, poblaciones
			WHERE
				especialidades.cod_especialidad = prestadores.cod_especialidad AND
				domicilios.cod_domicilio = personas.cod_domicilio AND
				personas.cod_persona = prestadores.cod_persona AND
				domicilios.cod_provincia = provincias.cod_provincia AND
				domicilios.cod_poblacion = poblaciones.cod_poblacion AND
				provincias.cod_provincia = var1 AND
				poblaciones.cod_poblacion = var2 AND
				provincias.cod_provincia = poblaciones.cod_provincia
			GROUP BY 
				especialidades.cod_especialidad, especialidad)

		   UNION DISTINCT

			(SELECT 
				especialidades.cod_especialidad, especialidad 
			FROM 
				especialidades, puntos_asistencia, 
				domicilios, provincias, poblaciones
			WHERE
				especialidades.cod_especialidad = puntos_asistencia.cod_especialidad AND
				domicilios.cod_domicilio = puntos_asistencia.cod_domicilio AND
				domicilios.cod_provincia = provincias.cod_provincia AND
				domicilios.cod_poblacion = poblaciones.cod_poblacion AND
				provincias.cod_provincia = var1 AND
				poblaciones.cod_poblacion = var2 AND
				provincias.cod_provincia = poblaciones.cod_provincia
			GROUP BY 
				especialidades.cod_especialidad, especialidad
			)

			ORDER BY 
				cod_especialidad, especialidad;
	
		WHEN 10 THEN
			SET @S = '
			SELECT 
				nombre, apellido1, apellido2, NIF, cod_poliza, tarjeta,
				CONCAT(tipovia, '' '', via, '', '', num_via) AS domicilio, 
				piso, escalera, puerta, cod_postal,
				provincias.provincia, poblaciones.poblacion
			FROM
				polizas, personas, domicilios, tipos_vias, provincias, poblaciones
			WHERE
				polizas.cod_persona = personas.cod_persona AND
				personas.cod_domicilio = domicilios.cod_domicilio AND
				domicilios.tipo_via = tipos_vias.cod_tipo AND
				domicilios.cod_provincia = provincias.cod_provincia AND
				domicilios.cod_provincia = poblaciones.cod_provincia AND
				domicilios.cod_poblacion = poblaciones.cod_poblacion';

			IF var1 <> '' THEN
				SET @S = CONCAT (@S, ' AND personas.nombre = \'', var1, '\'');
			END IF;

			IF var2 <> '' THEN
				SET @S = CONCAT (@S, ' AND personas.apellido1 = \'', var2, '\'');
			END IF;

			IF var3 <> '' THEN
				SET @S = CONCAT (@S, ' AND personas.apellido2 = \'', var3, '\'');
			END IF;

			IF var4 <> '' THEN
				SET @S = CONCAT (@S, ' AND personas.NIF = \'', var4, '\'');
			END IF;

			IF var5 <> '' THEN
				SET @S = CONCAT (@S, ' AND polizas.tarjeta = \'', var5, '\'');
			END IF;

			PREPARE SSQL FROM @S;

			EXECUTE SSQL;

			DEALLOCATE PREPARE SSQL;

		WHEN 20 THEN
			SELECT cod_usuario, clave, tipo_usuario
			FROM usuarios
			WHERE usuario = var1;

		WHEN 22 THEN
			SELECT clave
			FROM usuarios
			WHERE cod_usuario = var1;

		WHEN 23 THEN
			UPDATE usuarios
			SET	clave = var2
			WHERE cod_usuario = var1;

		WHEN 30 THEN
			SELECT opcion, segue
			FROM opciones_menu, opciones_usuario
			WHERE opciones_menu.cod_opcion = opciones_usuario.cod_opcion AND
				opciones_usuario.cod_tipo_usuario = var1
			ORDER BY opciones_menu.cod_opcion;

		WHEN 40 THEN
			(SELECT
				CONCAT (personas.tratamiento, ' ', personas.nombre, ' ', 
					personas.apellido1, ' ', personas.apellido2) AS nombre_completo, 
				tipos_vias.tipovia, domicilios.via, domicilios.num_via, 
				domicilios.cod_postal, poblaciones.poblacion, provincias.provincia,
				personas.telefono, especialidades.especialidad,
				CONCAT (tipos_vias.tipovia,  ' ', domicilios.via, ', ', 
					domicilios.num_via, ' ', poblaciones.poblacion, ' ESPAÑA') AS domicilio_gps
			FROM 
				especialidades, prestadores, personas, 
				domicilios, provincias, poblaciones, tipos_vias
			WHERE 
				especialidades.cod_especialidad = prestadores.cod_especialidad AND 
				domicilios.cod_domicilio = personas.cod_domicilio AND 
				personas.cod_persona = prestadores.cod_persona AND 
				domicilios.cod_provincia = provincias.cod_provincia AND 
				domicilios.cod_poblacion = poblaciones.cod_poblacion AND 
				provincias.cod_provincia = poblaciones.cod_provincia AND
				domicilios.tipo_via = tipos_vias.cod_tipo AND
				provincias.cod_provincia = var1 AND 
				poblaciones.cod_poblacion = var2 AND
				especialidades.cod_especialidad = var3)

		  UNION DISTINCT

			(SELECT
				puntos_asistencia.nombre AS nombre_completo, 
				tipos_vias.tipovia, domicilios.via, domicilios.num_via, 
				domicilios.cod_postal, poblaciones.poblacion, provincias.provincia,
				puntos_asistencia.telefono, especialidades.especialidad,
				CONCAT (tipos_vias.tipovia,  ' ', domicilios.via, ', ', 
					domicilios.num_via, ' ', poblaciones.poblacion, ' ESPAÑA') AS domicilio_gps
			FROM 
				especialidades, puntos_asistencia, 
				domicilios, provincias, poblaciones, tipos_vias
			WHERE 
				especialidades.cod_especialidad = puntos_asistencia.cod_especialidad AND 
				domicilios.cod_domicilio = puntos_asistencia.cod_domicilio AND 
				domicilios.cod_provincia = provincias.cod_provincia AND 
				domicilios.cod_poblacion = poblaciones.cod_poblacion AND 
				provincias.cod_provincia = poblaciones.cod_provincia AND
				domicilios.tipo_via = tipos_vias.cod_tipo AND
				provincias.cod_provincia = var1 AND 
				poblaciones.cod_poblacion = var2 AND
				especialidades.cod_especialidad = var3)

			ORDER BY
				nombre_completo;


	END CASE;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2013-05-20 17:46:47
